      SUBROUTINE FITS_BUFFO (STATUS)
C-----------------------------------------------------------------------
C     Writes the FITS header buffer (BUFF, in common) into the
C     main FITS output buffer (FBUFF).  If necessary, the buffer
C     will be written to the output file.
C
C     Parameter -   (">" input,  "!" modified,  "<" output)
C
C     (<) STATUS    (Integer) Return code.  0 => OK.  Non-zero codes
C                   represent errors.  This can be decoded by FITS_ERROR.
C
C     Common variables used -
C
C     (>) BUFF      (Character) The single line character buffer used
C                   for header keyword lines.
C     (<) FBUFF     (Byte array) The main FITS output buffer.
C     (!) FPTR      (Integer) The pointer to the next free byte in FBUFF.
C                   Should have been initialised by FITS_INIT.
C
C     Subroutines / functions used -
C
C     FITS_MWRIT      (FITS_ package) Writes FBUFF to output file.
C
C                                           KS / CIT 9th Oct 1983
C-----------------------------------------------------------------------
C
      INTEGER STATUS
C
      INCLUDE 'fits1.inc'
C
      INTEGER I
C
C     Copy BUFF into FBUFF, then write out if full.  (Note assumption
C     that FBUFF has been filled 80 bytes at a time, so will not fill in
C     the middle of the copy.)
C
      DO I=1,80
         FBUFF(FPTR)=ICHAR(BUFF(I:I))
         FPTR=FPTR+1
      END DO
      IF (FPTR.GT.2880) THEN
         CALL FITS_MWRIT(STATUS)
         FPTR=1
      ELSE
         STATUS=0
      END IF
C
      END
