      SUBROUTINE FITS_FLUSH (STATUS)
C-----------------------------------------------------------------------
C     Flushes the main I/O buffer to disk.
C
C     Parameters -  (">" input, "W" workspace, "<" output, "!" modified)
C
C     (<) STATUS    (Integer) Returned status code. 0 => OK, non-zero
C                   codes are I/O error codes, which may be decoded
C                   by FITS_ERROR.
C
C     Common variables used -
C  
C     (!) FBUFF     (Byte array) Main I/O buffer.  If non-empty, will
C                   be filled with zeros and flushed to the output file.
C     (!) FPTR      (Integer) Pointer to next free byte in FBUFF.
C
C     Subroutines / functions used -
C
C     FIT_MWRIT     (FITS_ package) Writes FBUFF to output file.
C
C                                       KS / CIT 11th Oct 1983
C-----------------------------------------------------------------------
C
      INTEGER STATUS
C
      INCLUDE 'fits1.inc'
C
      INTEGER I
C
C     Do we have to flush FBUFF?
C
      IF (FPTR.GT.1) THEN
         DO I=FPTR,2880
            FBUFF(I)=0
         END DO
         CALL FITS_MWRIT(STATUS)
         FPTR=1
         IF (STATUS.NE.0)  GO TO 600
      END IF
C
  600 CONTINUE
      END
