      SUBROUTINE FITS_INIT (FILE,FILEXP,LF,STATUS)
C-----------------------------------------------------------------------
C     Initialises the FITS_ routines.  This should be the first
C     FITS_ routine called.
C
C     Parameters -   (">" input, "<" output)
C
C     (>) FILE     (Character) The name of the disk file to be
C                  created. 
C     (<) FILEXP   (Character) The name of the file that was actually
C                  created (expanded file name)>
C     (<) LF       (Integer) Number of characters in FILEXP.
C     (<) STATUS   (Integer) A returned status code.  0 => OK, non-
C                  zero values are Fortran I/O error codes.
C
C     Common variables used -
C
C     (<) MTUNIT   (Integer) The Fortran logical unit used for output.
C     (<) FPTR     (Integer) The pointer to the main output buffer.
C
C-----------------------------------------------------------------------
C
      INTEGER STATUS, LF
      CHARACTER*(*) FILE, FILEXP
      INTEGER VLBOPE
C
      INCLUDE 'fits1.inc'
C
Cvms  INTEGER LIB$GET_LUN
C
C     Assign a logical unit
C
      MTUNIT = 77
Cvms  STATUS = LIB$GET_LUN(MTUNIT)
Cvms  IF (STATUS.NE.1) RETURN
C
C     Open the file (2880-byte records)
C
      STATUS = VLBOPE(MTUNIT, FILE, 'FITS', 'NEW', FILEXP)
      IF (STATUS.NE.0) THEN
          STATUS = 0
      ELSE
          STATUS = 1
      END IF
      LF = LEN(FILEXP)
      DO WHILE (FILEXP(LF:LF).EQ.' ')
          LF = LF-1
      END DO
C
C     Initialise pointers
C
      BLKNO = 1
      FPTR=1
C
      END
