      SUBROUTINE FITS_WCMT (NAME,COMMENT,STATUS)
C-----------------------------------------------------------------------
C     Writes a comment into a FITS header.  Assumes 
C     FITS_INIT has been called to initialise the header routines.
C     The FITS standard allows comments to be given the keywords
C     COMMENT, or HISTORY, or blank.  NAME should be passed as one
C     of these, but this is not tested by this routine.
C
C     Parameters -  (">" input, "<" output)
C
C     (>) NAME      (Character) The name of the comment (see above).
C     (>) COMMENT   (Character) Any comment to be associated with the
C                   keyword.  Should be no longer than 70 characters.
C     (>) STATUS    (Integer) Return status code. 0 => OK, non-zero
C                   values will be error codes caused by an
C                   I/O error.  These can be decoded by FITS_ERROR.
C
C     Note: The FITS standard says keyword names and values must be
C     output in upper case.  NAME can be passed in lower case, but
C     it will be output in upper.  COMMENT will be output as passed.
C
C     Common variables used -
C
C     (<) BUFF      (Character) Buffer for one header line
C
C     Functions / subroutines used -
C
C     FITS_BUFFO     (FITS_ package) Outputs BUFF to main I/O buffer.
C     UPCASE         Convert string to upper case.
C
C                                                KS / CIT  9th OCT 1983
C  Revised TJP 1988 Nov 2 : start text in column 9
C-----------------------------------------------------------------------
C
      INTEGER STATUS
      CHARACTER*(*) NAME,COMMENT
C
      INCLUDE 'fits1.inc'
C
      BUFF(1:8)=NAME
      CALL UPCASE(BUFF(1:8))
      BUFF(9:)=COMMENT
      CALL FITS_BUFFO(STATUS)
C
      END
