      SUBROUTINE FITS_WDBLE (NAME,VALUE,COMMENT,STATUS)
C-----------------------------------------------------------------------
C     Writes a double precision keyword into a FITS header.  Assumes 
C     FITS_INIT has been called to initialise the header routines.
C
C     Parameters -  (">" input, "<" output)
C
C     (>) NAME      (Character) The name of the keyword.
C     (>) VALUE     (Double precision) The value of the parameter.
C     (>) COMMENT   (Character) Any comment to be associated with the
C                   keyword.  Should be no longer than 46 characters.
C     (>) STATUS    (Integer) Return status code. 0 => OK, non-zero
C                   values will be error codes caused by an
C                   I/O error.  These can be decoded by FITS_ERROR.
C
C     Note: The FITS standard says keyword names and values must be
C     output in upper case.  NAME can be passed in lower case, but
C     it will be output in upper.  COMMENT will be output as passed.
C
C     Common variables used -
C
C     (<) BUFF      (Character) Buffer for one header line
C
C     Functions / subroutines used -
C
C     FITS_BUFFO     (FITS_ package) Outputs BUFF to main I/O buffer.
C     FITS_BUFP      ( "     "    ) Copies NAME and COMMENTS into BUFF.
C
C                                                KS / CIT  9th OCT 1983
C-----------------------------------------------------------------------
C
      INTEGER STATUS
      DOUBLE PRECISION VALUE
      CHARACTER*(*) NAME,COMMENT
C
      INCLUDE 'fits1.inc'
C
      CALL FITS_BUFP(NAME,COMMENT)
      WRITE (BUFF(11:30),'(1PE20.13)',IOSTAT=STATUS) VALUE
      CALL FITS_BUFFO(STATUS)
C
      END
