$! This procedure is used to update an entry in the VLBI help library.
$! Input required: a runoff file for the entry, e.g., XYZZY.RNO
$! Parameter P1 for this procedure is the name of the entry, e.g. XYZZY.
$!
$! First, make a standard printable file XYZZY.MEM. The EDT magic
$! converts the MEM file from internal carriage-control to more 
$! standard format (CR carriage-control) for printers which can't 
$! handle the internal format.
$!
$ RUNOFF /NOUNDER /OUT=X.TMP 'P1'
$ EDIT/EDT/CREATE/NOCOMMAND 'P1'.TMP
include X.TMP
s/
//whole/notype
exit
$ DELETE/NOCONFIRM X.TMP;*
$ RENAME 'P1'.TMP 'P1'.MEM
$!
$! Next, use runoff again to make a help file. Shift right by one
$! space to leave room for the help keys.
$!
$ RUNOFF /RIGHT=1 /NOUNDER /OUT=X.TMP 'P1'
$ EDIT/EDT/CREATE/NOCOMMAND 'P1'.TMP
include X.TMP
s/
//whole/notype
exit
$ DELETE/NOCONFIRM X.TMP;*
$ RENAME 'P1'.TMP 'P1'.HLP
$!
$! Edit the output file to insert help keys and remove form-feeds.
$! This is not automated. The first line should be a level 1 key
$! for the main entry; most entries will also have level 2 keys
$! (e.g. PARAMETERS, HISTORY) and level 3 keys (for individual
$! parameters.)
$!
$ ASSIGN/USER SYS$COMMAND SYS$INPUT
$ EDIT/EDT 'P1'.HLP
$!
$! Finally, insert the entry in the help library.
$!
$ LIBRARY/REPLACE/LOG VLBI.HLB 'P1'
$!
$! If you are satisfied, clean up:
$!
$! PURGE/LOG 'P1'.RNO,'P1'.MEM
$! DELETE/LOG 'P1'.HLP;*
