C-----------------------------------------------------------------------
C Common storage used by B2FITS.
C-----------------------------------------------------------------------
      INTEGER MAXSRC
      PARAMETER (MAXSRC=20)
C
C The requested experiment name, source name, and antenna names.
C The requested start and stop times.
C QAUTO is TRUE if all antennas are required. QANTN is the number of
C antennas in the list. QINVAL is the requested invalids threshold.
C
      CHARACTER*16 QEXP, QSRC(MAXSRC), QANT(MAXS)
      REAL*8  QSTART, QSTOP
      LOGICAL QAUTO, QAUSRC, QAUEXP
      INTEGER QANTN, QSRCN
      INTEGER QBAD(28)
      REAL    QINVAL
      COMMON /B2FS1/ QEXP, QSRC, QANT
      COMMON /B2FS2/ QSTART, QSTOP, QAUTO, QAUSRC, 
     1               QANTN, QBAD, QINVAL, QSRCN, QAUEXP
C
C The source coordinates and the antenna coordinates.
C
      REAL*8 QRA(MAXSRC), QDEC(MAXSRC), QRA0(MAXSRC), QDEC0(MAXSRC)
      REAL*8 COSDEC(MAXSRC), SINDEC(MAXSRC)
      REAL*8 QANTX(MAXS), QANTY(MAXS), QANTZ(MAXS)
      REAL*8 BXY(MAXB), BZ(MAXB), BOFF(MAXB)
      COMMON /B2FS3/ QRA, QDEC, QRA0, QDEC0, QANTX, QANTY, QANTZ,
     1               COSDEC, SINDEC, BXY, BZ, BOFF
C
C Frequency information.  QFREF is the reference frequency (Hz),
C QFDEL is the frequency increment per pixel (Hz), QFPIX is the pixel
C number at the reference frequency, NFREQ is the number
C of pixels, and QWAVE is the wavelength at the reference frequency.
C
      REAL*8 QFREF, QFDEL, QFPIX, QWAVE
      INTEGER  NFREQ
      COMMON /B2FS5/ QFREF, QFDEL, QFPIX, QWAVE, NFREQ
C
C Time information.
C
      REAL*8 QUT1TC, QXPOLE, QYPOLE
      COMMON /B2FS6/ QUT1TC, QXPOLE, QYPOLE
C
C Statistics of the data:
C  UTYEAR  (I*4)         Year of data (eg, 1985).
C  UTMIN   (R*8)         Minimum UT (days from beginning of year).
C  UTMAX   (R*8)         Maximum UT (days from beginning of year).
C  TOTEPC  (R*8)         Total epoch (years; to derive mean epoch).
C  AMAX    (R*4)         Maximum amplitude.
C  UMAX    (R*4)         Maximum abs(u) (wavelengths).
C  VMAX    (R*4)         Maximum abs(v) (wavelengths).
C  WMAX    (R*4)         Maximum abs(w) (wavelengths).
C
      INTEGER UTYEAR
      REAL*8  UTMIN,UTMAX,TOTEPC
      REAL*4  AMAX,UMAX,VMAX,WMAX
      COMMON /B2FS4/ UTYEAR, UTMIN, UTMAX, TOTEPC, 
     1               AMAX, UMAX, VMAX, WMAX
C-----------------------------------------------------------------------
