      PROGRAM CALERR
C-----------------------------------------------------------------------
C Program to add 'calibration errors' in quadrature with
C amplitude errors
C
C Version 1.0: 1980 Jan 31 - T.J. Pearson.
C Version 1.1: 1980 Sep 24 - extended to 15 stations.
C Version 1.2: 1982 Jul 29 - minor revisions.
C Version 1.3: 1987 Dec 16 - closer to standard Fortran-77.
C Version 1.4: 1988 Jul 13 - changes for Convex.
C-----------------------------------------------------------------------
C     -- Program version and date:
      CHARACTER*(*) PROGNM, VERSN
      PARAMETER (PROGNM='CALERR')
      PARAMETER (VERSN='1.4 - 1988 Jul 13')
C     -- I/O unit numbers
      INTEGER   INDAT,OUTDAT
      PARAMETER (INDAT=8,OUTDAT=9)
C     -- array sizes
      INTEGER   MAXS,MAXB,MAXT,MAXL
      PARAMETER (MAXS=15,MAXB=(MAXS-1)*MAXS/2,MAXT=(MAXS-2)*MAXB/3)
      PARAMETER (MAXL=4*MAXB+2*MAXT)
C
      INTEGER   IY, IZ, IMON, ID, JD, MONTH, DAY, IB, IS1, IS2, IUT
      INTEGER   LENG, NS, NB, NT, J, IF, IS, IER, L
      INTEGER   NB1(MAXB), NB2(MAXB)
      INTEGER   LEN1, GETIN, VLBOPE
      REAL      REC(MAXL),PCTERR(MAXB), ERR, DUM
      DOUBLE PRECISION  STX(MAXS), STY(MAXS), STZ(MAXS), RA, DEC
      DOUBLE PRECISION  GASTM, FREQ, FLUX
      DOUBLE PRECISION  CHANGE(110)
      DATA CHANGE/110*0D0/
      CHARACTER NEWHIS*80
      CHARACTER INDSN*64,OUTDSN*64,LEGEND*110,TEXT*80
      CHARACTER SOURCE*16
      CHARACTER*8 STNAME(MAXS)
      CHARACTER*17 BNAME(MAXB)
      COMMON    /PARMS/ STNAME,STX,STY,STZ,
     1                  SOURCE,RA,DEC,GASTM,FREQ,FLUX
      COMMON    /ORDER/ NS,NB,NT, NB1, NB2
C-----------------------------------------------------------------------
C
C Introduction.
C
      CALL PUTOUT(PROGNM//' adds quadrature "calibration" errors')
      CALL PUTOUT('(Version '//VERSN//')')
      CALL PUTOUT(' ')
C
C Set up new History record
C
      CALL MKHIST(PROGNM, VERSN, NEWHIS)
C
C Start:  open files
C
  100 IER = GETIN(INDSN, 'Input file name: ', L)
      IF (IER.NE.1) STOP
      IER = VLBOPE(INDAT, INDSN, 'MERGE', 'OLD', INDSN)
      IF (IER.NE.1) GOTO 100
C
  110 IER = GETIN(OUTDSN, 'Output file name: ', L)
      IF (IER.NE.1) STOP
      IER = VLBOPE(OUTDAT, OUTDSN, 'MERGE', 'NEW', OUTDSN)
      IF (IER.NE.1) GOTO 110
C
C Read and rewrite header
C
      CALL HEADX15(.FALSE.,INDAT,IZ,ID,IY,%REF(NEWHIS),1,OUTDAT,DUM,
     1            CHANGE,IF,0)
      IF (NS.LT.2) CALL ERROR('Not enough stations.')
      IF (NS.GT.MAXS) CALL ERROR('Too many stations.')
      LENG = 4*NB + 2*NT
      IMON = 1
      CALL TDATE(IY,IMON,ID,JD,MONTH,DAY)
      LEGEND = ' '
      WRITE (LEGEND,'(1X,A3,I5,1X,2A8)') MONTH,IY,SOURCE
      DO 120 IS=1,NS
          LEGEND = LEGEND(1:LEN1(LEGEND))//' '//STNAME(IS)
  120 CONTINUE
      CALL PUTOUT(LEGEND(1:LEN1(LEGEND)))
C
C Baseline names
C
      DO 140 IB=1,NB
          IS1 = NB1(IB)
          IS2 = NB2(IB)
          BNAME(IB) = STNAME(IS1)(1:LEN1(STNAME(IS1)))//'-'//STNAME(IS2)
 140  CONTINUE
C
      CALL PUTOUT(' ')
      CALL PUTOUT('Supply percentage calibration errors:')
      DO 240 IB=1,NB
  230     IER = GETIN(TEXT, BNAME(IB)(1:LEN1(BNAME(IB)))//': ', L)
          IF (IER.NE.1) STOP
          READ (TEXT(1:L),*, ERR=230) PCTERR(IB)
          PCTERR(IB) = PCTERR(IB)/100.0
  240 CONTINUE
C
C (start loop: read and rewrite data records)
C
  150 READ (INDAT,END=170) IUT,(REC(J),J=1,LENG)
      IF (IUT.LT.0) GOTO 170
      DO 160 IB=1,NB
          ERR = REC(4*IB-2)
          IF (ERR.NE.0.0) REC(4*IB-2) =
     1          SIGN( SQRT(ERR**2 + (PCTERR(IB)*REC(4*IB-3))**2), ERR )
  160 CONTINUE
      WRITE (OUTDAT) IUT,(REC(J),J=1,LENG)
      GOTO 150
C
C (end loop)
C
  170 WRITE (OUTDAT) -1,(0.0,J=1,LENG)
C-----------------------------------------------------------------------
      END
