        PROGRAM CLAMP
C-----------------------------------------------------------------------
C Program to calculate 'closure amplitudes' for
C a standard MERGE-format file
C
C T.J. Pearson  1979 Nov 13
C Minor changes 29-Jul-1982
C Minor changes  4-Apr-1988
C-----------------------------------------------------------------------
      INTEGER   INC,OUTC,INDAT,PS,PR
      INTEGER   MAXS,MAXB,MAXT,MAXQ
      PARAMETER (INC=5,OUTC=6,INDAT=8,PS=1,PR=10,
     1           MAXS=15,MAXB=(MAXS-1)*MAXS/2,
     2           MAXT=(MAXS-2)*MAXB/3,
     3           MAXQ=3*(MAXS-3)*MAXT/4)
C
      REAL      REC(4*MAXB)
      REAL      AMP(MAXB), ERR(MAXB)
      REAL      AMPQ(MAXQ), ERRQ(MAXQ)
      REAL*8    STNAME,STX,STY,STZ,SOURCE,RA,DEC,GASTM,FREQ,FLUX
      LOGICAL   QUERY, FULL
      INTEGER   LABELB(MAXB), LABELQ(MAXQ), CONST(MAXQ,4)
      CHARACTER INDSN*64,LISTDSN*64,LEGEND*110
      CHARACTER NOW*20
      CHARACTER*14 OUTPUT(5)
      CHARACTER*8 Q,TIMEC
      COMMON    /PARMS/ STNAME(MAXS),STX(MAXS),STY(MAXS),STZ(MAXS),
     1            SOURCE(2),RA,DEC,GASTM,FREQ,FLUX
      COMMON    /ORDER/ NS,NB,NT, NB1(MAXB),NB2(MAXB)
C-----------------------------------------------------------------------
      IBNUM(I1,I2) = I1 + (I2-1)*(I2-2)/2
C-----------------------------------------------------------------------
  601 FORMAT(/1X,A)
  604 FORMAT(1X,I4,3X,I3,'/',A8,5A)
  606 FORMAT(/3X,'N',10X,'U.T.',2X,5(5X,I4,5X))
  607 FORMAT(1X)
  608 FORMAT('1Page',I3,2(2X,A))
  610 FORMAT(/' There are',I4,' closure amplitudes:'/)
  620 FORMAT(4X,I4,4X,I8,4X,I4,' * ',I4,' / ',I4,' * ',I4)
  630 FORMAT(2X,F5.2,1X,F5.2,1X)
  388 FORMAT(A3,I5,1X,2A8)
  389 FORMAT(2A)
C-----------------------------------------------------------------------
C Constants
C
      CALL DATTIM(NOW)
C
C Start:  open files
C
  710 WRITE (OUTC,389) '$Input file name: '
      READ (INC,389) INDSN
      OPEN (UNIT=INDAT, NAME=INDSN, READONLY, STATUS='OLD',
     1       FORM='UNFORMATTED', ERR=710)
      FULL = .NOT.QUERY('Do you want a BRIEF listing?')
  720 WRITE (OUTC,389) '$Name for listing file (default SYS$OUTPUT): '
      READ (INC,389) LISTDSN
      IF (LISTDSN.EQ.' ') LISTDSN = 'SYS$OUTPUT'
      OPEN (UNIT=PR, NAME=LISTDSN, STATUS='NEW', FORM='FORMATTED',
     1             ERR=720)
      OPEN (UNIT=PS,TYPE='SCRATCH',FORM='UNFORMATTED')
      NPAGE = 0
      IOUTP = 0
      IF (FULL) IOUTP=PR
C
C Read header
C
  100 NREC = 0
      NPAGE = NPAGE+1
      IF (FULL) WRITE (PR,608) NPAGE,NOW,INDSN
      WRITE (PR,607)
      WRITE (PR,607)
      CALL HEADX15(.FALSE.,INDAT,IZ,ID,IY,DUM1,0,0,DUM2,DUM3,IF,IOUTP)
      IF (IF.NE.0) GOTO 490
      IF (NS.LT.4) CALL ERROR('At least 4 stations needed!')
      IF (NS.GT.MAXS) CALL ERROR('Too many stations.')
      IMON = 1
      CALL TDATE(IY,IMON,ID,JD,MONTH,DAY)
      LEGEND = ' '
      WRITE (LEGEND,388) MONTH,IY,SOURCE
      DO 104 IS=1,NS
          DO 102 I=LEN(LEGEND),1,-1
              IF (LEGEND(I:I).NE.' ') GOTO 104
  102     CONTINUE
          I=1
          WRITE (LEGEND(I+2:),389) STNAME(IS)
  104 CONTINUE
      WRITE (PR,601) LEGEND
C
C Enumerate the closure-amplitudes
C
      IB = 0
      DO 140 I2=2,NS
          DO 140 I1=1,(I2-1)
              IB = IB+1
              LABELB(IB) = I2 + 100*I1
  140 CONTINUE
C
      IQ = 0
      DO 150 I4=4,NS
          DO 150 I3=3,(I4-1)
              DO 150 I2=2,(I3-1)
                  DO 150 I1=1,(I2-1)
                      IQ = IQ+1
                      LABELQ(IQ) = I4 + 100*(I3 + 100*(I2 + 100*I1))
                      CONST(IQ,1) = IBNUM(I1,I2)
                      CONST(IQ,2) = IBNUM(I3,I4)
                      CONST(IQ,3) = IBNUM(I1,I3)
                      CONST(IQ,4) = IBNUM(I2,I4)
                      IQ=IQ+1
                      LABELQ(IQ) = LABELQ(IQ-1)
                      CONST(IQ,1) = IBNUM(I1,I2)
                      CONST(IQ,2) = IBNUM(I3,I4)
                      CONST(IQ,3) = IBNUM(I2,I3)
                      CONST(IQ,4) = IBNUM(I1,I4)
                      IQ=IQ+1
                      LABELQ(IQ) = LABELQ(IQ-1)
                      CONST(IQ,1) = IBNUM(I2,I3)
                      CONST(IQ,2) = IBNUM(I1,I4)
                      CONST(IQ,3) = IBNUM(I1,I3)
                      CONST(IQ,4) = IBNUM(I2,I4)
  150 CONTINUE
      NQ = IQ
C
      WRITE (PR,610) NQ
      DO 160 IQ=1,NQ
          WRITE (PR,620) IQ, LABELQ(IQ), (LABELB(CONST(IQ,J)),J=1,4)
  160 CONTINUE
C
      IP=0
C
C (start loop)
C
  300 READ(INDAT,END=400) IUT,(REC(J),J=1,4*NB)
      IF (IUT.LT.0) GOTO 400
      DO 320 IB=1,NB
          AMP(IB) = REC(4*IB-3)
          ERR(IB) = REC(4*IB-2)
  320 CONTINUE
      DO 350 IQ=1,NQ
          AMPQ(IQ) = -1E6
          ERRQ(IQ) = 0.0
          DO 330 J=1,4
              IB = CONST(IQ,J)
              IF (ERR(IB).LE.0.0) GOTO 350
              ERRQ(IQ) = ERRQ(IQ) + (ERR(IB)/AMP(IB))**2
  330     CONTINUE
          AMPQ(IQ) = AMP(CONST(IQ,1)) * AMP(CONST(IQ,2))
     1               / AMP(CONST(IQ,3)) / AMP(CONST(IQ,4))
          ERRQ(IQ) = AMPQ(IQ)*SQRT(ERRQ(IQ))
  350 CONTINUE
      WRITE (PS) IUT,(AMPQ(IQ),ERRQ(IQ),IQ=1,NQ)
      NREC = NREC+1
      GOTO 300
C
C (end loop)
C
C Produce listing
C
  400 NPASS = NQ/5
      IF (NQ.GT.NPASS*5) NPASS=NPASS+1
      DO 450 IPASS=1,NPASS
          REWIND PS
          IQ1 = (IPASS-1)*5 +1
          IQ2 = MIN0(IQ1+4,NQ)
          DO 440 IREC=1,NREC
              READ(PS) IUT,(AMPQ(IQ),ERRQ(IQ),IQ=1,NQ)
              ND = IUT/(60*86400) +1
              Q = TIMEC(MOD(IUT/60,86400))
              IF (MOD(IREC,50).EQ.1 .AND. FULL) THEN
                  NPAGE=NPAGE+1
                  WRITE (PR,608) NPAGE,NOW,'Closure Amplitudes'
                  WRITE (PR,606) (IQ,IQ=IQ1,IQ2)
              END IF
              IF (MOD(IREC,10).EQ.1) WRITE (PR,607)
              NJ = IQ2-IQ1+1
              DO 430 J=1,NJ
                  OUTPUT(J) = '  '
                  IQ = IQ1+J-1
                  IF (AMPQ(IQ).NE.-1E6) WRITE (OUTPUT(J),630)
     1                                         AMPQ(IQ),ERRQ(IQ)
  430         CONTINUE
              WRITE (PR,604) IREC,ND,Q,(OUTPUT(J),J=1,NJ)
  440     CONTINUE
  450 CONTINUE
C
      REWIND PS
      GOTO 100
  490 CLOSE (UNIT=PS, DISPOSE='DELETE')
      CLOSE (UNIT=PR)
C-----------------------------------------------------------------------
      END
