       program ConVax
c--------------------------------------------------------------------------
c      ConVax translates files written in the CIT VLBI Merge format 
c      back and forth between VAX VMS files and Convex Unix files. Both
c      file types conform with the VMS and Convex Fortran disk I/O.
c      
c      This version of ConVax runs only on the Convex computer.
c 
c versn 1.1 : first release on unsuspecting public. JMB
c versn 1.2 : fixed read errors for data records larger than 2044 bytes. JMB
c
c---------------------------------------------------------------------------
c
       integer*4  maxstn,maxbas,maxclo,maxwpb,maxwrd
       parameter  (maxstn = 20)
       parameter  (maxwpb = 4)
       parameter  (maxbas = maxstn*(maxstn-1)/2)
       parameter  (maxclo = maxbas*(maxstn-2)/3)
       parameter  (maxwrd = maxwpb*maxbas + 2*maxclo + 1)
c
c      maxwrd = 3041, dimension arrays manually.
c
       integer*2  i2buff(2*3041),irtn,n3vms,nbvms,i2rec(2),
     *            n1vms,n2vms
       integer*4  ierr,fd,nbytes,rwmode,nchar,i4buff(3041),
     *            getlog, iswx, nrec1, nrec2, npts2, nread,
     *            n1024, n2046
       real*4     r4buff(3041)
       real*8     r8buff(1522)
       character*8   ctime,cdtime,usrlog,cuser
       character*9   cdate,cddate
       character*24  filnam,outfil
c
       integer*2  newhis(40)
       integer*4  iversn,nhist,nhrec,nsta,nbas,nclo,lrec,
     *            iunits,ndwpb,statyp,iyear,iut,npts,n4,nrecs
       real*8     source(2),ra,dec,rap,decp,flux
       real*8     stname,stx,sty,stz,word(9)
       real*8     gst,gastm,freq,tintg,avg,bw
c
       equivalence (i2buff(1),i4buff(1),r4buff(1),r8buff(1))
       equivalence (newhis(10),cuser), (newhis(16),cddate),
     *             (newhis(21),cdtime)
c
       data   newhis/'CO','NV','AX','  ',' :',' r','un',' b','y ',
     *        31*'  '/
c-------------------------------------------------------------------------
c
       call date (cdate)
       call time (ctime)
       irtn = getlog(usrlog)
       cddate = cdate
       cdtime = ctime
       cuser  = usrlog
c
       write (6,'(1x,a)') 'Program ConVax'
       write (6,'(1x,a)') 'Convert VMS merge file <--> Convex merge file'
       write (6,'(1x,a,/)') '(Version 1.2 - 1988 May 12)'
c
       write (6,'(1x,a,$)') 'VMS->Convex, Convex->VMS (0 or 1) : '
       read  (5,'(i4)') iswx
c
       write (6,'(1x,a,$)') 'VMS filename    : '
       read  (5,'(a)') filnam
c
       write (6,'(1x,a,$)') 'Convex filename : '
       read  (5,'(a)') outfil
c
       open (unit=10,file=outfil,form='unformatted',
     *       status='unknown')
c
       nchar = lnblnk(filnam)
       rwmode = 2
       call vmsopen (filnam,nchar,rwmode,fd,iswx,ierr)
       if (ierr.ne.0) go to 999
c
       if (iswx.eq.1) go to 500
C-----------------------------------------------------------------------
c      Convert VMS merge file into Convex merge file
c
       nbytes = 4
       call vmsread (fd,i2buff,nbytes,ierr)
       if (ierr.ne.0) go to 999
       call i2ti2 (i2buff,2)
c
       nbytes = i2buff(1) - 2
       nwords = nbytes / 4
       if (nbytes.ne.80) then
          write (6,'(1x,a,a)')filnam,' is not a VMS merge format file'
          go to 999
       end if
       call vmsread (fd,i4buff,nbytes,ierr)
       if (ierr.ne.0) go to 999
       call i4ti4 (i4buff,nwords)
c
       i4buff(2) = i4buff(2) + 1
       i4buff(3) = i4buff(3) + 1
       write (10) (i4buff(i),i=1,20)
c
       iversn = i4buff(1)
       nhist  = i4buff(2) - 1
       nhrec  = i4buff(3) - 1
       nsta   = i4buff(4)
       nbas   = i4buff(5)
       nclo   = i4buff(6)
       lrec   = i4buff(7)
       iunits = i4buff(8)
       if (iversn.eq.1) ndwpb = 4
       if (iversn.eq.2) ndwpb = 7
       if (iversn.ne.1) then
          write (6,'(1x,a)') 
     *    'Sorry, ConVax only supports merge format version 1'
          go to 999
       end if
C                                       read/write baseline record
       if (nbas.gt.0) then
          nbytes = 4
          call vmsread (fd,i2buff,nbytes,ierr)
          if (ierr.ne.0) go to 999
          call i2ti2 (i2buff,2)
          nbytes = i2buff(1) - 2
          call vmsread (fd,i4buff,nbytes,ierr)
          if (ierr.ne.0) go to 999
          nwords = nbytes / 4
          call i4ti4 (i4buff,nwords)
          write (10) (i4buff(i),i=1,nbas)
       end if
C                                       read/write closure triangle rec
       if (nclo.gt.0) then
          nbytes = 4
          call vmsread (fd,i2buff,nbytes,ierr)
          if (ierr.ne.0) go to 999
          call i2ti2 (i2buff,2)
          nbytes = i2buff(1) - 2
          call vmsread (fd,i4buff,nbytes,ierr)
          if (ierr.ne.0) go to 999
          nwords = nbytes / 4
          call i4ti4 (i2buff,nwords)
          write (10) (i4buff(i),i=1,nclo)
       end if
C                                       read/write history records
       do 100 i = 1, nhist
          nbytes = 84
          call vmsread (fd,i2buff,nbytes,ierr)
          if (ierr.ne.0) go to 999
          write (10) (i2buff(k),k=3,42)
 100   continue
       write (10) newhis
C                                       read/write source record
       nbytes = 4
       call vmsread (fd,i2buff,nbytes,ierr)
       if (ierr.ne.0) go to 999
       call i2ti2 (i2buff,2)
       nbytes = i2buff(1) - 2
       call vmsread (fd,r8buff,nbytes,ierr)
       if (ierr.ne.0) go to 999
       nwords = 5
       call v8tc8(r8buff(3),nwords)
       write (10) (r8buff(i),i=1,7)
C                                       read/write station records
       do 120 i = 1, nsta
          nbytes = 4
          call vmsread (fd,i2buff,nbytes,ierr)
          if (ierr.ne.0) go to 999
          call i2ti2 (i2buff,2)
          nbytes = i2buff(1) - 2
          call vmsread (fd,r8buff,nbytes,ierr)
          if (ierr.ne.0) go to 999
          call v8tc8 (r8buff(2),3)
          write (10) (r8buff(k),k=1,4)
 120   continue
C                                       read/write time/freq record
       nbytes = 4
       call vmsread (fd,i2buff,nbytes,ierr)
       if (ierr.ne.0) go to 999
       call i2ti2 (i2buff,2)
       nbytes = i2buff(1) - 2
       call vmsread (fd,r8buff,nbytes,ierr)
       if (ierr.ne.0) go to 999
       call i4ti4 (i4buff,2)
       call v8tc8 (r8buff(2),5)
       write (10) (i4buff(i),i=1,2),(r8buff(i),i=2,10)
C                                       read/write data records
       npts = ndwpb*nbas + 2*nclo + 1
       nbytes = 4 * npts
       n4 = 4
       nrecs = 0
       do 200 i = 1, 10000
          nrecs = nrecs + 1
          call vmsread (fd,i2rec,n4,ierr)
          if (ierr.ne.0) go to 999
          call i2ti2 (i2rec,2)
          n2word = (i2rec(1) - 2) / 2
          nread  =  i2rec(1) - 2
c
          call vmsread (fd,i2buff,nread,ierr)
          if (ierr.ne.0) go to 999
          if (nread.ne.nbytes) then
             call vmsread (fd,i2rec,n4,ierr)
             if (ierr.ne.0) go to 999
             call i2ti2 (i2rec,2)
             nread = i2rec(1) - 2
             indx = n2word + 1
             call vmsread (fd,i2buff(indx),nread,ierr)
             if (ierr.ne.0) go to 999
          end if
c
          call i4ti4 (i4buff,1)
          call r4tr4 (r4buff(2),npts-1)
          write (10) i4buff(1),(r4buff(k),k=2,npts) 
          if (i4buff(1).eq.-1) 
     *       write (6,'(1x,i6,a)')nrecs,' data records copied '
          if (i4buff(1).eq.-1) go to 999
 200   continue
       go to 999
c -------------------------------------------------------------------------
c      Convert Convex file into VMS file
c
 500   continue
c
       n4    = 4
       n1vms = 1
       n2vms = 2
       n3vms = 3
       call i2ti2 (n1vms,1)
       call i2ti2 (n2vms,1)
       call i2ti2 (n3vms,1)
c
c      Read first merge header record
       read (10) (i4buff(i),i=2,21)
c
       i4buff(3) = i4buff(3) + 1
       i4buff(4) = i4buff(4) + 1
       iversn  = i4buff(2)
       nhist   = i4buff(3)
       nhrec   = i4buff(4)
       nsta    = i4buff(5)
       nbas    = i4buff(6)
       nclo    = i4buff(7)
       lrec    = i4buff(8)
c
       if (iversn.eq.1) ndwpb = 4
       if (iversn.eq.2) ndwpb = 7
       if (iversn.ne.1) then
          write (6,'(1x,a)')
     *    'Sorry, ConVax only supports format version 1'
          go to 999
       end if
       if (iversn.ne.1.and.iversn.ne.2) then
          write (6,'(1x,a,i6)') ' Invalid merge format version number : ',
     *                       iversn
          go to 999
       end if
C                                       write the output record
       nbytes = 84
       i4buff(1)  = 82
       call i4ti4 (i4buff(1),21)
       i2buff(2) = n3vms
       call vmswrit (fd,i4buff,nbytes,ierr)
       if (ierr.ne.0) go to 999
C                                       read the baselines record
       if (nbas.gt.0) then
          read (10) (i4buff(i),i=2,nbas+1)
          nbytes = 4 * nbas + 4
          i4buff(1) = 4 * nbas + 2
          call i4ti4 (i4buff(1),nbas+1)
          i2buff(2) = n3vms
          call vmswrit (fd,i4buff,nbytes,ierr)
          if (ierr.ne.0) go to 999
       end if
C                                       read/write closure triangles
       if (nclo.gt.0) then
          read (10) (i4buff(i),i=2, nclo+1)
          nbytes = 4 * nclo + 4
          i4buff(1)  = 4 * nclo + 2
          call i4ti4 (i4buff(1),nclo+1)
          i2buff(2) = n3vms
          call vmswrit (fd,i4buff,nbytes,ierr)
          if (ierr.ne.0) go to 999
       end if
C                                       read/write history records
       do 600 i = 1, nhist-1
          read (10) (i4buff(k),k=2,21)
          nbytes = 80 + 4
          i4buff(1)  = 82
          call i4ti4(i4buff(1),1)
          i2buff(2) = n3vms
          call vmswrit (fd,i4buff,nbytes,ierr)
          if (ierr.ne.0) go to 999
 600   continue
       i4buff(1) = 82
       call i4ti4 (i4buff(1),1)
       i2buff(2) = n3vms
       nbytes = 4
       call vmswrit (fd,i4buff,nbytes,ierr)
       nbytes = 80
       call vmswrit (fd,newhis,nbytes,ierr)
       if (ierr.ne.0) go to 999
C                                       read/write source record
       i4buff(1) = 56 + 2
       call i4ti4 (i4buff(1),1)
       i2buff(2) = n3vms
       call vmswrit (fd,i4buff,n4,ierr)
       if (ierr.ne.0) go to 999
       read (10) (r8buff(i),i=1,7)
       call c8tv8 (r8buff(3),5)
       nbytes = 56
       call vmswrit (fd,r8buff,nbytes,ierr)
       if (ierr.ne.0) go to 999
C                                       read/write stn records
       do 700 i = 1, nsta
          i4buff(1) = 4 * 8 + 2
          call i4ti4 (i4buff(1),1)
          i2buff(2) = n3vms
          call vmswrit (fd,i4buff,n4,ierr)
          if (ierr.ne.0) go to 999
c
          read (10) (r8buff(k),k=1,4)
          call c8tv8 (r8buff(2),3)
          nbytes = 4 * 8
          call vmswrit (fd,r8buff,nbytes,ierr)
          if (ierr.ne.0) go to 999
 700   continue
C                                       read/write time/freq recor
       i4buff(1) = 80 + 2
       call i4ti4 (i4buff(1),1)
       i2buff(2) = n3vms
       call vmswrit (fd,i4buff(1),n4,ierr)
       if (ierr.ne.0) go to 999
c
       read (10) (r8buff(k),k=1,10)
       call i4ti4 (i4buff(1),2)
       call i4ti4 (i4buff(13),8)
       call c8tv8 (r8buff(2),5)
       nbytes = 80
       call vmswrit (fd,i4buff(1),nbytes,ierr)
       if (ierr.ne.0) go to 999
C                                       read/write data records
       npts = ndwpb*nbas + 2*nclo + 1
       nbytes = 4 * npts + 4
       nrecs = 0
       do 800 i = 1, 10000
          nrecs = nrecs + 1
          read (10) (r4buff(k),k=2,npts+1)
          i4buff(1) = 4 * npts + 2
          iend  = i4buff(2)
c
          if (nbytes.le.2046) then
             call i4ti4(i4buff(1),2)
             i2buff(2) = n3vms
             call r4tr4 (r4buff(3),npts-1)
             call vmswrit (fd,i4buff(1),nbytes,ierr)
c
          else
             nrec2 = 4 * npts - 2042
             n1024 = 1024
             n2046 = 2046
             i4buff(1) = 2044
             call i4ti4 (i4buff(1),2)
             i2buff(2) = n1vms
             call r4tr4 (r4buff(3),npts-1)
             call vmswrit (fd,i2buff(1),n2046,ierr)
             i4buff(1) = nrec2 + 2
             call i4ti4 (i4buff(1),1)
             i2buff(2) = n2vms
             call vmswrit (fd,i4buff(1),n4,ierr)
             call vmswrit (fd,i2buff(n1024),nrec2,ierr)
          end if
c
          if (iend.eq.-1) then   
             write (6,'(1x,i6,a)') nrecs,' records copied'
             go to 999
          end if
c
 800   continue          
c             
 999   continue
       stop
       end
