C-----------------------------------------------------------------------
C ERRFIT.INC
C Revised 1989 Oct 31: 72 columns [TJP].
C Revised 1989 Nov 21: increase MXREC [TJP].
C-----------------------------------------------------------------------
C     This common block is used by the program ERRFIT and all of its
C     associated subroutines, via INCLUDE statements.
C
      PARAMETER (MXSTA=15)      ! Maximum number of stations in data
      PARAMETER (MXBAS=MXSTA*(MXSTA-1)/2)   ! Max. no. of baselines
      PARAMETER (MXTRI=MXBAS*(MXSTA-2)/3)   ! Max. no. of triangles
      PARAMETER (MXICLO=(MXBAS-1)*(MXBAS-2)/2) ! Max. no. of ind. tri.
      PARAMETER (MAXWPB=7)
      PARAMETER (MXPAR=20)      ! Max. no. of var. parameters
      PARAMETER (MXREC=350)     ! Max. no. of data records
      PARAMETER (MXMOD=15)      ! Max. no. of model components
      INTEGER INC,OUTC,INDAT,INMOD,PR
      PARAMETER (INC=5,OUTC=6,INDAT=8,INMOD=9,PR=10)
C
      REAL PI,DEGRAD,RADHRS,TWOPI,HALFPI,SIDR,VELC,CONV1
      INTEGER PARWHO
      COMPLEX MODDT0
      PARAMETER (PI=3.1415927)            ! pi
      PARAMETER (DEGRAD=PI/180.)          ! degrees per radian
      PARAMETER (RADHRS=1./(DEGRAD*15.))  ! Hours of UT per radian
      PARAMETER (TWOPI=2.*PI)             ! pi*2
      PARAMETER (HALFPI=PI/2.)            ! pi/2
      PARAMETER (SIDR=1.0027379093)       ! sec of ST per sec of UT
      PARAMETER (VELC=2.997925E8)         ! speed of light
      PARAMETER (CONV1 = 2.0626481E8)     ! msec of arc per radian
C
      COMMON
C
C     Model parameters:
     1   FLUX(MXMOD), RADIUS(MXMOD), THETA(MXMOD), AXIS(MXMOD),
     2   RATIO(MXMOD), PHI(MXMOD), TYPE(MXMOD), RTHETA(MXMOD),
     3   RPHI(MXMOD), NCOMP,
C
C     Amplitude related data:
     4   UDATA(MXREC,MXBAS), VDATA(MXREC,MXBAS), OBSVIS(MXREC,MXBAS),
     5   WTVIS(MXREC,MXBAS), MODVIS(MXREC,MXBAS),
C
C     Closure phase related variables:
     7   OBSCLO(MXREC,MXTRI), WTCLO(MXREC,MXTRI), MODCLO(MXREC,MXTRI),
     8   ICBSNO(3,MXTRI), NUMCLO(MXREC), DOWNWT(MXREC),
C
C     Variables to describe limits of data:
     9   NINDCL, NUMBAS, NUMREC, NUMSTA, NUMTRI, NZCLO(MXTRI), TNZCLO,
     1   NZVIS(MXBAS), NZAMP, NINTRI(MXREC), LAMBDA, UT(MXREC), OUTPR,
C
C     Variables used in the calculation of agreement factors:
     2   VISAF(MXBAS), CLOAF(MXTRI), AMPLAF, PHASAF, TOTLAF, 
     3   AMPLA0, PHASA0, TOTLA0, NU0, DELTAF,
C
C     Variables used in error estimate
     1   MODDT0(MXREC,MXBAS), VISPLU(MXREC,MXBAS), CLOPLU(MXREC,MXTRI),
     2   VISDEL(MXREC,MXBAS,MXPAR), CLODEL (MXREC,MXTRI,MXPAR),
     3   AMAT(MXPAR,MXPAR), RMAT(MXPAR,MXPAR), PARWHO(MXPAR,2), NUMPAR
C
      COMMON /PARMS/
     1   STNAME(MXSTA), STX(MXSTA), STY(MXSTA), STZ(MXSTA), SOURCE(2),
     2   RAP, DECP, GASTM, FREQ, IDAY, IYEAR, FLUX1
C
      COMMON /ORDER/
     1   NSTA, NBAS, NTRI, NAVIS(MXBAS), NBVIS(MXBAS),
     2   NACLO(MXTRI), NBCLO(MXTRI), NCCLO(MXTRI), NVER, NDWPB
C
      COMMON /STRINGS/
     1   INDSN, MODDSN, OUTDSN
C
      REAL  MODVIS, MODCLO, LAMBDA
      REAL*8      STNAME, STX, STY, STZ, SOURCE, RAP, DECP, GASTM, FREQ,
     1            FLUX1
C
      CHARACTER*64      INDSN, MODDSN, OUTDSN
C
      INTEGER     NZCLO, NZVIS, TYPE, OUTPR, ICBSNO
C-----------------------------------------------------------------------
