      PROGRAM EVNMERGE
C-----------------------------------------------------------------------
C Merge EVN120 files into standard MERGE format.
C
C T.J.Pearson
C Version 1.0:  1984 Jun 5
C Version 2.1:  1990 Feb 1 - revised for Unix (Sun/Convex).
C-----------------------------------------------------------------------
      CHARACTER*(*) VERSN,VERSD
      PARAMETER (VERSN='EVN,2.1',VERSD='1990 Feb 1')
      INTEGER   INC,OUTC,INDAT,OUTDAT
      PARAMETER (INC=5, OUTC=6, INDAT=10, OUTDAT=12)
      PARAMETER (MAXFILES=100)
C
      CHARACTER*64  INDSN(MAXFILES),OUTDSN
      INCLUDE 'merge64.inc'
      INTEGER       GETIN, LEN1, VLBOPE
      LOGICAL       CALIB
      LOGICAL       QUERY
C-----------------------------------------------------------------------
C
C File names.
C
      CALL PUTOUT('EVNMERGE extracts visibility data for one source '//
     1            'from EVN120 files')
      CALL PUTOUT('(Version '//VERSN//' '//VERSD//')')
      CALL PUTOUT(' ')
      IER = GETIN(OUTDSN, 'Output (MERGE) file name: ', L)
      IF (IER.NE.1) STOP
      IER = VLBOPE(OUTDAT, OUTDSN, 'MERGE', 'NEW', OUTDSN)
      IF (IER.NE.1) STOP
C
C Set up Header information.
C
      MODE = 0
      CALL MRG_PARAM(MODE,INC,OUTC,VERSN)
C
C Read EVN120 files.
C
      CALL PUTOUT(' ')
      CALL PUTOUT('List input file names - wild cards accepted.')
      CALL PUTOUT('End list with blank line or ^Z (VMS) or ^D (UNIX)')
      NFILE = 0
      CALL MRG_FFIND(NF,INDSN,MAXFILES,INC,OUTC)
      CALIB = QUERY('Are the data calibrated (Jy) [YES or NO]? ')
      DO J=1,NF
          LDSN = LEN1(INDSN(J))
          OPEN(UNIT=INDAT,FILE=INDSN(J),STATUS='OLD',FORM='FORMATTED',
     1            READONLY,IOSTAT=K)
          IF (K.NE.0) THEN
              WRITE (OUTC,70) INDSN(J)(1:LDSN)
          ELSE
              CALL MRG_EVN(INDSN(J),INDAT,OUTC,NFILE, CALIB)
              CLOSE(UNIT=INDAT)
          END IF
      END DO
C
C Write new dataset.
C
      IF (NFR.GT.0) THEN
          CALL MRG_OUTPUT(OUTDSN,OUTDAT,OUTC)
          CLOSE(UNIT=OUTDAT,DISPOSE='KEEP')
          WRITE (OUTC,40) OUTDSN(1:LEN1(OUTDSN)),NFR
      ELSE
          CLOSE(UNIT=OUTDAT,DISPOSE='DELETE')
          CALL ERROR('No data found for requested source')
      END IF
C
      STOP
C
C Format statements.
C
   40 FORMAT(/' Output in file: ',A/I6,' data records')
   70 FORMAT(' +++ERROR+++ Cannot read file ',A)
C
      END

      SUBROUTINE MRG_EVN(INFILE,IN,PR,NFILE,CALIB)
      CHARACTER*(*) INFILE
      INTEGER IN, PR
      LOGICAL CALIB
C-----------------------------------------------------------------------
C Read EVN120 files from unit 'IN' and merge with existing data.
C
C Format of EVN120 data records is:
C
C day, ut, int-time, ampl, err, phase, err, rate, delay, rate error,
C base, source, u, v, int_HA, gst, quality code
C FORMAT (3I3,F5.1, I5, F7.3, F6.3, F6.1, F5.1, F11.7, F9.3, F4.1, 1X,
C         2A2, A8, 2F10.4, F9.4, F8.3, I3)
C This program looks at only day, ut, ampl, err, phase, err, base, 
C source.
C-----------------------------------------------------------------------
      REAL*8  TWOPI
      PARAMETER (TWOPI=3.141592653589793 D0 * 2D0)
      INCLUDE 'merge61.inc'
      INCLUDE 'merge62.inc'
      INCLUDE 'merge63.inc'
      INCLUDE 'merge64.inc'
C
      CHARACTER*132 RECORD
      CHARACTER*8   SRC,STA
      CHARACTER*2   STN(2)
      REAL          AMP,AMPERR,PHS,PHSERR
      REAL*8        SX,SY,SZ
      INTEGER       UT,IS(2)
C
  600 FORMAT (3I3,F5.1,5X,F7.3,F6.3,F6.1,F5.1)
  640 FORMAT (/' File: ',A)
  650 FORMAT (I6,' records extracted from a total of',I6)
C-----------------------------------------------------------------------
C
C Initialize.
C
      NREC = 0
      NWANT = 0
      WRITE (PR,640) INFILE
C
C Calibration flag.
C
      KFLAG = 0
      IF (CALIB) KFLAG = 1
C
C Read next record.
C
  100 READ (IN,'(A)',END=210) RECORD
      NREC = NREC+1
      IF (RECORD(1:4).EQ.'EXP ') THEN
          READ (RECORD,'(12X,F14.3,F12.3)',ERR=100) HFREQ,HBW
          HFREQ = HFREQ*1D6
          HBW = HBW*1D6
      ELSE IF (RECORD(1:4).EQ.'RUN ') THEN
          READ (RECORD,'(4X,I2,I3,3X,2I2,F8.5)',ERR=100) 
     1                  HYEAR,HUTF,II,JJ,SS
          HYEAR = HYEAR+1900
          HUTF = (HUTF-1)*24*60*60*60
          HGST = (II+JJ/60D0+SS/3600D0)*TWOPI/24D0
      ELSE IF (RECORD(1:4).EQ.'SOUR') THEN
          SRC = RECORD(5:12)
          CALL UPCASE(SRC)
          IF (HSRC.EQ.' ') HSRC = SRC
          READ (RECORD,'(12X,F10.3)',ERR=100) HFLUX
          READ (RECORD,'(24X,2I2,F6.3)',ERR=100) II,JJ,SS
          HRA50 = (II+JJ/60D0+SS/3600D0)*TWOPI/24D0
          READ (RECORD,'(36X,2I2,F6.3)',ERR=100) II,JJ,SS
          HDEC50 = (II+JJ/60D0+SS/3600D0)*TWOPI/360D0
          IF (RECORD(36:36).EQ.'-') HDEC50 = -HDEC50
          READ (RECORD,'(48X,2I2,F6.2)',ERR=100) II,JJ,SS
          HRAP = (II+JJ/60D0+SS/3600D0)*TWOPI/24D0
          READ (RECORD,'(60X,2I2,F6.2)',ERR=100) II,JJ,SS
          HDECP = (II+JJ/60D0+SS/3600D0)*TWOPI/360D0
          IF (RECORD(60:60).EQ.'-') HDECP = -HDECP
      ELSE IF (RECORD(1:4).EQ.'ANT ') THEN
          READ (RECORD,'(4X,A8,F15.2,F15.2,F15.2)',ERR=100)
     1            STA,SX,SY,SZ
          DO I=1,NS
            IF (STA.EQ.OSTATN(I).OR.STA.EQ.NSTATN(I)) THEN
                HX(I) = SX
                HY(I) = SY
                HZ(I) = SZ
            END IF
          END DO
C
C Data record.
C
      ELSE
          SRC = RECORD(73:80)
          CALL UPCASE(SRC)
          IF (HSRC.EQ.' ') HSRC = SRC
          IF ((SRC.NE.HSRC).AND.(SRC.NE.HALIAS).AND.
     1            (HSRC.NE.'ALL')) GOTO 100
          STN(1) = RECORD(69:70)
          STN(2) = RECORD(71:72)
          IS(1) = 0
          IS(2) = 0
          CALL UPCASE(STN(1))
          CALL UPCASE(STN(2))
          DO I=1,NS
            IF (STN(1).EQ.OSTATN(I)(1:2)) IS(1) = I
            IF (STN(2).EQ.OSTATN(I)(1:2)) IS(2) = I
          END DO
          IF (IS(1).EQ.0 .OR. IS(2).EQ.0 .OR. IS(1).EQ.IS(2)) GOTO 100
          IF (IS(1).LT.IS(2)) THEN
C               ! note sign change
                SIGN=-1
                IBASE=IS(1)+(IS(2)-1)*(IS(2)-2)/2
          ELSE
C               ! note sign change
                SIGN=+1
                IBASE=IS(2)+(IS(1)-1)*(IS(1)-2)/2
          END IF
          READ (RECORD,600)  ID,IH,IM,RS, AMP,AMPERR,PHS,PHSERR
          NWANT = NWANT+1
          UT = 60*NINT((ID-1)*86400 + IH*3600 +IM*60 + RS)
          I0 = MRG_LOC(UT) + 4*(IBASE-1)
          IF (CALIB) THEN
              STORE(I0)   = AMP
              STORE(I0+1) = AMPERR
          ELSE
              STORE(I0)   = AMP*1E-6
              STORE(I0+1) = AMPERR*1E-6
          END IF
          STORE(I0+2) = PHS*SIGN
          STORE(I0+3) = PHSERR
      END IF
      GOTO 100
C
  210 WRITE (PR,650) NWANT, NREC
C
      END
