      PROGRAM GAINPL
C-----------------------------------------------------------------------
C GAINPLOT: plot gain curves.
C
C Author:            T.J. Pearson (TJP)
C Language:          Fortran-77
C
C Modifications:
C Version 1.0:  1989 Feb  2 - new program [TJP].
C Version 1.1:  1989 Oct  4 - correct errot in labelling [TJP].
C-----------------------------------------------------------------------
C
C Constants
C
      CHARACTER*(*) PROGNM, VERSN
      INTEGER    INC,OUTC,NPARS,MAXPT
      PARAMETER  (PROGNM='GAINPLOT')
      PARAMETER  (VERSN='1.1 - 1989 Oct 4')
C     -- unit numbers
      PARAMETER  (INC=5,OUTC=6)
C     -- number of parameters
      PARAMETER  (NPARS=38)
C     -- number of points in curve
      PARAMETER  (MAXPT=200)
C
C Input parameters
C
      DOUBLE PRECISION NAMES(NPARS),PARS(NPARS),ENDMRK
      DATA    ENDMRK/ '/' /
      DATA    NAMES / 'PLOtfile', 9*' ', 
     1                2*'NPxy',
     2                'LInewidt', 'FONt', 'CHarsize',
     3                2*'Xrange', 2*'Yrange',
     4                'TYpe', ' ',
     5                6*'POLynomi',
     6                'TItle', 9*' ', 
     7                'EXit'/
      DATA    PARS  / '?', 9*' ',
     1                1D0, 1D0,
     2                1D0, 1D0, 1D0,
     3                2*0D0, 0D0, 1.5D0,
     4                'ALTAZ', ' ',
     5                1D0, 5*0D0,
     6                'Gain Cur','ve',8*' ',
     7                -1D0 /
C
C Variables.
C
      INTEGER        I, J, MODE, NPX, NPY, NPXOLD, NPYOLD
      INTEGER        LINEW, FONT, ITYPE, IER, MM, PP, L, NC
      INTEGER        PGBEGIN, LEN1
      REAL           CFIT(6), XM(MAXPT), YM(MAXPT), CHSIZ
      REAL           X, X1, X2, Y1, Y2, XLEN, XINC, C
      CHARACTER*128  PLTFIL, PLTOLD
      CHARACTER*128  TITLE, XLABEL, LEGEND
      CHARACTER*16   TYPE
      CHARACTER*32   T
C-----------------------------------------------------------------------
C
C Introduction.
C
      CALL PUTOUT(PROGNM//' plots gain curves')
      CALL PUTOUT('(Version '//VERSN//')')
      CALL PUTOUT(' ')
      CALL PUTOUT('Control parameters (end with /):')
C
      PLTOLD = '*** UNSPECIFIED ***'
      NPXOLD = 1
      NPYOLD = 1
C
C Read control parameters.
C
 1000 MODE = 0
      CALL KEYIN(NAMES,PARS,NPARS,ENDMRK,MODE,INC,OUTC)
C     -- test for end-of-file or EXIT
      IF (MODE.EQ.1) GOTO 2000
      IF (PARS(38).NE.-1D0) GOTO 2000
C     -- PLOTFILE
      WRITE (PLTFIL,'(10A8)') (PARS(J),J=1,10)
C     -- NPX, NPY
      NPX   = PARS(11)
      NPY   = PARS(12)
C     -- Linewidth, Font, and Charsize
      LINEW = PARS(13)
      FONT  = PARS(14)
      CHSIZ = PARS(15)
C     -- Xrange, Yrange
      X1  = PARS(16)
      X2  = PARS(17)
      Y1  = PARS(18)
      Y2  = PARS(19)
C     -- Type
      WRITE (TYPE, '(2A8)') PARS(20), PARS(21)
      CALL UPCASE(TYPE)
      IF (TYPE.EQ.'ALTAZ') THEN
          ITYPE = 1
          XLABEL = 'Zenith Angle (degrees)'
          X1 = 0.0
          X2 = 90.0
      ELSE IF (TYPE.EQ.'EQUAT') THEN
          ITYPE = 2
          XLABEL = 'Hour Angle (hours)'
          X1 = -6.0
          X2 = 6.0
      ELSE
          CALL PUTOUT(' ++ Invalid TYPE = '//TYPE)
          GOTO 1000
      END IF
C     -- Poly
      CFIT(1) = PARS(22)
      CFIT(2) = PARS(23)
      CFIT(3) = PARS(24)
      CFIT(4) = PARS(25)
      CFIT(5) = PARS(26)
      CFIT(6) = PARS(27)
C     -- Title
      WRITE (TITLE,'(10A8)') (PARS(J),J=28,37)
C
C Make legend.
C
      LEGEND = 'POLY = '
      L = LEN1(LEGEND)
      DO 1300 I=1,6
          C = CFIT(I)
          IF (C.EQ.0.0) THEN
              PP = 0
              MM = 0
          ELSE
              PP = NINT(ALOG10(ABS(C)))-4
              MM = NINT(C*10.0**(-PP))
          END IF
          CALL PGNUMB(MM, PP, 0, T, NC)
          IF (I.GT.1) THEN
              LEGEND = LEGEND(1:L)//', '
              L = L+2
          END IF
          LEGEND = LEGEND(1:L)//T(:NC)
          L = L+NC
 1300 CONTINUE
C
C Open plot file (if necessary).
C
      IF (PLTFIL.NE.PLTOLD .OR. NPX.NE.NPXOLD .OR. NPY.NE.NPYOLD) THEN
          IER = PGBEGIN(7,PLTFIL,NPX,NPY)
          IF (IER.NE.1) GOTO 1000
          CALL PGASK(.FALSE.)
          PLTOLD = PLTFIL
          NPXOLD = NPX
          NPYOLD = NPY
      END IF
C
C Set plot attributes.
C
      CALL PGSLW(LINEW)
      CALL PGSCF(FONT)
      CALL PGSCH(CHSIZ)
C
C Calculate model curve.
C
      XLEN = X2-X1
      XINC = XLEN / FLOAT(MAXPT-1)
      DO 1500 I=1,MAXPT 
          XM(I) = X1 + (I-1)*XINC
          X = XM(I)
          YM(I) = ((((CFIT(6)*X + CFIT(5))*X + CFIT(4))*X + 
     1               CFIT(3))*X + CFIT(2))*X + CFIT(1)
 1500 CONTINUE
C
C Draw graph.
C
      CALL PGBBUF
      CALL PGENV(X1,X2,Y1,Y2,0,0)
      CALL PGLABEL(XLABEL, 'Relative Gain', ' ')
      CALL PGMTEXT('T', 2.5, 0.0, 0.0, TITLE)
      CALL PGMTEXT('T', 0.5, 0.0, 0.0, LEGEND) 
      CALL PGLINE(MAXPT ,XM, YM)
      CALL PGEBUF
C
C Get more parameters.
C
      GOTO 1000
C
C Finish.
C
 2000 CALL PGEND
      END
