C-----------------------------------------------------------------------
C IED.INC
C-----------------------------------------------------------------------
C These common blocks are used by the program IED and most of its
C associated subroutines, via INCLUDE statements.
C
      INTEGER PARMU,INU,OUTU,INDAT,OUTDAT,LENDSN
      INTEGER MXSTA,MXBAS,MXTRI,MXREC,MXWIN,MXCUT,MAXWPB
      PARAMETER (INU=5)
C                Fortran unit for input
      PARAMETER (OUTU=6)
C                Fortran init for terminal output
      PARAMETER (PARMU=10)
C                Fortran unit for parameter file
      PARAMETER (INDAT=11)
C                Fortran unit for input data file
      PARAMETER (OUTDAT=12)
C                Fortran unit for output data file
      PARAMETER (LENDSN=80)
C                Length of file names
      PARAMETER (MXSTA=20)
C                Maximum number of stations in data
      PARAMETER (MXBAS=MXSTA*(MXSTA-1)/2)
C                Max. no. of baselines
      PARAMETER (MXTRI=MXBAS*(MXSTA-2)/3)
C                Max. no. of triangles
      PARAMETER (MXREC=5000)
C                Max. no. of data records
      PARAMETER (MXWIN=40)
C                Max. no. of windows in the plot
      PARAMETER (MXCUT=MXWIN-1)
C                Max. no. of cuts allowed
      PARAMETER (MAXWPB=7)
C
      INTEGER BLACK,WHITE,RED,GREEN,BLUE,CYAN,MAGEN,YELLOW
      PARAMETER (BLACK=0,WHITE=1,RED=2,GREEN=3,BLUE=4,CYAN=5,
     1     MAGEN=6,YELLOW=7)
C
C     -- Limits, etc.
      INTEGER NUMREC, NPLOT, NPLOT0, IDATA, ISTA1, ISTA2, ISTA3
      INTEGER L1NAME, L2NAME, L3NAME, IER
C     -- Data
      REAL    UT(MXREC), AMP(MXREC), ERRAMP(MXREC), CLOS(MXREC)
      REAL    ERRCLO(MXREC), PHS(MXREC), ERRPHS(MXREC)
C     -- Variables for plotting arrays
      REAL    XP(2), YP(2), XDATA(MXREC), Y1DATA(MXREC), Y2DATA(MXREC)
      INTEGER NDATA(MXREC)
      REAL    XMINN, XMAXX, YMINN, YMAXX
      INTEGER ICOLOR(MXREC), IPOINT, NWIND
      LOGICAL SAMETT, WSDEV, VMS
      LOGICAL PLTBAR, TRYONE, PLTAMP, PLTPHS, NEWPLT

C
      COMMON /IEDCOM/
     1  UT, AMP, ERRAMP, CLOS,
     2  ERRCLO, PHS, ERRPHS,
     3  NUMREC, NPLOT, NPLOT0, IDATA, ISTA1, ISTA2, ISTA3,
     4  L1NAME, L2NAME, L3NAME,
     5  IER, PLTBAR, TRYONE, PLTAMP, PLTPHS, NEWPLT,
     6  XP, YP, XDATA, Y1DATA, Y2DATA, 
     7  NDATA, ICOLOR, IPOINT, XMINN, XMAXX, YMINN, YMAXX,
     8  NWIND, SAMETT, WSDEV, VMS
C
C Common block PARMS contains header data from input file.
C
      DOUBLE PRECISION 
     1  STNAME(MXSTA), STX(MXSTA), STY(MXSTA), STZ(MXSTA), SOURCE(2), 
     2  RAP, DECP, GASTM, FREQ, FLUX
      COMMON /PARMS/
     1  STNAME, STX, STY, STZ, SOURCE,
     2  RAP, DECP, GASTM, FREQ, FLUX
C
C Common block ORDER contains header data from input file.
C
      INTEGER NSTA, NBAS, NTRI
      INTEGER NAVIS(MXBAS), NBVIS(MXBAS)
      INTEGER NACLO(MXTRI), NBCLO(MXTRI), NCCLO(MXTRI)
      INTEGER NVER, NDWPB
      COMMON /ORDER/ NSTA, NBAS, NTRI, NAVIS, NBVIS,
     1               NACLO, NBCLO, NCCLO, NVER, NDWPB
C
C Miscellaneous character variables.
C
      CHARACTER*(LENDSN) DATDSN,EDIDSN,PRMDSN,PLTOUT
      CHARACTER*8  S1NAME,S2NAME,S3NAME
      CHARACTER*12 DEVTYP
      COMMON /STRING/ 
     1      DATDSN, EDIDSN, PRMDSN, PLTOUT, S1NAME, S2NAME, S3NAME, 
     2      DEVTYP
C
C Window-related data.
C
      INTEGER NCUTS, NEWNCU
      REAL    XCUT(MXCUT), YCUT(MXCUT), XMIN(MXWIN)
      REAL    XMAX(MXWIN), YBOT(MXWIN), YTOP(MXWIN)
      COMMON /IEDWIN/
     1      NCUTS, NEWNCU, XCUT, YCUT, XMIN,
     2      XMAX, YBOT, YTOP
C-----------------------------------------------------------------------
