C-----------------------------------------------------------------------
C VLBINC:MERGE63.INC : Include file for VLBMERGE control parameters.
C-----------------------------------------------------------------------
C HSRC      : requested source name [parameter SOURCE] 
C          => output Merge source name
C HALIAS    : requested source alias [parameter ALIAS]
C OSTATN    : requested station names [parameter STATIONS]
C NSTATN    : requested new station names [parameter NEWSTATIONS]
C          => output Merge station names
C GETFR     : if TRUE, extract fringe-frequencies (Phasor files only)
C             [parameter FRINGE-RATES]
C FIXPHS    : if TRUE, apply phase corrections (Phasor files only)
C KLOSE     : controls extraction/computation of closure phases
C             [parameter CLOSE]
C NCHANL    : requested channel number [parameter CHANNEL]
C TFREQ     : requested frequency [parameter FREQUENCY]
C TBAND     : requested frequency tolerance [parameter BANDWIDTH]
C
C Header parameters for output Merge file:
C
C NVER      : output Merge format version
C NHEAD     : output Merge count of header records
C NS        : output Merge count of stations
C NB        : output Merge count of baselines
C NT        : output Merge count of closure triangles
C LENG      : output Merge data record length
C KFLAG     : output Merge calibration status
C HYEAR     : output Merge year
C HUTF      : output Merge fiducial UT
C HRA50     : output Merge RA (1950)
C HDEC50    : output Merge Dec (1950)
C HRAP      : output Merge RA (date)
C HDECP     : output Merge Dec (date)
C HFLUX     : output Merge flux density
C             [initial value from parameter FLUX]
C HX        : output Merge station X coordinates
C HY        : output Merge station Y coordinates
C HZ        : output Merge station Z coordinates
C HGST      : output Merge GST at fiducial UT
C HFREQ     : output Merge frequency (Hz)
C HINTEG    : output Merge coherent integration time (s)
C HAVG      : output Merge average time (s)
C HBW       : output Merge bandwidth (Hz)
C-----------------------------------------------------------------------
      LOGICAL        GETFR,FIXPHS
      INTEGER        KLOSE,NCHANL
      INTEGER        NVER,NHEAD,NS,NB,NT,LENG,KFLAG,HYEAR,HUTF
      REAL*8         HRA50,HDEC50,HRAP,HDECP,HFLUX
      REAL*8         HX(MAXS),HY(MAXS),HZ(MAXS),HGST,HFREQ,HINTEG
      REAL*8         HAVG,HBW,TFREQ,TBAND
      CHARACTER*16   HSRC,HALIAS
      CHARACTER*8    OSTATN(MAXS),NSTATN(MAXS)
      COMMON /INFO/  HRA50,HDEC50,HRAP,HDECP,HFLUX,
     1               HX,HY,HZ,HGST,HFREQ,HINTEG,
     2               HAVG,HBW,TFREQ,TBAND,
     3               KLOSE,NCHANL,
     4               NVER,NHEAD,NS,NB,NT,LENG,KFLAG,HYEAR,HUTF,
     5               GETFR,FIXPHS
      COMMON /INFOC/ HSRC,HALIAS,OSTATN,NSTATN
C-----------------------------------------------------------------------
