C-----------------------------------------------------------------------
C VLBINC:MERGE64.INC : include file for VLBMERGE storage arrays.
C-----------------------------------------------------------------------
C Storage for amplitudes and phases.
C If MERGE dies with an "out of storage" message, one or both of the
C parameters in this file will have to be increased.
C
C MAXIND    : maximum number of records in output file.
C MAXSTR    : number of available storage words (real*4).
C NFR       :
C LAST      :
C NCELLS    : number of storage cells allocated for each record; this
C             will be 4 x NB if closure phases are not to be stored,
C             (4 x NB) + (2 x NT) if they are.
C FRINDX    : array containing the UT for each output record. The
C             entries are kept in increasing UT order.
C SPINDX    : the subscript of array STORE of the first storage cell
C             allocated to the record whose time is stored in the
C             corresponding element of FRINDX.
C STORE     : storage array.
C-----------------------------------------------------------------------
      INTEGER        MAXIND,MAXSTR
      PARAMETER      (MAXIND=5000)
      PARAMETER      (MAXSTR=5000000)
      INTEGER        NFR,LAST,NCELLS,FRINDX(MAXIND),SPINDX(MAXIND)
      REAL           STORE(MAXSTR)
      COMMON /SPACE/ STORE
      COMMON /TIMES/ NFR,LAST,NCELLS,FRINDX,SPINDX
C-----------------------------------------------------------------------
