      PROGRAM MODPLOT
C-----------------------------------------------------------------------
C AUTHOR:   ????????
C New version: R.S. Simon
C This version is loosely based on the old MODPLOT.  The contouring
C routines were implemented by S. Mochnachi and D. Schneider; Several
C subroutines have been borrowed from T. Pearson.
C Model components of type 2,3 added by G. Comoretto
C
C Version n+1:  04-April-1980	Fix Degrees usage.
C Version n+2:  07-April-1980	Improve cont. accuracy:go to 1.6577*FW
C Version n+3:  21-April-1980    Increase allowable number of components
C Version n+4:  07-Oct-1980	Improve and standardize plot file and
C					terminal selection
C Version n+5:  10-Oct-1980	Add SAVEMAP to save maps on tape
C Version n+6:  18-Oct-1980	Add FREQ parameter to change frequency
C Version n+7:  24-May-1981	Add AREAS parameter to save areas, fix
C					so plotting to user terminal is ok
C Version n+8:  03-Dec-1981	Add RMS calc.  New max pixels, Savemap
C Version n+9:  01-Jun-1982	Tidy up several small bugs.
C Version 10:   22-Jun-1982	Eliminate questions, new GRPCKG
C Version 11:   06-Jul-1982	LINEWIDTH parameter
C Version 12:   14-Jul-1982	Fix minor bugs
C Version 13:   09-Oct-1982	Add DRAWBEAM and DRAWSCALE parameters
C Version 14:   19-Apr-1983	Add Jy/beam parameters
C Version 15:   20-May-1983	Fix some minor bugs
C Version 16:   20-May-1985      Supports also model types 2-3 [GC]
C Version 17:   27-Jun-1985	Increase title to 80 characters [SCU]
C
C Version ??:   17-Apr-1986	Write scale on plot with DRAWSCAL (AKT)
C					Annotate and fill BEAM in DRAWBEAM.
C 					Add NOTEXT to omit writing next to plot.
C  	       19-APR-1986	Add COLOR parameters (A.K. Tzioumis)
C	
C	       21-Apr-1986	Add LABEL parameter (AKT)
C					Fix bug to plot header in plot window
C					for non-square plots. Plot header 
C					in double-sized letters.
C
C	 COLOR3D - 1 value VALUE(88)(def=2)
C	 COLOR2D - 5 values VALUE(89-93)(def=4,5,7,2,3), for the parameters:
C		grid, +contourrs, -contours, beam&title, writing.
C	 COLOR1D - 4 parameters VALUE(94-97)(def=3,5,4,2) for  the parameters:
C	   grid&beam label, function plot, header&position angle, beam plot.
C-----------------------------------------------------------------------
      COMMON /BYRSS1/ HEADER,BEAMNS,BEAMEW,ANGLE,SCALE,MAX,DELIN,FREQ
      COMMON /PARAM/ NCN,NV,PERCEN,TB,MAXJY,XLEFT,RIGHT,TOP,BOTTOM,
     +		      FLUX,DEFCON,TPERCM,JYPERBM
      COMMON /ID/ IDGRPH
      COMMON /CNTCOM/ IGRPH
      COMMON /JT/ JTYPE, SAMETT, SETERR, ISSOFT, SAVEA, IWIDTH
      COMMON /INM/ INMODL
C
	PARAMETER (PIE=3.141593)
	PARAMETER (DTR=3.14159/180.)
	PARAMETER (NPARM=98)           ! Number of free format parameters
	PARAMETER (NDELTA=10000) ! Maximum number of components
	PARAMETER (MAXPIX=512)	  ! Maximum number of pixels
	PARAMETER (MAXBEM=99)       ! Maximum dimenson of convolving beam table
	REAL*8 AMP,C,NAMES(NPARM),VALUE(NPARM),ENDMRK,HEADER(10),
     +	       OLDPF,OLDMOD(4),OLDLONG,OLDSHRT,OLDCNT(29)
	REAL*4 MAX, MAXJY, JYPERBM, FCPT
	INTEGER COLOR3D
	INTEGER*4 PR, OLDNUM
	CHARACTER*40   PLOTFILE, INMODL
	CHARACTER*32   ARSAVE
	CHARACTER*8    PLOTTYPE
	LOGICAL*4      NEWMOD, NEWPLT, SAVEA, SAMETT, SETERR, ISSOFT
	LOGICAL	       NOGAUS, INVAL
C
	EQUIVALENCE (ZZP(1),ZP(1,1))
C
	DIMENSION  itype(ndelta),C(NDELTA),RAD(NDELTA),THETA(NDELTA),
     +	  A(NDELTA),PERCEN(26)
     +   ,R(NDELTA),FCPT(NDELTA),PHI(NDELTA),SUM(MAXPIX,MAXPIX),
     +	  VCN(26),
     +    B(NDELTA),XO(NDELTA),YO(NDELTA),COSPHI(NDELTA),
     +	  SINPHI(NDELTA),
     +	XXXP(MAXPIX),YYYP(MAXPIX),ZP(MAXPIX,MAXPIX),ZZP(MAXPIX*MAXPIX),
     +	 DEFCON(26),EXPON(3000),AC(NDELTA),
     +   beamtb(maxbem,maxbem),tab(maxpix,maxpix)
C
      DATA NAMES /3*'BEAM ',26*'CONTours','DEGREEs','*Dummy*',
     + 5*'     ','SCALE','FREQuenc','PIXELs',4*'LRTB ','ROTATE','TWOD',
     + 'NUMBER','PLOTfile',4*'     ','*Dummy*','THREED?',
     + 'PERCENT?','ONEDMAX','ONED','MODfile',3*'     ','PEAKPLT',
     + '*Dummy*',4*'     ','AREAfile',3*'     ','RMS',
     + 'LINEwidt','EXIT','DRAWBEAM','DRAWSCAL','JYBEAM','TITLE',
     + 9*'     ','NOTEXT','COLOR3D',5*'COLOR2D',4*'COLOR1D','LABEL'/
C
	DATA VALUE/'***UNSET',2*0.D0,26*0.D0,-1D0,1*'        ',
     +       5*'     ',0.D0,'***UNSET',0.D0,4*1D6,0.D0,1.D0,
     +       NDELTA,'TEKTERM',4*'     ',-1.D0,-1.D0,
     +       1.D0,-1.D0,-1.D0,'***UNSET',3*'     ',-1.D0,
     +	     1.D0,4*'     ',4*'     ',1.D0,
     +	     1.D0,1.D0,-1.D0,-1.D0,-1.D0,10*'     ',-1.D0, 2D0,
     +       4D0,5D0,7D0,2D0,3D0, 3D0,5D0,4D0,2D0, -1.D0/
C
	DATA ENDMRK/'/    '/,MODE/2/,IN/5/,PR/6/,PP/0./,outc/6/,
     +	  DEFCON/-5.,5.,10.,15.,25.,35.,50.,65.,80.,95.,16*0./,NCN/10/
C-----------------------------------------------------------------------
  116 FORMAT (5A8)
 1001 FORMAT (A,A)
 2003 FORMAT (' Total flux density:',F8.2,' Jy.'/' Max =',F9.4,
     +        ' Jy/beam ','     =',1PE9.2,' degrees K.')
 2004 FORMAT (' Frequency =',F8.2,' MHz.')
 2005 FORMAT (A,I7,A)
 4003 FORMAT (' Beam:  ',F6.2,',',F6.2,',',F6.1)
 4004 FORMAT (' Plot scale:',F9.2,' mas/tick =',f10.3,' mas/cm =',
     +        F10.3,' tick/cm.')
 4005 FORMAT (/' Contours, in % of peak:'/,1(' ',10(F6.1,:,',')))
 4006 FORMAT (/' Contours, in units of 1E8 degrees K:'/
     +        1(' ',10(F7.1,:,',')))
 4008 FORMAT (/' Contours, in units of Jy per beam:'/
     +        1(' ',10(F7.3,:,',')))
 4012 FORMAT (/' Free format input (end with /):'//
     +  ' Required parameters for 1st plot: BEAM, FREQ, MODFILE'//
     +  ' Optional parameters: ',
     +      'PLOTFILE, LRTB, CONTOUR, TITLE, PIXELS, ROTATE, RMS,'/
     +  22X,'ONED, ONEDMAX, PEAKPLT, TWOD, THREED, AREAFILE,'/
     +  22X,'SCALE, PERCENT, DEGREES, JYBEAM, NUMBER, LINEWIDTH,'/
     +  22X,'DRAWBEAM, DRAWSCALE, EXIT')
 4013 FORMAT (' There are',I4,' pixels along X-axis of the plot.')
 4016 FORMAT (' RMS value for map= ',1PE9.2,' Jy/Sq Arcsec'/
     +        '                  =',0PF8.3,' % of peak')
 4017 FORMAT (' ***** Warning:  Maximum number of model components is',
     +        I6,'. *****')
 4018 FORMAT (' Number of components in map: ',I6)
 4019 FORMAT (/' ***WARNING: Unable to open input model file.  ',
     +        'Please specify MODFILE. ***'/)
 4020 FORMAT (/' ***WARNING: Unable to open AREAFILE.  ',
     +        'Please specify AREAFILE. ***'/)
 5001 FORMAT (' Window (LRTB) = ',3(F9.2,','),F9.2)
 9000 FORMAT (//' Program  MODPLOT      Version 27-Jun-1985 ',
     +          '          (R. S. Simon)'//)
C-----------------------------------------------------------------------
C
	WRITE (6,9000)
	NV = NPARM
	DIMPLT = 2.
	NEWMOD = .TRUE.
	NEWPLT = .TRUE.
	SETERR = .TRUE.		! Implies call to GRCLOS not needed in SETUP
C
	DO 22 I = 1,3000
	  X = (I-1.) * -2.77259  / 500.
	  EXPON(I) = EXP(X)
   22	CONTINUE
C
C	Entry point when replotting:
    1	IF (NEWPLT) THEN
	  VALUE(47) = 'TEKTERM'		! PLOTFILE
	  OLDPF = 0
	ELSE
	  OLDPF = VALUE(47)
	ENDIF
	VALUE(53) = -1.			! THREED
	VALUE(56) = -1.			! ONED
	DO 99 I=63,70
   99	  VALUE(I) = '        '		! SAVEFILE and AREAFILE
	IF (SAMETT .AND. .NOT.SETERR) THEN
	  CALL GRPAGE(IDGRPH)
	  CALL GRTERM(IDGRPH)
	ENDIF
    4	MODE = 2
	WRITE (6,4012)
	CALL KEYIN (NAMES, VALUE , NPARM, ENDMRK, MODE, IN, PR)
	IF (VALUE(73).EQ.0. .OR. MODE.EQ.1) GO TO 9999
	FREQ = VALUE(38)
	NUMBER = VALUE(46)
	IF (VALUE(47).NE.OLDPF) THEN
C	  Get a new plot unit:
	  ENCODE (40,116,PLOTFILE) (VALUE(I), I=47,51)
	  CALL SETUP(PLOTFILE,PLOTTYPE)
	ENDIF
	IF (SETERR) THEN
	  WRITE (6,1001)' ***WARNING: You''ve somehow failed to specify',
     +	  ' a valid PLOTFILE.  Try again.***'
	  GO TO 4
	END IF
	IF (VALUE(54) .EQ. 0.) THEN		! PERCENT
	  VALUE(30) = -1.
	  VALUE(54) = 1.
	  VALUE(76) = -1.
	ELSEIF (VALUE(30) .EQ. 0.) THEN		! DEGREES
	  VALUE(30) = 1.
	  VALUE(54) = -1.
	  VALUE(76) = -1.
	ELSEIF (VALUE(76) .EQ. 0.) THEN		! JY/BEAM  (JYBEAM)
	  VALUE(30) = -1.
	  VALUE(54) = -1.
	  VALUE(76) = 1.
	ENDIF
	IF (VALUE(53) .GE. 0.) THEN		! THREED
	  DIMPLT = 3.
	ELSE IF (VALUE(45) .EQ. 0) THEN		! TWOD
	  DIMPLT = 2.
	  CALL SETUPE
	ELSE IF (VALUE(56) .EQ. 0.) THEN	! ONED
	  DIMPLT = 1.
	  CALL SETUPE
	ENDIF
	IWIDTH = VALUE(72)			! LINEWIDTH
	IF (IWIDTH .LT. 1) THEN
	  IWIDTH = 1
	  WRITE (6,1001) ' ***WARNING*** Minimum LINEWIDTH is 1.'
	ELSEIF (IWIDTH .GT. 21) THEN
	  IWIDTH = 21
	  WRITE (6,1001) ' ***WARNING*** Maximum LINEWIDTH is 21.'
	ENDIF
	VALUE(72) = IWIDTH
C	Reset GRTRAN, if necessary, so that 3d will work.
	IF (DIMPLT .EQ. 3.) CALL GRTRAN (IDGRPH,0.,0.,1.,1.)
	IF (VALUE(57).NE.OLDMOD(1) .OR. VALUE(58).NE.OLDMOD(2) .OR.
     +	VALUE(59).NE.OLDMOD(4) .OR. VALUE(60).NE.OLDMOD(4)) THEN
	  NEWMOD = .TRUE.
	  ENCODE (40,116,INMODL) (VALUE(I), I=57,60)
	  CLOSE (UNIT=8)
	  OPEN  (UNIT=8,TYPE='OLD',READONLY,FORM='FORMATTED',ERR=114
     +		,  NAME=INMODL)
	  GO TO 113
  114	  WRITE (6,4019)
	  GO TO 4
  113	  CONTINUE
	  DO 115 I=57,60
	    OLDMOD(I+1-57) = VALUE(I)
  115	  CONTINUE
	ENDIF
C
	ROTANG = VALUE(44)			! ROTATE
	DO 130 I = 1,10
  130	HEADER(I) = VALUE(76 + I)		! TITLE
C
	IF (NEWMOD .OR. OLDROT.NE.ROTANG .OR. OLDNUM.NE.NUMBER) THEN
	  NEWMOD = .TRUE.
c
C	  READ IN MODEL
C	  isdelt = # of delta functions
c	  ncomp  = total # of components
C         nogaus = flag that records if there are non gaussian components
c	  inval  = flag that records if there are invalid components
c	  type=0 for delta functions
c
	  isdelt = 0
	  NCOMP  = 0
	  nogaus = .false.
	  inval  = .false.
	  IF (NUMBER .GT. NDELTA) THEN
C	    Warn about trying to exceed max. no. of model comp.
	    NUMBER = NDELTA
	    WRITE (6,4017) NUMBER
	  ENDIF
	  REWIND (8,ERR=240)
  240	  DO 2 I=1,NUMBER
	    FCPT(I) = 0.
	    CALL GTMODL(8,itype(i),FCPT(I),RAD(I),THETA(I),A(I),R(I),
     +		PHI(I),*500,0)
	    IF (FCPT(I) .EQ. 0.)  GO TO 500
	    NCOMP = NCOMP + 1
	    IF (ITYPE(I).EQ.0) ITYPE(I)=1
	    IF (A(I).EQ.0.0)   ITYPE(I)=0
	    IF (ITYPE(I).GT.1) NOGAUS=.TRUE.
	    IF (ITYPE(i) .EQ. 0) ISDELT = ISDELT + 1
	    IF (ITYPE(I) .GT. 3) THEN
		INVAL = .TRUE.
		ITYPE(I) = 1
	    END IF
    2	  CONTINUE
  	  WRITE (6,2005) ' Only first',NUMBER,
     +                   ' model comp. will be used.'
C
  500	  isdisk = NCOMP - isdelt
	  if (inval) then
	    write (6,*) ' Some components are of type > 3.'
	    write (6,*) ' They have been considered as gaussian components.'
	  end if
          FLUX = 0.
	  DO 3 I = 1,NCOMP
	      THET = (THETA(I) + ROTANG) * DTR
	      RADI = RAD(I) * 0.001
	      YO(I) =  RADI*COS(THET)
	      XO(I) = -RADI * SIN(THET)
    	      FLUX = FLUX + FCPT(I)
    3     CONTINUE
	ENDIF
C
C	If AREAFILE parameter specified, open unit 10
	IF (VALUE(67) .NE. '     ') THEN
	  CLOSE (UNIT=10)
	  ENCODE (32,116,ARSAVE) (VALUE(I), I=67,70)
	  OPEN  (UNIT=10,TYPE='NEW',FORM='FORMATTED',ERR=12
     +    ,NAME=ARSAVE)
	  SAVEA = .TRUE.
	ELSE
	  CLOSE (UNIT=10)
	  SAVEA = .FALSE.
	ENDIF
	GO TO 13
   12	WRITE (6,4020)
	GO TO 4
   13	CONTINUE
C
C	FIND LIMITS, BEAM, SCALE, ETC. HERE
C	FIND TOP, BOTTOM, LEFT, AND RIGHT SIDES (LIMITS) OF PLOTS
	TOPX = 0.
	BOTTX = 0.
	XLEFTX = 0.
	RIGHTX = 0.
	TOP = VALUE(42)
	IF (TOP .GT. 9.E5) THEN
	  TOP = -1.E6
	  DO 362 J = 1, NCOMP
  362	    IF (YO(J) .GT. TOP) TOP = YO(J)
	  TOPX = 1.0
	  TOP = TOP * 1000
	ENDIF
	BOTTOM = VALUE(43)
	IF (BOTTOM .GT. 9.E5) THEN
	  DO 364 J = 1, NCOMP
  364	    IF (YO(J) .LT. BOTTOM) BOTTOM = YO(J)
	  BOTTOM = BOTTOM * 1000.
	  BOTTX = 1.5
	ENDIF
	XLEFT = VALUE(40)
	IF (XLEFT .GT. 9.E5) THEN
	  DO 366 J = 1, NCOMP
  366	    IF (XO(J) .LT. XLEFT) XLEFT = XO(J)
	  XLEFTX = 1.0
	  XLEFT = XLEFT * 1000.
	ENDIF
	RIGHT = VALUE(41)
	IF (RIGHT .GT. 9.E5) THEN
	  RIGHT = -1.E6
	  DO 368 J = 1, NCOMP
  368	    IF (XO(J) .GT. RIGHT) RIGHT = XO(J)
	  RIGHT = RIGHT * 1000.
	  RIGHTX = 1.5
	ENDIF
C
C	Make sure a legal window was selected; if not, correct and warn
	IF (RIGHT .LT. XLEFT) THEN
	  TEMP = RIGHT
	  RIGHT = XLEFT
	  XLEFT = TEMP
	  WRITE (6,1001)' ***WARNING*** Right and left sides of window '//
     +	  'were reversed.'
	ENDIF
	IF (TOP .LT. BOTTOM) THEN
	  TEMP   = TOP
	  TOP    = BOTTOM
	  BOTTOM = TEMP
	  WRITE (6,1001)' ***WARNING*** Top and bottom of window '//
     +	  'were reversed.'
	ENDIF
	IF (TOP .EQ. BOTTOM .OR. XLEFT .EQ. RIGHT) THEN
	  WRITE (6,1001)' ***WARNING*** ILLEGAL window.  Try again with '//
     +	  'new LRTB.'
	  GO TO 4
	ENDIF
C
C	DETERMINE WHAT TO USE AS BEAM
	IF (VALUE(1) .NE. OLDLONG .OR. NEWPLT) THEN
	  IF (VALUE(2) .EQ. OLDSHRT) VALUE(2) = VALUE(1)
	  IF (VALUE(2) .LE. 0.D0) VALUE(2) = VALUE(1)
	  IF (VALUE(1) .LT. VALUE(2)) THEN
	    TEMP = VALUE(1)
	    VALUE(1) = VALUE(2)
	    VALUE(2) = TEMP
	  END IF
	  VALUE(1) = VALUE(1) + 1D-8
	  OLDLONG = VALUE(1)
	  VALUE(2) = VALUE(2) + 1D-8
	  OLDSHRT  = VALUE(2)
	  BEAMNS = VALUE(1)
	  BEAMEW = VALUE(2)
	  NEWPLT = .FALSE.
	ENDIF
	AXIS = BEAMNS * 0.001
	IF (BEAMNS .GT. 0.) THEN
	  RATIO = BEAMEW / BEAMNS
	ELSE
	  RATIO = 1.0
	  AXIS = 4.E-6
	ENDIF
C
	ANGLE = (VALUE(3) + ROTANG) * DTR
	COSANG = COS(ANGLE)
	SINANG = SIN(ANGLE)
	bk=axis*ratio
	ck=2.77259 / (3.14159 * axis * BK)
C	If window chosen automatically, enlarge it slightly to allow for beam:
	IF (VALUE(40) .GT. 9D5 .OR. VALUE(41) .GT. 9D5 .OR.
     +	    VALUE(42) .GT. 9D5 .OR. VALUE(43) .GT. 9D5) THEN
	  AX1 = 1000. * SQRT((AXIS*COSANG)**2 + (BEAMEW*.001*SINANG)**2)
	  AX2 = 1000. * SQRT((AXIS*SINANG)**2 + (BEAMEW*.001*COSANG)**2)
	  TOP = TOP + TOPX * AX1
	  BOTTOM = BOTTOM - BOTTX * AX1
	  XLEFT = XLEFT - XLEFTX * AX2
	  RIGHT = RIGHT + RIGHTX * AX2
	END IF
C
C	FIND SCALE, SIZE OF PLOT
	SCALE = VALUE(37)
	XINCHS = 10.
	IF (SCALE .GT. 0.) THEN
	  XINCHS = (RIGHT - XLEFT) / SCALE
	  YINCHS = (TOP - BOTTOM) / SCALE
	ELSE
	  SCALE = (RIGHT - XLEFT) / XINCHS
	  YINCHS = (TOP - BOTTOM) / SCALE
	END IF
	IF (YINCHS .GT. 10.) THEN
	  SCALE = SCALE * YINCHS / 10.
	  XINCHS = XINCHS * 10. / YINCHS
	  YINCHS = 10.
	END IF
	IF (XINCHS .GT. 10.) THEN
	  SCALE = SCALE * XINCHS / 10.
	  YINCHS = YINCHS * 10. / XINCHS
	  XINCHS = 10.
	END IF
C
	IF (VALUE(39) .EQ. 0.) THEN
C	  Determine the def no. of pixels.  TEMP is #pixels/beam;
C	  Coarser plots are used on terminals (TEK scopes)
	  TEMP = 6.
	  IF (.NOT.ISSOFT) TEMP = 12.
	  IF (BEAMEW .GT. 0.) THEN
	    PIXELS = (RIGHT - XLEFT) * TEMP / BEAMEW
	  ELSE
	    PIXELS = 120.
	  ENDIF
	  IF (PIXELS .GT. 60. .AND. ISSOFT) PIXELS = 60.
	  IF (PIXELS .GT. 200.) PIXELS = 200.
	ELSE
C	  User has specified the number of pixels to use, so don't use default:
	  PIXELS = VALUE(39)
	END IF
	IF (PIXELS .GT. MAXPIX) PIXELS = MAXPIX
	IF (VALUE(53) .EQ. 0 .AND. PIXELS .GT. 100) PIXELS = 100
	IF (VALUE(62) .EQ. 0 ) PIXELS = 100
	VALUE(39) = PIXELS
	NX = PIXELS + 0.5
	WRITE (6,4013) NX
	IF (SAVEA) THEN
	  WRITE (10,1001) ' Contour areas for model file ',INMODL
	  WRITE (10,4013) NX
	ENDIF
	DEL = (RIGHT - XLEFT) / NX
	NY = (TOP - BOTTOM) / DEL + 0.5
	IF (NY .GT. MAXPIX) THEN
	  DEL = (TOP - BOTTOM) / MAXPIX
	  NX = NX * MAXPIX / NY
	  NY = MAXPIX
	END IF
C
	WRITE (6,5001) XLEFT,RIGHT,TOP,BOTTOM	!  Write window, in mas
	IF (SAVEA) WRITE (10,5001)XLEFT,RIGHT,TOP,BOTTOM
	WRITE (6,4003) BEAMNS,BEAMEW,VALUE(3)	!  Write beam parameters
	IF (SAVEA) WRITE (10,4003) BEAMNS,BEAMEW,VALUE(3)	
	WRITE (6,4018) NCOMP
	IF (SAVEA) WRITE (10,4018) NCOMP
C
C	Compute the map, but only if necessary:
	IF (NEWMOD .OR. OLDLFT.NE.XLEFT .OR. OLDRIT.NE.RIGHT .OR.
     +	  OLDTOP.NE.TOP .OR. OLDBOT.NE.BOTTOM .OR. OLDBNS.NE.BEAMNS .OR.
     +    OLDBEW.NE.BEAMEW .OR. OLDANG.NE.VALUE(3) .OR.
     +	  OLDPIX.NE.PIXELS .OR. OLDSCL.NE.SCALE)
     +	  THEN
	  NEWMOD = .FALSE.
	  OLDLFT = XLEFT
	  OLDRIT = RIGHT
	  OLDTOP = TOP
	  OLDBOT = BOTTOM
	  OLDBNS = BEAMNS
	  OLDBEW = BEAMEW
	  OLDANG = VALUE(3)
	  OLDPIX = PIXELS
	  OLDROT = ROTANG
	  OLDNUM = NUMBER
	  OLDSCL = SCALE
C
	  IF (isdelt .GT. 0) THEN
C
C           This routine sorts a model so that delta fncts 
C	    are first, followed by gaussians, disks & other models
C
	    MOVE = 0
	    DO I = 1, NCOMP
	      IF (itype(I) .eq. 0) THEN
	        MOVE = MOVE + 1
		if (itype(move).ne.0) then
		    itemp=itype(i)
		    itype(i)=itype(move)
		    itype(move)=itemp
		    TEMP = FCPT(I)
		    FCPT(I) = FCPT(MOVE)
		    FCPT(MOVE) = TEMP
		    TEMP = A(I)
		    A(I) = A(MOVE)
		    A(MOVE) = TEMP
		    TEMP = R(I)
		    R(I) = R(MOVE)
		    R(MOVE) = TEMP
		    TEMP = PHI(I)
		    PHI(I) = PHI(MOVE)
		    PHI(MOVE) = TEMP
		    TEMP = XO(I)
		    XO(I) = XO(MOVE)
		    XO(MOVE) = TEMP
		    TEMP = YO(I)
		    YO(I) = YO(MOVE)
		    YO(MOVE) = TEMP
		end if
	      ENDIF
	      IF (MOVE .GE. isdelt) GO TO 510
	    ENDDO
	  end if
  510	  CONTINUE
c
c calculate some global parameters of map
c
	  kstart=isdelt + 1
	  XX = XLEFT / 1000.
	  YY = TOP / 1000.
C	Delin equals inches per pixel on plot.
	  DELIN = DEL / SCALE
C	Del equals arcseconds per pixel on plot.
	  DEL = DEL * 0.001
	  NGSC = NX / XINCHS + 0.5
	  DO 8 J = 1, ny
	  DO 8 I = 1, nx
	    tab(i,j) = 0.0
    8	    SUM(I,J) = 0.0
C
c calculate dimensions & luminosities for each component
c
	  DO K = 1,ncomp
	    if (itype(k).eq.0) then
c - - - - - - - - delta functions
c
		ac(k)=axis
		c(k)=fcpt(k)*ck
	    else if (itype(k).eq.1) then
c - - - - - - - - gaussians
c
		phik = (phi(k) + rotang) * dtr
		ak   = a(k) * 0.001
c
c - - - - - - - -  convolve component with beam
c
		CALL GCONVL(AXIS,RATIO,ANGLE,AK,R(K),PHIK,AC(K),RC,PHIC)
		cosphi(k) = cos(phic)
		sinphi(k) = sin(phic)
		b(k)      = ac(k) * rc
		c(k)      = fcpt(k) * 2.77259 / (3.14159*ac(k)*b(k))
	    else
c - - - - - - - - - disks
c
		PHIC = (PHI(K)+ROTANG) * DTR
		AC(K) = A(K) * 0.0005
		COSPHI(K) = COS(PHIC)
		SINPHI(K) = SIN(PHIC)
		B(K) = AC(K) * R(K)
c - - - - - - - - - diks must have a minimum size to be gridded properly
c
		if (ac(k).lt.del) ac(k)=del
		if ( b(k).lt.del)  b(k)=del
		C(K) = FCPT(K) / (3.14159*AC(K)*B(K))
c
c If disk is tapered, peak intensity is higher
c
		if (itype(k).eq.3) c(k)=c(k) * 1.5 
	    end if
	  end do
c
	  IF (isdisk .GT. 0) THEN
c
c	    Find SUM(I,J) for gaussian components
c	    and prepare unconvolved map for disk components
c
	    X = XX-DEL
	    DO I = 1,NX
		X = X+DEL
		Y = YY+DEL
		DO J = 1,NY
		    Y = Y-DEL
		    DO K = kstart,ncomp
			XP =  (X-XO(K))*COSPHI(K) + (Y-YO(K))*SINPHI(K)
			YP = -(X-XO(K))*SINPHI(K) + (Y-YO(K))*COSPHI(K)
			if (itype(k).eq.1) then
c
c		  For each guassian, find all contribution within 2 FWHMs
c
			    IF (ABS(XP) .GT. B(K)*1.6557) GO TO 19
			    IF (ABS(YP) .GT. AC(K)*1.6557) GO TO 19
			    ixrad=500*((xp/b(k))**2 + (yp/ac(k))**2) + 1.5
			    if (ixrad.lt.3000) 
     +			       sum(i,j)=sum(i,j) + c(k)*expon(ixrad)
			else
c
c for each disk, record components in unconvolved map within a radius
c
			    IF (ABS(XP) .GT. B(K)) GO TO 19
			    IF (ABS(YP) .GT. AC(K)) GO TO 19
			    AMP = (1.0 - (XP/B(K))**2 - (YP/AC(K))**2)
			    IF (AMP.le.0.0) go to 19
			    if (itype(k).eq.3) tab(I,J) = tab(I,J)+ C(K)* SQRT (AMP)
			    if (itype(k).eq.2) tab(i,J) = tab(i,j)+ c(k)
			end if
19			continue
		    end do
		end do
	    end do
	  ENDIF
	  if (isdelt.gt.0) then
c
c	    Find SUM(I,J) for delta functions
c
	    slimit = 1.6557 * axis
	    sinbk = sinang/bk
	    cosbk = cosang/bk
	    sinax = sinang/axis
	    cosax = cosang/axis
	    do 117 k = 1,isdelt
		nxlow = (xo(k) - slimit - xx) / del - 0.5  
		nxhi  = (xo(k) + slimit - xx) / del + 0.5
		nyhi  = (yy - yo(k) + slimit) / del + 0.5
		nylow = (yy - yo(k) - slimit) / del - 0.5
		if (nxlow .gt. nx .or. nylow .gt. ny .or.
     +		    nxhi  .lt. 1  .or. nyhi  .lt. 1) go to 117
		if (nxlow .lt. 1) nxlow = 1
		if (nxhi  .gt. nx) nxhi = nx
		if (nylow .lt. 1) nylow = 1
		if (nyhi  .gt. ny) nyhi = ny
		x = xx + (nxlow-2)*del
		do i=nxlow, nxhi
		    x = x + del
		    y = yy - (nylow-2)*del
		    do j=nylow,nyhi
			y = y - del
			xp = (x-xo(k)) * cosbk + (y-yo(k)) * sinbk
			if (abs(xp).gt.1.6657) go to 119
			yp = (y-yo(k)) * cosax - (x-xo(k)) * sinax
			ixrad = 500. * (xp**2 + yp**2) + 1.5
			if (ixrad.lt.3000) 
     +			   sum(i,j) = sum(i,j) + c(k)*expon(ixrad)
119			continue
		    end do
		end do
117	    continue
	  end if
c
c convolve non-gaussian components
c
	  if (nogaus) then
c
c calculate beam table
c
	    bk=axis*ratio
	    ck1=ck*del*del
	    cosang=cos(angle)
	    sinang=sin(angle)
c
c actual size of the table is nbeamx*nbeamy
c center is pixel (ixob,iyob)
c
	    ymb= (abs(axis*cosang)+abs(bk*sinang)) * 1.6557
	    xmb= (abs(axis*sinang)+abs(bk*cosang)) * 1.6557
	    ixob=xmb/del + 1.5
	    iyob=ymb/del + 1.5
c
c check that beam patch is not too large
c ratb is  (size of beam) / (size of patch)
c
	    ratb=1.0
	    icntbm=(maxbem+1)/2
	    cntbm=icntbm
	    if (ixob.gt.icntbm) then
		ratb=ixob/cntbm
		ixob=icntbm
	    end if
	    if (iyob.gt.icntbm) then
		ratby=iyob/cntbm
		if (ratby.gt.ratb) ratb=ratby
		iyob=icntbm
	    end if
	    i1 = ixob+ixob
	    j1 = iyob+iyob
	    nbeamx=i1-1
	    nbeamy=j1-1
	    write (6,*)'Dimension of beam patch, in pixels:',nbeamx,nbeamy
            if (ratb.gt.1.1) then
		write (6,*) '******* WARNING: Beam patch truncated'
		write (6,*) 'Use a beam at least',ratb,'times smaller'
	    end if
c
c now compute table of beam patch values
c	
	    x=-del*ixob
	    do i=1,nbeamx
		x= x+del
		y= del*iyob
		do j=1,iyob
		    y=y-del
		    xp= x*cosang + y*sinang
		    yp=-x*sinang + y*cosang
		    amp = ck1 * exp(-2.77259 * ((xp/bk)**2 + (yp/axis)**2))
		    beamtb (i,j)=amp
		    beamtb (i1-i,j1-j)=amp
		end do
	    end do
c
c actual convolution
c
	    do i=1,nx
	    do j=1,ny
		if (tab (i,j).ne.0.0) then
		    i1 = i-ixob+1
		    if (i1.lt.1) i1=1
		    i2 = i+ixob-1
		    if (i2.gt.nx) i2=nx
		    j1 = j-iyob+1
		    if (j1.lt.1) j1=1
		    j2 = j+iyob-1
		    if (j2.gt.ny) j2=ny
		    do ii=i1,i2
		    ib=ii-i+ixob
		    do jj=j1,j2
			jb=jj-j+iyob
			sum(ii,jj)=sum(ii,jj) + tab(i,j)*beamtb(ib,jb)
		    end do
		    end do
		end if
	    end do
	    end do
	  ENDIF
c
C end of section for non gaussian components
C
	  MAX = 0.0
	  RMS = 0.0
	  DO 120 J = 1, NY
	    DO 120 I = 1, NX
	      IF (MAX .LT. SUM(I,J)) MAX = SUM(I,J)
	      RMS = RMS + SUM(I,J)**2
  120	  CONTINUE
	  RMS = SQRT(RMS/(NX*NY))
	  RMSP = 100. * RMS/MAX
C
	end if
C
c end of map calculation
c
	ANORM = MAX * 0.01
	TB = 1.3806E+12*MAX/FREQ**2
	MAXJY = MAX ! Peak in JY per square arcsec
C	Peak in JY per beam :
	JYPERBM = MAX * (PIE*BEAMNS*BEAMEW/(4.E6*LOG(2.)))
	WRITE (6,2003) FLUX,JYPERBM,TB
	IF (VALUE(71) .EQ. 0.) WRITE (6,4016) RMS,RMSP
	IF (SAVEA) WRITE (10,2003) FLUX,JYPERBM,TB
	IF (SAVEA .AND. VALUE(71) .EQ. 0) WRITE (10,4016)RMS,RMSP
	WRITE (6,2004) FREQ
	IF (SAVEA) WRITE (10,2004) FREQ
C
C	Settle on values for contour levels; VCN are contour levels
C		in JY per square arcsec
	IF (VALUE(54) .GT. 0.D0) THEN
C	  Scaling of contour levels in percent of peak
	  VNORM = ANORM
	ELSEIF (VALUE(30) .GT. 0.D0) THEN
C	  Scaling of contour levels in 1E8 degrees kelvin
	  VNORM = ANORM * 1.E10 / TB
	ELSE
C	  Scaling of contour levels in Jy per beam (jybeam)
	  VNORM = ANORM * 100. / JYPERBM
	ENDIF
	IF (VALUE(4) .NE. OLDCNT(4) .AND. VALUE(4) .NE. 0.D0) THEN
	  NCN = 0
	  DO I=1,26
	    IF (VALUE(I+3).NE.0.D0 .AND. VALUE(I+3).NE.OLDCNT(I+3)) THEN
	      VCN(I) = VALUE(I+3) * VNORM
	      DEFCON(I) = VALUE(I+3)
	      VALUE(I+3) = VALUE(I+3) + 1.D-8
	      OLDCNT(I+3) = VALUE(I+3)
	      PERCEN(I) = VCN(I) / ANORM
	      NCN = NCN + 1
	    ELSE
	      VALUE(I+3) = 0.D0
	      OLDCNT(I+3) = 0.D0
	    ENDIF
	  ENDDO
	ELSE
	  DO I = 1,NCN
	    VCN(I) = DEFCON(I) * VNORM
	    PERCEN(I) = VCN(I) / ANORM
	  ENDDO
	ENDIF
C
C	WRITE SCALE
	SCALEM = SCALE * TPERCM
	WRITE (6,4004) SCALE,SCALEM,TPERCM
	IF (SAVEA) WRITE (10,4004) SCALE,SCALEM,TPERCM
	ANGLE = ANGLE / DTR
   	II = 1
	DO 62 J = 1, NY
	DO 62 I = 1, NX
	  ZZP(II) = SUM(I,J)
	  II = II + 1
   62	CONTINUE
	IF (.NOT.ISSOFT .AND. PP .EQ. 1.) CALL GRPAGE(IDGRPH)
	IF (.NOT.ISSOFT) PP = 1
C
	IF (DIMPLT .EQ. 2.) THEN
C	  Print the contour levels here:
	  WRITE (6,4005) (PERCEN(I), I = 1, NCN)
	  IF (SAVEA) WRITE (10,4005) (PERCEN(I), I = 1, NCN)
	  IF (VALUE(30) .EQ. 1.)  WRITE (6,4006) (DEFCON(I), I = 1, NCN)
	  IF (VALUE(30) .EQ. 1. .AND. SAVEA)
     +	  WRITE (10,4006) (DEFCON(I), I = 1, NCN)
	  IF (VALUE(76) .EQ. 1.)  WRITE (6,4008) (DEFCON(I), I = 1, NCN)
	  IF (VALUE(76) .EQ. 1. .AND. SAVEA)
     +	  WRITE (10,4008) (DEFCON(I), I = 1, NCN)
	ENDIF
C
	IF (SAMETT) THEN
C&          CALL LIB$GET_COMMAND(ANSWER,
C&     1	   'Hit <RETURN> to wipe screen and draw plot: ')
	  CALL GRPAGE(IDGRPH)
	ENDIF
C
C	Begin plotting:
C
	IF (DIMPLT .EQ. 3.) THEN
C	  If 3d is desired, do it:
	  BIGMAX = MAX
	  IGRPH = IDGRPH
	  IF (VALUE(53) .GE. 0.) VUANG = VALUE(53)
	  IF (VUANG .LT. 1.E-6) VUANG = 25.
	  COLOR3D=VALUE(88)
	  CALL GRSCI(COLOR3D)
	  CALL FREDP(ZP,NX,NY,1,NX,1,NY,VUANG,BIGMAX)
	  CALL GRSCI(1)
C
	ELSE IF (DIMPLT .EQ. 2.) THEN
C	  If 2d is desired, do it:
C	  Just in case the user is plotting on his terminal, clear it now.
	  IF (ISSOFT) CALL GRPAGE(IDGRPH)	!  Clear Tektronix screens
	  IF (PLOTTYPE(1:1) .EQ. 'G') CALL GRPAGE(IDGRPH)
	  CALL AREAS(VCN,NCN,NX,XINCHS,NY,YINCHS,ZP,XXXP,YYYP,VALUE)
	  ANGLE = ANGLE - ROTANG
	  CALL PLTTIT(VALUE,XINCHS)
C	  Reset the TWOD parameter here, after a twod plot has been done.
	  VALUE(45) = 1.
C
	ELSE IF (DIMPLT .EQ. 1.) THEN
C	  If 1d is desired, do it:
C	  Just in case the user is plotting on his terminal, clear it now.
	  IF (ISSOFT) CALL GRPAGE(IDGRPH)	!  Clear Tektronix screens
	  IF (PLOTTYPE(1:1) .EQ. 'G') CALL GRPAGE(IDGRPH)
	  CALL ONEPLT (ZP,NX,NY,VALUE)
	ENDIF
C
C	See if another plot is to be drawn:
C	First, finish off the current plot and send cursor to corner:
	IF (SAMETT) THEN
	  XCORN = 10.0
	  YCORN = 0.0
	  CALL GRVECT (IDGRPH,3,.FALSE.,1,XCORN,YCORN)
	ENDIF
	CALL GRTERM(IDGRPH)
C
C&	IF (SAMETT) THEN
C&          CALL LIB$GET_COMMAND(ANSWER,
C&     1	   'Hit <RETURN> to continue: ')
C&	ENDIF
	GO TO 1
C
 9999   CALL GRCLOS(IDGRPH)
C
	END
	SUBROUTINE AREAS(CLVL,NC,NX,XINCHS,NY,YINCHS,ZP,XP,YP,VALUE)
	DIMENSION XP(NX),YP(NY),ZP(NX,NY),CLVL(26)
	COMMON /BYRSS1/ HEADER,BEAMNS,BEAMEW,ANGLE,SCALE,MAX,DELIN,FREQ
	COMMON /PARAM/ NCN,NV,PERCEN,TB,MAXJY,XLEFT,RIGHT,TOP,BOTTOM,
     +		      FLUX,DEFCON,TPERCM,JYPERBM
	COMMON /ID/ IDGRPH
	COMMON /PLTTR/ KPLOT,KSKIP
	COMMON /JT/ JTYPE, SAMETT, SETERR, ISSOFT, SAVEA, IWIDTH
	LOGICAL*4   SAMETT, SETERR, ISSOFT, SAVEA 
	logical LABEL, INTSCA
	integer color2d(5)
	CHARACTER*6 CLAB
	CHARACTER*10 FRMT
	REAL * 8 HEADER(10), VALUE(NV)
	REAL*4 MAX, MAXJY, JYPERBM, DEFCON(26), PERCEN(26)
c
	RMIN = 0.5
	VALL=3.0
	VALL =0.0
	IDZ=NX
	XYMAX=MAX0(NX,NY)
C
C	Set up the color array
	DO I=1,5
	 COLOR2D(I) = VALUE(88+I)
	ENDDO
C
	IF (VALUE(98) .GE. 0.0) THEN
	 LABEL=.TRUE.
	ELSE
	 LABEL=.FALSE.
	ENDIF
C
C	THE FOLLOWING REPLACES THE OLD SUBR. XPYPRY
	DO 10 I = 1, NX
   10	  XP(I) = I * DELIN
	DO 15 J = 1, NY
   15	  YP(J) = (NY-J) * DELIN
C
C	THE FOLLOWING REPLACES THE OLD SUBR. CNTPLT
	IF (SAVEA) WRITE (10,100)
  100	FORMAT (//,' LEVEL(PERCENT)    AREA(SQ. INS.)      AREA(BEAMS)   
     +    X CENTER    Y CENTER')
	CALL GRSCI(COLOR2D(1))
	IF (IWIDTH .GT. 1) CALL GRSLW(IWIDTH)  ! Set line width for box
        CALL GRMOVA(0.0, 0.0)
	CALL GRLINA(0.0, YINCHS)
	CALL GRLINA(XINCHS, YINCHS)
	CALL GRLINA(XINCHS, 0.0)
	CALL GRLINA(0.0, 0.0)
C
	ISTOP = YINCHS
	JSTOP = XINCHS
	X = XINCHS - .1
	DO 20 I = 1, ISTOP
	  Y = I
          CALL GRMOVA(0.0, Y)
	  CALL GRLINA(0.1, Y)
	  CALL GRMOVA(X, Y)
	  CALL GRLINA(XINCHS, Y)
   20	CONTINUE
	Y = YINCHS - .1
	DO 30 J = 1, JSTOP
	  X = J
	  CALL GRMOVA(X, 0.0)
	  CALL GRLINA(X, 0.1)
	  CALL GRMOVA(X, Y)
	  CALL GRLINA(X, YINCHS)
   30	CONTINUE
C
C	write labels if required
	IF (LABEL) THEN
	 IF(SCALE-INT(SCALE) .EQ. 0.0) THEN
	  INTSCA = .TRUE.
	  FRMT = '(I4)'
	  XOFS = 0.3
	  YOFS = 0.15
	 ELSE
	  INTSCA = .FALSE.
	  FRMT = '(F6.1)'
	  XOFS = 0.4
	  YOFS = 0.15
	 ENDIF
C 
	 DO I = 1, ISTOP-1
	  Y = I
	  YLAB = BOTTOM + Y*SCALE
	  IF (INTSCA) THEN 
	   WRITE (CLAB,FRMT) IFIX(YLAB)
	  ELSE
	   WRITE (CLAB,FRMT) YLAB
	  ENDIF
	  CALL GRCHAR(IDGRPH,.FALSE.,0.0,.FALSE.,YOFS,Y,CLAB)
	 END DO
C
	 DO J = 1, JSTOP-1
	  X = J
	  XLAB = XLEFT + X*SCALE
	  IF (INTSCA) THEN
	   WRITE (CLAB,FRMT) IFIX(XLAB)
	  ELSE
	   WRITE (CLAB,FRMT) XLAB
	  ENDIF
 	  CALL GRCHAR(IDGRPH,.FALSE.,0.0,.FALSE.,X-XOFS,0.2,CLAB)
	 END DO
	ENDIF
C
	DO 11 I=1,NC
	A=CLVL(I)
	KPLOT = 1			! prevents a crude dashed line
	IF (A .GT. 0.) THEN
	  CALL GRSCI(COLOR2D(2))		! cyan plots if pos. contour
	  CALL GRSLS(1)		! Solid line
	ELSE
	  CALL GRSCI(COLOR2D(3))		! yellow if neg. contour
	  CALL GRSLS(4)		! neg. contour dashed
C	  IF (IWIDTH .GT. 1) THEN
CC	    Since GRPCKG will not dash thick lines, do it myself
C	    CALL GRSLS(1)
C	    KPLOT = -1
C	    KSKIP = -1
C	  ENDIF
	ENDIF
	CALL CNTOUR(XP,NX,YP,NY,ZP,IDZ,A,VALL,A,XYMAX,XINCHS,RMIN)
   11	CONTINUE
	CALL GRSCI(1)
	CALL GRSLS(1)
	CALL GRSLW(1)
	RETURN
C
	END
      SUBROUTINE BMPLOT(AXLO,AXSH,ROTDEG,XCENTR,YCENTR,IDGRPH,SHADE)
C-----------------------------------------------------------------------
C  This routine plots an ellipse of major axis AXLONG, minor axis AXSHRT,
C  and rotated by ROTDEG degrees.All units are in plotting units, and the
C  plot is sent to unit IDGRPH.
C-----------------------------------------------------------------------
      PARAMETER (TWOPI=6.28318531, DEGRAD=57.2957795, 
     1           DELTA=TWOPI/360.)
      LOGICAL SHADE
      REAL PX(360),PY(360)
C
      ROT = ROTDEG / DEGRAD
      AXLONG = AXLO / 2.
      AXSHRT = AXSH / 2.
      THETA = 0.
      SQRL = AXLONG*AXLONG
      SQRS = AXSHRT*AXSHRT
      IF (SQRL .EQ. 0.) SQRL=1.E-6
      IF (SQRS .EQ. 0.) SQRS=1.E-6
C      -- compute beam contour
      DO 100 I=1,360
          THETA = THETA + DELTA
          R2 = 1. / ( ( (SIN(THETA))**2/SQRS )+( (COS(THETA))**2/SQRL))
          R = SQRT (R2)
          PX(I) = R * SIN(THETA - ROT) + XCENTR
          PY(I) = R * COS(THETA - ROT) + YCENTR
  100 CONTINUE
C     -- fill interior
      IF (SHADE) THEN
          CALL GRQCI(ICOL)
          CALL GRSCI(14)
          CALL GRFA(360,PX,PY)
          CALL GRSCI(ICOL)
      END IF
C     -- draw outline
      CALL GRMOVA(PX(360),PY(360))
      DO 110 I=1,360
          CALL GRLINA(PX(I),PY(I))
  110 CONTINUE
      RETURN
      END

      SUBROUTINE CNTOUR(XP,NXX,YP,NYY,ZP,IDIMX,TOURR,VALL,CVAL,
     $XYMAX,XINCHS,RADMIN)
C
C      C O N T O U R  P L O T T I N G  O F  A  G R I D
C
C      XP = ARRAY OF X VALUES - SINGLE DIMENSION
C      YP = ARRAY OF Y VALUES - SINGLE DIMENION,
C      ZP ' DOUBLE DIMENSION ARRAY( IDIMX BY ..... ) CONTAINING THE
C              Z VALUES ( Z = F( X , Y )  )  TO BE CONTOURED.
C      NX , NY , = THE CONTOURING GRID IS NX LONG BY NY WIDE .
C      I. E. THE GRID MAY BE SMALLER THAN THE ARRAY WHICH CONTAINS IT.
C      'VAL' IS AN INDICATOR FO- PLOTT&NG NUMBERS ON THE LINES.
C      IF ABS( VAL ) .LT. 0.5 THEN NO NUMBERS ARE PLOTTED
C      IF POSITIVE NTE NUMBERS ARE PLACED VAL INCHES APART.
C      IF NEGATIVE THE NUMBERS ARE PLOTTED ABS( VAL) APART.
C      IF NEGATIVE NEGATIVE VALUES ON THE GRID ARE NOT PLOTTED AT ALL.
C
C      CVAL IS THE VALUE OF THE NUMBER TO BE PLACED ON THE CONTOUR.
C      ONLY THE INTEGER PORTION OF THE NUMBER IS PLOTTED .
C      IF 'CVAL' = 0 THEN THE FIRST 3 SIGNIFIGANT DIGITS OF TOUR ARE
C              USED.
C                                 W. J. COULTHARD
C                                 1969
C
C   MODIFIED FOR   FIRM  BY S.W.MOCHNACKI, SEPT. 1976.
C   MODIFIED SO WILL SEMI-WORK ON CIT IBM 370 BY THE BIG D  AUG. 1978
C
       DIMENSION XP(   2   ) , YP(   2   ) , ZP( IDIMX ,2  ), HEADER(20)
      COMMON /BYRSS1/ HEADER,BEAMNS,BEAMEW,ANGLE,SCALE,MAX,DELIN,FREQ
	COMMON /PARAM/ NCN,NV,PERCEN,TB,MAXJY,XLEFT,RIGHT,TOP,BOTTOM,
     +		      FLUX,DEFCON,TPERCM,JYPERBM
       COMMON / TOUR1C / TOUR , IRP , JRP , ISP , JSP , NX , NY
       COMMON /TOUR2C/ IPEN, VAL, XVAL, SEP, PLACE, POS, XSEP, XSEP2
      COMMON /TOUR3C/ XA,YA,XB,YB,DEL,R8,XFST,YFST,NPTS,CLOSED
      COMMON /PLTTR/ KPLOT,KSKIP
	COMMON /ID/ IDGRPH
	COMMON /JT/ JTYPE, SAMETT, SETERR, ISSOFT, SAVEA, IWIDTH
       LOGICAL PLACE , POS ,BATCH
	LOGICAL*4 SAMETT,SETERR,ISSOFT,SAVEA
	REAL*4 MAX, MAXJY, JYPERBM, DEFCON(26), PERCEN(26)
      REAL*8 YDX,XDY,XYDX,YXDY,X2DY,Y2DX,DELX,DELY,DEL,R8(8),XA,YA,XB,YB
      LOGICAL CLOSED
      EQUIVALENCE (R8(1),YDX),(R8(2),XDY),(R8(3),XYDX),(R8(4),YXDY),
     1(R8(5),X2DY),(R8(6),Y2DX),(R8(7),DELX),(R8(8),DELY)
      BATCH=.TRUE.
      XYSCL=XINCHS/XYMAX
       VAL = VALL
       TOUR = TOURR
      CLOSED=.TRUE.
       NX = NXX
       NY = NYY
C***** &NITIAL&0E FO- PLACING NUMBE-S ON THE CONTOURS *****
       PLACE = .FALSE.
       SEP = ABS( VAL )
       IF( SEP .LT. 0.5 ) GO TO 195
       PLACE = .TRUE.
       IF( ABS( CVAL ) .LT. 1.0 ) GO TO 190
C****** CVAL IS THE NUMBER TO BE PLACED ON THE CONTOURS *****
       XVAL = CVAL
C**** CALCULATE THE NUMBER OF DIGITS IN THE NUMBER *****
       TEMP = INT( ALOG10( ABS( CVAL ) ) )
       TEMP = TEMP + 1.0
C***** IF MORE THAN 6 DIGITS USE THE OTHER METHOD *****
       IF( TEMP .GT. 6.0 ) GO TO 190
C**** THE WIDTH OF THE NUMBER IN PLOT INCHES *****
       XSEP = TEMP * 0.06 + 0.04
       IF( CVAL .GT. 0.0 ) GO TO 194
       GO TO 1935
C**** WE PLOT THE FIRST 3 SIGNIF&GANT DIGITS OF THE NUMBER *****
190    CONTINUE
       XVAL = 0.0
       XSEP = 0.11
       IF( TOUR .EQ. 0.0 ) GO TO 194
       XSEP = 0.22
       TEMP = ALOG10( ABS( TOUR ))
       TEMP = TEMP - FLOAT( INT( TEMP ) ) + 2.0
       IF( TEMP .LT. 2.0 ) TEMP = TEMP + 1.0
       XVAL = 10.0 ** TEMP
       XVAL = INT( XVAL + 0.5 )
       IF( TOUR .GT. 0.0 ) GO TO 194
       XVAL = -XVAL
1935   XSEP = XSEP + 0.06
194    XSEP2 = XSEP * 0.5 - 0.02
195    CONTINUE
       POS = .FALSE.
       IF( VAL .GE. 0.0 ) POS = .TRUE.
C
C      THIS SUBROUTINE INITIALIZES AND CONDUCTS THE SEARCH
C              F I R S T  C L E A R  A L L  S W I T C H E S
C
       ITEMP = ISON( NX , NY , -1 )
C
C     S E A R C H  F O R  A  B O T T O M  E D G E  C O N T O U R
C
       JRP = 1
       JSP = 1
       DO 1 I = 2 , NX
       IF( ZP( I , 1 ) .LE. TOUR ) GO TO 1
       J = I - 1
       IF( ZP( J , 1 ) .GT. TOUR ) GO TO 1
       IRP = I
       ISP = J
       CALL TOURA(   IDIMX ,  XP , YP , ZP )
1      CONTINUE
C
C      S E A R C H  T H E  R I G H T  E D G E
C
       ISP = NX
       IRP = NX
       DO 15 I = 2 , NY
       IF( ZP( NX , I ) .LE. TOUR ) GO TO 15
       J = I - 1
       IF( ZP( NX , J ) .GT. TOUR ) GO TO 15
       JSP = J
       JRP = I
       CALL TOURA(   IDIMX ,  XP , YP , ZP )
15     CONTINUE
C
C      S E A R C H  T H E  T O P  E D G E
C
       ITEMP = NX - 1
       JRP = NY
       JSP = NY
       DO 2 I = 1 , ITEMP
       II = NX - I
       IF( ZP( II , NY  ) .LE. TOUR ) GO TO 2
       J = II + 1
       IF( ZP(   J , NY ) .GT. TOUR ) GO TO 2
       IRP = II
       ISP = J
       CALL TOURA(   IDIMX ,  XP , YP , ZP )
2      CONTINUE
C
C      S E A R C H  F O R  A  L E F T  E D G E  C O N T O U R
C
       JTEMP = NY - 1
       IRP = 1
       ISP = 1
       DO 25 I = 1 , JTEMP
       II = NY - I
       IF( ZP( 1 , II ) .LE. TOUR ) GO TO 25
       J = II + 1
       IF( ZP( 1 , J ) .GT. TOUR ) GO TO 25
       JRP = II
       JSP = J
       CALL TOURA(   IDIMX ,  XP , YP , ZP )
25     CONTINUE
C
C      S E A R C H  T H E  R E S T  O F  T H E  A R R A Y
C
       DO 30 I = 2 , JTEMP
       DO 26 J = 2 , NX
       JJ = J - 1
       IF( ZP( J , I ) .LE. TOUR)GO TO 26
       IF( ZP( JJ , I ) .GT. TOUR ) GO TO 26
       IF( ISON( J , I , 0 ) .EQ. 1 ) GO TO 26
       IRP = J
       ISP = JJ
       JRP = I
       JSP = I
      CLOSED=.TRUE.
      NPTS = 0
      DO 40 IRCL=1,8
   40 R8(IRCL) = 0.0
      CALL TOURA( IDIMX, XP, YP, ZP )
      ARYDX = 0.
      ARXDY = 0.
      XBAR = 0.
      YBAR = 0.
      TOURTM = TOUR / MAX * 100.
      IF (CLOSED) GO TO 42
      IF (SAVEA) WRITE(10,41)TOURTM
   41 FORMAT('0CONTOUR = ',F9.3,'   IS NOT CLOSED.')
   42 IF (NPTS.LE.1) GO TO 26
      IF (.NOT.BATCH) GO TO 26
C    FORM AREAS AND CENTROID IN UNITS OF INTERDIODE SPACING = 1.
      ARYDX=0.5*DABS(YDX)/((XYSCL)**2)
      ARYMAS = ARYDX * (SCALE*DELIN)**2
      ARYBMS = ARYMAS / (3.14159 * BEAMNS * BEAMEW / (4.*LOG(2.)) )
      XBAR=0.25*XYDX/(ARYDX*(XYSCL**3))
      YBAR=0.25*YXDY/(ARYDX*(XYSCL**3))
      XBAR = ABS(XBAR) 
      YBAR = ABS(YBAR)
      XCENTER = XLEFT  + XBAR*SCALE*DELIN
      YCENTER = BOTTOM + YBAR*SCALE*DELIN
      RSTAR = SQRT(ARYDX/3.141593)
      IF(RSTAR.LE.RADMIN) GO TO 26
      ARYDX = ARYDX * DELIN**2
      IF (SAVEA) WRITE (10,43) TOURTM,ARYDX,ARYBMS,XCENTER,YCENTER
   43 FORMAT (' ',6X,F6.2,6X,F10.3,8X,F12.4,6X,F8.1,5X,F8.1)
26     CONTINUE
30     CONTINUE
       RETURN
       END

      FUNCTION ISON( NI, NJ, IND )
C***********************************************************************
C* THIS FUNCTION SUBROUTINE HANDLES AN ARRAY OF ONE                    *
C*BIT FLAGS. THE BITS ARE TESTED USING MULTIPLICATION AND              *
C*DIVISION AND SET USING ADDITION. THUS THIS SUBROUTINE                *
C*IS ALMOST MACHINE INDEPENDANT. IT SHOULD WORK UNCHANGED              *
C*ON ANY MACHINE HAVING A WORD LENGTH LESS THEN 32 BITS.               *
C*                                                                     *
C*FOR MACHINES WITH A SMALLER WORDSIZE AND OPTIONALLY                  *
C*FOR A MACHINE WITH A LARGER WORDSIZE SET THE SIZE                    *
C*OF THE 'IMASK' ARRAY AND THE VALUE FOR 'NBITS' TO                    *
C*THE WORDSIZE-1.( E.G. FOR A 36 BIT MACHINE SET THEM                  *
C*TO 35).                                                              *
C*                                                                     *
C*THE IARRAY SIZE ALLOWS A TOTAL OF 263000 (? HAS BEEN INCREASED -RSS) FLAGS.
C*IT MAY BE INCREASED TO HANDLE LARGER CASES.                          *
C*THE VARIABLE 'NWORDS' SHOULD BE SET TO THE SAME                      *
C*VALUE AS THE SIZE OF THAT ARRAY.                                     *
C*                                                                     *
C*&ND = -1 : CLEAR THE ARRAY OF FLAGS. SAVE NI AS                      *
C*           VALUE FOR THE FIRST DIMENSION.                            *
C*    = 0  : CHECK THE FLAG ONLY.                                      *
C*    = +1 : CHECK THE FLAG, IF OFF SET IT.                            *
C*                                                                     *
C*ISON = 0 : IF THE FLAG WAS NOT SET.                                  *
C*     = 1 : IF THE FLAG WAS SET.                                      *
C*                                                                     *
C***********************************************************************
      DIMENSION IARRAY(20000),IMASK(31)
      DATA NWORDS/20000/,NBITS/31/
      LOGICAL FIRST
      DATA FIRST / .TRUE. /
C*** IF IND EQUALS -1 INITIALIZE THINGS.
      IF( IND .NE. (-1) ) GO TO 200
C*** CHECK IF FIRST TIME THROUGH. IF SO INIT IMASK.
      IF( .NOT. FIRST ) GO TO 100
      FIRST = .FALSE.
      DO 50 I = 1 , NBITS
50    IMASK( I ) = 2 ** (I-1)
100   DO 150 I = 1 , NWORDS
150   IARRAY( I ) = 0
      NN = NI
      ISON = 0
      RETURN
C*** CALCULATE IWORD - WORD FLAG IS IN AND ...
C***           IBIT - THE BIT LOCATION IN THE WORD.
200   IPOS = ( NJ - 1 ) * NN + NI
      IWORD = IPOS / NBITS
      IBIT = IPOS - IWORD * NBITS + 1
      IWORD = IWORD + 1
      IF( IWORD .LE. NWORDS ) GO TO 300
      WRITE( 6 , 61 )
61    FORMAT( ' CNTOUR (ISON) ERROR: MAP TOO LARGE ' , /
     1        '        DIMENSIONS IN ISON MUST BE INCREASED. ' )
      STOP
C*** NOW CHECK THE FLAG.
300   ISON = 1
      ITEMP = IARRAY( IWORD ) / IMASK( IBIT )
      IF( (ITEMP/2)*2 .EQ. ITEMP ) ISON = 0
C*** IF IND .EQ. ZERO JUST RETURN.
      IF( IND .EQ. 0 ) RETURN
C*** ELSE SET THE FLAG ( IF NECCESSARY )
      IF( ISON .EQ. 0 ) IARRAY(IWORD) = IARRAY(IWORD) + IMASK(IBIT)
      RETURN
      END
	SUBROUTINE ONEPLT (ZP,NX,NY,VALUE)
C
C  This subroutine makes a 1d plot of an array
C
	COMMON /BYRSS1/ HEADER,BEAMNS,BEAMEW,ANGLE,SCALE,MAX,DELIN,FREQ
	COMMON /PARAM/ NCN,NV,PERCEN,MAXK,MAXJY,XLEFT,RIGHT,TOP,BOTTOM
     +		      ,FLUX,DEFCON,TPERCM,JYPERBM
	COMMON /ID/ IDGRPH
	COMMON /JT/ JTYPE, SAMETT, SETERR, ISSOFT, SAVEA, IWIDTH
	COMMON /INM/ INMODL
C
	CHARACTER*4   YS
	CHARACTER*24  BB, CC, DD, EE
	CHARACTER*26  BC
	CHARACTER*40  INMODL
	CHARACTER*80  HEADR
	CHARACTER*50  MODFILE
	integer color1d(4)
	REAL * 8 HEADER(10), VALUE(NV)
	REAL * 4 MAX, MAXK, MAXJY, JYPERBM
	LOGICAL*4 SAMETT, SETERR, ISSOFT, SAVEA
	DIMENSION ONED(512), PERCEN(26), ZP(NX,NY), DEFCON(26)
	PARAMETER (DTR=.0174533)
C
C  Get one dimensional array to be plotted:
	DO 5 I = 1,NX
    5	  ONED(I) = 0.0
	IF (VALUE(61) .NE. 0.) THEN		! no PEAKPLT
C	  Integrate flux along desired PA
	  DO 10 I = 1,NX
	    DO 10 J = 1,NY
	      ONED(I) = ONED(I) + ZP(I,J)
   10	  CONTINUE
C	  Normalize to Jy/mas, and find max
	  PEAK = 0.
	  DO 20 I = 1,NX
	    ONED(I) = ONED(I) * DELIN * SCALE * 1.E-6
	    IF (PEAK .LT. ONED(I)) PEAK = ONED(I)
   20	  CONTINUE
C  Set vertical scale
	  IF (VALUE(55) .GT. 0.)  THEN
	    XPEAK = VALUE(55)
	  ELSE
  	    XPEAK = PEAK
	  ENDIF
	  WRITE (6,1014)  PEAK
	  WRITE (6,1005) XPEAK
	ELSE
C	  Find peak flux projected onto X axis		(PEAKPLT)
	  DO 25   I = 1, NX
	    DO 25 J = 1, NY
	      IF (ONED(I) .LT. ZP(I,J)) ONED(I) = ZP(I,J)
   25	  CONTINUE
	  PEAK = MAXJY
	  PEAKTB = PEAK * 1.38E12 / FREQ**2
C  Set vertical scale
	  IF (VALUE(55) .GT. 0.)  THEN			! ONEDMAX
	    XPEAK= VALUE(55) / (BEAMNS * BEAMEW * 3.14159/(4.E6*LOG(2.)))
	    TMAX  = VALUE(55)
	  ELSE
	    XPEAK = PEAK
	    TMAX  = JYPERBM
	  ENDIF
	  WRITE (6,1022) PEAK
	  WRITE (6,1023) JYPERBM
	  WRITE (6,1027) PEAKTB
 1027	  FORMAT ('    =',1PE8.2,' DEGREES K    ')
	  WRITE (6,1024) TMAX
	ENDIF
C
C  Start plotting:
C
C	Set up the color array
	DO I=1,4
	 COLOR1D(I) = VALUE(93+I)
	ENDDO
C
C
C  Plot grid
	CALL GRSCI(COLOR1D(1))
	XMAX = INT( (RIGHT-XLEFT)/SCALE + 0.5 )
	YMAX = 9.33071
	Y = 9.33071
	YSCALE = 1.0
	DO 30 I = 1,12
	  CALL GRMOVA (0,Y)
	  CALL GRSLW(IWIDTH)
	  CALL GRLINA (0.1,Y)
	  CALL GRLINA (XMAX-0.1,Y)
	  CALL GRLINA (XMAX,Y)
	  CALL GRSLW(1)
	  ENCODE (4,1020,YS) YSCALE
 1020	  FORMAT (F4.1)
	  IF (YSCALE.LT.1.)
     +	  CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,0.1,YPLUS,YS)
	  Y = Y - .787402
	  YPLUS = Y
	  IF (I .EQ. 12) YPLUS = Y + 0.05
	  YSCALE = YSCALE - .1
   30	CONTINUE
	ISTOP = XMAX + 1
	CALL GRSLW(IWIDTH)
	DO 40 I = 1, ISTOP
	  X = I-1
	  CALL GRMOVA (X,.66929)
	  CALL GRLINA (X,.76929)
	  CALL GRMOVA (X,YMAX-0.1)
	  CALL GRLINA (X,YMAX)
   40	CONTINUE
C
C	Draw window:
	CALL GRLINA (X,.66929)
	CALL GRLINA (0,.66929)
	CALL GRLINA (0,YMAX)
	CALL GRLINA (X,YMAX)
C
C  Plot function:
	NPLOT = XMAX/DELIN
	X = DELIN/2.
	Y = (ONED(1)/XPEAK)*7.87402 + 1.45669
	CALL GRSCI(COLOR1D(2))
	CALL GRMOVA (X,Y)
	DO 50 I = 2, NPLOT
	  X = DELIN * (I-0.5)
	  Y = (ONED(I)/XPEAK) * 7.87402 + 1.45669
	  IF (Y .GT. YMAX) Y = YMAX	    ! Prevent plotting outside window
	  IF (Y .LT. 0.66929) Y = 0.66929   ! Prevent plotting outside window
	  CALL GRLINA (X,Y)
   50	CONTINUE
	CALL GRSLW(1)
C
C  Plot header:
	ENCODE (80, 1000, HEADR) HEADER
 1000	FORMAT (10A8)
	CALL GRSCI(COLOR1D(3))
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,.5,9.6,HEADR)
C
C 	Plot BEAMNS, BEAMEW, ANGLE, SCALES, FREQ, MAX, LEFT, etc.
	BANGLE = ANGLE - VALUE(44)
	IF (ISSOFT) GO TO 100
	IF (BEAMNS .GE. 10. .OR. BEAMEW .GT. 10.) THEN
	  ENCODE (24, 1001, BB) BEAMNS, BEAMEW
 1001	  FORMAT (' BEAM = ',F4.1,' BY ',F4.1,' MAS')
	ELSE
	  ENCODE (24, 1016, BB) BEAMNS, BEAMEW
 1016	  FORMAT (' BEAM = ',F4.2,' BY ',F4.2,' MAS')
	ENDIF
	ENCODE (24, 1002, CC) BANGLE
 1002	FORMAT (' BEAM ANGLE =  ',F5.1,' DEG')
	ENCODE (24, 1003, DD) SCALE
 1003	FORMAT (' XSCALE =',F6.2,' MAS/TICK')
	SCALEM = SCALE * TPERCM
	ENCODE (24, 1026, EE) SCALEM
 1026	FORMAT ('        =',F7.3,' MAS/CM ')
	Y = 9.7
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,BB)
	Y = Y-0.2
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,CC)
	Y = Y-0.2
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,DD)
	Y = Y-0.2
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,EE)
	Y = Y-0.2
	ENCODE (24, 1004, EE) FREQ
 1004	FORMAT (' FREQ = ',F7.1,' MHZ    ')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,EE)
	Y = Y-0.2
C
	IF (VALUE(61) .NE. 0.) THEN
	  ENCODE (26, 1014, BC) PEAK
 1014	  FORMAT (' MAX = ',F8.2,' JY/MAS    ')
	  CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,BC)
	  Y = Y-0.2
	  ENCODE (26, 1005, BC) XPEAK
 1005	  FORMAT (' YMAX = ',F8.2,' JY/MAS   ')
	  CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,BC)
	  Y = Y-0.2
	ELSE
	  ENCODE (26,1022,BC) PEAK
	  ENCODE (24,1023,CC) JYPERBM
	  ENCODE (24,1024,EE) TMAX
 1022	  FORMAT (' MAX=',1PE8.2,' JY/SQ ARCSEC')
 1023	  FORMAT ('    =',F9.4,' JY/BEAM  ')
 1024	  FORMAT (' YMAX=',F9.4,' JY/BEAM ')
	  CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,BC)
	  Y = Y-0.2
	  CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,CC)
	  Y = Y-0.2
	  CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,EE)
	  Y = Y-0.2
	ENDIF
C
	ENCODE (24, 1015, BB) FLUX
 1015	FORMAT (' TOTAL FLUX =',F6.2,' JY  ')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,BB)
	Y = Y-0.2
	ENCODE (24,1017,BB)
 1017	FORMAT (' INPUT MODEL FILE =     ')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,BB)
	Y = Y-0.2
	INQUIRE (FILE=INMODL,NAME=MODFILE)
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.1,Y,MODFILE(1:25))
	Y = Y - 0.2
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.1,Y,MODFILE(26:50))
	Y = Y-0.3
	ENCODE (24, 1013, BB)
 1013	FORMAT (' WINDOW:   ')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,BB)
	Y = Y-0.2
	ENCODE (24, 1011, BB) XLEFT, RIGHT
 1011	FORMAT (' L=',F7.2,'   R=',F7.2)
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,BB)
	Y = Y-0.2
	ENCODE (24, 1012, BB) TOP, BOTTOM
 1012	FORMAT (' T=',F7.2,'   B=',F7.2)
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,BB)
	Y = Y-0.2
C
C  Draw the beam onto plot
  100	ENCODE (24, 1010, BB)
 1010	FORMAT ('RESTORING BEAM')
	CALL GRSCI(COLOR1D(1))
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.7,1.0,BB)
	IF (BEAMNS .EQ. BEAMEW) THEN
	  XBIG = BEAMNS / 2.
	ELSE
	  XBIG = 0.
	  ROT = (BANGLE + VALUE(44)) * DTR
	  SQRL = BEAMNS*BEAMNS / 4.
	  SQRS = BEAMEW*BEAMEW / 4.
	  IF (SQRL .EQ. 0.) SQRL=1.E-6
	  IF (SQRS .EQ. 0.) SQRS=1.E-6
	  DO 110 I = 1, 180
	    THETA = I * DTR
	    R2 = 1. / ( ( (SIN(THETA))**2/SQRS )+( (COS(THETA))**2/SQRL))
	    R = SQRT (R2)
	    X = R * SIN(THETA - ROT)
	    IF (XBIG .LT. ABS(X)) XBIG = ABS(X)
  110	  CONTINUE
	ENDIF
	HWHM = XBIG / SCALE
	FWHM = XBIG * 2.
	A = LOG(.5) / (HWHM*HWHM)
	ENCODE (24, 1021, BB) FWHM
 1021	FORMAT ('FWHM =',F7.2,'  MAS      ')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.375,0.66929,BB)
C  Plot beam:
	CALL GRSCI(COLOR1D(4))
	CALL GRMOVA (10.,1.45669)
	CALL GRSLW(IWIDTH)
	CALL GRLINA (13.,1.45669)
	X = 10.
	RX = -1.5
	RX2 = RX*RX
	AX2 = A * RX2
	IF (AX2 .LT. -6) THEN
	  Y = 1.45669
	ELSE
	  Y = 1.5748 * EXP(AX2) + 1.45669
	ENDIF
	CALL GRMOVA(X,Y)
C
	DO 120 I = 1,100
	  X = 10. + .03*I
	  RX = -1.5 + .03*I
	  RX2 = RX*RX
	  AX2 = A * RX2
	  IF (AX2 .LT. -6) THEN
	    Y = 1.45669
	  ELSE
	    Y = 1.5748 * EXP(AX2) + 1.45669
	  ENDIF
	  CALL GRLINA(X,Y)
  120	CONTINUE
	CALL GRSLW(1)
C
C	Write position angle onto plot:
	PA = 90-VALUE(44)
	ENCODE (48,1019,HEADR) PA
 1019	FORMAT ('ONE DIMENSIONAL PLOT ALONG P.A. =',F6.1,' DEGREES ')
	CALL GRSCI(COLOR1D(3))
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,0.1,0.1,HEADR)
	IF (VALUE(61) .EQ. 0.) THEN
	  ENCODE (24,1025,BB)
 1025	  FORMAT (', ALONG PEAK BRIGHTNESS ')
	  CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,7.95,0.1,BB)
	ENDIF
C
	CALL GRSCI(1)
C
	RETURN
	END
	SUBROUTINE PLTTIT (VALUE,XINCHS)
	COMMON /BYRSS1/ HEADER,BEAMNS,BEAMEW,ANGLE,SCALE,MAX,DELIN,FREQ
	COMMON /PARAM/ NCN,NV,PERCEN,MAXK,MAXJY,XLEFT,RIGHT,TOP,BOTTOM,
     +		      FLUX,DEFCON,TPERCM,JYPERBM
	COMMON /ID/ IDGRPH
	COMMON /XSZ/ XSIZE
	COMMON /JT/ JTYPE, SAMETT, SETERR, ISSOFT, SAVEA, IWIDTH
	COMMON /INM/ INMODL
	PARAMETER (DEGRAD=57.2957795)
	CHARACTER*10  XX
	CHARACTER*24  BB, CC, DD, EE
	CHARACTER*26  BC
	CHARACTER*40  INMODL
	CHARACTER*80  HEADR
	CHARACTER*52  ROT
	CHARACTER*50  MODFILE
	integer color2d(5)
	REAL * 8 HEADER(10), VALUE
	REAL * 4 MAX, MAXK, MAXJY, JYPERBM
	LOGICAL*4 SAMETT,SETERR,ISSOFT
	DIMENSION PERCEN(26), VALUE(NV), DEFCON(26)
C
C	Set up the color array
	DO I=1,5
	 COLOR2D(I) = VALUE(88+I)
	ENDDO
C
C  PLOT HEADER
	ENCODE (80, 1000, HEADR) HEADER
 1000	FORMAT (10A8)
	call grsetc(idgrph,2.0*xsize)
	CALL GRSCI(COLOR2D(4))
	YLP = (ABS(TOP-BOTTOM)/SCALE)-0.4
	IF (VALUE(98) .GE. 0.) THEN	! labels present
	 CALL GRCHAR(IDGRPH,.FALSE.,0.0,.FALSE.,1.5,YLP,HEADR)
	ELSE
	 CALL GRCHAR(IDGRPH,.FALSE.,0.0,.FALSE.,.5,YLP,HEADR)
	ENDIF
	call GRSETc(idgrph,xsize)
C
	IF (VALUE(87) .GE. 0.0) GOTO 333   ! NOTEXT flag on
C
C   WRITE BEAMNS, BEAMEW, ANGLE, SCALE, FREQ, MAX, LEFT, ETC. ONTO PLOT
	IF (ISSOFT) GO TO 100
	CALL GRSCI(COLOR2D(5))
	IF (BEAMNS .GE. 10. .OR. BEAMEW .GT. 10.) THEN
	  ENCODE (24, 1001, BB) BEAMNS, BEAMEW
 1001	  FORMAT (' BEAM = ',F4.1,' BY ',F4.1,' MAS')
	ELSE
	  ENCODE (24, 1016, BB) BEAMNS, BEAMEW
 1016	  FORMAT (' BEAM = ',F4.2,' BY ',F4.2,' MAS')
	ENDIF
	ENCODE (28, 1002, CC) ANGLE
 1002	FORMAT (' BEAM ANGLE =  ',F5.1,' DEG')
	ENCODE (24, 1003, DD) SCALE
 1003	FORMAT (' SCALE =',F7.2,' MAS/TICK')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,9.3,DD)
	SCALEM = SCALE * TPERCM
	ENCODE (24, 1020, DD) SCALEM
 1020	FORMAT ('       =',F8.3,' MAS/CM ')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,9.1,DD)
	ENCODE (24, 1004, EE) FREQ
 1004	FORMAT (' FREQ = ',F7.1,' MHZ    ')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,9.5,CC)
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,9.7,BB)
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,8.9,EE)
	ENCODE (24, 1009, BB) MAXK
 1009	FORMAT (' MAX= ',1PE8.2,' DEGREES K')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,8.7,BB)
	ENCODE (26, 1014, BC) JYPERBM
 1014	FORMAT ('    =',F9.4,' JY PER BEAM')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,8.5,BC)
	ENCODE (24, 1015, BB) FLUX
 1015	FORMAT (' TOTAL FLUX =',F6.2,' JY')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,8.3,BB)
	ENCODE (24,1017,BB)
 1017	FORMAT (' INPUT MODEL FILE =     ')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,8.1,BB)
	INQUIRE (FILE=INMODL,NAME=MODFILE)
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.1,7.9,MODFILE(1:25))
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.1,7.7,MODFILE(26:50))
	ENCODE (24, 1013, BB)
 1013	FORMAT (' WINDOW:   ')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,7.4,BB)
	ENCODE (24, 1011, BB) XLEFT, RIGHT
 1011	FORMAT (' L=',F7.2,'   R=',F7.2)
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,7.2,BB)
	ENCODE (24, 1012, BB) TOP, BOTTOM
 1012	FORMAT (' T=',F7.2,'   B=',F7.2)
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,7.0,BB)
C  Write contour levels onto plot:
	ENCODE (24, 1005, BB)
 1005	FORMAT (' CONTOURS IN PERCENT:   ')
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,6.6,BB)
	ISTOP = NCN + 3
	Y = 6.6
	DO 10 I = 3,ISTOP,3
	  JSTOP = I
	  JSTART = I-2
	  IF (JSTOP .GT. NCN) JSTOP = NCN
	  ENCODE (24, 1006, BB) (PERCEN(J), J=JSTART, JSTOP)
 1006	  FORMAT (3F8.3)
C1006	  FORMAT (F6.<2-INT(LOG10 (ABS(PERCEN(J))+0.0101) )>,
C    +	  F6.<2-INT(LOG10 (ABS(PERCEN(J))+0.0101) )>,
C    +		  F6.<         2-INT(LOG10 (ABS(PERCEN(J))+0.0101) )  >,
C1006	  FORMAT (F6.<MAX0(0,(2-INT(LOG10 (ABS(PERCEN(J))+0.0101) )))>,
C    +	  	  F6.<MAX0(0,(2-INT(LOG10 (ABS(PERCEN(J))+0.0101) )))>,
C    +	  	  F6.<MAX0(0,(2-INT(LOG10 (ABS(PERCEN(J))+0.0101) )))>,
C    +	  	  F6.<MAX0(0,(2-INT(LOG10 (ABS(PERCEN(J))+0.0101) )))> )
	  Y = Y - .2
	  CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,BB)
   10	CONTINUE
C  Print contour values in units of 1E8 K or Jy/beam:
	IF (VALUE(30) .EQ. 1.)  THEN
	  ENCODE (24, 1007, BB)
 1007	  FORMAT (' CONTOURS IN 1E8 DEG:   ')
	ELSE
	  ENCODE (24, 1021, BB)
 1021	  FORMAT (' CONTOURS IN JY/BEAM:   ')
	ENDIF
	Y = Y - .4
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,BB)
	ISTOP = NCN + 2
	DO 40 I = 3,ISTOP,3
	  JSTART = I - 2
	  JSTOP = I
	  IF (JSTOP .GT. NCN) JSTOP = NCN
	  IF (VALUE(30) .EQ. 1) THEN
	    ENCODE (24, 1008, BB) (DEFCON(J), J=JSTART, JSTOP)
 1008	    FORMAT (3F8.1)
	  ELSE
	    ENCODE (24,1022,BB) (JYPERBM*0.01*PERCEN(J), J=JSTART, JSTOP)
 1022	    FORMAT (3F8.3)
	  ENDIF
	  Y = Y - .2
	  CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.,Y,BB)
   40	CONTINUE
C
C  Draw the beam onto plot
  100	ENCODE (24, 1010, BB)
 1010	FORMAT ('RESTORING BEAM')
	CALL GRSCI(COLOR2D(4))
	CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,10.7,0.5,BB)
	AXLONG = BEAMNS/SCALE
	AXSHRT = BEAMEW/SCALE
	XCENTR= 11.5
	YCENTR = 2.0
	BMANGL = ANGLE + VALUE(44)
	CALL GRSLW(IWIDTH)
	CALL BMPLOT(AXLONG,AXSHRT,BMANGL,XCENTR,YCENTR,IDGRPH,.FALSE.)
C
C	Entry point for not plotting text outside plot window
 333	CONTINUE
	IF (VALUE(74) .GE. 0.) THEN
C	  Draw beam onto plot in lower right corner
	  ENCODE(10, 1040, XX)
 1040	  FORMAT('BEAM')
	  AXLONG = BEAMNS/SCALE
	  AXSHRT = BEAMEW/SCALE
	  BMANGL = ANGLE + VALUE(44)
	  CALL GRSCI(COLOR2D(4))
	  CALL GRSLW(IWIDTH)
	  IF (VALUE(74) .EQ. 0.) THEN
	   IF (VALUE(98) .GE. 0.) VALUE(74) = 1.5  ! labels present
	   IF (VALUE(98) .LT. 0.) VALUE(74) = 1.0
	  ENDIF
	  XCENTR = VALUE(74)
	  YCENTR = VALUE(74)
	  CALL BMPLOT(AXLONG,AXSHRT,BMANGL,XCENTR,YCENTR,IDGRPH,.TRUE.)
	  XLAB = XCENTR-0.2
	  YLAB = YCENTR-0.2-( (AXLONG/2)*COS(BMANGL/DEGRAD) )
	  CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,XLAB,YLAB,XX)
	ENDIF
C
	IF (VALUE(75) .GE. 0) THEN
C	  Draw scale onto plot in lower left corner
	  IF (VALUE(75) .EQ. 0.) VALUE(75) = SCALE
	  ENCODE (10, 1030, XX) VALUE(75)
 1030	  FORMAT (F4.1,' MAS  ')
	  ILX = XINCHS - 0.5
	  XL = ILX
	  CALL GRMOVA(XL,1.1)
	  CALL GRLINA(XL,1.0)
	  XL = XL - VALUE(75)/SCALE
	  CALL GRLINA(XL,1.0)
	  CALL GRLINA(XL,1.1)
	  XLCPOS = XL + ((VALUE(75)/SCALE)/2.0)-0.4 ! position for label
	 CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,XLCPOS,1.1,XX)
	ENDIF
C
	CALL GRSLW(1)
C
C  Write non-zero rotation angle onto plot:
	IF (VALUE(44) .NE. 0.) THEN
	  ENCODE (52,1019,ROT) VALUE(44)
 1019	  FORMAT ('MODEL AND BEAM HAVE BEEN ROTATED BY ',F6.1,' DEGREES')
	  CALL GRSCI(COLOR2D(5))
	 IF (VALUE(98) .GE. 0.) THEN	! labels present
	  CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,2.0,0.4,ROT)
	 ELSE
	  CALL GRCHAR (IDGRPH,.FALSE.,0.0,.FALSE.,0.15,0.15,ROT)
	 ENDIF
	ENDIF
C
	CALL GRSCI(1)
C
	RETURN
	END
	SUBROUTINE SETUP(PLOTFILE,PLOTTYPE)
C-----------------------------------------------------------------------
C Modified 4-MAR-1981
C Re-written 3-june-1982:New GRPCKG
C This subroutine sets up plotting units for MODPLOT.
C-----------------------------------------------------------------------
	PARAMETER (PIXBUF=5.0)
	CHARACTER*40	PLOTFILE
        CHARACTER*80    PLOTOUT
        CHARACTER*40    INMODL
	CHARACTER*8	PLOTTYPE
C
	LOGICAL*4	SAMETT, SETERR, ISSOFT, SAVEA
	INTEGER*4 	GROPEN
C
	COMMON /ID/ IDGRPH
	COMMON /XSZ/ XSIZE
	COMMON /JT/ JTYPE, SAMETT, SETERR, ISSOFT, SAVEA, IWIDTH
	COMMON /INM/ INMODL
	COMMON /PARAM/ NCN,NV,PERCEN,MAXK,MAXJY,XLEFT,RIGHT,TOP,BOTTOM
     +		      ,FLUX,DEFCON,TPERCM,JYPERBM
	REAL*4 DEFCON(26),PERCEN(26),JYPERBM
C
C
      JUNIT = 7
C
      IF(.NOT.SETERR) CALL GRCLOS(IDGRPH)
      IER = GROPEN(JTYPE,JUNIT,PLOTFILE,IDGRPH)
C
	IF (IER .NE. 1 ) THEN
C	  Gropen failed, so give user another chance:
	  WRITE (6,1001) ' I am unable to open ',PLOTFILE
	  WRITE (6,1001) ' ****** Please try again. ****** '
	  SETERR = .TRUE.
	  RETURN
	ELSE
	  SETERR = .FALSE.
	ENDIF
C
C	Determine if plot is going to user's terminal
C
      SAMETT = .FALSE.
      ISSOFT = .FALSE.
      CALL GRQDT(PLOTOUT)
      L = LEN1(PLOTOUT)
      WRITE (6,1003) PLOTOUT(1:L)
C
C	Set scale so that plotting occurs on a 10x13 area.
	ENTRY SETUPE
	CALL GRSIZE (IDGRPH,XSZDEF,YSZDEF,XSZMAX,YSZMAX,XPERIN,YPERIN)
C
C	Set up a plotting area that has 13 units in x and 10 in y
C	with a PIXBUF pixel buffer on all sides
	XORG = PIXBUF
	YORG = PIXBUF
	TWOBUF = 2*PIXBUF
	XINCH = (XSZDEF - TWOBUF) / XPERIN
	YINCH = (YSZDEF - TWOBUF - 1.) / YPERIN
	IF (XINCH .LE. 1.3*YINCH) THEN
	  XSCALE = (XSZDEF - TWOBUF) / 13.
	  YSCALE = (XSZDEF - TWOBUF) * (YPERIN/XPERIN) / 13.
	  XSIZE = (XSZDEF - TWOBUF) / 160.
	  TPERCM = 13. / (2.54*XINCH)
	ELSE
	  XSCALE = (YSZDEF - TWOBUF - 1.) * (XPERIN/YPERIN) / 10.
	  YSCALE = (YSZDEF - TWOBUF - 1.) / 10.
	  XSIZE = XSCALE / 16.
	  TPERCM = 10. / (2.54*YINCH)
	ENDIF
C
	CALL GRTRAN (IDGRPH,XORG,YORG,XSCALE,YSCALE)
	CALL GRSETC (IDGRPH,XSIZE)
	CALL GRTERM(IDGRPH)
C
	RETURN
C
 1001	FORMAT (A,A,A,A)
 1003	FORMAT (/' Plot will go to: ',A)
	END

       SUBROUTINE TOURA( NNX ,  XP , YP , ZP )
C
C      PLACE PARAMETERS WE CAN IN COMMON
C
       COMMON / TOUR1C / TOUR , IIRP , JJRP , IISP , JJSP , NX , NY
       COMMON /TOUR2C/ IPEN, VAL, XVAL, SEP, PLACE, POS, XSEP, XSEP2
      COMMON /PLTTR/ KPLOT,KSKIP
C
C      TOUR = THE CONTOUR VALUE
C      IRP , JRP  = REFERENCE POINT
C      ISP , JSP  = POINT WE ARE CONTOURING TO
C
       DIMENSION XP( 2 ) , YP( 2 ) , ZP( NNX , 2 )
       DIMENSION IT( 9 )  , JT( 9 )
       DATA IT / 0 , 1 , 1 , 0 , 9 , 0 , -1 , -1 , 0 /
       DATA JT / -1 , 0 , 0 , -1 , 9 , 1 , 0 , 0 , 1 /
       LOGICAL DTEST( 9 )
       DATA DTEST / .FALSE. , .TRUE. , .FALSE. , .TRUE. , .FALSE. ,
     1  .TRUE. , .FALSE. , .TRUE. , .FALSE.                      /
      REAL*8 YDX,XDY,XYDX,YXDY,X2DY,Y2DX,DELX,DELY,DEL,R8(8),XA,YA,XB,YB
      LOGICAL CLOSED
      COMMON /TOUR3C/ XA,YA,XB,YB,DEL,R8,XFST,YFST,NPTS,CLOSED
      EQUIVALENCE (R8(1),YDX),(R8(2),XDY),(R8(3),XYDX),(R8(4),YXDY),
     1(R8(5),X2DY),(R8(6),Y2DX),(R8(7),DELX),(R8(8),DELY)
       IRP = IIRP
       JRP = JJRP
       ISP = IISP
       JSP = JJSP
      CLOSED=.TRUE.
       IPEN = +3
       GO TO 5
C
C      S W I T C H  P O I N T S
C
95     IRP = IN
       JRP = JN
5      CONTINUE
       CALL TOURB1( XP( IRP ) , YP( JRP ) , ZP( IRP , JRP ) ,
     1  XP( ISP ) , YP( JSP ) , ZP( ISP , JSP )  )
C
C      FIND THE NEXT POINT TO CHECK THROUGH A TABLE LOOKUP
C
       LOCATE = 3*( JRP - JSP ) + IRP - ISP + 5
C
C      IN , JN = THE NEW POINT
C
       IN = ISP + IT( LOCATE )
       JN = JSP + JT( LOCATE )
C
C      T E S T  F O R  A N  E D G E
C
       IF( IN .GT. NX .OR. IN .LT. 1 .OR. JN .GT. NY .OR. JN .LT. 1 )
     1  GO TO 120
C
C      I T  M A Y  B E  A  D I A G O N A L
C
       IF( LOCATE .NE. 6 ) GO TO 60
       IF( ISON( IRP , JRP , +1 ) .EQ. 1 ) RETURN
60     IF( DTEST( LOCATE ) ) GO TO 97
C
C      DETERMINE IF IT IS A CONTOUR OR SWITCH POINTS
C
       ZPP = ZP( IN , JN )
       IF( ZPP .GT. TOUR ) GO TO 95
       ISP = IN
       JSP = JN
       GO TO 5
C
C      D I A G O N A L S  G E T  S P E C I A L  T R E A T M E N T
C
C      CALCULATE THE HEIGHT AND LOCATION OF THE MIDPOINT
C
97     CONTINUE
       VX = ( XP( IRP ) + XP( IN )  )*0.5
       VY = ( YP( JRP ) + YP( JN )  )*0.5
       LOCATE = 3*( JRP - JN ) + IRP - IN + 5
       INN = IN + IT( LOCATE )
       JNN = JN + JT( LOCATE )
       HTM = ( ZP( IRP , JRP ) + ZP( ISP , JSP ) + ZP( IN , JN ) +
     1 ZP( INN , JNN )  )/4.0
       IF( HTM .GT. TOUR ) GO TO 975
C
C      M I D P O I N T  L E S S  T H A N  C O N T O U R
C
       CALL TOURB1( XP( IRP ) , YP( JRP ) , ZP( IRP , JRP ) ,
     1  VX , VY , HTM  )
       IF( ZP( INN , JNN ) .GT. TOUR ) GO TO 9715
C      T U R N O F F  S H A R P  R I G H T
       ISP = INN
       JSP = JNN
       GO TO 5
9715   CONTINUE
       CALL TOURB1( XP( INN ) , YP( JNN ) , ZP( INN , JNN ) ,
     1  VX , VY , HTM  )
       IF( ZP( IN , JN ) .GT. TOUR ) GO TO 9716
C      C O N T I N U E  S T R A I G H T  T H R O U G H
       IRP = INN
       JRP = JNN
       ISP = IN
       JSP = JN
       GO TO 5
C      W I D E  L E F T  T U R N
9716   CONTINUE
       CALL TOURB1( XP( IN ) , YP( JN ) , ZP( IN , JN ) , VX, VY, HTM)
       GO TO 95
C
C       M I D P O I N T  G R E A T E R  T H A N  C O N T O U R
C
975    CONTINUE
       CALL TOURB1( VX , VY , HTM , XP( ISP ) , YP( JSP ) , ZP( ISP ,
     1  JSP )  )
C      I T  M A Y  B E  A  S H A R P  L E F T  T U R N
       IF( ZP( IN  , JN  ) .GT. TOUR ) GO TO 95
       CALL TOURB1( VX , VY , HTM , XP( IN ) , YP( JN ) , ZP( IN , JN))
       IF( ZP( INN , JNN ) .GT. TOUR ) GO TO 976
C      W I D E  R I G H T  T U R N
       CALL TOURB1( VX , VY , HTM , XP( INN ) , YP( JNN ) ,
     1  ZP( INN , JNN )  )
       ISP = INN
       JSP = JNN
       GO TO 5
C      C O N T & N U E  S T - A & G H T  T H R O U G H
976    ISP = IN
       JSP = JN
       IRP = INN
       JRP = JNN
       GO TO 5
  120 CLOSED=.FALSE.
      RETURN
       END
       SUBROUTINE TOURB1( XRR , YRR , HR , XSS , YSS , HS )
       COMMON /TOUR2C/ IPEN, VAL, XVAL, SEP, PLACE, POS, XSEP, XSEP2
      COMMON /PLTTR/ KPLOT,KSKIP
	COMMON /ID/ IDGRPH
       LOGICAL PLACE , POS,NUMIN
      REAL*8 AVX,AVY
       COMMON / TOUR1C / TOUR , IRP , JRP , ISP , JSP , NX , NY
      REAL*8 YDX,XDY,XYDX,YXDY,X2DY,Y2DX,DELX,DELY,DEL,R8(8),XA,YA,XB,YB
      LOGICAL CLOSED
      COMMON /TOUR3C/ XA,YA,XB,YB,DEL,R8,XFST,YFST,NPTS,CLOSED
      EQUIVALENCE (R8(1),YDX),(R8(2),XDY),(R8(3),XYDX),(R8(4),YXDY),
     1(R8(5),X2DY),(R8(6),Y2DX),(R8(7),DELX),(R8(8),DELY)
      CHARACTER*5 OUT
C
       DATA YSEP/ 0.12  /,NUMIN/ .FALSE. /
C-----------------------------------------------------------------------
       IF( POS .OR. HS .GE. 0.0 ) GO TO 100
      IPEN=+3
      RETURN
100   CONTINUE
       XR = XRR
       YR = YRR
       XS = XSS
       YS = YSS
C***** LINEAR INTERPOLATION FOR THE CONTOUR *****
       DDX = XR - XS
       DDY = YR - YS
       FRAC = ( HR - TOUR ) / ( HR - HS )
       XPLOT = XR - FRAC*DDX
       YPLOT = YR - FRAC*DDY
C  START OF NEW CONTOUR.
      NPTS=NPTS + 1
      IF (NPTS.EQ.1) GO TO 900
C  SECTION TO INCREMENT AREAS AND CENTROID INTEGRALS. ***
      XA=XB
      YA=YB
      XB=XPLOT
      YB=YPLOT
      DELX=XB-XA
      DELY=YB-YA
      AVY=YA + YB
      YDX = YDX + AVY*DELX
      AVX = XA + XB
      XYDX = XYDX + AVX*AVY*DELX
      YXDY = YXDY + AVX*AVY*DELY
C***** PATCH TO PLOT NUMBERS ON THE CONTOURS - WJC *****
       IF( .NOT. PLACE  ) GO TO 1000
C**** START OF A NEW CONTOUR ... *****
       IF( IPEN .EQ. 3 ) GO TO 900
       DISTX = XPLOT - XST
       ADISTX = ABS( DISTX )
       DISTY = YPLOT - YST
       ADISTY = ABS( DISTY )
C***** ARE WE ALREADY SPACING FO- A NUMBER ... *****
       IF( NUMIN ) GO TO 950
C***** SHOULD WE START A NEW NUMBER ... *****
C****** ARE WE 'SEP' &NCHES FROM THE LAST NUMBER PLOTTED *****
       IF( ADISTX .LT. SEP .AND . ADISTY .LT. SEP ) GO TO 1000
C***** OR 'SEP' INCHES FROM THE FIRST NUMBER PLOTTED FOR THIS CONTOUR **
       IF( ABS( XPLOT - XFST ) .LT. SEP .AND. ABS( YPLOT - YFST )
     1 .LT. SEP ) GO TO 1000
       GO TO 940
C***** THE FIRST NUMBER ON EACH CONTOUR IS SAVED FOR CHECKING *****
900    CONTINUE
       XFST = XPLOT
       YFST = YPLOT
      XB=XFST
      YB=YFST
C****** START A NEW NUMBER *****
940    CONTINUE
       NUMIN = .TRUE.
       XST = XPLOT
       YST = YPLOT
       GO TO 1000
C***** IS THE SPACE BIG ENOUGH ****
950    CONTINUE
       IF( ADISTY .GE. YSEP ) GO TO 970
       IF( ADISTX .LT. XSEP ) RETURN
C***** NOW PLOT THE NUMBER ***
       TEMP = SIGN(XSEP , DISTX )
       XPLT = XST + TEMP
       YPLT = YST + XSEP * DISTY / ADISTX
       GO TO 975
970    TEMP = SIGN(YSEP , DISTY )
       YPLT = YST + TEMP
       XPLT = XST + YSEP * DISTX / ADISTY
975    CONTINUE
      ENUM=0.5*(XST+XPLT)-XSEP2-0.2
      FNUM=0.5*(YST+YPLT)-0.035
      NDLVL=XVAL
      WRITE (OUT, '(I5)') NDLVL
      CALL GRCHAR(IDGRPH, .FALSE., 0.0, .FALSE., ENUM, FNUM, OUT)
      CALL GRMOVA(XPLT,YPLT)
      IPEN=2
       NUMIN = .FALSE.
1000   CONTINUE
      IF(KPLOT.GT.0) THEN
	MODE = IPEN-1
      ELSE
	IF (KSKIP .GT. 0) THEN
	  MODE = 1
	ELSE
	  MODE = 2
	ENDIF
	IF (KSKIP .GE. 2) KSKIP = -3
	KSKIP = KSKIP + 1
      ENDIF
      CALL GRVECT(IDGRPH,MODE,.FALSE.,1,XPLOT,YPLOT)
      IPEN=2
       RETURN
       END
      SUBROUTINE FREDP(DATA,IMAX,JMAX,I1,I2,J1,J2,ANGLE,CUTOFF)
C
C            Draw isometric plot of array
C
      REAL DATA(IMAX,JMAX)
      INTEGER ADDRESS
      INTEGER LIB$GET_VM
C
      COMMON /CNTCOM/ IPLOT
C
      CALL GRPAGE(IPLOT)
      CALL GRSIZE(IPLOT,XSZDEF,YSZDEF,XSZMAX,YSZMAX,XPI,YPI)
C
      IDIM = (I2-I1+1)
      JDIM = (J2-J1+1)
      NL = IDIM*JDIM
C
C            Attempt to allocate storage
C
      IF(LIB$GET_VM(NL*4,ADDRESS).NE.1) CALL 
     1    ERROR('FREDP: dynamic allocation failed.')
C
C            Copy array into local storage
C
      CALL FREDCP(DATA,IMAX,JMAX,I1,I2,J1,J2,%VAL(ADDRESS),NL,CUTOFF)
C
C            Do the plot
C
      CALL FREDDY(%VAL(ADDRESS),IDIM,JDIM,AMIN1(XSZDEF,YSZDEF),ANGLE)
      CALL GRTERM(IPLOT)
C
C            Liberate the storage
C
      CALL LIB$FREE_VM(NL*4,ADDRESS)
C
      RETURN
      END
C=======================================================================
      SUBROUTINE FREDCP(DATA,IMAX,JMAX,I1,I2,J1,J2,LOCAL,NL,CUTOFF)
C
      REAL DATA(IMAX,JMAX), LOCAL(NL)
C
      ILOC=0
      DO 100 J=J2,J1,-1
      DO 100 I=I1,I2
            ILOC=ILOC+1
            LOCAL(ILOC)=DATA(I,J)
            IF(LOCAL(ILOC).GT.CUTOFF) LOCAL(ILOC)=CUTOFF
  100 CONTINUE
C
      RETURN
      END
C=======================================================================
      SUBROUTINE CPLOT(K,X,Y,Z)
      COMMON /CNTCOM/ IPLOT
      IF(K.EQ.0) THEN
          MODE=2
      ELSE IF(K.EQ.1) THEN
          MODE=1
      ELSE
          RETURN
      END IF
      CALL GRVECT(IPLOT,MODE,.FALSE.,1,X,Y)
      RETURN
      END
C======================================================================
C
      SUBROUTINE FREDDY(ARRAY,KX,NY,SIZE,ANGLE)
C
C            Draws isometric plot of array
C
      REAL ARRAY(KX,NY), SIZE, ANGLE
      REAL FMAX,FMIN,DELTAX,DELTAY,DELTAV,SINE,PEAK,X,DX
      INTEGER I,J,KI,KJ,NX,MX,MY,STEP,LEFT,RIGHT,IT
      LOGICAL VISBLE
      COMMON /FREDCM/ DELTAX,X,STEP,LEFT,RIGHT,IT,NX,VISBLE
C
      MN=KX*NY
      NX=KX
      IF(NX.LT.2 .OR. NY.LT.2) CALL ERROR('FREDDY: not an array')
      FMAX=ARRAY(1,1)
      FMIN=FMAX
      DO 20 J=1,NY
      DO 10 I=1,NX
          FMIN=AMIN1(ARRAY(I,J),FMIN)
   10     FMAX=AMAX1(ARRAY(I,J),FMAX)
   20 CONTINUE
      DELTAX=SIZE/(NX+NY)
      SINE=SIN(ANGLE/58.)
      DELTAY=DELTAX*SINE
      HEIGHT=SIZE*(1.-ABS(SINE))
      DELTAV=HEIGHT
      FMAX=FMAX-FMIN
      IF(FMAX.LT.0.0001) FMAX=DELTAV
      DELTAV=DELTAV/FMAX
      MX=NX+1
      MY=NY+1
      STEP=MX
C
C            Work our way down the Y axis, then up the X axis,
C            calculating the Y plotter coordinates for each
C            column of the plot, doing the hidden-line suppression
C            at the same time.
C
      DO 50 J=1,NY
      KJ=MY-J
      KI=1
C            ( KI,KJ are coordinates of bottom of column)
      ARRAY(KI,KJ)=DELTAY*(KI+KJ) + DELTAV*(ARRAY(KI,KJ)-FMIN)
   30 PEAK=ARRAY(KI,KJ)
   40 KI=KI+1
      KJ=KJ+1
      IF(KI.GT.NX .OR. KJ.GT.NY) GOTO 50
      ARRAY(KI,KJ)=DELTAY*(KI+KJ) + DELTAV*(ARRAY(KI,KJ)-FMIN)
      IF(ARRAY(KI,KJ).GT.PEAK) GOTO 30
      IF(ARRAY(KI,KJ).LE.PEAK) ARRAY(KI,KJ)=-ABS(ARRAY(KI,KJ))
      GOTO 40
   50 CONTINUE
C
C            Now to work our way up the X axis
C
      DO 80 I=2,NX
      KI=I
      KJ=1
      ARRAY(KI,KJ)=DELTAY*(KI+KJ)+DELTAV*(ARRAY(KI,KJ)-FMIN)
   60 PEAK=ARRAY(KI,KJ)
   70 KI=KI+1
      KJ=KJ+1
      IF(KI.GT.NX .OR. KJ.GT.NY) GOTO 80
      ARRAY(KI,KJ)=DELTAY*(KI+KJ)+DELTAV*(ARRAY(KI,KJ)-FMIN)
      IF(ARRAY(KI,KJ).GT.PEAK) GOTO 60
      IF(ARRAY(KI,KJ).LE.PEAK) ARRAY(KI,KJ)=-ABS(ARRAY(KI,KJ))
      GOTO 70
   80 CONTINUE
C
C            Draw a line along the bottom of the vertical faces
C
      CALL CPLOT(0, DELTAX*(NX+NY-2), DELTAY*(MX), 3)
      CALL CPLOT(1, DELTAX*(NY-1),    DELTAY*2, 2)
      CALL CPLOT(1, 0.0,              DELTAY*MY, 2)
C
C            Array is now ready for plotting.  If a point is
C            positive, then it is to be plotted at that Y
C            coordinate; if it is negative, then it is
C            invisible, but at minus that Y coordinate (the point
C            where the line heading towards it disappears has to
C            be determined by finding the intersection of it and
C            the cresting line).
C
C            Plot rows:
C
      DO 110 J=1,NY,2
      KJ=MY-J
      DX=DELTAX*(J-2)
      X=DX+DELTAX
      CALL CPLOT(0,X,DELTAY*(KJ+1),3)
      CALL CPLOT(1,X,ARRAY(1,KJ),2)
      VISBLE=.TRUE.
      DO 90 I=2,NX
          RIGHT=I+NX*(KJ-1)
          LEFT=RIGHT-1
          IT=RIGHT
          X=DX+DELTAX*I
          CALL FREDGO(ARRAY,MN)
   90 CONTINUE
C
C            Now at far end of row so come back
C
      KJ=KJ-1
      IF(KJ.LE.0) GOTO 170
      VISBLE = ARRAY(NX,KJ).GE.0.0
      DX=DELTAX*(NX+J)
      IF(VISBLE) CALL CPLOT(0,DX-DELTAX,ARRAY(NX,KJ),3)
      DELTAX=-DELTAX
      DO 100 I=2,NX
          KI=MX-I
          LEFT=KI+NX*(KJ-1)
          RIGHT=LEFT+1
          IT=LEFT
          X=DX+DELTAX*I
          CALL FREDGO(ARRAY,MN)
  100 CONTINUE
C
      X=DX+DELTAX*NX
      IF(.NOT.VISBLE) CALL CPLOT(0,X,ARRAY(1,KJ),3)
      CALL CPLOT(1,X,DELTAY*(KJ+1),2)
C            (set DELTAX positive for return trip)
      DELTAX=-DELTAX
  110 CONTINUE
C
C            Now do the columns:
C            as we fell out of the last DO-loop we do the
C            columns in ascending-X order
C
      INCX=1
      KI=1
C            (set DELTAX -ve since scanning R to L)
  120 DX=DELTAX*(KI+NY-1)
      DELTAX=-DELTAX
      X=DX+DELTAX
      CALL CPLOT(0,X,ARRAY(1,1),3)
  130 VISBLE=.TRUE.
      DO 140 J=2,NY
          LEFT=KI+NX*(J-1)
          RIGHT=LEFT-NX
          IT=LEFT
          X=DX+DELTAX*J
          CALL FREDGO(ARRAY,MN)
  140 CONTINUE
C
C            At far end, increment X and check still inside array
C
      KI=KI+INCX
      IF(KI.LE.0 .OR. KI.GT.NX) GOTO 180
      VISBLE=ARRAY(KI,NY).GE.0.0
      DELTAX=-DELTAX
      DX=DELTAX*(KI-2)
      X=DX+DELTAX
      IF(VISBLE) CALL CPLOT(0,X,ARRAY(KI,NY),3)
      DO 150 J=2,NY
          KJ=MY-J
          RIGHT=KI+NX*(KJ-1)
          LEFT=RIGHT+NX
          IT=RIGHT
          X=DX+DELTAX*J
          CALL FREDGO(ARRAY,MN)
  150 CONTINUE
C
      X=DX+DELTAX*NY
      IF(.NOT.VISBLE) CALL CPLOT(0,X,ARRAY(KI,1),3)
      IF(KI.EQ.1) GOTO 180
      CALL CPLOT(1,X,DELTAY*(KI+1),2)
      KI=KI+INCX
      IF(KI.GT.NX) GOTO 180
      IF(KI.EQ.1) GOTO 120
  160 DELTAX=-DELTAX
      DX=DELTAX*(1-KI-NY)
      X=DX+DELTAX
      CALL CPLOT(0,X,DELTAY*(KI+1),3)
      CALL CPLOT(1,X,ARRAY(KI,1),2)
      GOTO 130
C
C            Do columns backwards because ended rows at far
C            end of X
C
  170 KI=NX
      INCX=-1
      DX=DELTAX*(KI+NY)
      GOTO 160
C
C
  180 RETURN
      END
C======================================================================
C
      SUBROUTINE FREDGO(ARRAY,MN)
      REAL ARRAY(MN),DELTAX,X
      INTEGER STEP,LEFT,RIGHT,IT,NX
      LOGICAL VISBLE
      REAL AL,AR,BL,EM
      COMMON /FREDCM/ DELTAX,X,STEP,LEFT,RIGHT,IT,NX,VISBLE
C
C            Test visibility
C
      IF(ARRAY(IT).LT.0.0) GOTO 80
C
C            This point is visible - was last?
C
      IF(VISBLE) GOTO 50
C
C            No: calculate point where this line vanishes
C      
   10 IF(LEFT.LE.NX .OR. MOD(LEFT-1,NX).EQ.0 .OR.
     1     RIGHT.LE.NX .OR. MOD(RIGHT-1,NX).EQ.0) GOTO 100
      AL=ABS(ARRAY(LEFT))
      AR=ABS(ARRAY(RIGHT))
      IF(ARRAY(LEFT).LT.0.0) GOTO 70
C            Right-hand point is crested
   20 RIGHT=RIGHT-STEP
      IF(ARRAY(RIGHT).LT.0.0) GOTO 20
C            Left-hand end of cresting line is either
C            RIGHT+NX or RIGHT-1
      LEFT=RIGHT+NX
      IF(ARRAY(LEFT).LT.0.0) LEFT=RIGHT-1
C
C            RIGHT and LEFT index into the endpoints of the
C            cresting line
   30 BL=ABS(ARRAY(LEFT))
      EM=ABS(ARRAY(RIGHT))-BL
      XX=EM-AR+AL
      IF(ABS(XX).LT.0.0001) GOTO 60
      XX=(AL-BL)/XX
   40 Y=EM*XX+BL
      IF(DELTAX.GT.0.0) XX=1.0-XX
      XX=X-XX*DELTAX
      IF(VISBLE) GOTO 90
C            Drawing a line from an invisible point
C            to a visible one
      CALL CPLOT(0,XX,Y,3)
      VISBLE=.TRUE.
   50 CALL CPLOT(1,X,ARRAY(IT),2)
      RETURN
C
   60 XX=0.5
      GOTO 40
C
C            Left-hand point crested
C
   70 LEFT=LEFT-STEP
      IF(ARRAY(LEFT).LT.0.0) GOTO 70
C
C            Right-hand end of cresting line is either
C            LEFT+1 or LEFT-NX
C
      RIGHT=LEFT+1
      IF(ARRAY(RIGHT).LT.0.0) RIGHT=LEFT-NX
      GOTO 30
C
C            This point is invisible; if last one was too, then
C            forget it; else draw a line towards it
C
   80 IF(.NOT.VISBLE) RETURN
      GOTO 10
C
   90 CALL CPLOT(1,XX,Y,2)
  100 VISBLE=.FALSE.
      RETURN
      END
