      PROGRAM MODSUM
C-----------------------------------------------------------------------
C This program takes several input model files, shifts them so that
C the first component in each is coincident with the first component
C in the first model file, divides the individual component fluxes by
C the number of input model files, and writes all the components into
C the output file.
C
C Original program by R. Simon.
C Version 2.0 - 1988 Jul 2 : revised for Fortran-77 standard (TJP).
C-----------------------------------------------------------------------
      CHARACTER*(*) VERSN
      PARAMETER (VERSN='2.0 - 1988 Jul 11')
      DOUBLE PRECISION DTR
      PARAMETER (DTR=3.141592653589D0/180.D0)
      INTEGER NMAX
      PARAMETER (NMAX=20)
C
      INTEGER NCOMP, NMOD, I, J, L, JMOD, IER
      REAL FLUX, RADIUS, THETA, AXIS, RATIO, PHI
      CHARACTER*64 INMOD(NMAX),OUTMOD,BLANK
      CHARACTER*1  SHIFT,YES
      DOUBLE PRECISION X,Y,RTHETA,DX(NMAX),DY(NMAX)
      REAL FACTOR(NMAX)
      DATA BLANK/' '/,YES/'Y'/
      INTEGER VLBOPE
C
  600 FORMAT (' MODSUM combines model files'/
     1        ' (Version ',A,')'/)
 1000 FORMAT (' Input model file number',I3,': ',$)
 1001 FORMAT (A)
 1010 FORMAT (' Factor by which the fluxes in this model should',
     +        ' be multiplied,'/' prior to summation: ',$)
 1004 FORMAT (' Name of output model file: ',$)
 1011 FORMAT (' Should each model be shifted so'/' that the first',
     +        ' component is at the origin (Y or N)? ',$)
 1005 FORMAT (6F13.5,I1)
 1006 FORMAT (' I have finished the model summation.',I6,' output ',
     +        ' components were written.')
 1007 FORMAT (' ',80('*')/' * WARNING:  SOME VLB PROGRAMS MAY NOT ',
     +        'HANDLE MORE THAN 2000 DELTA FUNCTIONS.  *'/' ',80('*'))
 1008 FORMAT (' Sorry.  I had trouble reading file number,',I3,
     +        '.  Good-bye.')
C-----------------------------------------------------------------------
C
C Start.
C
      WRITE (6,600) VERSN
C
      NMOD = 10
    5 NMOD = NMOD + 1
      JMOD = NMOD - 10
    6 WRITE (6,1000) JMOD
      READ (5,1001) INMOD(JMOD)
      IF (INMOD(JMOD) .NE. BLANK) THEN
          IER = VLBOPE(NMOD, INMOD(JMOD), 'MODEL', 'OLD', INMOD(JMOD))
          IF (IER.NE.1) GOTO 6
          WRITE (6,1010)
          READ (5,*) FACTOR(JMOD)
          GOTO 5
      ENDIF
      IF (NMOD .LE. 11) GOTO 6
      JMOD = JMOD - 1
   17 WRITE (6,1004)
      READ (5,1001) OUTMOD
      IER = VLBOPE(99, OUTMOD, 'MODEL', 'NEW', OUTMOD)
      IF (IER.NE.1) GOTO 17
C       Find shifts for models:
      SHIFT = 'N'
      WRITE (6,1011)
      READ (5,1001) SHIFT
      DO 20 I = 1, JMOD
          IF (SHIFT .EQ. YES) THEN
            NMOD = I + 10
            CALL GTMODL(NMOD,L,FLUX,RADIUS,THETA,AXIS,RATIO,PHI,*999,0)
            RTHETA = THETA * DTR
            X = RADIUS * DCOS(RTHETA)
            Y = RADIUS * DSIN(RTHETA)
            DX(I) = X
            DY(I) = Y
            REWIND NMOD
          ELSE
            DX(I) = 0.D0
            DY(I) = 0.D0
          ENDIF
   20 CONTINUE
C       Do shifts, and write to output file:
      NCOMP = 0
      DO 30 I = 1,JMOD
          NMOD = I + 10
          DO 25 J = 1,32767
            CALL GTMODL(NMOD,L,FLUX,RADIUS,THETA,AXIS,RATIO,PHI,*27,0)
            RTHETA = THETA * DTR
            X = RADIUS * DCOS(RTHETA) - DX(I)
            Y = RADIUS * DSIN(RTHETA) - DY(I)
            RADIUS = DSQRT(X**2 + Y**2)
            IF (X .EQ. 0. ) THEN
              IF (Y .GT. 0.) THEN
                THETA = 90.
              ELSE IF (Y .LT. 0.) THEN
                THETA = -90.
              ELSE
                THETA = 0.
              ENDIF
            ELSE
              THETA = DATAN2(Y,X) / DTR
            ENDIF
            FLUX = FLUX * FACTOR(I)
            IF (AXIS .GT. 0.) THEN
              WRITE (99,1005) FLUX,RADIUS,THETA,AXIS,RATIO,PHI,L
            ELSE
              WRITE (99,1005) FLUX,RADIUS,THETA
            ENDIF
            NCOMP = NCOMP + 1
   25     CONTINUE
   27 CONTINUE
   30 CONTINUE
      WRITE (6,1006) NCOMP
      IF (NCOMP .GT. 2000) THEN
          WRITE (6,1007)
      ENDIF
      STOP
  999 WRITE (6,1008) JMOD
      STOP
      END
