C-----------------------------------------------------------------------
C Header parameters for a Merge file.
C-----------------------------------------------------------------------
C Constants used for array dimensions:
C  MGMAXS = maximum number of stations
C  MGMAXB = maximum number of baselines
C  MGMAXT = maximum number of triangles
      INTEGER MGMAXS
      INTEGER MGMAXB
      INTEGER MGMAXT
      PARAMETER (MGMAXS=40)
      PARAMETER (MGMAXB=MGMAXS*(MGMAXS-1)/2)
      PARAMETER (MGMAXT=MGMAXB*(MGMAXS-2)/3)
C-
C Parameters:
C  MGVERS = format version number
C  MGNHIS = number of history records
C  MGNS   = number of stations
C  MGNB   = number of baselines
C  MGNT   = number of closure phases
C  MGTYPE = type of data (0=cor.coeff; 1=Jy)
C  MGSTOK = Stokes parameter
C  MGBIDX = baseline index
C  MGTIDX = triangle index
C  MGSTYP = station type (1=ground, 2=orbiter)
C  MGSRC  = source name
C  MGSTN  = station names
C  MGRA50 = mean RA, 1950.0
C  MGDC50 = mean DEC, 1950.0
C  MGARA  = apparent RA, reference epoch
C  MGADEC = apparent DEC, reference epoch
C  MGFLUX = total flux density, Jy
C  MGXYZ  = station locations
C  MGEPO  = reference epoch, UTC Modified JD
C  MGGAST = Greenwich apparent sidereal time at reference epoch (radian)
C  MGFREQ = center frequency (Hz)
C  MGBW	  = bandwidth (Hz)
C  MGAVG1 = coherent averaging time (s)
C  MGAVG2 = incoherent averaging time (s)
C  MGEQUI = equinox of coordinates
C-
      INTEGER MGVERS
      INTEGER MGNHIS
      INTEGER MGNS
      INTEGER MGNB
      INTEGER MGNT
      INTEGER MGTYPE
      INTEGER MGSTOK
      INTEGER MGBIDX(MGMAXB)
      INTEGER MGTIDX(MGMAXT)
      INTEGER MGSTYP(MGMAXS)
C-
      CHARACTER*16 MGSRC
      CHARACTER*8  MGSTN(MGMAXS)
C-
      DOUBLE PRECISION MGRA50
      DOUBLE PRECISION MGDC50
      DOUBLE PRECISION MGARA
      DOUBLE PRECISION MGADEC
      DOUBLE PRECISION MGFLUX
      DOUBLE PRECISION MGXYZ(9,MGMAXS)
      DOUBLE PRECISION MGEPO
      DOUBLE PRECISION MGGAST
      DOUBLE PRECISION MGFREQ
      DOUBLE PRECISION MGBW
      DOUBLE PRECISION MGAVG1
      DOUBLE PRECISION MGAVG2
      DOUBLE PRECISION MGEQUI
C-
      COMMON /MGRCM1/ MGVERS, MGNHIS, MGNS,   MGNB,   MGNT,   MGTYPE,
     1                MGSTOK, MGBIDX, MGTIDX, MGSTYP
      COMMON /MRGCM2/ MGSRC,  MGSTN
      COMMON /MRGCM3/ MGRA50, MGDC50, MGARA,  MGADEC, MGFLUX, MGXYZ,
     1                MGEPO,  MGGAST, MGFREQ, MGBW,   MGAVG1, MGAVG2,
     2                MGEQUI
C-----------------------------------------------------------------------
