      PROGRAM MTCOPY
*-----------------------------------------------------------------------
* MTCOPY - Magnetic Tape Copy
*
* T.J. Pearson  6-Dec-1982; based on
* D. Pearce     9-Sep-1981  (Starlink - Chilton)
* Revised      19-Apr-1983.
* Revised      29-Apr-1991 for Convex compatibility; uses MTPCKG (TJP).
*-----------------------------------------------------------------------
      CHARACTER FUNIT*5,TUNIT*5,ANSWER*64
      LOGICAL   FREWIN,TREWIN,SWAB,TFORW,MTSEOF
      INTEGER   IER, GETIN, N, ICHAN, OCHAN, STATUS, FCHAN, TCHAN
      INTEGER   NDONE, NFILE, NBLK, BLKLEN, L, I, TSKIP, FSKIP, NFCOPY
*
      INTEGER BUFSIZ
      PARAMETER (BUFSIZ=65534)
      BYTE      BUFFER(BUFSIZ),T
*-----------------------------------------------------------------------
 2000 FORMAT ('File ',I10,' written, ',I10,' blocks')
*-----------------------------------------------------------------------
*
* Prompt user for input tape unit (no default)
*
   10 IER = GETIN(FUNIT,'Copy from Tape (device) = ',N)
      IF (IER.NE.1) STOP
      IF (N.EQ.0) STOP
      CALL MTOPID(FUNIT(1:N), ICHAN, STATUS)
      IF (STATUS.NE.0) THEN
          CALL PUTOUT('Unable to read tape '//FUNIT(1:N))
          GOTO 10
      END IF
*
* Prompt user for output tape unit
*
   20 IER = GETIN(TUNIT,'       to Tape (device) = ',N)
      IF (IER.NE.1) STOP
      IF (N.EQ.0) STOP
      CALL MTOPID(TUNIT(1:N), OCHAN, STATUS)
      IF (STATUS.NE.0) THEN
          CALL PUTOUT('Unable to read tape '//TUNIT(1:N))
          GOTO 20
      END IF
*
* Prompt user for number of input files to skip
*
      IER = GETIN(ANSWER,'Rewind input tape [no] ? ',N)
      IF (IER.NE.1) STOP
      FREWIN = .FALSE.
      IF (ANSWER(1:1).EQ.'Y' .OR. ANSWER(1:1).EQ.'y') FREWIN = .TRUE.
   30 IER = GETIN(ANSWER,
     1        'Number of files to skip on input tape [0] = ',N)
      IF (IER.NE.1) STOP
      FSKIP = 0
      IF (N.NE.0) READ (ANSWER(:N), *, ERR=30) FSKIP
*
* Prompt user for number of output files to skip
*
      IER = GETIN(ANSWER,'Rewind output tape [no] ? ',N)
      IF (IER.NE.1) STOP
      TREWIN = .FALSE.
      IF (ANSWER(1:1).EQ.'Y' .OR. ANSWER(1:1).EQ.'y') TREWIN = .TRUE.
      IF (.NOT.TREWIN) THEN
          IER = GETIN(ANSWER,'Position output tape at end [yes] ? ',N)
          IF (IER.NE.1) STOP
          TFORW = .TRUE.
          IF (ANSWER(1:1).EQ.'N' .OR. ANSWER(1:1).EQ.'n') TFORW =
     1        .FALSE.
      ELSE
          TFORW = .FALSE.
      END IF
      IF (.NOT.TFORW) THEN
   40     IER = GETIN(ANSWER,
     1        'Number of files to skip on output tape [0] = ',N)
          TSKIP = 0
          IF (N.NE.0) READ (ANSWER(:N), *, ERR=40) TSKIP
      ELSE
          TSKIP = 0
      END IF
*
* Prompt user for number of files to be copied. Def=32,768
*
      CALL PUTOUT('Copy will be terminated at end of tape'
     1        //' (double tape mark)')
      CALL PUTOUT('or after number of files requested')
   50 IER = GETIN(ANSWER,
     1        'Number of files to be copied [32768] = ',N)
      IF (IER.NE.1) STOP
      NFCOPY = 32768
      IF (N.NE.0) READ (ANSWER(:N), *, ERR=50) NFCOPY
*
* Prompt user for byte-swap option
*
      IER = GETIN(ANSWER,'Swap bytes [no] ? ',N)
      IF (IER.NE.1) STOP
      SWAB  = .FALSE.
      IF (ANSWER(1:1).EQ.'Y' .OR. ANSWER(1:1).EQ.'y') SWAB = .TRUE.
*
* Open tape streams
*
      IF (FREWIN) THEN
          CALL MTREWI(FCHAN,STATUS)
          CALL ERRCHK(STATUS, 'MTREWI', 'Error rewinding input tape')
      END IF
      IF (TREWIN) THEN
          CALL MTREWI(TCHAN,STATUS)
          CALL ERRCHK(STATUS, 'MTREWI', 'Error rewinding output tape')
      END IF
C      IF (TFORW) THEN
C          CALL TIO_END(TCHAN,STATUS)
C          CALL ERRCHK(STATUS,'Error locating end of data'//
C     1                    ' on output tape')
C      END IF
*
* Skip any preceding files
*
      CALL MTSKFI(FCHAN,FSKIP,NDONE,STATUS)
      CALL ERRCHK(STATUS, 'MTFSKI', 'Error skipping input tape')
      CALL MTSKFI(TCHAN,TSKIP,NDONE,STATUS)
      CALL ERRCHK(STATUS, 'MTFSKI', 'Error skipping output tape')
      NFILE = TSKIP+1
      NBLK = 0
*
* Copy all the requested files
*
      DO WHILE (NFCOPY.GT.0)
*         .....read from input device
          CALL MTREAD(FCHAN,BUFSIZ,BUFFER,BLKLEN,STATUS)
*         .....if end-of-file, write two tape-marks to output device
*         .....and skip back over one of them
*         .....if last file was empty, quit
          IF (MTSEOF(STATUS)) THEN
              IF (NBLK.EQ.0) STOP
              CALL MTWEOF(TCHAN,STATUS)
              CALL ERRCHK(STATUS, 'MTWEOF', 'Error writing tapemark')
              CALL MTWEOF(TCHAN,STATUS)
              CALL ERRCHK(STATUS, 'MTWEOF', 'Error writing tapemark')
              CALL MTSKFI(TCHAN,-1,NDONE,STATUS)
              CALL ERRCHK(STATUS, 'MTWEOF', 'Error writing tapemark')
              WRITE (ANSWER, 2000) NFILE, NBLK
              CALL SSPACE(ANSWER,L)
              CALL PUTOUT(ANSWER(:L))
              NFCOPY = NFCOPY-1
              NBLK = 0
              NFILE = NFILE + 1
          ELSE
              CALL ERRCHK(STATUS, 'MTREAD', 'Error reading input tape')
              IF (SWAB) THEN
                  DO 100 I=1,BLKLEN,2
                      T = BUFFER(I)
                      BUFFER(I) = BUFFER(I+1)
                      BUFFER(I+1) = T
  100             CONTINUE
              END IF
              CALL MTWRIT(TCHAN,BUFFER,BLKLEN,NDONE,STATUS)
              CALL ERRCHK(STATUS, 'MTWRIT', 'Error writing output tape')
              NBLK = NBLK + 1
          ENDIF
      END DO
*
* End of job
*
      END

      SUBROUTINE ERRCHK(STATUS, ROUTIN, USRMSG)
*-----------------------------------------------------------------------
* TIO_ERRCHK - Check status from tape I/O operation
*-----------------------------------------------------------------------
      CHARACTER*(*) ROUTIN, USRMSG
      INTEGER       STATUS
*
      INTEGER       LEN1
      CHARACTER*76  ERRMSG
*
*
      IF (STATUS.NE.0) THEN
          CALL MTMESS(STATUS,ROUTIN,ERRMSG)
          CALL PUTOUT(USRMSG)
          CALL PUTOUT(ERRMSG(:LEN1(ERRMSG)))
          STOP
      END IF
*
      END
