C     Include file for VLA and VLBA setup information.
C
C     Some parameters   MSET  - Max of setups allowed in schedule.
C                       MCHAN - Max number of channels.
C                       MSTR  - Max number of arbitrary strings.
C
      INTEGER           MSET, MCHAN, MSTR
      PARAMETER         (MSET=12)
      PARAMETER         (MCHAN=16)
      PARAMETER         (MSTR=4)
C
C     Bookkeeping, etc. LS - slot of current setup
C
      INTEGER           LS
      CHARACTER         SETUPS(MSET)*80
C
C     The COMMONs for bookkeeping parameters.
C
      COMMON  /SETN1/   LS
      COMMON  /SETC1/   SETUPS
C
C     The setup data for VLBA antennas
C
      REAL              AZCOLIM(MSET), ELCOLIM(MSET)
      REAL              PTINCR(MSET)
      REAL              FIRSTLO(MCHAN,MSET)
      REAL              BBSYN(MCHAN,MSET)
      REAL              BBSYN2(MCHAN,MSET)
      REAL              BBSOUT(MCHAN)
      REAL              BBFILT(MCHAN,MSET)
      REAL              BBFOUT(MCHAN)
      REAL              SAMPRATE(MSET)
      REAL              SYNTH(3,MSET)
      INTEGER*2         NCHAN(MSET)
      INTEGER*2         TRACK(MCHAN,4,MSET)
      INTEGER*2         SPEED(MSET)
      INTEGER*2         PERIOD(MSET)
      INTEGER*2         BITS(MCHAN,MSET)
      INTEGER*2         LEVEL(MSET)
      INTEGER*2         BBC(MCHAN,MSET)
      INTEGER*2         TAPEMODE(MSET)
      INTEGER*2         SWTCHDUR(MSET)
      INTEGER*2         PCALFR1(8,MSET)
      INTEGER*2         PCALFR2(8,MSET)
      LOGICAL*1         FRSWITCH(MSET)
      LOGICAL*1         DUALX(MSET)
      CHARACTER         IFDIST(4,MSET)*3
      CHARACTER         SIDEBD(MCHAN,MSET)*1
      CHARACTER         NOISE(4,MSET)*6
      CHARACTER         FE(4,MSET)*6
      CHARACTER         IFCHAN(MCHAN,MSET)*1
      CHARACTER         LOGGING(MSET)*8
      CHARACTER         STRING(MSTR,MSET)*80
      CHARACTER         FORMAT(MSET)*8
      CHARACTER         SPCAL(MSET)*4
      CHARACTER         PCALX1(8,MSET)*3
      CHARACTER         PCALX2(8,MSET)*3
C
      COMMON  /SETN2/   AZCOLIM, ELCOLIM, PTINCR, FIRSTLO, BBSYN, 
     1                  BBSYN2, BBSOUT, BBFILT, BBFOUT, SAMPRATE, 
     2                  SYNTH, NCHAN, TRACK, SPEED, PERIOD, BITS, 
     3                  LEVEL, BBC, TAPEMODE, SWTCHDUR, PCALFR1,
     4                  PCALFR2, FRSWITCH, DUALX
      COMMON  /SETC2/   SIDEBD, NOISE, FE, IFCHAN, LOGGING,
     1                  STRING, FORMAT, IFDIST, SPCAL, PCALX1, PCALX2
C
C     VLA information.
C     Included are the fluke set, the fluke frequencies, the F.E. LO
C     frequencies and the 2-4 GHz synthesizer frequencies (MHz)
C     The 2-4 GHz synthesizer frequencies are the true frequency.  The
C     value sent to the LO card is rounded to the nearest MHz.
C
      INTEGER           FLUKESET(MSET)   
      REAL              FLUKEA(MSET)     
      REAL              FLUKEB(MSET)     
      REAL              VLAFEAB(MSET)    
      REAL              VLAFECD(MSET)    
      REAL              VLASYNA(MSET)    
      REAL              VLASYNB(MSET)    
      CHARACTER         FEFILTER(MSET)*4
      CHARACTER         VLAIF(MSET)*10
      CHARACTER         VLAROT(MSET)*10
C
      COMMON  /SETN3/   FLUKESET, FLUKEA, FLUKEB, VLAFEAB, VLAFECD,
     1                  VLASYNA, VLASYNB
      COMMON  /SETC3/   FEFILTER, VLAIF, VLAROT
C
C     End of setup include file.
