      PROGRAM PHASE
C
C Closure-Phase Solution for Hybrid Mapping
C T.J. Pearson     VAX-11 Fortran
C
C Version 1:  1979 July 5
C   1979 October 17: change model calculation to x,y
C                                : allow case NT=0
C Version 2:  1981 March 5
C   (1) Change to 15 stations
C   (2) Change to Fortran-77 syntax
C Version 2.1: 1981 December 22
C   Remove check that data have been calibrated
C Version 2.2: 1981 December 29 - S.C. Unwin
C   Introduce OLDERRORS option: do not recalculate phase errors
C Version 2.3: 1982 August 4 - S.C. Unwin
C   Make OLDERRORS unnecessary (disabled);
C   program now never recalculate phase errors
C Version 2.4: 1982 December 19 - R.C. Walker
C   Fix 15 stations - put MAXS in NAMES etc arrays.
C Version 3.0: 1983 July 21 - D.L. Meier
C   Extend to include MERGE format version 2 files.
C Version 3.1: 1983 August 4 - D.L. Meier
C   Add W to version 2 files
C Version 3.2: 1988 Apr 4 - Changes for Convex [TJP].
C Version 3.3: 1988 Dec 30 - new parameter names: INPUT etc. [TJP].
C Version 3.4: 1989 Jul 17 - default baseline list [TJP].
C-----------------------------------------------------------------------
      CHARACTER*(*) VERSN
      INTEGER MAXS,MAXB,MAXT,MAXL,MAXMOD,NPARS,INDAT,OUTDAT,INMOD,
     1          MAXWPB
      PARAMETER (VERSN='3.4 - 1989 Jul 17')
      PARAMETER (MAXS=15)     ! maximum number of stations
      PARAMETER (MAXB=MAXS*(MAXS-1)/2)
      PARAMETER (MAXT=MAXB*(MAXS-2)/3)
      PARAMETER (MAXWPB=7)
      PARAMETER (MAXL=MAXWPB*MAXB+2*MAXT)
      PARAMETER (MAXMOD=2001) ! maximum no of model points
      PARAMETER (NPARS=21+MAXB) !No of input parameters
      PARAMETER (INDAT=9)
      PARAMETER (OUTDAT=10)
      PARAMETER (INMOD=4)
C
      REAL PI, RPDEG, RPMAS, VELC, SIDR
      PARAMETER (PI=3.141592654)
      PARAMETER (RPDEG=PI/180.0)
      PARAMETER (RPMAS=RPDEG/3600000.0)
      PARAMETER (VELC=2.997925E8)
      PARAMETER (SIDR=(PI/2592000.)*1.00273791)
C               ( radians of ST per sec/60 of UT)
C
      INTEGER BASE(MAXB),TRIG(MAXT),TYPE,STATYP
      INTEGER CONST(MAXT,3),B1,B2,B3,FROM(MAXB),PREFER(MAXB)
      LOGICAL USABLE(MAXT),KNOWN(MAXB),BAD,BRIEF,OLDERR,
     1          ORBITERS
      REAL    REC(MAXL)
      REAL    FLUX(MAXMOD),XC(MAXMOD),YC(MAXMOD),AA(MAXMOD),
     1          R(MAXMOD),PHI(MAXMOD)
      REAL    U(MAXB),V(MAXB),SCORR(MAXB),ERR(MAXB),C(MAXB),CERR(MAXB)
      REAL    CLSPHS(MAXT),CLSERR(MAXT)
      REAL*8  BX,BY,BZ(MAXB),BXY(MAXB),BOFF(MAXB)
      REAL*8  STNAME,STX,STY,STZ,SOURCE(2),RA,DEC,GASTM,FREQ,TOTFL,
     1          COSDEC,SINDEC,TIHA,TINTG,AVG,BW,AEIOWM
      CHARACTER*8  UTP,TIMEC
      REAL*8  DUMMY,NEWHIS(40),CHANGE(110)
      REAL*8  NAMES(NPARS),PARS(NPARS),ENDMRK
      CHARACTER*64  FFROM,FTO,FMODEL
      CHARACTER*80  HIST(4)
      DATA    NAMES/ 'Cglim','Xcg','Ycg', 'Ncprint', 'Input',
     1               4*' ', 'OUtput',4*' ', 'Modfile',4*' ',
     2               'BRief', 'OLderror', MAXB*'Baseline'  /
      DATA    PARS / 10D0, 0D0, 0D0, 9999D0, '***UNSET',
     1               4*' ', '***UNSET',4*' ', '***UNSET',
     2               4*' ', -1D0, -1D0, MAXB*-1D0  /
      DATA    ENDMRK/'/'/, CHANGE/110*0D0/
      COMMON  /MODEL/ NCOMP,FLUX,XC,YC,AA,R,PHI
      COMMON  /PARMS/ STNAME(MAXS),STX(MAXS),STY(MAXS),STZ(MAXS),
     1                SOURCE,RA,DEC,GASTM,FREQ,TOTFL,TINTG,AVG,BW,
     2                AEIOWM(6,MAXS),STATYP(MAXS),ORBITERS
      COMMON  /ORDER/ NS,NB,NT,NB1(MAXB),NB2(MAXB),
     1                NT1(MAXT),NT2(MAXT),NT3(MAXT),NVER,NDWPB
C-----------------------------------------------------------------------
C Define default baseline list.
C
      IB = 0
      DO 20 I2=2,MAXS
          DO 10 I1=1,I2-1
              IF (I2.GT.9) THEN
                  ID = I1*100+I2
              ELSE
                  ID = I1*10 +I2
              END IF
              IB = IB+1
              PARS(IB+21) = ID
   10     CONTINUE
   20 CONTINUE
C        
C Read input parameters; KEYIN  returns parameters in 'PARS'.
C
      WRITE (6,598) VERSN
      MODE = 0
      CALL KEYIN (NAMES,PARS,NPARS,ENDMRK,MODE,5,6)
      CGLIM = PARS(1)
      XCG   = PARS(2)
      YCG   = PARS(3)
      NCPRIN= PARS(4)
      BRIEF = PARS(20).NE.-1D0
      OLDERR= PARS(21).NE.-1D0
C               File names
      WRITE(FFROM,640) (PARS(I),I= 5, 9)
      WRITE(FTO,640)   (PARS(I),I=10,14)
      WRITE(FMODEL,640)(PARS(I),I=15,19)
      OPEN (UNIT=INDAT,NAME=FFROM,TYPE='OLD',READONLY,
     1        FORM='UNFORMATTED',ERR=510)
      INQUIRE (UNIT=INDAT,NAME=FFROM)
      OPEN (UNIT=INMOD,NAME=FMODEL,TYPE='OLD',READONLY,
     2        FORM='FORMATTED',ERR=530)
      INQUIRE (UNIT=INMOD,NAME=FMODEL)
      OPEN (UNIT=OUTDAT,NAME=FTO,TYPE='NEW',FORM='UNFORMATTED',
     1        ERR=520)
      INQUIRE (UNIT=OUTDAT,NAME=FTO)
C
C               Information for history
C
      CALL MKHIST('PHASE', VERSN, HIST(1))
      HIST(2) = '- Input file:  '//FFROM
      HIST(3) = '- Input model: '//FMODEL
      HIST(4) = '- Output file: '//FTO
      ENCODE(4*80,800,NEWHIS) HIST
C
C               Read and rewrite the header records
C
      WRITE(6,599) FFROM
      CALL HEADX15(.FALSE.,INDAT,IZ,ID,IY,
     1          NEWHIS,4,OUTDAT,KFLAG,CHANGE,IFEOF,6)
      LENG=NDWPB*NB + 2*NT
C
      IF(NS.GT.MAXS) CALL ERROR('Too many stations.')
      IF(NB.LT.1 .OR. NS.LT.2) CALL ERROR('Not enough baselines.')
C
C               Baseline labels (BASE)
C               Each label is 'IJ' where I and J are station numbers
C
      DO 100 IB=1,NB
  100 BASE(IB) = 100*NB1(IB) + NB2(IB)
C
      WRITE(6,601) SOURCE,NS,NB,NT,(STNAME(I),I=1,NS)
      WRITE(6,602) (BASE(IB),IB=1,NB)
C
C               Triangle labels (TRIG)
C               Each label is 'IJK'; closure phase for 'IJK' is
C                  PH(IJ) + PH(JK) - PH(IK)
C               Constituent baselines (CONST)
C
      IF(NT.LT.1) GOTO 120
      DO 110 IT=1,NT
      TRIG(IT)=10000*NT1(IT) + 100*NT2(IT) + NT3(IT)
      CONST(IT,1)=LOOKUP(100*NT1(IT)+NT2(IT),BASE,NB)
      CONST(IT,2)=LOOKUP(100*NT2(IT)+NT3(IT),BASE,NB)
  110 CONST(IT,3)=LOOKUP(100*NT1(IT)+NT3(IT),BASE,NB)
C
      WRITE(6,603) (TRIG(IT),(BASE(CONST(IT,J)),J=1,3),IT=1,NT)
C
C               Set up and check list of preferred baselines
C
  120 BAD = .FALSE.
      DO 190 I=1,NB
          ID=PARS(I+21)
          IF(ID.LT.100) THEN
                IS1 = ID/10
                IS2 = MOD(ID,10)
                ID = IS1*100 + IS2
          END IF
          IB=LOOKUP(ID,BASE,NB)
          IF(IB.EQ.0) THEN
                BAD = .TRUE.
                WRITE(6,630) ID
          END IF
          PREFER(I)=IB
          I1=I-1
          IF(I1.NE.0) THEN
              DO 180 J=1,I1
                  IF(PREFER(I).EQ.PREFER(J)) BAD = .TRUE.
  180         CONTINUE
          END IF
  190 CONTINUE
      IF (BAD)  CALL ERROR('Illegal preferred-baseline list')
      WRITE(6,608)(BASE(PREFER(I)),I=1,NB)
C
C               Compute baseline parameters
C
      WAVE=VELC/FREQ
      COSDEC=DCOS(DEC)
      SINDEC=DSIN(DEC)
      DO 210 IB=1,NB
      IS1 = NB1(IB)
      IS2 = NB2(IB)
      BX=(STX(IS1)-STX(IS2))/WAVE
      BY=(STY(IS1)-STY(IS2))/WAVE
      BZ(IB)=(STZ(IS1)-STZ(IS2))/WAVE
      BOFF(IB)=GASTM-RA-PI/2.0-DATAN2(BY,BX)
  210 BXY(IB)=DSQRT(BX*BX + BY*BY)
C
C----------------------------------------------------------------------
C
C               Read the model parameters
C
      WRITE(6,604) FMODEL
      WRITE(6,614)
      NCS=0
      XSUM=0.0
      YSUM=0.0
      TOTFLX=0.0
      FLXSUM=0.0
      DO 150 I=1,MAXMOD
      CALL GTMODL(INMOD,TYPE,FLUX(I),RAD,THETA,AA(I),R(I),
     1              PHI(I), *155, 0)
      IF(FLUX(I).EQ.0.0) GOTO 155
      FLXSUM=FLXSUM+FLUX(I)
      IF(I.LE.NCPRIN) WRITE(6,605) I,FLUX(I),RAD,THETA,AA(I),
     1          R(I),PHI(I),TYPE
      THETA=THETA*RPDEG
      XC(I) = RAD*SIN(THETA)
      YC(I) = RAD*COS(THETA)
      IF( ABS(FLUX(I)).LE.CGLIM*FLUX(1) ) GOTO 150
            NCS = NCS+1
            TOTFLX = TOTFLX+FLUX(I)
            XSUM = XSUM + XC(I)*FLUX(I)
            YSUM = YSUM + YC(I)*FLUX(I)
  150 CONTINUE
      WRITE(6,650) MAXMOD
      I = MAXMOD+1
  155 NCOMP = I-1
      WRITE(6,607) NCOMP,FLXSUM
      CLOSE (UNIT=INMOD)
      IF(FLXSUM.EQ.0.0) CALL ERROR('Model has zero total flux')
C
C               Find centroid of components > CGLIM times first
C
      IF(CGLIM.GE.1.0) GOTO 160
      XSUM = XSUM/TOTFLX
      YSUM = YSUM/TOTFLX
      WRITE(6,606) XSUM,YSUM,XCG,YCG,NCS
      WRITE(6,614)
  160 XSHIFT = XSUM - XCG
      YSHIFT = YSUM - YCG
      DO 170 I=1,NCOMP
      XC(I) = XC(I) - XSHIFT
      YC(I) = YC(I) - YSHIFT
      RAD = SQRT(XC(I)*XC(I)+YC(I)*YC(I))
      IF(RAD.GT.0.0) THETA = ATAN2(XC(I),YC(I))/RPDEG
      IF(CGLIM.LE.1.0 .AND. I.LE.NCPRIN)
     1     WRITE(6,605) I,FLUX(I),RAD,THETA,AA(I),R(I),PHI(I)
      XC(I) = XC(I)*RPMAS
      YC(I) = YC(I)*RPMAS
      AA(I) = AA(I)*RPMAS
      PHI(I) = PHI(I)*RPDEG
  170 CONTINUE
C----------------------------------------------------------------------
C
C               Loop to solve for phases at each time
C
      IF(.NOT.BRIEF) WRITE(6,610)
C
C               Read next data record
C
  300 READ(INDAT,END=500) IUT,(REC(I),I=1,LENG)
      IF(IUT.LT.0) GOTO 500
      UTP=TIMEC(MOD(IUT/60,86400))
C
C               Which triangles are usable ?
C
      IF(NT.LT.1) GOTO 311
      DO 310 IT=1,NT
      CLSPHS(IT)=REC(NDWPB*NB + 2*(IT-1) +1)
      CLSERR(IT)=REC(NDWPB*NB + 2*(IT-1) +2)
  310 USABLE(IT)=CLSERR(IT).GT.0.0
  311 DO 320 IB=1,NB
      SCORR(IB)=REC(NDWPB*(IB-1) +1)
      ERR(IB)  =REC(NDWPB*(IB-1) +2)
      IF (NVER.EQ.1) THEN
           TIHA=(IUT-IZ)*SIDR +BOFF(IB)
           U(IB)=BXY(IB)*DCOS(TIHA)
           V(IB)=BZ(IB)*COSDEC + BXY(IB)*SINDEC*DSIN(TIHA)
      ELSE IF (NVER.EQ.2) THEN
           U(IB) = REC(NDWPB*(IB-1) +5)
           V(IB) = REC(NDWPB*(IB-1) +6)
      END IF
  320 KNOWN(IB)=.FALSE.
C
C               Compute model phase on next-preferred baseline,
C               and mark this baseline "KNOWN"
C
      NKNOWN=0
      NEXT=0
  330 NEXT=NEXT+1
      IB=PREFER(NEXT)
      IF(KNOWN(IB)) GOTO 330
      C(IB)=PHSMOD(U(IB),V(IB))/RPDEG
      IF(ERR(IB).LE.0.0 .OR. SCORR(IB).LE.0.0) THEN
                CERR(IB) = 0.0
                FROM(IB) = 0
      ELSE
                CERR(IB) = ERR(IB)/SCORR(IB)/RPDEG
                FROM(IB) = BASE(IB)
      END IF
  340 KNOWN(IB)=.TRUE.
      NKNOWN=NKNOWN+1
      IF(NKNOWN.GE.NB) GOTO 380
C
C               If there are any closure-phases, then
C               try to solve each triangle in turn; if a
C               triangle is solved, mark it "unUSABLE" and add the
C               baseline to the "KNOWN" list
C
      IF(NT.LT.1) GOTO 330
      DO 370 IT=1,NT
      IF(.NOT.USABLE(IT)) GOTO 370
      B1=CONST(IT,1)
      B2=CONST(IT,2)
      B3=CONST(IT,3)
      PHICL=CLSPHS(IT)
C
C               Try B1
C
      IF(KNOWN(B1)) GOTO 350
            IF((.NOT.KNOWN(B2)).OR.(.NOT.KNOWN(B3))) GOTO 370
            IB=B1
            C(IB)=PHICL-C(B2)+C(B3)
            CERR(IB)=CLSERR(IT)
            USABLE(IT)=.FALSE.
            FROM(IB)=TRIG(IT)
            GOTO 340
C
C               Try B2
C
  350 IF(KNOWN(B2)) GOTO 360
            IF((.NOT.KNOWN(B1)).OR.(.NOT.KNOWN(B3))) GOTO 370
            IB=B2
            C(IB)=PHICL-C(B1)+C(B3)
            CERR(IB)=CLSERR(IT)
            USABLE(IT)=.FALSE.
            FROM(IB)=TRIG(IT)
            GOTO 340
C
C               Try B3
C
  360 IF(KNOWN(B3)) GOTO 370
            IF((.NOT.KNOWN(B1)).OR.(.NOT.KNOWN(B2))) GOTO 370
            IB=B3
            C(IB)=-PHICL+C(B1)+C(B2)
            CERR(IB)=CLSERR(IT)
            USABLE(IT)=.FALSE.
            FROM(IB)=TRIG(IT)
            GOTO 340
  370 CONTINUE
C
C               If no triangles were solved in last pass, grab another
C               model phase
C
      GOTO 330
C
C               All phases now known. Put into range (-180,180)
C               Write revised data record
C
  380 IF(.NOT.BRIEF) WRITE(6,611) UTP,(FROM(IB),IB=1,NB)
      DO 390 IB=1,NB
      PP = AMOD(C(IB),360.0)
      IF(PP.LE.-180.0) PP = PP+360.0
      IF(PP.GT. 180.0) PP = PP-360.0
      REC(NDWPB*(IB-1) +3) = PP
C               The next statement is commented out (SCU - 4 Aug 1982)
C               OLDERRORS not needed now;  CERR not used to replace errors
C-------REC(NDWPB*(IB-1) +4)   = CERR(IB)
  390 CONTINUE
      WRITE(OUTDAT) IUT,(REC(I),I=1,LENG)
      GOTO 300
C-----------------------------------------------------------------------
C
C               Terminate
C
  500 WRITE(OUTDAT) -1,(0.0,I=1,LENG)
      CLOSE (UNIT=INDAT)
      CLOSE (UNIT=OUTDAT)
C
      STOP 'PHASE completed'
C
C               Error exits
C
  510 CALL ERROR('Cannot open file INPUT: '//FFROM)
  520 CALL ERROR('Cannot open file OUTPUT: '//FTO)
  530 CALL ERROR('Cannot open file MODFILE: '//FMODEL)
C
C----------------------------------------------------------------------
C
C               Format statements
C
  598 FORMAT(' PHASE uses closure phases and model phases to',
     1       ' estimate visibility phases'/' (Version ',A,')'//
     2       ' Control parameters:')
  599 FORMAT(/' Input file: ',A/)
  601 FORMAT('0Hybrid mapping of ',2A8/' with',I3,' stations,',I4,
     1       ' baselines,',I4,' triangles.'//
     2       ' Stations:  ',5(1X,A8)/(12X,5(1X,A8)))
  602 FORMAT(/' The baselines are labelled:'/(1X,16I5))
  603 FORMAT(/' The triangles are labelled:'/(20X,I6,' = ',I4,
     1        ' + ',I4,' - ',I4))
  608 FORMAT(//' Preferred order for using model phases:'/(1X,16I5))
  604 FORMAT(///' Input model: ',A/)
  614 FORMAT(12X,'Flux',3X,'Radius',4X,'Theta',5X,
     2         'Axis',4X,'Ratio',6X,'Phi',2X,'Type'/)
  605 FORMAT(1X,I5,')',6F9.3,I5)
  607 FORMAT(/' Model consists of',I4,' components'/
     1        ' Total flux density = ',F8.4,' Jy')
  606 FORMAT(/' Centroid of model is at X =',F10.5,', Y =',F10.5,
     1        ' (milliarcsec);'/
     2        ' centroid shifted to     X =',F10.5,
     3        ', Y =',F10.5/1X,I4,' components used for centroid',
     4        ' calculation'//)
  610 FORMAT(///25X,'*** PHASE SOLUTION ***'//1X,
     1     '(used model phases on baselines ####;',
     2     ' used closure phases for triangles ######)'//10X,'U.T.'/)
  611 FORMAT(3X,A8,2X,17I7/(13X,17I7))
  630 FORMAT(I10,' is not a valid baseline')
  640 FORMAT(5A8)
  650 FORMAT(/' ++WARNING++ Model truncated after ',I4,' components.')
  800 FORMAT(4A80)
      END

      FUNCTION PHSMOD(UU,VV)
C
C               Calculate model phase at point (UU,VV)
C
      PARAMETER (MAXMOD = 2001)
      REAL    FLUX(MAXMOD),XC(MAXMOD),YC(MAXMOD),AA(MAXMOD),
     1          R(MAXMOD),PHI(MAXMOD)
      COMMON /MODEL/ NCOMP,FLUX,XC,YC,AA,R,PHI
C
      VISI = 0.0
      VISR = 0.0
      DO 30 J = 1,NCOMP
      COMPHA = 6.283185*(UU*XC(J)+VV*YC(J))
      IF(AA(J).EQ.0.0) GOTO 10
      SPHI = SIN(PHI(J))
      CPHI = COS(PHI(J))
      ARG = (-3.559707*AA(J)**2 * ((VV*CPHI+UU*SPHI)**2 +
     1         (R(J)*(UU*CPHI-VV*SPHI))**2 ))
      COMVIS = EXP(ARG)*FLUX(J)
      GOTO 20
   10 COMVIS = FLUX(J)
   20 VISI = VISI+COMVIS*SIN(COMPHA)
   30 VISR = VISR+COMVIS*COS(COMPHA)
C
      IF(VISI.EQ.0.0 .AND. VISR.EQ.0.0) THEN
                PHSMOD = 0.0
      ELSE
                PHSMOD = ATAN2(VISI,VISR)
      END IF
C
      RETURN
      END
