      PROGRAM PRECES
C-----------------------------------------------------------------------
C PRECES: coordinate conversion program.
C
C Author:            T.J. Pearson (TJP)
C Language:          Fortran-77 (almost standard)
C Acknowledgments:   This program would be impossible without
C                    Patrick Wallace's SLALIB library.
C
C Modifications:
C Version 2.0:  1990 Jun  1 - new program (TJP).
C Version 2.1:  1994 Aug  8 - option to write source-catalog file (TJP).
C Version 2.2:  1994 Nov 17 - 12-character source names (TJP).
C-----------------------------------------------------------------------
C
C Constants
C
      CHARACTER*(*) VERSN
      INTEGER    LIST,INCAT,INC,OUTC,NPARS,MAXSRC
      DOUBLE PRECISION PI, DEG
      PARAMETER  (VERSN='2.2 - 1994 Nov 17')
C     -- unit numbers
      PARAMETER  (LIST=1,INCAT=2,INC=5,OUTC=6)
C     -- number of parameters
      PARAMETER  (NPARS=27)
C     -- maximum number of sources
      PARAMETER  (MAXSRC=5000)
      PARAMETER  (PI=3.14159265359D0)
      PARAMETER  (DEG=180D0/PI)
C
C Catalog data.
C
      INCLUDE 'rdcat.inc'
C
C Variables.
C
      INTEGER I, IER, MODE, NSRC, PRECIS
      INTEGER IY, IM, ID, MDATE
      LOGICAL CATOUT
      CHARACTER*16  SYSTEM
      CHARACTER*255 SRCFIL, SRCOLD
      CHARACTER*255 LISFIL, LISDSN, LISOLD
      CHARACTER*12  SNAME(MAXSRC)
      CHARACTER*16  CHR1, CHR2, CHD1, CHD2
      CHARACTER*5   EPOCH(MAXSRC)
      DOUBLE PRECISION RACAT(MAXSRC), DECAT(MAXSRC)
      DOUBLE PRECISION R2000(MAXSRC), D2000(MAXSRC)
      DOUBLE PRECISION DL, DB, R1950, D1950, DR1950, DD1950, BEPOCH
      DOUBLE PRECISION RA, DA, DATE
      DOUBLE PRECISION AMPRMS(21)
C
C Functions.
C
      INTEGER VLBOPE
      INTEGER RDSRC
      DOUBLE PRECISION SLA_EPJ
C
C Input parameters.
C
      DOUBLE PRECISION NAMES(NPARS),PARS(NPARS),ENDMRK
      DATA    NAMES / 'Srcfile', 9*' ',
     1                'Listfile', 9*' ',
     1                'Precisio',
     2                'System', ' ',
     3                'BEpoch',
     4                'Date',
     5                'CATforma',
     6                'Exit' /
      DATA    PARS  / 'VLB_SOUR', 'CES', 8*' ',
     1                'precess.','lis',  8*' ',
     1                3D0,
     2                'J2000', ' ',
     3                1975.0D0,
     4                -1D0,
     5                -1D0,
     6                -1D0 /
      DATA    ENDMRK/ '/' /
C
C Format statements.
C
  600  FORMAT('----Name----',2X,
     1  '-------Catalog Position------------------',
     2  ' : ', '----J2000 coordinates-------------')
  601  FORMAT(A12,2X,A16,2X,A16,2X,A5,' : ',A16,2X,A16)
  602  FORMAT('SOURCE=''',A12,''' RA=',A16,' DEC=',A16,
     1        ' EPOCH=''',A,''' /')
  610  FORMAT('----Name----',2X,
     1  '-------Catalog Position------------------',
     2  ' : ', '--Galactic long, lat--')
  611  FORMAT(A12,2X,A16,2X,A16,2X,A5,' : ',F10.3,2X,F10.3)
  620  FORMAT('----Name----',2X,
     1  '-------Catalog Position------------------',
     2  ' : ', '----B1950 coordinates-------------')
  630  FORMAT('----Name----',2X,
     1  '-------Catalog Position------------------',
     2  ' : ', '---Geocentric Apparent Position---')
  631  FORMAT(57X,'Calendar date: ',I4,'/',I2.2,'/',I2.2/
     1        57X,'Epoch: J',F7.2)
  640  FORMAT('----Name----',2X,
     1  '-------Catalog Position------------------',
     2  ' : ', '--Ecliptic long, lat--')
C-----------------------------------------------------------------------
C
C Start.
C
      CALL PUTOUT('PRECESS does celestial coordinate conversions')
      CALL PUTOUT('(Version '//VERSN//')')
      SRCOLD = '*** UNSPECIFIED ***'
C     -- Default date: today as yy:mm:dd
      CALL IDATE(IM,ID,IY)
      MDATE = IY*3600 + IM*60 + ID
      PARS(25) = MDATE
C
C Read control parameters.
C
 1000 MODE = 0
      CALL PUTOUT(' ')
      CALL PUTOUT('PRECESS control parameters ("EXIT /" to finish):')
      CALL KEYIN(NAMES,PARS,NPARS,ENDMRK,MODE,INC,OUTC)
C     -- test for end-of-file or EXIT
      IF (MODE.EQ.1) GOTO 2000
      IF (PARS(NPARS).NE.-1D0) GOTO 2000
C
C Decode parameters.
C
C     -- Source catalog SRCFILE
      WRITE (SRCFIL,'(10A8)') (PARS(I),I=1,10)
C     -- PRECISION
      PRECIS = NINT(PARS(21))
      PRECIS = MAX(0,PRECIS)
      PRECIS = MIN(3,PRECIS)
C     -- Coordinate SYSTEM
      WRITE (SYSTEM,'(2A8)') (PARS(I),I=22,23)
      CALL UPCASE(SYSTEM)
      IF (SYSTEM.NE.'J2000' .AND. 
     1    SYSTEM.NE.'B1950' .AND.
     2    SYSTEM.NE.'APP'   .AND.
     3    SYSTEM.NE.'GAL'   .AND.
     4    SYSTEM.NE.'ECLIP') THEN
          CALL PUTOUT('+++ SYSTEM='//SYSTEM//
     1       ' is invalid (try J2000, B1950, APP, GAL, ECLIP)')
          GOTO 1000
      END IF
C     -- BEpoch
      BEPOCH = PARS(24)
C     -- Date
      MDATE = PARS(25)
      IY = MOD(MDATE/3600,100)
      IM = MOD(MDATE,3600)/60
      ID = MOD(MDATE,60)
C     -- DATE is Modified Julian Date (in TDB)
      CALL SLA_CALDJ(IY, IM, ID, DATE, IER)
      IF (IER.NE.0) THEN
          CALL PUTOUT('+++ Invalid DATE')
          GOTO 1000
      END IF
C     -- Listing file LISTFILE
      WRITE (LISFIL,'(10A8)') (PARS(I),I=11,20)
C     -- Catalog format?
      CATOUT = PARS(26).GE.0D0
C
C Read source catalog SRCFIL (if necessary).
C
      IF (SRCFIL.NE.SRCOLD) THEN
          SRCOLD = SRCFIL
          NSRC = 0
 1100     IER = RDSRC(INCAT, .TRUE., SRCFIL)
          IF (IER .EQ. 1) GOTO 1800
              NSRC = NSRC+1
              IF (NSRC.GT.MAXSRC) THEN
                  CLOSE (UNIT=INCAT)
                  CALL PUTOUT ('Too many sources in SRCFILE catalog')
                  GOTO 1000
              END IF
C             -- check input coordinate system: J2000 and B1950
C                allowed, others (e.g., DATE) illegal
              IF (SRCEPO.EQ.'J2000') THEN
                  SNAME(NSRC) = SRCNAM(1)
                  RACAT(NSRC) = SRCRA
                  DECAT(NSRC) = SRCDEC
                  EPOCH(NSRC) = SRCEPO
                  R2000(NSRC) = SRCRA
                  D2000(NSRC) = SRCDEC
              ELSE IF (SRCEPO.EQ.'B1950') THEN
                  SNAME(NSRC) = SRCNAM(1)
                  RACAT(NSRC) = SRCRA
                  DECAT(NSRC) = SRCDEC
                  EPOCH(NSRC) = SRCEPO
                  CALL SLA_FK45Z(SRCRA, SRCDEC, BEPOCH, R2000(NSRC),
     1                           D2000(NSRC))
              ELSE
                  NSRC = NSRC - 1
              END IF
          GOTO 1100
 1800     IF (NSRC.LT.1) THEN
              CALL PUTOUT('No sources found in catalog')
              GOTO 1000
          END IF
      END IF
C
C Open listing file (if necessary).
C
      IF (LISFIL.NE.LISOLD) THEN
          LISOLD = LISFIL
          CLOSE (UNIT=LIST)
          IER = VLBOPE(LIST, LISFIL, 'TEXT', 'NEW', LISDSN)
          IF (IER.NE.1) LISOLD = '***invalid***'
          IF (IER.NE.1) GOTO 1000
      ELSE
          WRITE (LIST,'(/)')
      END IF
C
C Output.
C
      IF (SYSTEM.EQ.'J2000') THEN
          IF (.NOT.CATOUT) WRITE (LIST, 600)
          DO 1900 I=1,NSRC
              IF (CATOUT) THEN
                  CALL PANGLE('H:', R2000(I), CHR2, PRECIS+1)
                  CALL PANGLE('D:', D2000(I), CHD2, PRECIS)
                  WRITE (LIST, 602) SNAME(I), CHR2, CHD2, 'J2000'
              ELSE
                  CALL PANGLE('H', RACAT(I), CHR1, PRECIS+1)
                  CALL PANGLE('D', DECAT(I), CHD1, PRECIS)
                  CALL PANGLE('H', R2000(I), CHR2, PRECIS+1)
                  CALL PANGLE('D', D2000(I), CHD2, PRECIS)
                  WRITE (LIST, 601) SNAME(I), CHR1, CHD1, EPOCH(I),
     1                              CHR2, CHD2
              END IF
 1900     CONTINUE
C
      ELSE IF (SYSTEM.EQ.'GAL') THEN
          WRITE (LIST, 610)
          DO 1910 I=1,NSRC
              CALL PANGLE('H', RACAT(I), CHR1, PRECIS+1)
              CALL PANGLE('D', DECAT(I), CHD1, PRECIS)
              CALL SLA_EQGAL(R2000(I), D2000(I), DL, DB)
              WRITE (LIST, 611) SNAME(I), CHR1, CHD1, EPOCH(I), 
     1          DL*DEG, DB*DEG
 1910     CONTINUE
C
      ELSE IF (SYSTEM.EQ.'B1950') THEN
          IF (.NOT.CATOUT) WRITE (LIST, 620)
          DO 1920 I=1,NSRC
              CALL PANGLE('H', RACAT(I), CHR1, PRECIS+1)
              CALL PANGLE('D', DECAT(I), CHD1, PRECIS)
              CALL SLA_FK54Z(R2000(I), D2000(I), BEPOCH,
     1                       R1950, D1950, DR1950, DD1950)
              IF (CATOUT) THEN
                  CALL PANGLE('H:', R1950, CHR2, PRECIS+1)
                  CALL PANGLE('D:', D1950, CHD2, PRECIS)
                  WRITE (LIST, 602) SNAME(I), CHR2, CHD2, 'B1950'
              ELSE
                  CALL PANGLE('H', R1950, CHR2, PRECIS+1)
                  CALL PANGLE('D', D1950, CHD2, PRECIS)
                  WRITE (LIST, 601) SNAME(I), CHR1, CHD1, EPOCH(I),
     1                              CHR2, CHD2
              END IF
 1920     CONTINUE
C
      ELSE IF (SYSTEM.EQ.'APP') THEN
          WRITE (LIST, 630)
          WRITE (LIST, 631) IY,IM,ID, SLA_EPJ(DATE)
          CALL SLA_MAPPA(2000D0, DATE, AMPRMS)
          DO 1930 I=1,NSRC
              CALL PANGLE('H', RACAT(I), CHR1, PRECIS+1)
              CALL PANGLE('D', DECAT(I), CHD1, PRECIS)
              CALL SLA_MAPQKZ(R2000(I), D2000(I), AMPRMS,
     1                        RA, DA)
              CALL PANGLE('H', RA, CHR2, PRECIS+1)
              CALL PANGLE('D', DA, CHD2, PRECIS)
              WRITE (LIST, 601) SNAME(I), CHR1, CHD1, EPOCH(I), CHR2,
     1                          CHD2
 1930     CONTINUE
C
      ELSE IF (SYSTEM.EQ.'ECLIP') THEN
          WRITE (LIST, 640)
          WRITE (LIST, 631) IY,IM,ID, SLA_EPJ(DATE)
          DO 1940 I=1,NSRC
              CALL PANGLE('H', RACAT(I), CHR1, PRECIS+1)
              CALL PANGLE('D', DECAT(I), CHD1, PRECIS)
              CALL SLA_EQECL(R2000(I), D2000(I), DATE, DL, DB)
              WRITE (LIST, 611) SNAME(I), CHR1, CHD1, EPOCH(I), 
     1          DL*DEG, DB*DEG
 1940     CONTINUE
C
      END IF
      GOTO 1000
C
C Finish.
C
 2000 CONTINUE
C-----------------------------------------------------------------------
      END
