C-----------------------------------------------------------------------
C QFIT.INC
C-----------------------------------------------------------------------
C     This common block is used by the program QFIT and all of its
C     associated subroutines, via INCLUDE statements.
C
C     Modified 19-Jun-1985 (TJP) - add comma after ICBSNO.
C     Modified 17-Mar-1994 (TJP) - remove unused variables.
C
      INTEGER MXSTA, MXBAS, MXTRI, MXICLO, MAXWPB, MXREC, MXMOD
C         Maximum number of stations, baselines, triangles
      PARAMETER (MXSTA=20)
      PARAMETER (MXBAS=MXSTA*(MXSTA-1)/2)
      PARAMETER (MXTRI=MXBAS*(MXSTA-2)/3)
C         Maximum number of independent triangles
      PARAMETER (MXICLO=(MXBAS-1)*(MXBAS-2)/2)
      PARAMETER (MAXWPB=7)
C         Maximum number of data records
      PARAMETER (MXREC=400)
C         Maximum number of model components
      PARAMETER (MXMOD=5000)
      INTEGER INC,OUTC,INDAT,INMOD,PR
      PARAMETER (INC=5,OUTC=6,INDAT=8,INMOD=9,PR=10)
C
      REAL PI,DEGRAD,RADHRS,TWOPI,HALFPI,SIDR,VELC,CONV1
      PARAMETER (PI=3.1415927)
      PARAMETER (DEGRAD=PI/180.)
      PARAMETER (RADHRS=1./(DEGRAD*15.))
      PARAMETER (TWOPI=2.*PI)
      PARAMETER (HALFPI=PI/2.)
C         Sec of ST per sec of UT
      PARAMETER (SIDR=1.0027379093)
C         Speed of light
      PARAMETER (VELC=2.997925E8)
C           msec of arc per radian
      PARAMETER (CONV1 = 2.0626481E8)
C
      REAL
     1  FLUX(MXMOD), RADIUS(MXMOD), THETA(MXMOD), AXIS(MXMOD),
     2  RATIO(MXMOD), PHI(MXMOD), RTHETA(MXMOD),
     3  RPHI(MXMOD),
     4  UDATA(MXREC,MXBAS), VDATA(MXREC,MXBAS), OBSVIS(MXREC,MXBAS),
     5  WTVIS(MXREC,MXBAS), MODVIS(MXREC,MXBAS),
     7  OBSCLO(MXREC,MXTRI), WTCLO(MXREC,MXTRI), MODCLO(MXREC,MXTRI),
     8  DOWNWT(MXREC),
     9  TNZCLO,
     1  LAMBDA, UT(MXREC), 
     2  VISAF(MXBAS), CLOAF(MXTRI), AMPLAF, PHASAF, TOTLAF
      INTEGER
     2  TYPE(MXMOD),
     3  NCOMP,
     8  ICBSNO(3,MXTRI), NUMCLO(MXREC),
     9  NINDCL, NUMBAS, NUMREC, NUMSTA, NUMTRI, NZCLO(MXTRI), 
     1  NZVIS(MXBAS), NZAMP, NINTRI(MXREC), OUTPR
      COMMON
C     Model parameters:
     1  FLUX, RADIUS, THETA, AXIS,
     2  RATIO, PHI, TYPE, RTHETA,
     3  RPHI, NCOMP,
C     Amplitude related data:
     4  UDATA, VDATA, OBSVIS,
     5  WTVIS, MODVIS,
C     Closure phase related variables:
     7  OBSCLO, WTCLO, MODCLO,
     8  ICBSNO, NUMCLO, DOWNWT,
C     Variables to describe limits of data:
     9  NINDCL, NUMBAS, NUMREC, NUMSTA, NUMTRI, NZCLO, TNZCLO,
     1  NZVIS, NZAMP, NINTRI, LAMBDA, UT, OUTPR,
C     Variables used in the calculation of agreement factors:
     2  VISAF, CLOAF, AMPLAF, PHASAF, TOTLAF
C
      DOUBLE PRECISION STNAME(MXSTA), STX(MXSTA), STY(MXSTA),
     1       STZ(MXSTA), SOURCE(2), RAP, DECP, GASTM, FREQ, FLUX1
      COMMON /PARMS/
     1  STNAME, STX, STY, STZ, SOURCE, RAP, DECP, GASTM, FREQ, FLUX1
C
      INTEGER 
     1  NSTA, NBAS, NTRI, NAVIS(MXBAS), NBVIS(MXBAS),
     2  NACLO(MXTRI), NBCLO(MXTRI), NCCLO(MXTRI), NVER, NDWPB
      COMMON /ORDER/
     1  NSTA, NBAS, NTRI, NAVIS, NBVIS,
     2  NACLO, NBCLO, NCCLO, NVER, NDWPB
C
      CHARACTER*64 INDSN, MODDSN, OUTDSN
      COMMON /STRING/
     1  INDSN, MODDSN, OUTDSN
C-----------------------------------------------------------------------
