      PROGRAM UNBIAS
C-----------------------------------------------------------------------
C This program is based on the VLB program AVERAGE.  It makes an
C empirical correction for the positive bias present in low SNR data.
C It should be run on MERGED data, before NCAL, before any final
C averaging is done, and after most of the editing has been done.
C
C Version 2.0: 1981 Apr  1 - Let user state which version of PHASOR
C Version 3.0: 1987 Dec 16 - closer to Fortran-77 (TJP).
C Version 4.0: 1991 Feb 18 - 20 stations (TJP).
C
C MS sets the maximum number stations the program can handle
C MAXSEC is the maximum number of sections per average
C-----------------------------------------------------------------------
      CHARACTER*(*) PROGNM, VERSN
      PARAMETER  (PROGNM='UNBIAS')
      PARAMETER  (VERSN='4.0 - 1991 Feb 18')
      INTEGER    MS,MB,MC,MR,MAXSEC,MRSAVE
      PARAMETER  (MS=20)
      PARAMETER  (MB=MS*(MS-1)/2)
      PARAMETER  (MC=MS*(MS-1)*(MS-2)/6)
      PARAMETER  (MR=4*MB+2*MC)
      PARAMETER  (MAXSEC=720)
      PARAMETER  (MRSAVE=MR)
C
      LOGICAL    END,SKIPH
      DATA     SKIPH/.FALSE./
      CHARACTER*80 NEWHIS
      INTEGER    OUTREC
      INTEGER    NPTS(MB),ITSAVE(MAXSEC)
      REAL       TAKE(MR),SAVE(MRSAVE,MAXSEC)
      REAL       AMP(MB),ERRA(MB)
      REAL*8     DEGRAD,XVALS(130),COR(MB),C(9)
      DATA       DEGRAD/57.29577951D0/,XVALS/130*0.D0/
      REAL*8 GASTM,FREQ,STNAME(MS),STX(MS),STY(MS),STZ(MS),SOURCE(2),
     +        RA,DEC,RAP,DECP,FLUX
      COMMON /PARMS/STNAME,STX,STY,STZ,SOURCE,RAP,DECP,GASTM,FREQ,FLUX
      COMMON /ORDER/NSTA,NBM,NCM,NB1(MB),NB2(MB),NC1(MC),NC2(MC),
     +                NC3(MC)
      CHARACTER*64  AVGIN,AVGOUT
      CHARACTER*1   PORF
C-----------------------------------------------------------------------
      INUNIT = 8
      IOUT = 9
C
C Determine which version of PHASOR was used, to decide which
C polynomial to use:
C
      WRITE (6,1100) ' '//PROGNM//
     1   ' corrects for positive bias in weak data'
      WRITE (6,1100) ' (Version '//VERSN//')'
      WRITE (6,1100)'0If you do not know the answer to the following',
     +' question, DO NOT guess if you '
      WRITE (6,1100)' require accurate calibration!!!!!!!'
      TRIAL = 0
      WRITE (6,1100)' '
    3 WRITE (6,1100)'$Which version of PHASOR did you use, FPHASRB or',
     +' PHASRB  (F or P)?   '
 1100 FORMAT (A,A,A,A,A)
      READ (5,1100,ERR=4) PORF
      CALL UPCASE(PORF)
    4 IF (PORF .EQ. 'F') THEN
C         FPHASRB (freq domain) version of phasor was used:
          C(1) =  9.12449
          C(2) = -6.27936
          C(3) =  2.07748
          C(4) = -3.82259E-1
          C(5) =  4.27675E-2
          C(6) = -2.98286E-3
          C(7) =  1.26867E-4
          C(8) = -3.01362E-6
          C(9) =  3.06591E-8
          NTERMS = 9
          CUTOFF = 15.0
      ELSEIF(PORF .EQ. 'P') THEN
          C(1) = 1.3857
          C(2) = -.11282
          C(3) = 1.2745E-2
          C(4) = -6.603E-4
          C(5) = 1.34E-5
          NTERMS = 4
          CUTOFF = 10.0
      ELSE
C         No acceptable answer given:
          IF (TRIAL .EQ. 3) THEN
C           This is not the first failure, so exit via an error
            WRITE (6,1100)'0Since you insist on refusing to answer ',
     +      'the question properly,'
            CALL ERROR('I am going to KILL YOU!!!!!!')
          ELSE
C           Give'em another chance
            TRIAL = TRIAL + 1.0
            WRITE (6,1100)' '
            WRITE (6,1100)
     1 ' That was NOT an acceptable answer; try again, you turkey!'
            WRITE (6,1100)' '
            GO TO 3
          ENDIF
      ENDIF
C
C Open files.
C
    1 WRITE(6,1000)
 1000 FORMAT('$Input file name : ')
      READ(5,1001) AVGIN
 1001 FORMAT(A)
      OPEN (UNIT=8, FILE=AVGIN, STATUS='OLD', READONLY,
     1      FORM='UNFORMATTED', ERR=1)
    2 WRITE(6,1002)
 1002 FORMAT('$Output file name : ')
      READ(5,1001) AVGOUT
      OPEN (UNIT=9, FILE=AVGOUT, STATUS='NEW', FORM='UNFORMATTED',
     1      ERR=2)
C
C Make new history record.
C
      CALL MKHIST(PROGNM, VERSN, NEWHIS)
C
C Obtain average time.
C
      WRITE(6,1006)
 1006 FORMAT('$Integration time to use to find SNR''s in this',
     +          ' data (seconds) : ')
      READ(5,*) INSEC
      SECAVG = INSEC
      INTAVG = SECAVG * 60
      XVALS(45) = SECAVG
C
C Process header records.
C
      NHN = 1
      IPROUT = 0
      CALL HEADX20(SKIPH,INUNIT,IZERO,IDAY,IYEAR,%REF(NEWHIS),
     +         NHN,IOUT,IUNITS,XVALS,IFILE,IPROUT)
      IF(IFILE.EQ.1) CALL ERROR('end of file')
C
C Set size parameters.
C
      N = 4*NBM  + 2*NCM
C
C Initialize counters.
C
      INREC = 0
      OUTREC = 0
      INAVG = 0
      IFIRST = -1
      ILAST = -1
      END = .FALSE.
C
C Process data.
C
  100 CONTINUE
      ITLAST = IT
      READ(INUNIT,END=110) IT,(TAKE(I),I=1,N)
      IF(IT.EQ.-1) GO TO 110
      INREC = INREC + 1
      IF(IT.GE.IFIRST.AND.IT.LE.ILAST) GO TO 300
           IF(INREC.EQ.1) GO TO 200
           GO TO 120
C
C         PREPARE OUTPUT
  110      END = .TRUE.
           IF(END.AND.INAVG.EQ.0) GO TO 900
  120      OUTREC = OUTREC + 1
C
C        OUTPUT SECTION
C  Find correction factor as a fn of signal-to-noise (SNR)
           DO 130 I = 1,NBM
             COR(I) = 1.0
             IF (ERRA(I) .EQ. 0.0) GO TO 130
             SNR = AMP(I) / SQRT(ERRA(I)*NPTS(I))
             IF (SNR .LT. CUTOFF) THEN
               COR(I) = 0.0
               DO 125 J = 1,NTERMS
  125            COR(I) = COR(I) + C(J) * SNR**(J-1)
             ENDIF
  130      CONTINUE
C  Correct the amplitudes, and write everything to the output file
           DO 150 J = 1, INAVG
             DO 140 I = 1, NBM
               K = I*4 - 3
  140          SAVE(K,J) = SAVE(K,J) / COR(I)
             ITOUT = ITSAVE(J)
             WRITE (IOUT) ITOUT, ( SAVE(I,J), I=1,N )
  150      CONTINUE
           IF(END) GO TO 900
C
C        RESET ACCUMULATION
  200      INAVG = 0
           IFIRST = IT/INTAVG
           IFIRST = IFIRST * INTAVG
           ILAST = IFIRST + INTAVG - 1
           DO 210 I = 1,NBM
             AMP(I) = 0.0
             NPTS(I) = 0
  210        ERRA(I) = 0.0
C
C
C     ACCUMULATE
C
  300 INAVG = INAVG + 1
C  Save the input record
      ITSAVE(INAVG) = IT
      DO 302 I = 1,N
  302     SAVE(I,INAVG) = TAKE(I)
      DO 310 I = 1,NBM
           K = 4*I
           IF(TAKE(K-2).LE.0.) GO TO 310
           ERA = 1/(TAKE(K-2)*TAKE(K-2))
           AMP(I) = AMP(I) + TAKE(K-3)*ERA
           ERRA(I) = ERRA(I) + ERA
           NPTS(I) = NPTS(I) + 1
  310      CONTINUE
      GO TO 100
C
C
C     TERMINATION
C
  900 CONTINUE
      ITOUT=-1
      WRITE(IOUT) ITOUT,(0.0,I=1,N)
      WRITE(6,1901) SOURCE,INREC
 1901 FORMAT(1X,2A8,' Unbiasing of ',I6,' records completed.')
      END
