      PROGRAM VAMPHI
C
C Main Program for VAMPHI. 
C
C Version 1.0: 1989 Dec 11: derived from AMPHI v8.3 (TJP).
C Version 1.1: 1990 Dec 12: corrected for Sun Fortran (TJP).
C-----------------------------------------------------------------------
      CHARACTER*(*) VERSN
      PARAMETER (VERSN='1.1 - 1990 Dec 12')
      INTEGER    INC, OUTC, LIST
      PARAMETER (INC=5, OUTC=6)
      PARAMETER (LIST=1)
      INTEGER    MAXS, MAXB, MAXT, MAXWPB, MAXL, NPARS
      PARAMETER (MAXS=20)
      PARAMETER (MAXB=MAXS*(MAXS-1)/2)
      PARAMETER (MAXT=MAXB*(MAXS-2)/3)
      PARAMETER (MAXWPB=7)
      PARAMETER (MAXL=MAXWPB*MAXB+2*MAXT)
      PARAMETER (NPARS=36+MAXS*3)
C
      INTEGER   MXSECS, MXS, MXL, I, IER, MODE, NB, NT, NP
      INTEGER   LIB$GET_VM, LEN1, VLBOPE
      INTEGER   NBYTES(5), LOC(5)
      CHARACTER*128 LISFIL, INFILE, TEXT, MOKFIL, ASSFIL
      DOUBLE PRECISION NAMES(NPARS), PARS(NPARS), ENDMRK
      DATA NAMES/ 'INput',8*' ',
     1         'OUtput',4*' ', 'MOckdata',4*' ',
     2         'LOng', 'CLamp', 3*'*2',
     3         'FLOatgai', 'SCale', 'FLAgfail', '*3', 'CUtoff',
     4         'UCutoff', 'UVratio', 'LIstfile', 4*' ', 
     5          MAXS*'PHSerr', MAXS*'GAInerr',
     6          MAXS*'TImescal'/
      DATA PARS / 9*' ', '***UNSET',4*' ', '***UNSET', 4*' ',
     2         -1D0,-1D0,-1D0, 400D0, 10D0,
     3         -1D0,-1D0,-1D0, 0D0, 0.1D0,
     4         0D0,1D0, 'vamphi.l', 'is', 3*' ',
     5         MAXS*-1D0, MAXS*-1D0,
     6         MAXS*-1D0/
      DATA ENDMRK/'/'/
C-----------------------------------------------------------------------
  630 FORMAT ('Program VAMPHI  --  Visibility amplitude and phase',
     1        ' correction'/'(Version ',A,')'//
     2        'Control parameters:'/)
  640 FORMAT ('Allocating memory for',I3,' stations, ',I5,
     1        ' data records, and ',I6,' data points;',
     2        F9.2,' Mbytes required.')
C-----------------------------------------------------------------------
C
C Introduction.
C
      CALL PUTOUT('VAMPHI self-calibrates MERGE files')
      CALL PUTOUT('(Version '//VERSN//')')
      CALL PUTOUT(' ')
C
C Read the control parameters.
C
      CALL PUTOUT('Control parameters (Mockdata, Output, etc):')
      MODE = 0
      CALL KEYIN (NAMES,PARS,NPARS,ENDMRK,MODE,INC,OUTC)
C
C Find the Mock Data file, and read it to get the name of the input
C MERGE file.
C
      WRITE (INFILE, '(9A8)') (PARS(I),I=1,9)
      WRITE (MOKFIL,'(5A8)') (PARS(I),I=15,19)
      OPEN (UNIT=16, FILE=MOKFIL, STATUS='OLD', READONLY,
     *      FORM='UNFORMATTED', IOSTAT=IER)
      READ (16,IOSTAT=IER) ASSFIL
      READ (16,IOSTAT=IER) MEMNP
      IF (IER.NE.0) CALL ERROR(
     *      'Mock data file does not exist or is invalid')
C
C Determine the size of the input file. The critical parameters
C are the number of stations (MXS) and the number of data records 
C (MXSECS).
C
      IF (INFILE.EQ.' ') INFILE = ASSFIL
      IER = VLBOPE(17, INFILE, 'MERGE', 'OLD', INFILE)
      IF (IER.NE.1) CALL ERROR('Input Merge file does not exist')
      CALL PUTOUT('Data file (MERGE): '//INFILE(1:LEN1(INFILE)))
      CALL MRGSIZ(17, MXS, NB, NT, MXSECS, NP)
      REWIND (UNIT=17)
      IF (NP.NE.MEMNP) CALL ERROR('Merge file doesn''t match MEM file.')
C     -- Add 1 to MXSECS (needed for workspace).
      MXSECS = MXSECS+1
      MXL = 7*MAXB
C
C Allocate memory. The dynamic arrays are:
C  1. REAL DATA(MXSECS,MXL) - holds data from input file
C  2. REAL BSTORE(MXSECS,MXS,MXS) - 
C  3. REAL FSTORE(MXSECS,MXS,MXS) -
C  4. REAL MAMP(NP) - model amplitudes
C  5. REAL MPHS(NP) - model phases (degrees)
C
      NBYTES(1) = MXSECS*MXL*4
      NBYTES(2) = MXSECS*MXS*MXS*4
      NBYTES(3) = MXSECS*MXS*MXS*4
      NBYTES(4) = NP*4
      NBYTES(5) = NP*4
      WRITE (TEXT, 640) MXS, MXSECS, NP,
     *      REAL(NBYTES(1)+NBYTES(2)+NBYTES(3)+NBYTES(4)+NBYTES(5))
     *      /(1024.0*1024.0)
      CALL PUTOUT(TEXT(1:LEN1(TEXT)))
      IF (MXS.GT.MAXS) CALL ERROR
     1       ('Actual number of stations exceeds maximum (20)')
      IF(MXSECS.GT.2000) CALL ERROR
     1       ('Actual number of data records exceeds maximum (2000)')
      DO 30 I=1,5
          IER = LIB$GET_VM(NBYTES(I),LOC(I))
          IF (IER.NE.1) CALL 
     1       ERROR('Dynamic allocation failed: arrays too big')
   30 CONTINUE
C
C Open the listing file.
C
      WRITE (LISFIL,'(5A8)') (PARS(I),I=32,36)
      OPEN (UNIT=LIST, FILE=LISFIL, STATUS='NEW',
     1      CARRIAGECONTROL='LIST', IOSTAT=IER)
      IF (IER.NE.0) CALL ERROR('Cannot open LISTFILE')
      WRITE (LIST,630) VERSN
      CALL KEYOUT(NAMES,PARS,NPARS,LIST)
C
C Read the mock data into MAMP and MPHS arrays.
C
      CALL GETMEM(16, NP, %val(LOC(4)), %val(LOC(5)))
      CLOSE (UNIT=16)
C
C Call a subroutine to do all the work.
C
      CALL AMPHI1(MXSECS,MXS,MXL,NP,
     1           %VAL(LOC(1)), %VAL(LOC(2)), %VAL(LOC(3)),
     2           %val(LOC(4)), %val(LOC(5)),
     3           PARS, NPARS, VERSN)
C
C Execution summary.
C
      WRITE (LIST,'(/A,T20,A)') 'VAMPHI version:',VERSN
      CALL REPORT(LIST)
      CALL REPCPU(LIST)
C
C Close the listing file.
C
      INQUIRE (UNIT=LIST, NAME=LISFIL)
      CLOSE (UNIT=LIST)
      CALL PUTOUT('VAMPHI completed; listing in '//
     1            LISFIL(1:LEN1(LISFIL)))
C
      END

      SUBROUTINE AMPHI1(MXSECS,MXS,MXL,NP,
     *                  DATA,BSTORE,FSTORE, MAMP, MPHS,
     *                  PARS,NPARS,
     *                  VERSN)
      INTEGER MXSECS, MXS, MXL, NP, NPARS
      REAL DATA(MXSECS,MXL)
      REAL BSTORE(MXSECS,MXS,MXS)
      REAL FSTORE(MXSECS,MXS,MXS)
      REAL MAMP(NP)
      REAL MPHS(NP)
      REAL*8 PARS(NPARS)
      CHARACTER*(*) VERSN
C
C       Subroutine AMPHI1 called by VAMPHI, which uses dynamic memory
C       allocation for the largest arrays.
C
C       Station amplitude and phase solution for Hybrid-mapping.
C       Uses method of Cornwell and Wilkinson (1981) MNRAS, 196, 1067.
C       Observed baseline amplitudes and phases are adjusted
C       station-by-station, minimizing differences between the
C       observed and input-model visibilities. Loosely based on PHASE
C       program of T.J. Pearson (1981 March 5).
C
C       S.C. Unwin      VAX-11 Fortran      20 stations
C-----------------------------------------------------------------------
      INTEGER MAXS,MAXB,MAXT,MAXL,INDAT,OUTDAT,INMOD,
     1          MAXWPB,LIST
      PARAMETER (MAXS=20)              ! maximum number of stations
      PARAMETER (MAXB=MAXS*(MAXS-1)/2)                 !  baselines
      PARAMETER (MAXT=MAXB*(MAXS-2)/3)                 !  triangles
      PARAMETER (MAXWPB=7)          ! maximum data words per baseline
      PARAMETER (MAXL=MAXWPB*MAXB+2*MAXT)       !  data record length
C                                                 !  with clos. phases
      PARAMETER (MAXSECS=2000)                      ! no of UT times
      PARAMETER (MAXS450=50+MAXS*4)           ! for CHANGE in HEADX20
      PARAMETER (INDAT=17)
      PARAMETER (OUTDAT=10)
      PARAMETER (INMOD=4)
      PARAMETER (LIST=1)
C
C
      REAL REC(MAXL)
      REAL*8 BBB(MAXS,MAXS),FFF(MAXS,MAXS),FSUM(MAXS,MAXS)
      REAL*8 CCC(MAXS),EEE(MAXS),ESUM(MAXS),XXX(MAXS),YYY(MAXS)
      REAL CSTORE(MAXSECS,MAXS),ESTORE(MAXSECS,MAXS)
      REAL*8 BASERR(MAXB),AERRIN(MAXS),PERRIN(MAXS)
      REAL*8 DELSQA,DELSQP,ADATA,PDATA,AMPMOD,PHSMOD
      INTEGER BASE(MAXB),TRIG(MAXT),STATYP
      INTEGER CONST(MAXT,3),B1,B2,B3,IUT(MAXSECS)
      LOGICAL CLAMP,SCALE,FLOATGN,SMOOTH
      LOGICAL TUSED(MAXT),PCHECK(MAXB),AUSABLE(MAXB),PUSABLE(MAXB)
      LOGICAL FLAGFAIL
      LOGICAL*1 UVFLAG(MAXSECS,MAXB)
      CHARACTER*8 UTP,TIMEC
      CHARACTER*8 FIELD(MAXS),STAR,ZERO,BLANK,FORM1,FORM2,FORM3
      CHARACTER*8 TDATA(MAXL),STAR2,FORM4
      CHARACTER NEWHIS*240, MODE*80
      REAL    WT(MAXS),TIMESCAL(MAXS)
      REAL    AMPM(MAXSECS,MAXB),PHSM(MAXSECS,MAXB)
      REAL*8  BX,BY,BZ(MAXB),BXY(MAXB),BOFF(MAXB),RPDEG,PI,RPMAS
      REAL*8  VELC,WAVE,SIDR
      REAL*8  STNAME,STX,STY,STZ,SOURCE(2),RA,DEC,GASTM,FREQ,TOTFL,
     1          TINTG,AVG,BW,AEIOWM,
     2          COSDEC,SINDEC,TIHA,CHANGE(MAXS450)
      REAL    RMSIN,RMSINJ,RMSOUT,RMSOUTJ
      CHARACTER*64  FFROM,FTO
      DATA    STAR/'     *  '/,ZERO/'    0   '/,BLANK/'        '/,
     1          FORM1/'(F8.4)'/,FORM2/'(A8)'/,FORM3/'(F8.3)'/,
     2          STAR2/'    *   '/,FORM4/'(F8.2)'/
      DATA    CHANGE/MAXS450*0D0/
      COMMON  /PARMS/ STNAME(MAXS),STX(MAXS),STY(MAXS),STZ(MAXS),
     1                  SOURCE,RA,DEC,GASTM,FREQ,TOTFL,TINTG,AVG,BW,
     2                  AEIOWM(6,MAXS),STATYP(MAXS),ORBITERS
      COMMON  /ORDER/ NS,NB,NT,NB1(MAXB),NB2(MAXB),
     1                  NT1(MAXT),NT2(MAXT),NT3(MAXT),NVER,NDWPB
      COMMON  /ERR/ NSECS,NBASE,AMPM,PHSM
      COMMON  /SCACOM/ XXX,AERRIN,NSTA
C
      CALL SCLOCK     ! set clock
      PI=3.141592654D0
      RPDEG=PI/180.0D0
      RPMAS=RPDEG/3.6D6
      VELC=2.997925D8
C     ! radians of ST per sec/60 of UT
      SIDR=(PI/2592000.0D0)*1.00273791D0 
C
      CALL MKHIST('VAMPHI', VERSN, NEWHIS(1:80))
C
C Interpret parameters.
C
      LONG  = PARS(20)
      CLAMP = PARS(21).NE.-1D0
      FLOATGN  = PARS(25).NE.-1D0
      SCALE    = PARS(26).NE.-1D0
      FLAGFAIL = PARS(27).NE.-1D0
      CUTOFF   = PARS(29)
      UCUT     = PARS(30)
      RATIO    = PARS(31)
C
      DO 99 IS=1,MAXS
          IF (PARS(37).EQ.-1D0) THEN
              PERRIN(IS) = 360.0*RPDEG            ! Def PERRIN(IS) = 360 deg
          ELSE
              PERRIN(IS) = PARS(IS+36)*RPDEG
          END IF
          IF (PARS(MAXS+37).EQ.-1D0) THEN
              AERRIN(IS) = 2.0                       ! Def AERRIN(IS) = 2.0
          ELSE
              AERRIN(IS) = PARS(IS+MAXS+36)
          END IF
          IF (PARS(2*MAXS+37).EQ.-1D0) THEN   ! Def SMOOTH = .FALSE. if
              SMOOTH = .FALSE.                       ! TIMESCAL(1) is unset
          ELSE
              SMOOTH = .TRUE.
              TIMESCAL(IS) = PARS(IS+2*MAXS+36)*3600.0  ! Unit = frames
              IF (TIMESCAL(IS).LT.0.001) TIMESCAL(IS) = 1.0
          END IF
 99   CONTINUE
C
C Open and check file names
C
      WRITE (FTO,640)   (PARS(I),I=10,14)
      INQUIRE (UNIT=INDAT,NAME=FFROM)
      OPEN    (UNIT=OUTDAT,NAME=FTO,TYPE='NEW',FORM='UNFORMATTED',
     1         ERR=530)
      INQUIRE (UNIT=OUTDAT,NAME=FTO)
      WRITE (LIST,596) FFROM
      WRITE (LIST,598) FTO
C
C Read header from input file
C
      CALL HEADX20(.FALSE.,INDAT,IZ,ID,IY,
     1          %REF(NEWHIS),2,0,KFLAG,CHANGE,IFEOF,0)
      LENG=NDWPB*NB + 2*NT
      LENGB=NDWPB*NB
      NBASE=NB
      NSTA=NS
      IF(NS.GT.MXS) CALL ERROR('Too many stations.') ! Limit from D.M.A.
      IF(KFLAG.NE.1) WRITE (LIST,620)
      IF(NB.LT.1 .OR. NS.LT.2) CALL ERROR('Not enough baselines.')
C
      DO 100 IB=1,NB                          ! Baseline labels BASE
  100 BASE(IB) = 100*NB1(IB) + NB2(IB)
      NTX=NS*(NS-1)*(NS-2)/6
      IF(NS.LE.2) NTX=0
      NTIND=NB-NS+1
      IF(NS.LE.2) NTIND=0
      NCLAMP=NS*(NS-1)*(NS-2)*(NS-3)/8
      IF(NS.LE.3) NCLAMP=0
      NCLAMPI=NB-NS
      IF(NS.LE.3) NCLAMPI=0
      WRITE (LIST,601) SOURCE,NS,NB,NTX,NTIND,NCLAMP,NCLAMPI
C
      IF(CLAMP.AND.SCALE) CLAMP = .FALSE.     ! Prefer SCALE over CLAMP
      IF(SMOOTH.AND.(.NOT.SCALE)) CLAMP = .TRUE.      ! SMOOTH => CLAMP
      IF(SCALE.AND.SMOOTH) SMOOTH = .FALSE. ! SCALE =>  SMOOTH = .FALSE.
      IF(.NOT.SCALE) WRITE (LIST,611) (STNAME(IS),IS=1,NS)
      IF(CLAMP) THEN
         WRITE (LIST,615)
         IF(SMOOTH) WRITE (LIST,604) (TIMESCAL(IS)/3600.0,IS=1,NS)
         IF(SMOOTH) WRITE (LIST,613) CUTOFF
         ENDIF
      WRITE (LIST,602) (BASE(IB),IB=1,NB)
C
      IT = 0                              ! constituent baselines CONST
      DO 110 I3=3,NS
      DO 110 I2=2,I3-1
      DO 110 I1=1,I2-1
      IT = IT+1
      TRIG(IT) = 10000*I1 + 100*I2 + I3
      CONST(IT,1) = I1+(I2-1)*(I2-2)/2
      CONST(IT,2) = I2+(I3-1)*(I3-2)/2
  110 CONST(IT,3) = I1+(I3-1)*(I3-2)/2
      IF(IT.NE.NTX) CALL ERROR('Problem with closure phases')
C
      WAVE=VELC/FREQ                      ! Compute baseline parameters
      COSDEC=DCOS(DEC)
      SINDEC=DSIN(DEC)
      DO 120 IB=1,NB
      IS1 = NB1(IB)
      IS2 = NB2(IB)
      IF ((STATYP(IS1).LE.1) .AND. (STATYP(IS2).LE.1)) THEN
           BX=(STX(IS1)-STX(IS2))/WAVE
           BY=(STY(IS1)-STY(IS2))/WAVE
           BZ(IB)=(STZ(IS1)-STZ(IS2))/WAVE
           BOFF(IB)=GASTM-RA-PI/2.0-DATAN2(BY,BX)
           BXY(IB)=DSQRT(BX*BX + BY*BY)
      ELSE
           BZ(IB)   = 0D0
           BOFF(IB) = 0D0
           BXY(IB)  = 0D0
      END IF
  120 CONTINUE
C
C Read the input data; store in array DATA(*,*).
C
      NSECS=1
 200  READ(INDAT,END=210) IUT(NSECS),(DATA(NSECS,J),J=1,LENGB)
      IF(IUT(NSECS).LT.0) GOTO 210
      NSECS=NSECS+1
      IF(NSECS.GT.MXSECS) GOTO 209    ! Limit set by dynamic allocation
      GOTO 200
 209  WRITE (LIST,651) MXSECS
 210  NSECS=NSECS-1
C
C Read through the data, filling the arrays AMPM and PHSM with
C mock data, and flagging data outside uv limits.
C
      IP = 0
      DO 220 ISECS=1,NSECS
          DO 219 IB=1,NB
C             -- Skip deleted data
              IF (DATA(ISECS,NDWPB*(IB-1)+2).LE.0.0 .OR.
     1            DATA(ISECS,NDWPB*(IB-1)+4).LE.0.0) GOTO 219
C             -- Count the data point
              IP = IP+1
C             -- Store the model visibility
              AMPM(ISECS,IB) = MAMP(IP)
              PHSM(ISECS,IB) = MPHS(IP)
C             -- Get uv of data point
              IF (NVER.EQ.1) THEN
                  TIHA = (IUT(ISECS)-IZ)*SIDR + BOFF(IB)
                  UU = BXY(IB)*DCOS(TIHA)
                  VV = BZ(IB)*COSDEC + BXY(IB)*SINDEC*DSIN(TIHA)
              ELSE IF (NVER.EQ.2) THEN
                  UU = DATA(ISECS,NDWPB*(IB-1)+5)
                  VV = DATA(ISECS,NDWPB*(IB-1)+6)
              END IF
C             -- Flag data outside u-v limits
C             -- UVFLAGS is true for rejected data
              UVFLAG(ISECS,IB) = .FALSE.
              IF (UCUT.NE.0) THEN
                  UVSIGN = -1.0            ! neg/pos = 'inside'/'outside'
                  IF( SQRT( (UU*1.0E-6)**2 + (RATIO*VV*1.0E-6)**2 )
     1                   .GT. ABS(UCUT) )  UVSIGN = +1.0
                  IF(UVSIGN*UCUT .LT. 0.0) UVFLAG(ISECS,IB) = .TRUE.
              END IF
  219     CONTINUE
  220 CONTINUE
      IF (UCUT.GT.0) WRITE (LIST,657)  UCUT, UCUT*RATIO
      IF (UCUT.LT.0) WRITE (LIST,658) -UCUT,-UCUT*RATIO
C
C Compute fit of mock data (model) to input data.
C
      CALL RMSERR(DATA,MXSECS,MXL,NDWPB,RMSIN,RMSINJ)
C----------------------------------------------------------------------
C               Solve for amp and phase correction for each UT
C
      DO 300 ISECS=1,NSECS
C
      DO 320 IB=1,NB
      AMPERR =      DATA(ISECS,NDWPB*(IB-1)+2)
      PHSERR =      DATA(ISECS,NDWPB*(IB-1)+4)
      AUSABLE(IB)= AMPERR.GT.0.0 .AND. PHSERR.GT.0.0
      PUSABLE(IB)= AMPERR.GT.0.0 .AND. PHSERR.GT.0.0
      IF(PUSABLE(IB)) DATA(ISECS,NDWPB*(IB-1)+3) =
     1     PNORM(DATA(ISECS,NDWPB*(IB-1)+3),0.0)
      BASERR(IB) = AMPERR
      IF(UVFLAG(ISECS,IB)) THEN       ! Flag data rejected by u-v limits
          AUSABLE(IB) = .FALSE.
          PUSABLE(IB) = .FALSE.
          ENDIF
 320  CONTINUE
C
      DO 720 IB=1,NB           ! Compute (observed-model) closure phase,
 720  PCHECK(IB) = .FALSE.            ! and adjust observed phase until
      NTAKE=0                         ! |diff| < 180deg.
 730  NTAKE=NTAKE+1
      IF(NTAKE.GE.NB+1) GOTO 310
      IF(PCHECK(NTAKE)) GOTO 730
      IF(.NOT.PUSABLE(NTAKE)) GOTO 730
      IB=NTAKE
      DATA(ISECS,NDWPB*(IB-1)+3) =
     1     PNORM(DATA(ISECS,NDWPB*(IB-1)+3),PHSM(ISECS,IB))
 740  PCHECK(IB)=.TRUE.
      DO 700 IT=1,NTX
      TUSED(IT)=.FALSE.
      IF(TUSED(IT)) GOTO 700
      B1=CONST(IT,1)
      B2=CONST(IT,2)
      B3=CONST(IT,3)
      IF( (.NOT.PUSABLE(B1)) .OR. (.NOT.PUSABLE(B2)) .OR.
     1      (.NOT.PUSABLE(B3)) )  GOTO 700
      IF(PCHECK(B1)) GOTO 701
      IF((.NOT.PCHECK(B2)).OR.(.NOT.PCHECK(B3))) GOTO 700
      IB=B1
      GOTO 710
 701  IF(PCHECK(B2)) GOTO 702
      IF((.NOT.PCHECK(B1)).OR.(.NOT.PCHECK(B3))) GOTO 700
      IB=B2
      GOTO 710
 702  IF(PCHECK(B3)) GOTO 700
      IF((.NOT.PCHECK(B1)).OR.(.NOT.PCHECK(B2))) GOTO 700
      IB=B3
 710  CLS = DATA(ISECS,NDWPB*(B1-1)+3) + DATA(ISECS,NDWPB*(B2-1)+3)
     1        - DATA(ISECS,NDWPB*(B3-1)+3)
      CLSM=PHSM(ISECS,B1) + PHSM(ISECS,B2) - PHSM(ISECS,B3)
      DIFF = CLS - CLSM
      TUSED(IT)=.TRUE.
      SIGN =  +1.0
      IF(DIFF.GT.180.0) SIGN = -1.0
      SIGN3 = +1.0
      IF (IB.EQ.B3) SIGN3 = -1.0
 711  IF((DIFF.LT. 180.0) .AND. (DIFF.GE.-180.0)) GOTO 740
      DATA(ISECS,NDWPB*(IB-1)+3) = DATA(ISECS,NDWPB*(IB-1)+3) +
     1                               SIGN3*SIGN*360.0
      DIFF    = DIFF    + SIGN*360.0
      GOTO 711
 700  CONTINUE
      GOTO 730
C
 310  DO 330 IS2=1,MAXS                       ! Initialize matrix arrays
      CCC(IS2)=0.0D0
      EEE(IS2)=0.0D0
      XXX(IS2)=0.0D0
      YYY(IS2)=0.0D0
      DO 330 IS1=1,MAXS
      BBB(IS1,IS2)=0.0D0
 330  FFF(IS1,IS2)=0.0D0
C
      DO 340 IB=1,NB              ! Fill matrix arrays BBB,CCC,FFF,EEE
      IS1=NB1(IB)
      IS2=NB2(IB)
      DELSQA=0.0D0
      DELSQP=0.0D0
      ADATA=DATA(ISECS,NDWPB*(IB-1)+1)        ! data  amplitude
      PDATA=DATA(ISECS,NDWPB*(IB-1)+3)        ! data  phase
      AMPMOD=AMPM(ISECS,IB)                   ! model amplitude
      PHSMOD=PHSM(ISECS,IB)                   ! model phase
      IF (PUSABLE(IB))
     1          DELSQP =  (ADATA/BASERR(IB))*(AMPMOD/BASERR(IB))
      IF (AUSABLE(IB))
     1          DELSQA = (AMPMOD/BASERR(IB))*(AMPMOD/BASERR(IB))
      BBB(IS1,IS2) = DELSQP
      BBB(IS2,IS1) = DELSQP
      BBB(IS1,IS1) = BBB(IS1,IS1) - DELSQP
      BBB(IS2,IS2) = BBB(IS2,IS2) - DELSQP
      FFF(IS1,IS2) = -DELSQA
      FFF(IS2,IS1) = -DELSQA
      FFF(IS1,IS1) = FFF(IS1,IS1) - DELSQA
      FFF(IS2,IS2) = FFF(IS2,IS2) - DELSQA
      CCC(IS1) = CCC(IS1) - DELSQP*(PDATA-PHSMOD)*RPDEG
      CCC(IS2) = CCC(IS2) + DELSQP*(PDATA-PHSMOD)*RPDEG
C
C       If AMPMOD = 0, then DELSQA = 0 also, so trap zero-divide:-
      IF(AMPMOD.GT.1.0E-12) THEN
      EEE(IS1) = EEE(IS1) - DELSQA*(ADATA/AMPMOD - 1.0D0)
      EEE(IS2) = EEE(IS2) - DELSQA*(ADATA/AMPMOD - 1.0D0)
      ENDIF
 340  CONTINUE
C
      DO 341 IS1=1,NS
      CCC(IS1) = CCC(IS1)*PERRIN(IS1)*PERRIN(IS1)
      EEE(IS1) = EEE(IS1)*AERRIN(IS1)*AERRIN(IS1)
      DO 342 IS2=1,NS
      BBB(IS1,IS2) = BBB(IS1,IS2)*PERRIN(IS1)*PERRIN(IS1)
 342  FFF(IS1,IS2) = FFF(IS1,IS2)*AERRIN(IS1)*AERRIN(IS1)
      BBB(IS1,IS1) = BBB(IS1,IS1) - 1.0D0
 341  FFF(IS1,IS1) = FFF(IS1,IS1) - 1.0D0
C
      DO 343 IS1=1,NS
      CSTORE(ISECS,IS1) = CCC(IS1)
      ESTORE(ISECS,IS1) = EEE(IS1)
      DO 343 IS2=1,NS
      BSTORE(ISECS,IS1,IS2) = BBB(IS1,IS2)
 343  FSTORE(ISECS,IS1,IS2) = FFF(IS1,IS2)
C---------------
 300  CONTINUE       ! Go back and fill arrays for next UT section
C=======================================================================
      IF((LONG.GE.1).OR.((LONG.GE.0).AND.CLAMP))
     1                 WRITE (LIST,609) (STNAME(I),I=1,NS)
      IF(LONG.GE.3)  WRITE (LIST,610) (BASE(IB),IB=1,NB)
      IF((LONG.GE.1).OR.((LONG.GE.0).AND.CLAMP))
     1                 WRITE (LIST,616)
C---------------------------
      GAINSUM = 0.0           ! Accumulate for average value of GAIN
      NGAINS  = 0
      DO 800 ISECS=1,NSECS    ! Loop to evaluate amp and phs errors
      UTP=TIMEC(MOD(IUT(ISECS)/60,86400))
C
C Solve for amp errors XXX and apply to DATA(ISECS,NDWPB*(IB-1)+1).
C If SMOOTH set, smooth arrays EEE and FFF first.
C
      IF(CLAMP) THEN
      IF(LONG.GE.3) THEN ! write diagnostics (deleted data printed as *)
                WRITE (LIST,612) ISECS,UTP
                DO IX=1,NB
                WRITE(TDATA(IX),FORM3) DATA(ISECS,NDWPB*(IX-1)+1)
                IF(DATA(ISECS,NDWPB*(IX-1)+2).LE.0.0)
     1                  WRITE(TDATA(IX),FORM2) STAR
                END DO
                WRITE (LIST,631) (TDATA(IB),IB=1,NB)
                WRITE (LIST,632) (AMPM(ISECS,IB),IB=1,NB)
                ENDIF
C
      IF(.NOT.SMOOTH) THEN            ! Unpack data for section ISECS
      DO 805 IS1=1,NS
      ESUM(IS1) = ESTORE(ISECS,IS1)
      DO 805 IS2=1,NS
 805  FSUM(IS1,IS2) = FSTORE(ISECS,IS1,IS2)
      ENDIF
C
      IF(SMOOTH) THEN                 ! Smooth amp data over index JSECS
      DO 810 IS1=1,NS
      ESUM(IS1) = 0.0D0
      DO 810 IS2=1,NS
 810  FSUM(IS1,IS2) = 0.0D0
C
      TIMEI = IUT(ISECS)
      DO 820 JSECS=1,NSECS
      DO 820 IS1=1,NS
      TIMEJ = IUT(JSECS)
      WT(IS1) = WEIGHT((TIMEJ-TIMEI)/TIMESCAL(IS1))
      IF(WT(IS1).GT.CUTOFF) THEN
         ESUM(IS1) = ESUM(IS1) + WT(IS1)*ESTORE(JSECS,IS1)
         DO 821 IS2=1,NS
 821     FSUM(IS1,IS2) = FSUM(IS1,IS2) + WT(IS1)*FSTORE(JSECS,IS1,IS2)
         ENDIF
 820  CONTINUE
      ENDIF
C
      GAIN = 1.0
      NZERO=0
      DO 802 IS=1,NS
          XXX(IS)=0.0
          IF(ABS(ESUM(IS)).LT.1.0E-12) NZERO=NZERO+1
  802 CONTINUE
      IF(NZERO.GE.NS) GOTO 807
      DO IK=1,NS      ! In LEQT1F ESUM is overwritten by the soln XXX
      XXX(IK) = ESUM(IK)
      END DO
      CALL GAUSSJ(FSUM,NS,MAXS,XXX,1,1,IER)
      IF(IER.EQ.0) THEN
      IF(.NOT.FLOATGN) CALL SCALEX(GAIN)      ! GAIN = average 1/(1+XXX)
      NGAINS = NGAINS + 1
      GAINSUM = GAINSUM + GAIN*GAIN   ! For average value of GAIN**2
      DO 806 IB=1,NB
      FACTOR = 1.0/((1.0 + XXX(NB1(IB)))*(1.0 + XXX(NB2(IB))))
      IF (FACTOR.GT.100.0 .OR. FACTOR.LE.0.0) THEN
          WRITE (LIST, 8061) ISECS, IB, FACTOR
      ELSE
          DATA(ISECS,NDWPB*(IB-1)+1) =
     1          DATA(ISECS,NDWPB*(IB-1)+1)*FACTOR
C          ! amplitudes
          DATA(ISECS,NDWPB*(IB-1)+2) =
     1          DATA(ISECS,NDWPB*(IB-1)+2)*FACTOR
C          ! amplitude errors
      END IF
 806  CONTINUE
                ELSE
                DO IK=1,NS
                XXX(IK) = 0.0
                END DO
                WRITE (LIST,661) ISECS,UTP,IER
                        IF(FLAGFAIL) THEN
                        DO IB=1,NB
                        ERRA = DATA(ISECS,NDWPB*(IB-1)+2)
                        ERRP = DATA(ISECS,NDWPB*(IB-1)+4)
                        IF(ERRA.GT.0) DATA(ISECS,NDWPB*(IB-1)+2)=-ERRA
                        IF(ERRP.GT.0) DATA(ISECS,NDWPB*(IB-1)+4)=-ERRP
                        END DO
                        ENDIF
                ENDIF
 807  IF(LONG.GE.3) THEN      ! write diagnostics
                DO IX=1,NB
                WRITE(TDATA(IX),FORM3) DATA(ISECS,NDWPB*(IX-1)+1)
                IF(DATA(ISECS,NDWPB*(IX-1)+2).LE.0.0)
     1                  WRITE(TDATA(IX),FORM2) STAR
                END DO
                WRITE (LIST,633) (TDATA(IB),IB=1,NB)
                ENDIF
      DO 808 IS=1,NS
      IF(ABS(1.0 + XXX(IS)).LT.0.01) XXX(IS) = 0.0
      XXX(IS) = 1.0/(1.0 + XXX(IS))
      WRITE(FIELD(IS),FORM1,ERR=808) XXX(IS)
      IF(ABS(ESUM(IS)).LT.1.0E-12) WRITE(FIELD(IS),FORM2) STAR2
 808  CONTINUE
      IF(LONG.GE.0) WRITE (LIST,637) ISECS,UTP,(FIELD(IS),IS=1,NS)
      ENDIF
C=======================================================================
C Solve for phs errors YYY and apply to DATA(ISECS,NDWPB*(IB-1)+3)
C
      IF(LONG.GE.3)  THEN     ! write diagnostics 
                WRITE (LIST,616)
                DO IX=1,NB
                WRITE(TDATA(IX),FORM4) DATA(ISECS,NDWPB*(IX-1)+3)
                IF(DATA(ISECS,NDWPB*(IX-1)+4).LE.0.0)
     1                  WRITE(TDATA(IX),FORM2) STAR
                END DO
                WRITE (LIST,634) (TDATA(IB),IB=1,NB)
                WRITE (LIST,635) (PHSM(ISECS,IB),IB=1,NB)
                ENDIF
      NZERO=0
      IFIXPHS=0
      DO 381 IS1=1,NS
      YYY(IS1)=0.0
      CCC(IS1)=CSTORE(ISECS,IS1)
      IF(ABS(CCC(IS1)).LT.1.0E-12) NZERO=NZERO+1
      IF(ABS(CCC(IS1)).GT.1.0E-12) IFIXPHS=IS1
      DO 381 IS2=1,NS
 381  BBB(IS1,IS2)=BSTORE(ISECS,IS1,IS2)
      IF((NZERO.GE.NS-1).OR.(IFIXPHS.EQ.0)) GOTO 382
C
C       Phase at one station can be set to 0.0
C       But must have at least two stations with CCC(IS) .NE. 0.0
C       IFIXPHS = number of last such station
C
      CCC(IFIXPHS)=0.0
      DO 384 IS=1,NS
      BBB(IS,IFIXPHS)=0.0
 384  BBB(IFIXPHS,IS)=0.0
      BBB(IFIXPHS,IFIXPHS)=-1.0
C
      DO IK=1,NS      ! In LEQT1F CCC is overwritten by the solution YYY
      YYY(IK) = CCC(IK)
      END DO
      CALL GAUSSJ(BBB,NS,MAXS,YYY,1,1,IER)
      IF(IER.EQ.0) THEN
      DO 383 IB=1,NB
 383  DATA(ISECS,NDWPB*(IB-1)+3) = DATA(ISECS,NDWPB*(IB-1)+3) -
     1          (YYY(NB1(IB))-YYY(NB2(IB)))/RPDEG
                ELSE
                DO IK=1,NS
                YYY(IK) = 0.0
                END DO
                WRITE (LIST,661) ISECS,UTP,IER
                        IF(FLAGFAIL) THEN
                        DO IB=1,NB
                        ERRA = DATA(ISECS,NDWPB*(IB-1)+2)
                        ERRP = DATA(ISECS,NDWPB*(IB-1)+4)
                        IF(ERRA.GT.0) DATA(ISECS,NDWPB*(IB-1)+2)=-ERRA
                        IF(ERRP.GT.0) DATA(ISECS,NDWPB*(IB-1)+4)=-ERRP
                        END DO
                        ENDIF
                ENDIF
 382  IF(LONG.GE.3)  THEN     ! write diagnostics
                DO IX=1,NB
                WRITE(TDATA(IX),FORM4) DATA(ISECS,NDWPB*(IX-1)+3)
                IF(DATA(ISECS,NDWPB*(IX-1)+4).LE.0.0)
     1                  WRITE(TDATA(IX),FORM2) STAR
                END DO
                WRITE (LIST,636) (TDATA(IB),IB=1,NB)
                ENDIF
      IF(LONG.GE.1) THEN
         DO 385 IS=1,NS
         WRITE(FIELD(IS),FORM3,ERR=385) YYY(IS)/RPDEG
         IF(ABS(CCC(IS)).LT.1.0E-12) WRITE (FIELD(IS),FORM2) STAR2
         IF(IS.EQ.IFIXPHS)           WRITE (FIELD(IS),FORM2) ZERO
 385     CONTINUE
         IF(CLAMP)      WRITE (LIST,638)           (FIELD(IS),IS=1,NS)
         IF(.NOT.CLAMP) WRITE (LIST,639) ISECS,UTP,(FIELD(IS),IS=1,NS)
         ENDIF
C---------------
 800  CONTINUE        ! End main loop for phase and CLAMP corrections
C=======================================================================
C               Constant amplitude corrections -- SCALE option
C
      IF(SCALE) THEN
      DO 850 IS1=1,NS
      ESUM(IS1)=0.0
      DO 850 IS2=1,NS
 850  FSUM(IS1,IS2)=0.0
C
      DO 851 ISECS=1,NSECS
      DO 851 IS1=1,NS
      ESUM(IS1) = ESUM(IS1) + ESTORE(ISECS,IS1)
      DO 851 IS2=1,NS
 851  FSUM(IS1,IS2) = FSUM(IS1,IS2) + FSTORE(ISECS,IS1,IS2)
C
      NZERO=0
      DO 852 IS=1,NS
      XXX(IS)=0.0
 852  IF(ABS(ESUM(IS)).LT.1.0E-12) NZERO=NZERO+1
      GAIN = 1.0
      IF(NZERO.GE.NS) GOTO 854
      DO IK=1,NS      ! In LEQT1F ESUM is overwritten by solution XXX
      XXX(IK) = ESUM(IK)
      END DO
      CALL GAUSSJ(FSUM,NS,MAXS,XXX,1,1,IER)
      IF((.NOT.FLOATGN) .AND. (IER.EQ.0))
     1          CALL SCALEX(GAIN)        ! GAIN = average 1/(1+XXX)
 854  CONTINUE
      IF(IER.EQ.0) THEN
      DO 855 ISECS=1,NSECS
      UTP=TIMEC(MOD(IUT(ISECS)/60,86400))
      IF(LONG.GE.3)  THEN     ! write diagnostics
                WRITE (LIST,612) ISECS,UTP
                DO IX=1,NB
                WRITE(TDATA(IX),FORM3) DATA(ISECS,NDWPB*(IX-1)+1)
                IF(DATA(ISECS,NDWPB*(IX-1)+2).LE.0.0)
     1                  WRITE(TDATA(IX),FORM2) STAR
                END DO
                WRITE (LIST,631) (TDATA(IB),IB=1,NB)
                WRITE (LIST,632) (AMPM(ISECS,IB),IB=1,NB)
                ENDIF
      DO 853 IB=1,NB
      FACTOR = 1.0/((1.0 + XXX(NB1(IB)))*(1.0 + XXX(NB2(IB))))
      IF(ABS(FACTOR).GT.100.0) GOTO 853
      IF(.NOT.FLOATGN) FACTOR = FACTOR/(GAIN*GAIN)
      DATA(ISECS,NDWPB*(IB-1)+1) = DATA(ISECS,NDWPB*(IB-1)+1)*FACTOR
C          ! amplitudes
      DATA(ISECS,NDWPB*(IB-1)+2) = DATA(ISECS,NDWPB*(IB-1)+2)*FACTOR
C          ! amplitude errors
 853  CONTINUE
      IF(LONG.GE.3)   THEN    ! write diagnostics 
                DO IX=1,NB
                WRITE(TDATA(IX),FORM3) DATA(ISECS,NDWPB*(IX-1)+1)
                IF(DATA(ISECS,NDWPB*(IX-1)+2).LE.0.0)
     1                  WRITE(TDATA(IX),FORM2) STAR
                END DO
                WRITE (LIST,633) (TDATA(IB),IB=1,NB)
                ENDIF
 855  CONTINUE
                ELSE            ! IER .GE. 64 in LEQT1F
                DO IK=1,NS
                XXX(IK) = 0.0
                END DO
                WRITE (LIST,662) IER
                IF(FLAGFAIL) CALL ERROR('SCALE gain solution failed -
     1all data flagged bad')
                ENDIF
      DO 856 IS=1,NS
      IF(ABS(1.0 + XXX(IS)).LT.0.01) XXX(IS) = 0.0
      XXX(IS) = 1.0/(1.0 + XXX(IS))
      XXX(IS) = XXX(IS)/GAIN
      WRITE(FIELD(IS),FORM1,ERR=856) XXX(IS)
      IF(ABS(ESUM(IS)).LT.1.0E-12) WRITE(FIELD(IS),FORM2) STAR2
 856  CONTINUE
      WRITE (LIST,653)
      WRITE (LIST,611) (STNAME(IS),IS=1,NS)
      WRITE (LIST,654) (FIELD(IS),IS=1,NS)
      IF(.NOT.FLOATGN) WRITE (LIST,655) 1.0/GAIN  ! Overall gain correction
      ENDIF
C=======================================================================
C
C Apply overall scaling if CLAMP specified, FLOATGAIN omitted.
C Multiply amp and amperr by 1/(mean GAIN**2).
C
      IF (CLAMP .AND. (.NOT.FLOATGN)) THEN
          FACTOR = NGAINS
          FACTOR = FACTOR/GAINSUM
          WRITE (LIST,656) SQRT(FACTOR)
          DO ISECS=1,NSECS     
              DO IB=1,NB
                  DATA(ISECS,NDWPB*(IB-1)+1) =
     *                DATA(ISECS,NDWPB*(IB-1)+1)*FACTOR
                  DATA(ISECS,NDWPB*(IB-1)+2) =
     *                DATA(ISECS,NDWPB*(IB-1)+2)*FACTOR
              END DO
          END DO
      END IF
C
C Compute fit of adjusted data to model.
C
      CALL RMSERR(DATA,MXSECS,MXL,NDWPB,RMSOUT,RMSOUTJ)
      WRITE (LIST,652) RMSINJ,RMSIN,RMSOUTJ,RMSOUT
C
C Create new history records for output file.
C
      IF (CLAMP) THEN
           MODE = '- CLAMP: phase and amplitude'
      ELSE IF (SCALE) THEN
           MODE = '- SCALE'
      ELSE
           MODE = '- Phase only'
      END IF
      IF (SMOOTH) THEN
           NEWHIS(81:160) = MODE(1:LEN1(MODE))//' (smoothed)'
      ELSE
           NEWHIS(81:160) = MODE
      END IF
      WRITE (NEWHIS(161:240),622) RMSOUTJ, RMSOUT
C
C Reread the input file, and write out a new file containing the
C adjusted data. If the input file contains closure phases, the output
C file contains unmodified closure phases.
C
      REWIND (UNIT=INDAT)
      CALL HEADX20(.FALSE.,INDAT,IZ,ID,IY,
     1          %REF(NEWHIS),3,OUTDAT,KFLAG,CHANGE,IFEOF,0)
      DO 400 ISECS=1,NSECS
          READ (INDAT) IUTCHK,(REC(J),J=1,LENG)
          IF (IUTCHK.NE.IUT(ISECS)) CALL ERROR(
     *        'Error writing output file. '//
     *        'Input and output records do not match.')
          WRITE (OUTDAT) IUT(ISECS),(DATA(ISECS,J),J=1,LENGB),
     *        (REC(J),J=LENGB+1,LENG)
  400 CONTINUE
      WRITE(OUTDAT) -1,(0.0,I=1,LENG)
      CLOSE (UNIT=OUTDAT)
      CLOSE (UNIT=INDAT)
C
C And we're done.
C
      RETURN
C
C Error exits.
C
  530 CALL ERROR('Cannot open file OUTPUT: ' //FTO)
C-----------------------------------------------------------------------
  596 FORMAT(/' Input file:  ',A)
  598 FORMAT( ' Output file: ',A/)
  601 FORMAT(' Amplitude and phase correction of ',
     1   2A8,' with',I3,' stations.'/
     2   1X,I4,' baselines,',I4,' triangles (',I4,' independent),'/
     3   1X,I4,' closure amplitudes  (',I4,' independent).')
  602 FORMAT(/' The baselines are labelled:'/(1X,15I5))
  604 FORMAT('+',21X,' - TIMESCALE for amplitude averaging ',
     1     '(minutes):'/' FWHM:   ',7(F10.1)/(9X,7(F10.1)))
  609 FORMAT(//' Station gain and phase solution:'//
     1            1X,'Section    UT',14X,12A8/(1X,27X,12A8))
  610 FORMAT(1X,'Baselines:      ',14I8/(1X,16I8))
  611 FORMAT(/' Stations:  ',7(2X,A8)/(12X,7(2X,A8)))
  612 FORMAT(//,' N =',I4,2X,A8,' UT')
  613 FORMAT(' CUTOFF level =',F5.2,' of peak')
  615 FORMAT(' CLAMP option selected')
  616 FORMAT(1X)
  620 FORMAT(' ++WARNING++ Data have not been calibrated')
  622 FORMAT('- RMS difference model:observed =',F9.3,
     1          ' Jy,  (',F8.3,' sigma)')
  631 FORMAT(1X,'Observed  amp:  ',14A8/(1X,16A8))
  632 FORMAT(1X,'Model     amp:  ',14F8.3/(1X,16F8.3))
  633 FORMAT(1X,'Corrected amp:  ',14A8/(1X,16A8))
  634 FORMAT(1X,'Observed  phs:  ',14A8/(1X,16A8))
  635 FORMAT(1X,'Model     phs:  ',14F8.2/(1X,16F8.2))
  636 FORMAT(1X,'Corrected phs:  ',14A8/(1X,16A8))
  637 FORMAT(1X,I4,3X,A8,'   gain:  ',12A8/(26X,12A8))
  638 FORMAT(1X,15X,     '  phase:  ',12A8/(26X,12A8))
  639 FORMAT(1X,I4,3X,A8,'  phase:  ',12A8/(26X,12A8))
  640 FORMAT(5A8)
  651 FORMAT(/' ++WARNING++ Input data truncated after ',
     1         I4,'UT sections.')
  652 FORMAT(/' RMS difference between observed and model',
     1     ' visibilities:'
     2/2X,F9.3,' Jy   (',F8.3,' sigma)   before correction'
     3/2X,F9.3,' Jy   (',F8.3,' sigma)   after  correction'/)
  653 FORMAT(/' SCALE option selected  - gain corrections applied:')
  654 FORMAT(' Gain:    ',7(2X,A8)/(10X,7(2X,A8)))
  655 FORMAT(' Station gain solutions multiplied by',F11.4,
     1' in calculating these gains (FLOATGAIN not specified)')
  656 FORMAT(/' Each station gain also multiplied by',F11.4,
     1          '  (FLOATGAIN not specified)')
  657 FORMAT(/' U,V data within an ellipse with semi-axes U =',
     1F8.2,', V =',F8.2,' million wavelengths excluded from fit')
  658 FORMAT(/' U,V data outside an ellipse with semi-axes U =',
     1F8.2,', V =',F8.2,' million wavelengths excluded from fit')
  661 FORMAT(1X,I4,3X,A8,' UT,  solution failed, IER =',
     1          I4,' - no corrections applied')
  662 FORMAT(' ++WARNING++ Solution failed, IER =',
     1          I4,' - no gain corrections applied')
 8061 FORMAT(' ++WARNING++ Bad correction (',I5,I3,'), Factor =',
     1          F12.3)
      END

      FUNCTION  WEIGHT(DTIME)
      REAL    VALS(27)
      DATA    VALS/1.000,.993,.973,.940,.895,.841,.779,.712,.642,
     1          .570,.5000,.432,.369,.310,.257,.210,.170,.135,.106,
     2          .0819,.0625,.0470,.0349,.0256,.0185,.0131,.0092 /
      WEIGHT = 0.0
      TIME   = 20*ABS(DTIME) + 1.00
      INT    = JINT(TIME)
      IF(INT.GE.27) RETURN
      WEIGHT = VALS(INT) + (TIME-AINT(TIME))*(VALS(INT+1)-VALS(INT))
      END

      SUBROUTINE SCALEX(GAIN)
C
C       Calculate gain correction GAIN = mean value of 1/(1 + XXX),
C       weighted by the user-supplied AERRIN.
C       (Original version - 1982 March 23)
C       S.C. Unwin              1984 Jun 16
C       Revised version - do not APPLY corrections to XXX
C       Version 7.6     1986 Aug 28; Increase MAXS to 20
C
      PARAMETER (MAXS=20)
      REAL*8 XXX(MAXS),AERRIN(MAXS)
      COMMON  /SCACOM/ XXX,AERRIN,NS
      SUM1 = 0.0
      SUM2 = 0.0
      DO 2 IS=1,NS
      IF(ABS(1.0 + XXX(IS)).LT.0.01) XNEW = 1.0
      IF(ABS(1.0 + XXX(IS)).GE.0.01) XNEW = 1.0/(1.0 + XXX(IS))
      GAIN = XNEW
      IF(AERRIN(IS).LT.0.0001) GOTO 3
      WEIGHT = 1.0/(AERRIN(IS)*AERRIN(IS))
      IF(ABS(XXX(IS)).LT.0.0001) WEIGHT = 0.0
      SUM1 = SUM1 +  1.0*WEIGHT
  2   SUM2 = SUM2 + XNEW*WEIGHT
      GAIN=1.0
      IF(SUM1.LT.0.0001)    RETURN
      GAIN = SUM2/SUM1
  3   IF(ABS(GAIN).LT.0.01) GAIN = 1.0
      RETURN
      END

      SUBROUTINE RMSERR(DATA,MXSECS,MXL,NDWPB,RMS,RMSJ)
C     -- Input
      INTEGER MXSECS, MXL, NDWPB
      REAL DATA(MXSECS,MXL)
C     -- Output
      REAL RMS, RMSJ      
C
C Calculate rms difference between observed and model visibilities
C S.C. Unwin              1981 September 24
C Fix bug in RMS calculation; USABLE handled wrongly.  1982 May 3.
C D.L. Meier
C Extended to include MERGE format version 2 files.  1983 Jul 23.
C               S.C. Unwin    1984 Apr 16; Increase max MAXSECS to 2000
C Version 7.6     1986 Aug 28; Increase MAXS to 20
C-----------------------------------------------------------------------
      PARAMETER (MAXSECS=2000)
      PARAMETER (MAXS=20)
      PARAMETER (MAXB=MAXS*(MAXS-1)/2)
      PARAMETER (MAXT=MAXB*(MAXS-2)/3)
      PARAMETER (MAXWPB=7)
      REAL AMPM(MAXSECS,MAXB),PHSM(MAXSECS,MAXB)
      COMMON /ERR/ NSECS,NB,AMPM,PHSM
C
      RPDEG=3.141592654/180.0
      NERR = 0
      RMS  = 0.0
      RMSJ = 0.0
      DO ISECS=1,NSECS
          DO IB=1,NB
              AMPERR = DATA(ISECS,NDWPB*(IB-1)+2)
              PHSERR = DATA(ISECS,NDWPB*(IB-1)+4)
              IF (AMPERR.GT.0.0 .AND. PHSERR.GT.0.0) THEN
                  NERR = NERR+1
                  AD   = DATA(ISECS,NDWPB*(IB-1)+1)
                  PD   = DATA(ISECS,NDWPB*(IB-1)+3)*RPDEG
                  AM   = AMPM(ISECS,IB)
                  PM   = PHSM(ISECS,IB)*RPDEG
                  CALC = (AD*COS(PD)-AM*COS(PM))**2 +
     *                   (AD*SIN(PD)-AM*SIN(PM))**2
                  RMSJ = RMSJ + CALC
                  SQ   = AD*PHSERR*RPDEG
                  SNR  = 1.0/(AMPERR*AMPERR + SQ*SQ)
                  RMS  = RMS  + CALC*SNR
              END IF
          END DO
      END DO
C     -- Agreement factor
      RMS  = SQRT(RMS/NERR)
C     -- RMS difference in Jy
      RMSJ = SQRT(RMSJ/NERR)
      RETURN
      END

      FUNCTION PNORM(P,A)        ! Normalize P to +/- 180deg of A
      PNORM=AMOD(P-A,360.0)
      IF(PNORM.LT.-180.0) PNORM=PNORM+360.0
      IF(PNORM.GT. 180.0) PNORM=PNORM-360.0
      PNORM=PNORM+A
      RETURN
      END

      SUBROUTINE GAUSSJ(A,N,NP,B,M,MP,IER)
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER (NMAX=50)
      DIMENSION A(NP,NP),B(NP,MP),IPIV(NMAX),INDXR(NMAX),INDXC(NMAX)
      IER = 0
      DO 11 J=1,N
        IPIV(J)=0
11    CONTINUE
      DO 22 I=1,N
        BIG=0.
        DO 13 J=1,N
          IF(IPIV(J).NE.1)THEN
            DO 12 K=1,N
              IF (IPIV(K).EQ.0) THEN
                IF (ABS(A(J,K)).GE.BIG)THEN
                  BIG=ABS(A(J,K))
                  IROW=J
                  ICOL=K
                ENDIF
              ELSE IF (IPIV(K).GT.1) THEN
                IER = 1
                RETURN
C               CALL ERROR('Singular matrix')
              ENDIF
12          CONTINUE
          ENDIF
13      CONTINUE
        IPIV(ICOL)=IPIV(ICOL)+1
        IF (IROW.NE.ICOL) THEN
          DO 14 L=1,N
            DUM=A(IROW,L)
            A(IROW,L)=A(ICOL,L)
            A(ICOL,L)=DUM
14        CONTINUE
          DO 15 L=1,M
            DUM=B(IROW,L)
            B(IROW,L)=B(ICOL,L)
            B(ICOL,L)=DUM
15        CONTINUE
        ENDIF
        INDXR(I)=IROW
        INDXC(I)=ICOL
        IF (A(ICOL,ICOL).EQ.0.) THEN
          IER = 1
          RETURN
C         CALL ERROR('Singular matrix.')
        END IF
        PIVINV=1./A(ICOL,ICOL)
        A(ICOL,ICOL)=1.
        DO 16 L=1,N
          A(ICOL,L)=A(ICOL,L)*PIVINV
16      CONTINUE
        DO 17 L=1,M
          B(ICOL,L)=B(ICOL,L)*PIVINV
17      CONTINUE
        DO 21 LL=1,N
          IF(LL.NE.ICOL)THEN
            DUM=A(LL,ICOL)
            A(LL,ICOL)=0.
            DO 18 L=1,N
              A(LL,L)=A(LL,L)-A(ICOL,L)*DUM
18          CONTINUE
            DO 19 L=1,M
              B(LL,L)=B(LL,L)-B(ICOL,L)*DUM
19          CONTINUE
          ENDIF
21      CONTINUE
22    CONTINUE
      DO 24 L=N,1,-1
        IF(INDXR(L).NE.INDXC(L))THEN
          DO 23 K=1,N
            DUM=A(K,INDXR(L))
            A(K,INDXR(L))=A(K,INDXC(L))
            A(K,INDXC(L))=DUM
23        CONTINUE
        ENDIF
24    CONTINUE
      RETURN
      END

C*GETMEM -- read MEM mock data.

      SUBROUTINE GETMEM(UNIT, NP, MAMP, MPHS)
      INTEGER UNIT,NP
      REAL MAMP(NP), MPHS(NP)

      REAL PI, DEG
      PARAMETER (PI = 3.141592653589793)
      PARAMETER (DEG=180.0/PI)

      INTEGER IP
      REAL AMP, PHS

* Read data (complex numbers)

      READ (UNIT=UNIT) (MAMP(IP),MPHS(IP), IP=1,NP)

* Convert to amplitude, phase (degrees) range -180 to +180.

      DO 10 IP=1,NP
         AMP = SQRT(MAMP(IP)**2 + MPHS(IP)**2)
         IF (AMP.EQ.0) THEN
             PHS = 0.0
         ELSE
             PHS = ATAN2(MPHS(IP), MAMP(IP)) * DEG
         END IF
         MAMP(IP) = AMP
         MPHS(IP) = PHS
   10 CONTINUE
      END
