C       INCLUDE FILE FOR VLBPLOT THAT PLOTS CLOSURE AMPLITUDES.
C
C
      IF(ATMAX.LT.-1000.) THEN
          WRITE(6,520)
  520     FORMAT('  No closure amplitudes available')
          GO TO 541
      END IF
C
C
C				SET DEFAULTS
      CAMAX = 1.5
      CAMIN = -1.5
      INCHUN = HTPLOT/(CAMAX-CAMIN)
      IF(TIMEA.NE.TIMEC.OR.NBP.EQ.0)
     +CALL TSCALE(ATMIN,ATMAX,INHRA,LEFTA,RIGHTA,MAXWID,MINWID,HR5A,
     +             TIMEC,XCENTER)
      IF(TIMEA.NE.TIMEC.OR.NBP.EQ.0) GO TO 533
         INHRA = INHRB
         RIGHTA = RIGHT
         LEFTA = LEFT
         HR5A = HR5
  533 CONTINUE
      IF(TIMEC.EQ.HGST) INHRA = INHRA*SIDR
C     
C     FOR TEK SCREENS - SPREAD SCALE TO FILL SCREEN
C    
      WR = 1.0
      XPER = XPERIN
      XADR = 0.0
      IF(TYPE.EQ.3) THEN
         WID = RIGHTA - LEFTA
         WR = WID/MAXWID
         XPER = XPERIN / WR
         XADR = (XPERIN - XPER)*XCENTER
      END IF
C
      IF(SETWIDTH) THEN
	 WID = RIGHTA - LEFTA
	 WR = WID/SETW
         XPER = XPERIN / WR
         XADR = (XPERIN - XPER)*XCENTER
      END IF
C
C
      NCLA = NS*(NS-1)*(NS-2)*(NS-3)/8
      NAP = NCLA
      WRITE(6,521) NCLA
  521 FORMAT(' Do you want all ',I4,' closure amplitudes? (y,n) ',$)
      READ(5,522)  YESNO
  522 FORMAT(A1)
      IF(YESNO.EQ.'Y' .OR. YESNO.EQ.'y') FOOL=.TRUE.
C                              
C                             GET SCALE FOR PLOTS
      IF (FOOL)  THEN
          WRITE(6,
     1    '('' Minimum and maximum for plots (try -1.5,1.5): '',$)')
          READ(5,*)  CAMIN,CAMAX
      END IF
C
      NPLOT = 0
      IONPG = 0
C
C     BEGIN LOOP THROUGH CLOSURE AMPLITUDES
C
  501 NPLOT = NPLOT + 1
      IF(FOOL) THEN
         CALL NXTRAT(IB11,IB12,IB21,IB22,IB31,IB32,IB41,IB42,NS,LAST)
         IF(LAST.EQ.1.0) GO TO 541
        END IF
      IF(.NOT.FOOL) THEN
         WRITE(6,510) 
  510    FORMAT(' Specify four baselines for closure amplitude and',
     +     ' min and max for scale (log)',/,
     +          '     (Specify all six!) : ',$)
         READ(5,*,END=541) NA1,NA2,NA3,NA4,CAMIN,CAMAX
         IF(NA1.EQ.0) GO TO 541
         CALL REQRAT(NA1,NA2,NA3,NA4,FLAG,
     +               IB11,IB12,IB21,IB22,IB31,IB32,IB41,IB42)
         IF(FLAG.EQ.1.0) GO TO 501
        END IF
C
C                                 SET SCALING
      INCHUN = HTPLOT / (CAMAX-CAMIN)
C
C                                 SET UP PLOT LEVEL OF CLOSAMP=0.0
      YCLAD = BOT + HTPLOT * (0.0-CAMIN) / (CAMAX-CAMIN)
C
C
C
C     DETERMINE WHICH BASELINES ARE INVOLVED
C
      NBCA1 = 0
      NBCA2 = 0
      NBCA3 = 0
      NBCA4 = 0
      DO 511 INB = 1,NB
         IF (UTBMIN(INB).EQ.9999.) GO TO 511
         IF(IB11.EQ.NB1(INB) .AND. IB12.EQ.NB2(INB)) NBCA1 = INB
         IF(IB21.EQ.NB1(INB) .AND. IB22.EQ.NB2(INB)) NBCA2 = INB
         IF(IB31.EQ.NB1(INB) .AND. IB32.EQ.NB2(INB)) NBCA3 = INB
         IF(IB41.EQ.NB1(INB) .AND. IB42.EQ.NB2(INB)) NBCA4 = INB
  511 CONTINUE
      IF(NBCA1.EQ.0 .OR. NBCA2.EQ.0 .OR. NBCA3.EQ.0 .OR. NBCA4.EQ.0)
     +   THEN
         WRITE(6,512) IB11,IB12,IB21,IB22,IB31,IB32,IB41,IB42
  512    FORMAT(' No data for closure amplitude ([',i2,',',i2,']*[',i2,
     +     ',',i2,'] / [',i2,',',i2,']*[',i2,',',i2,'])')
         IF(NPLOT.EQ.NAP.AND.IONPG.NE.NPAGE.AND.IONPG.GT.0) THEN
            IF(TIMEC.EQ.HGST) STIME = SGST
            IF(TIMEC.EQ.HUT.OR.TIMEC.EQ.HUTMOD) STIME = SUT
            CALL GRCHAR(IDEVICE,.FALSE.,0.0,.FALSE.,
     +           XCENTER-15.*HTLET*WR,BOT-3.5*HTLET,STIME)
            IPLAB = 1
            CALL BORDER(RIGHTA,LEFTA,IPLAB,HTPLOT,BOT,
     +                  HTTICK,HTLET,WR,IDEVICE)
            CALL GRTERM(IDEVICE)
C
         X = (LEFTA-6.*HTLET*WR)*XPER + XADR
         Y = YSZDEF-16.0*HTLET*YPERIN-(IONPG)*HTPLOT*YPERIN/2.0
	 IF(Y .GT. YSZDEF-21.0*HTLET*YPERIN) Y=YSZDEF-21.0*HTLET*YPERIN
         CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,X,Y,SCLCA)
         CALL GRTERM(IDEVICE)
C
         END IF
         GO TO 539
        END IF
C
C
C      PAUSE IF PLOTTING ON TEK SCREEN
C
      IF(TYPE.EQ.3.AND.NEWPAGE) THEN
         CALL VISBEL
         NEWPAGE = .FALSE.
      END IF
C
C
C
C     SET UP PLOT AREA
C
      IONPG = IONPG + 1
      IONPG = MOD(IONPG,NPAGE)
      IF(IONPG.EQ.0) IONPG = NPAGE
      IF(IONPG.EQ.1) CALL GRPAGE(IDEVICE)
      YADD = (NPAGE-IONPG) * HTPLOT * YPERIN  
      CALL GRTRAN(IDEVICE,XADR,YADD,XPER,YPERIN)
C
C
C
C      PLOT BORDERS AND LABELS FOR CLOSURE AMPLITUDE PLOTS
C
      IPLAB = 0
      IF(IONPG.EQ.NPAGE.OR.NPLOT.EQ.NAP) IPLAB = 1
      CALL BORDER(RIGHTA,LEFTA,IPLAB,HTPLOT,BOT,HTTICK,HTLET,WR,IDEVICE)
C
      IF(IONPG.EQ.NPAGE.OR.NPLOT.EQ.NAP)  THEN
         IF(TIMEC.EQ.HGST) STIME = SGST
         IF(TIMEC.EQ.HUT.OR.TIMEC.EQ.HUTMOD) STIME = SUT
         CALL GRCHAR(IDEVICE,.FALSE.,0.0,.FALSE.,XCENTER-15.*HTLET*WR,
     +                BOT-3.5*HTLET,STIME)
C
        X = (LEFTA-6.*HTLET*WR)*XPER + XADR
 	IF (IONPG.EQ.NPAGE) THEN
         Y = YSZDEF/2.0  - 12.0*HTLET*YPERIN
	ELSE
         Y = YSZDEF-16.0*HTLET*YPERIN-(IONPG)*HTPLOT*YPERIN/2.0
	 IF(Y .GT. YSZDEF-21.0*HTLET*YPERIN) Y=YSZDEF-21.0*HTLET*YPERIN
	ENDIF
         CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,X,Y,SCLCA)
C
      END IF
C
      Y = BOT
      YLAB = BOT + HTPLOT - 2.5*HTLET
      YLAB2 = YLAB - 1.5*HTLET
      XLAB = LEFTA + 2.0*HTLET
C
      CALL VSTR(STLAB,4,STNAME(IB11),STNAME(IB12),STNAME(IB21),
     +          STNAME(IB22))
      CALL GRCHAR(IDEVICE,.FALSE.,0.0,.FALSE.,XLAB,YLAB,STLAB)
      CALL VSTR(STLAB,4,STNAME(IB31),STNAME(IB32),STNAME(IB41),
     +          STNAME(IB42))
      CALL GRCHAR(IDEVICE,.FALSE.,0.0,.FALSE.,XLAB,YLAB2,STLAB)
      CALL ATICKS(RIGHTA,LEFTA,Y,HTTICK,HTLET,HTPLOT,WR,
     +          CAMIN,CAMAX,IDEVICE)
C
      IF(IONPG.EQ.1) THEN
         X = LEFTA
         Y = BOT + HTPLOT
         CALL HLAB(X,Y,HTLET,SOURCE,MONTH,IDAY,IYEAR,FLUX,FREQ,IDEVICE)
C
C                                     Write file names and warnings
         IF(.NOT.NOTEXT) THEN
            CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,
     +               HTLET*1.5*XPERIN,HTLET*3.*YPERIN,WDATA)
            IF(MODEL) CALL GRCHAR(IDEVICE,.FALSE.,90.0,.TRUE.,
     +            HTLET*3.5*XPERIN,HTLET*3.*YPERIN,WMODEL)
            IF(TIMEC.EQ.HUTMOD.AND.MODEL.AND.UTMAX-UTMIN.GT.24.0) THEN      
              WWARN='Model and data will not coincide after first day.'
              WWARN(53:)='Use UT, GST, or IHA for match.'
              CALL GRCHAR(IDEVICE,.FALSE.,90.0,.FALSE.,
     +                   (XINMAX-HTLET)*XPERIN,HTLET*3.*YPERIN,WWARN)
            END IF          
         END IF                
      END IF
      CALL GRTERM(IDEVICE)	! Plot box etc. now
C
C     DATA   CLOSURE AMPLITUDE
C
  601 ND = 0
      NR = 0
C     READ DATA
      NBR1 = NDWPB*(NBCA1-1) + 1
      NBR2 = NDWPB*(NBCA2-1) + 1
      NBR3 = NDWPB*(NBCA3-1) + 1
      NBR4 = NDWPB*(NBCA4-1) + 1
      NBR1E = NBR1 + 1
      NBR2E = NBR2 + 1
      NBR3E = NBR3 + 1
      NBR4E = NBR4 + 1
      DO 605 ID = 1,MAXMOD
         READ (INDAT,END=650) IT,(TAKE(I),I=1,NWORDS)
         NR = NR + 1
         IF(IT.EQ.-1) GO TO 650
         IF(TAKE(NBR1E).EQ.0.0 .OR. TAKE(NBR2E).EQ.0.0 .OR.
     +      TAKE(NBR3E).EQ.0.0 .OR. TAKE(NBR4E).EQ.0.0) GO TO 605
         IF((.NOT.PLOTDEL).AND.(TAKE(NBR1E).LT.0.0 .OR. TAKE(NBR2E).LT.0.0 
     +      .OR. TAKE(NBR3E).LT.0.0 .OR. TAKE(NBR4E).LT.0.0)) GO TO 605
         UT = (IT-IZERO)/(60.*3600.)
         IF (UT.LT.UTMIN0) GO TO 605
         IF (UT.GT.UTMAX0) GO TO 605
         ND = ND + 1
         T(ND) = UT
         IUT(ND) = IT
         AMP(ND,1) = TAKE(NBR1)*TAKE(NBR2)/
     +              (TAKE(NBR3)*TAKE(NBR4))
         AMP(ND,2) = (TAKE(NBR1E)/TAKE(NBR1))**2 +
     +               (TAKE(NBR2E)/TAKE(NBR2))**2 +
     +               (TAKE(NBR3E)/TAKE(NBR3))**2 +
     +               (TAKE(NBR4E)/TAKE(NBR4))**2
C
C	 Fractional error in closure amp...
         AMP(ND,2) = SQRT(AMP(ND,2))
C
C	 Now to determine proper error in log of closure amp:
C	 Log(ab/cd) = log(a) + log(b) - log(c) - log(d)
C	 Error in log(a) is log(e)*sigma(a)/(a), in log(b) is 
C        log(e)*sigma(b)/(b), etc. 
C	 Error in log(ab/cd) is log(e) * sqrt of  
C	 [sigma(a)/a]**2 + [sigma(b)/b]**2 + [sigma(c)/c]**2 + [sigma(d)/c]**2
C	 But this is just the above fractional error in closure amp 
C        times log(e), so plot
C	 as upper point log(closure amp) + fractional error*log(e)
C	 as lower point log(closure amp) - fractional error*log(e)
C        Log(e)=0.434294482  (use to avoid many recalculations)
C      
         ATOP      = ALOG10(AMP(ND,1)) + AMP(ND,2)*0.434294482
         ABOT      = ALOG10(AMP(ND,1)) - AMP(ND,2)*0.434294482 
         AMP(ND,1) = ATOP
         AMP(ND,2) = ABOT
C
C        If we want to plot deleted data, and the data are flagged, then
C        flag the closure amplitudes by reversing the numbers
         IF(TAKE(NBR1E).LT.0.0 .OR. TAKE(NBR2E).LT.0.0 
     +      .OR. TAKE(NBR3E).LT.0.0 .OR. TAKE(NBR4E).LT.0.0) THEN
            AMP(ND,1) = ABOT
	    AMP(ND,2) = ATOP
         END IF
  605    CONTINUE
C		Modified TJP 23-Mar-1983
  650	IF (NR.NE.0) THEN
	    DO 538 ID = 1,ND
		CALL CCTIME(T(ID),TT)
		X = XCENTER - (HR5A-TT)*INHRA
		IF (AMP(ND,1).GT.AMP(ND,2)) THEN
	            CALL GRSCI(COLOR(2))	! green
		ELSE
	            CALL GRSCI(2)		! red
		END IF
		CALL GRMOVA(X, AMP(ID,1)*INCHUN+YCLAD)
		CALL GRLINA(X, AMP(ID,2)*INCHUN+YCLAD)
  538	    CONTINUE
	    CALL GRSCI(COLOR(1))	! cyan
	    CALL GRTERM(IDEVICE) 	! Plot data now
	END IF
C
      IF(NR.EQ.MAXMOD) GO TO 601
C
C     MODEL  
C
      IF(.NOT.MODEL) GO TO 506
C
	 CALL GRSCI(COLOR(3))	! white
         MAX24 = .TRUE.
         IF(TIMEC.EQ.HUT) MAX24 = .FALSE.
C
       CALL MODCAL(INMOD,IB11,IB12,0.0,MAX24,MODPTS)
       DO 515 II = 1,MODPTS
  515    CLOS(II) = AMP(II,1)
       CALL MODCAL(INMOD,IB21,IB22,0.0,MAX24,MODPTS)
       DO 516 II = 1,MODPTS
  516    CLOS(II) = CLOS(II) * AMP(II,1)
       CALL MODCAL(INMOD,IB31,IB32,0.0,MAX24,MODPTS)
       DO 517 II = 1,MODPTS
  517    CLOS(II) = CLOS(II) / AMP(II,1)
       CALL MODCAL(INMOD,IB41,IB42,0.0,MAX24,MODPTS)
       DO 518 II = 1,MODPTS
  518    CLOS(II) = CLOS(II) / AMP(II,1)
C
C        RETURN TIMING TO ORIGINAL AXIS UNITS
         CALL TIMING(TIMEA,TIMEC)
C
         IPEN = 13
         DO 508 IT = 1,MODPTS
            CALL CCTIME(T(IT),TT)
            IF(TT.GT.ATMIN.AND.TT.LT.ATMAX) GO TO 507
               IPEN = 13
               GO TO 508
  507      CONTINUE
            XX = XCENTER - (HR5A - TT)*INHRA
            CALL SYSPLT(XX, ALOG10( CLOS(IT) ) * INCHUN + YCLAD,
     +                 IPEN,IDEVICE)
            IPEN = 12
  508       CONTINUE
	    CALL GRSCI(COLOR(1))		! cyan
	    CALL GRTERM(IDEVICE)	! Plot model now
  506    CONTINUE
C
  539 CONTINUE
C  
C     PREPARE FOR NEXT PLOT
C
      REWIND INDAT
      CALL HEADX20(SKIPH,INDAT,IDU,IDU,IDU,IDU,IDU,IDU,IDU,XDUM,IDU,IDU)
      IF(IONPG.EQ.NPAGE.OR.NPLOT.EQ.NAP) NEWPAGE = .TRUE.
      GO TO 501
C
