      PROGRAM EDIT
C-----------------------------------------------------------------------
C 15 Stations, Parameters etc  Dec 15, 1982  RCW
C Modified for more N-values (510); Feb 10, 1986, TJP.
C Modified for 20 stations; Aug 28, 1986, TJP.
C V4.1: Minor changes for Convex; Apr 2, 1988, TJP.
C V4.2: Use VLBOPE and GETIN routines; Jul 19, 1988, TJP.
C V4.3: Modified for 30 stations; Feb 27, 1994, TJP.
C-----------------------------------------------------------------------
      CHARACTER*(*) PROGNM, VERSN
      INTEGER    NCOM, NS, NB, NC, MAXWPB, LEN, NVAL1, NVAL2
      PARAMETER  (PROGNM='VLBEDIT')
      PARAMETER  (VERSN='4.3 - 1994 Feb 27')
      PARAMETER  (NCOM=300)            !  Maximum number of commands.
      PARAMETER  (NS=30)               !  Number of stations.
      PARAMETER  (NB=NS*(NS-1)/2)      !  Number of baselines.
      PARAMETER  (NC=NB*(NS-2)/3)      !  Number of closure phases.
      PARAMETER  (MAXWPB=7)            !  Max words per baseline.
      PARAMETER  (LEN=MAXWPB*NB+2*NC)  !  Maximum size of data records.
      PARAMETER  (NVAL1=570+NS)
      PARAMETER  (NVAL2=(50+4*NS))
C
      LOGICAL SKIPH, ORBITERS
      REAL       TAKE(LEN)          !  Array for reading.
      REAL*8     SOURCE(2),RA,DEC,FLUX,FREQ,GASTM,TINTG,
     +           AVG,BW
      REAL*8     STNAME,STX,STY,STZ,AEIOWM
      INTEGER    STATYP
      INTEGER    IER, L, MODE, INUNIT, IPROUT, IOUT, NHN, IZERO
      INTEGER    IDAY, IYEAR, IUNITS, IFILE, N, NDWPB, NBAS, NCLO, NST
      INTEGER    NSTA, ICO, IB, IC, I, INSP, INTSP, NSS, MS, NB1, NB2
      INTEGER    NC1, NC2, NC3, IS, JS, KS, NCO, IT, IUT, IDUMMY, K
      INTEGER    NVER
      CHARACTER*80 NEWHIS
      REAL       AMP(NB),ERRA(NB),CLOS(NC)
      REAL       ERRCL(NC),PH(NB),ERP(NB),U(NB),V(NB)
      REAL       PT, T
      COMMON /ORDER/NSTA,NBAS,NCLO,NB1(NB),NB2(NB),NC1(NC),
     +               NC2(NC),NC3(NC),NVER,NDWPB
      COMMON /PARMS/ STNAME(NS),STX(NS),STY(NS),STZ(NS),SOURCE,RA,DEC,
     +               GASTM,FREQ,FLUX,TINTG,AVG,BW,AEIOWM(6,NS),
     +               STATYP(NS),ORBITERS
C
      REAL*8     NAMES(NVAL1),VALUE(NVAL1),ENDMRK
      DATA       NAMES/'DELETE','RESTORE','MULTIPLY','ALL','PHASE',
     +           'CLOSE','AMP','FLUX','COPY','DUMMY0',
     +           510*'N',40*'INT',
     +           'ADD','KILL','ERRMULT','ERRADD',6*'DUMMY2',
     +           NS*'STATION' /
      DATA       VALUE / NVAL1*0.D0 /
      DATA       ENDMRK /'/'/
C
      LOGICAL    HDEND,DTEND
      DATA       HDEND/.FALSE./,DTEND/.FALSE./
      LOGICAL    COPY
      LOGICAL    AFLAG(NCOM,NB),PFLAG(NCOM,NB),CFLAG(NCOM,NC)
      LOGICAL               ALL,PHASE,AMPL,CLOSE,ST(NS)
      LOGICAL    DEL(NCOM),RES(NCOM),MULT(NCOM),ADD(NCOM),TOSS(NCOM)
      LOGICAL    EDITREC
      INTEGER*2  NSPEC(510,NCOM),INTSPEC(40,NCOM),IDI
      REAL       VMULT(NCOM),VADD(NCOM)
      LOGICAL    EMULT(NCOM),EADD(NCOM)
      REAL       VEMULT(NCOM),VEADD(NCOM)
      INTEGER    GETIN, VLBOPE, LEN1
C
      REAL*8     XNAMES(NVAL2),XVALS(NVAL2)
      DATA       XNAMES / 'IUNITS','HISTORY',9*' ','DAY'  ,'RA','DEC',
     +           'RAP','DECP','FLUX','BW',19*'DUMMY1','YEAR','UT',
     +           'GST','FREQ','TINTG','SOURCE','        ','AVG ',
     +           'PRINT',
     +           4*'DUMMY2',NS*'NAME',NS*'X',NS*'Y',NS*'Z'/
      DATA       XVALS /45*0.D0,1.D0,4*0.D0,NS*0.D0,NS*0.D0,NS*0.D0,
     +                  NS*0.D0/
C
      CHARACTER*255 INFILE,OUTFIL
      CHARACTER*16  STR
C-----------------------------------------------------------------------
C
C Introduction.
C
      CALL PUTOUT(PROGNM//' edits MERGE files')
      CALL PUTOUT('(Version '//VERSN//')')
      CALL PUTOUT(' ')
C
C Open data files.
C
    4 IER = GETIN(INFILE, 'Input data file name: ', L)
      IF (IER.NE.1) STOP
      IER = VLBOPE(8, INFILE(1:L), 'MERGE', 'OLD', INFILE)
      IF (IER.NE.1) GOTO 4
C
    7 IER = GETIN(OUTFIL, 'Output data file name: ', L)
      IF (IER.NE.1) STOP
      IER = VLBOPE(9, OUTFIL(1:L), 'MERGE', 'NEW', OUTFIL)
      IF (IER.NE.1) GOTO 7
C
      CALL PUTOUT(' ')
      CALL PUTOUT('Input file:  '//INFILE(1:LEN1(INFILE)))
      CALL PUTOUT('Output file: '//OUTFIL(1:LEN1(OUTFIL)))
C
      COPY = .FALSE.
      MODE = 1
      IF(.NOT.HDEND) THEN
         CALL PUTOUT(' ')
         CALL PUTOUT('Input header modifications - end with /')
         CALL KEYIN(XNAMES,XVALS,NVAL2,ENDMRK,MODE,5,6)
         IF(MODE.EQ.1) HDEND = .TRUE.
      END IF
      INUNIT = 8
      IPROUT = 0
      IF(XVALS(46).EQ.0) IPROUT = 6
      SKIPH = .FALSE.
C               ---------
C               Constants
C               ---------
C
      CALL MKHIST(PROGNM, VERSN, NEWHIS)
      IOUT = 9
      NHN  = 1
      CALL  HEADX30(SKIPH,INUNIT,IZERO,IDAY,IYEAR,%ref(NEWHIS),
     +             NHN,IOUT,IUNITS,XVALS,IFILE,IPROUT)
      IF (IFILE.EQ.1) CALL ERROR('End of file')
C
      IF (IPROUT.EQ.0) THEN
          CALL PUTOUT(' ')
          WRITE (STR, '(2A8)') SOURCE
          CALL PUTOUT('Editing source '//STR)
      END IF
C
      N = NDWPB*NBAS + 2*NCLO
      IF (N.GT.LEN) CALL ERROR('Data records too big for this program')
C
      DO NST = 1,NSTA
         NAMES(NST+570) = STNAME(NST)
      END DO
C
C =====================================================================
C                           READ CONTROL CARDS
C =====================================================================
      ICO = 0
C     BEGIN LOOP THROUGH CONTROL CARDS
  300 CONTINUE
      ICO = ICO + 1
      IF(ICO.GT.NCOM) THEN
         WRITE(6,6302) NCOM
 6302    FORMAT(T30,'TOO MANY CONTROL CARD GROUPS PROVIDED  --  ',
     +           'MAXIMUM IS ',I5)
         ICO = ICO - 1
         GO TO 201
      END IF
C
C     RESET FLAGS
      DO  IB = 1,NBAS
         AFLAG(ICO,IB) = .FALSE.
         PFLAG(ICO,IB) = .FALSE.
      END DO
      DO IC = 1,NCLO
         CFLAG(ICO,IC) = .FALSE.
      END DO
      DEL(ICO) = .FALSE.
      RES(ICO) = .FALSE.
      ADD(ICO) = .FALSE.
      MULT(ICO) = .FALSE.
      TOSS(ICO) = .FALSE.
      EMULT(ICO) = .FALSE.
      EADD(ICO) = .FALSE.
      ALL    = .FALSE.
      PHASE  = .FALSE.
      AMPL   = .FALSE.
      CLOSE  = .FALSE.
C
      DO  I = 1,NSTA
         ST(I) = .FALSE.
      END DO
C
      DO INSP = 1,510
         NSPEC(INSP,ICO) = 0
      END DO
      DO INTSP = 1,40
         INTSPEC(INTSP,ICO) = 0
      END DO
C
      DO  I = 1,10            !  Reset logicals
         VALUE(I) = 1.D0
      END DO
C
      DO  I = 11,560          !  Reset N and INT
         VALUE(I) = 0.D0
      END DO
C
      DO  I = 571,570+NS      !  Reset stations.
         VALUE(I) = 1.D0
      END DO
C
      VALUE(3)   = 9999.D0    !  Multiply
      VALUE(561) = 9999.D0    !  Add
      VALUE(562) = 1.D0       !  Kill
      VALUE(563) = 9999.D0    !  Emult
      VALUE(564) = 9999.D0    !  Eadd
C
C     READ CONTROL CARD
C
      MODE = 1
      IF(.NOT.DTEND) THEN
         IF(ICO.EQ.1) THEN
             CALL PUTOUT('Input data edit controls - end records '//
     1                   'with /, end input with end-of-file')
         END IF
         CALL KEYIN(NAMES,VALUE,NVAL1,ENDMRK,MODE,5,6)
         IF(MODE.EQ.1) DTEND = .TRUE.
      END IF
C
C
C     SET FLAGS
C
      IF(VALUE(9).EQ.0.D0) COPY   =.TRUE.
      IF(COPY) GO TO 201
      IF(VALUE(1).EQ.0.D0) DEL(ICO) = .TRUE.
      IF(VALUE(2).EQ.0.D0) RES(ICO) = .TRUE.
      IF(VALUE(3).NE.9999.D0) MULT(ICO) = .TRUE.
      IF(VALUE(4).EQ.0.D0) ALL    = .TRUE.
      IF(VALUE(5).EQ.0.D0) PHASE  = .TRUE.
      IF(VALUE(6).EQ.0.D0) CLOSE  = .TRUE.
      IF(VALUE(7).EQ.0.D0) AMPL   = .TRUE.
      IF(VALUE(8).EQ.0.D0) AMPL   = .TRUE.
      IF(VALUE(561).NE.9999.D0) ADD(ICO) = .TRUE.
      IF(VALUE(562).EQ.0.D0) TOSS(ICO) = .TRUE.
      IF(VALUE(563).NE.9999.D0) EMULT(ICO) = .TRUE.
      IF(VALUE(564).NE.9999.D0) EADD(ICO)  = .TRUE.
C
C                              Quit if no operation specified
      IF(.NOT.(COPY.OR.DEL(ICO).OR.RES(ICO).OR.ADD(ICO).OR.
     +  MULT(ICO).OR.TOSS(ICO).OR.EMULT(ICO).OR.EADD(ICO))) THEN
           ICO = ICO - 1
           IF(ICO.EQ.0) COPY = .TRUE.
           GO TO 201
      END IF
C
      IF(.NOT.TOSS(ICO))  THEN
         IF(MULT(ICO)) VMULT(ICO) = VALUE(3)
         IF(ADD(ICO))  VADD(ICO) = VALUE(561)
         IF(EMULT(ICO))  VEMULT(ICO) = VALUE(563)
         IF(EADD(ICO))  VEADD(ICO)  = VALUE(564)
         IF(.NOT.(PHASE.OR.AMPL.OR.CLOSE.OR.ALL))  THEN
            ALL = .TRUE.
            CALL PUTOUT('Type of data not specified -- assume ALL')
         END IF
C
         NSS = 0
         DO MS = 1,NSTA
            IF(VALUE(570+MS).EQ.0.D0) ST(MS) = .TRUE.
            IF(ST(MS)) NSS = NSS + 1
         END DO
         IF(NSS.EQ.0) THEN
            CALL PUTOUT('No stations specified -- assume all')
            DO MS = 1,NSTA
               ST(MS) = .TRUE.
            END DO
         END IF
      END IF
C
C
      DO INSP = 1,510
         NSPEC(INSP,ICO) = VALUE(INSP+10)
         IF(VALUE(INSP+10).GT.32000.D0) NSPEC(INSP,ICO)=32000
      END DO
      DO INTSP = 2,40,2
         INTSPEC(INTSP-1,ICO) = VALUE(INTSP+519)
         INTSPEC(INTSP,ICO)   = VALUE(INTSP+520)
         IF(VALUE(INTSP+519).GT.32000.D0) INTSPEC(INTSP-1,ICO)=32000
         IF(VALUE(INTSP+520).GT.32000.D0) INTSPEC(INTSP,ICO)=32000
         IF(INTSPEC(INTSP-1,ICO) .GT. INTSPEC(INTSP,ICO)) THEN
            WRITE(6,'(''  Invalid interval: '',I6,'' TO '',I6)')
     +           INTSPEC(INTSP-1,ICO), INTSPEC(INTSP,ICO)
         END IF
      END DO
      IF(NSPEC(1,ICO).EQ.0 .AND. INTSPEC(2,ICO).EQ.0) THEN
         CALL PUTOUT('No record numbers or intervals specified  - '//
     +               'Skip to next command')
         IF(MODE.EQ.1) GO TO 201  !  Go to processing (out of cards)
         GO TO 300                !  Jump to next card.
C
      END IF

C
C
      IF (.NOT.TOSS(ICO)) THEN      !    TOSS=>don't pass data
C
C                              One station specified
C                              Act on any data containing that station
         IF(NSS.EQ.1.OR.NSS.EQ.0) THEN
            DO IB = 1,NBAS          !    Baseline data
               DO MS = 1,NSTA
                  IF((ALL.OR.AMPL).AND.ST(MS).AND.(NB1(IB).EQ.MS.OR.
     +                   NB2(IB).EQ.MS)) AFLAG(ICO,IB) = .TRUE.
                  IF((ALL.OR.PHASE).AND.ST(MS).AND.(NB1(IB).EQ.MS.OR.
     +                   NB2(IB).EQ.MS)) PFLAG(ICO,IB) = .TRUE.
               END DO
            END DO
            DO IC = 1,NCLO         !    Closure phases
               DO MS = 1,NSTA
                  IF((ALL.OR.CLOSE).AND.ST(MS).AND.(NC1(IC).EQ.MS.OR.
     +                NC2(IC).EQ.MS.OR.NC3(IC).EQ.MS))
     +                CFLAG(ICO,IC) = .TRUE.
               END DO
            END DO
         END IF
C
C                            Two stations specified
C                            Act on any data containing that baseline
         IF(NSS.EQ.2) THEN
            DO IB = 1,NBAS       !    Baseline data.
               DO IS = 1,NSTA
                  DO MS = 1,NSTA
                     IF((ALL.OR.AMPL ).AND.(ST(IS).AND.ST(MS)).AND.
     +                  (NB1(IB).EQ.IS.AND.NB2(IB).EQ.MS))
     +                  AFLAG(ICO,IB) = .TRUE.
                     IF((ALL.OR.PHASE).AND.(ST(IS).AND.ST(MS)).AND.
     +                  (NB1(IB).EQ.IS.AND.NB2(IB).EQ.MS))
     +                  PFLAG(ICO,IB) = .TRUE.
                  END DO
               END DO
            END DO
            DO IC = 1,NCLO             !  Closure phases
               DO IS = 1,NSTA
                  DO MS = 1,NSTA
                     IF((ALL.OR.CLOSE).AND.(ST(IS).AND.ST(MS)).AND.
     +                   ((NC1(IC).EQ.IS.AND.NC2(IC).EQ.MS).OR.
     +                        (NC1(IC).EQ.IS.AND.NC3(IC).EQ.MS).OR.
     +                        (NC2(IC).EQ.IS.AND.NC3(IC).EQ.MS)))
     +                        CFLAG(ICO,IC) = .TRUE.
                  END DO
               END DO
            END DO
         END IF
C
C                              Three stations specified
C                              Act on one closure phase
         IF(NSS.EQ.3) THEN
            DO IC = 1,NCLO
               DO IS = 1,NSTA
                  DO JS = 1,NSTA
                     DO KS = 1,NSTA
                        IF((ALL.OR.CLOSE).AND.(ST(IS).AND.ST(JS)
     +                      .AND.ST(KS)).AND.(NC1(IC).EQ.IS
     +                      .AND.NC2(IC).EQ.JS.AND.NC3(IC).EQ.KS))
     +                      CFLAG(ICO,IC) = .TRUE.
                     END DO
                  END DO
               END DO
            END DO
         END IF
      END IF       !   'TOSS' IF statement
C
C
C                          Return for next control card
C
      IF(MODE.NE.1) GO TO 300
C
C
C =====================================================================
C                          READ DATA
C =====================================================================
  201 CONTINUE             !  Done with input cards.
      NCO = ICO
      IDI = 0
 1201 CONTINUE             !  Jump back here for next data point.
      READ(INUNIT,END=250) IT,(TAKE(I),I=1,N)
      IF(IT.EQ.-1) GO TO 250
      IDI = IDI + 1
      T = (IT-IZERO)/(60.*3600.)
      IUT = IT
      DO IB = 1,NBAS          !   Place data in arrays.
         K = NDWPB*(IB-1)
         AMP(IB) = TAKE(K+1)
         ERRA(IB) = TAKE(K+2)
         PH(IB) = TAKE(K+3)
         ERP(IB) = TAKE(K+4)
         IF (NVER.EQ.2) THEN
            U(IB) = TAKE(K+5)
            V(IB) = TAKE(K+6)
         ELSE
            U(IB) = 0.0
            V(IB) = 0.0
         END IF
      END DO
      IF(NCLO.GT.0) THEN
         DO IC = 1,NCLO
            K = NDWPB*NBAS + 2*(IC-1)
            CLOS(IC) = TAKE(K+1)
            ERRCL(IC) = TAKE(K+2)
         END DO
      END IF
C
C =====================================================================
C                       EDIT DATA
C =====================================================================
      IF(.NOT.COPY) THEN     !  No editing in copy mode !
         DO ICO = 1,NCO      !  Loop through edit commands !
            EDITREC = .FALSE.
            DO INSP = 1,510                ! Test against N
               IF(IDI.EQ.NSPEC(INSP,ICO))  EDITREC=.TRUE.
            END DO
            DO INTSP = 2,40,2              ! Test against INT
               IF(IDI.GE.INTSPEC(INTSP-1,ICO) .AND.
     +            IDI.LE.INTSPEC(INTSP,ICO) )  EDITREC=.TRUE.
            END DO
C
            IF(EDITREC) THEN
C              ! Edit this record (IDI) based on command line ICO
               IF(TOSS(ICO)) GO TO 1201      ! Jump straight to
C                                            ! next data point.
               DO IB = 1,NBAS
                  IF(AFLAG(ICO,IB)) THEN   !  Amplitudes
C                        Next line modified 27 Oct 80 by SCU
C                        Allow 'restoration' of zero-error data.
C                        Changed to use IF-THEN  RCW
                     IF(ERRA(IB).NE.0.0 .OR. RES(ICO)) THEN
                        PT = ERRA(IB)
                        IF(DEL(ICO).AND.PT.GT.0.0) PT = -PT
                        IF(RES(ICO).AND.PT.LT.0.0) PT = -PT
                        ERRA(IB) = PT
C
                        IF(MULT(ICO))  AMP(IB) = AMP(IB) * VMULT(ICO)
                        IF(ADD(ICO))   AMP(IB) = AMP(IB) + VADD(ICO)
                        IF(EMULT(ICO)) ERRA(IB)= ERRA(IB)* VEMULT(ICO)
                        IF(EADD(ICO))  ERRA(IB)= SIGN( ABS(ERRA(IB)) +
     +                                        VEADD(ICO) , ERRA(IB) )
                     END IF
                  END IF
C                                  Edit phases
                  IF(PFLAG(ICO,IB).AND.ERP(IB).NE.0.0) THEN
                     PT = ERP(IB)
                     IF(DEL(ICO).AND.PT.GT.0.0) PT = -PT
                     IF(RES(ICO).AND.PT.LT.0.0) PT = -PT
                     ERP(IB) = PT
C
                     IF(MULT(ICO))  PH(IB) =  PH(IB) * VMULT(ICO)
                     IF(ADD(ICO))   PH(IB) =  PH(IB) + VADD(ICO)
                     IF(EMULT(ICO))  ERP  (IB) = ERP  (IB) * VEMULT(ICO)
                     IF(EADD(ICO))  ERP(IB) = SIGN( ABS(ERP(IB)) +
     +                        VEADD(ICO) , ERP(IB) )
                  END IF
               END DO
               DO IC = 1,NCLO
                  IF(CFLAG(ICO,IC).AND.ERRCL(IC).NE.0.0) THEN
                     PT = ERRCL(IC)
                     IF(DEL(ICO).AND.PT.GT.0.0) PT = -PT
                     IF(RES(ICO).AND.PT.LT.0.0) PT = -PT
                     ERRCL(IC) = PT
C
                     IF(MULT(ICO)) CLOS(IC) = CLOS(IC) * VMULT(ICO)
                     IF(ADD(ICO))  CLOS(IC) = CLOS(IC) + VADD(ICO)
                     IF(EMULT(ICO)) ERRCL(IC) = ERRCL(IC)*VEMULT(ICO)
                     IF(EADD(ICO))  ERRCL(IC) = SIGN( ABS(ERRCL(IC)) +
     +                                VEADD(ICO) , ERRCL(IC) )
                  END IF
               END DO
C
            END IF                !  End of editing for this record.
         END DO                   !  End of edit commands loop.
      END IF                      !  If TOSS
C
C =====================================================================
C                      WRITE DATA
C =====================================================================
      IF(IOUT.NE.0) THEN              !  Output unit not 0
         IF(ERP(1).LE.1.E10) THEN     !  ?????
            DO IB = 1,NBAS
               K = NDWPB*(IB-1)
               TAKE(K+1) = AMP(IB)
               TAKE(K+2) = ERRA(IB)
               TAKE(K+3) = PH(IB)
               TAKE(K+4) = ERP(IB)
               IF (NVER.EQ.2) THEN
                  TAKE(K+5) = U(IB)
                  TAKE(K+6) = V(IB)
               END IF
            END DO
            IF(NCLO.GT.0) THEN
               DO IC = 1,NCLO
                  K = NDWPB*NBAS + 2*(IC-1)
                  TAKE(K+1) = CLOS(IC)
                  TAKE(K+2) = ERRCL(IC)
               END DO
            END IF
            WRITE(IOUT) IUT,(TAKE(I),I=1,N)
         END IF
      END IF
C
      GO TO 1201                    !  Go for next data point.
C
C                                   Out of data.
C                                   Write final blank line.
  250 IDUMMY = -1
      WRITE(IOUT) IDUMMY,(IDUMMY,I=1,N)
      CALL PUTOUT(PROGNM//' completed')
      END
