$!----------------------------------------------------------------------
$! This procedure tests the sequence: FAKE, MRGSUB, QFIT.
$! TJP     1993 Apr 01
$!----------------------------------------------------------------------
$!
$ PROC = F$ENVIRONMENT("PROCEDURE")
$ PROC := 'PROC'
$ NAME = F$PARSE(PROC,,,"NAME","SYNTAX_ONLY")
$!
$ ON WARNING THEN GOTO EXIT
$!----------------------------------------------------------------------
$ CREATE  comp1.mod
     1.000000      0.0          0.0          0.9      1.0      0.0   1
$ CREATE  comp2.mod
     0.500000      2.0         37.0          2.0      0.5     38.0   1
$ COPY/CONCAT comp1.mod+comp2.mod testg.mod
$!----------------------------------------------------------------------
$!
$! Make a fake dataset that fits a model.
$!
$ ASSIGN/USER fakefake.lis FOR006
$ fake
  OUTPUT        = testg.mrg
  MODEL         = testg.mod
  RA            = 18:03:39.177
  DEC           = 28:27:54.21
  YEAR          = 1982
  DAY           = 95
  START         = 06:00:00
  STOP          = 18:00:00
  INTEG         = 120
  FREQ          = 4989
  SOURCE        = TESTG
  NUP           = 9
  STATIONS      =  HN,   NL,   FD,   PT,   MK,  SC,   BR,   OV,   KP,   LA
    EFFICIENCY  = 0.5,  0.5,  0.5,  0.5,  0.5, 0.5,  0.5,  0.5,  0.5,  0.5
    DIAMETER    =  25,   25,   25,   25,   25,  25,   25,   25,   25,   25
    POINTING    =   1,    1,    1,    1,    1,   1,    1,    1,    1,    1  
    TSYS        =  60,   60,   60,   60,   60,  60,   60,   60,   60,   60
  BANDWIDTH     = 32
  ERRMULT       = 0.01
  NOCLOSE
  /
$!----------------------------------------------------------------------
$! We can't do a coherent model subtraction until the phases have
$! been corrected for antenna-based errors.
$ amphi
  INPUT         = testg.mrg
  OUTPUT        = testg.adj
  MODFILE       = testg.mod
$!----------------------------------------------------------------------
$! Subtract one of the two model components.
$ mrgsub
  INPUT         = testg.adj
  OUTPUT        = test2.mrg
  MODFILE       = comp1.mod
  OPCODE        = VECTOR
  HISTORY       = "Subtract core component"
$!----------------------------------------------------------------------
$! Recompute the closure phases (QFIT wants them).
$ addclo
  INPUT         = test2.mrg
  OUTPUT        = test2.cmrg
$!----------------------------------------------------------------------
$! The new dataset should fit the other component.
$ qfit
test2.cmrg
comp2.mod
qfit.lis
NO
$!----------------------------------------------------------------------
$ EXIT: EXIT
