#/bin/csh
#----------------------------------------------------------------------
# This procedure tests the sequence: FAKE, MRGSUB, QFIT.
# TJP     1993 Apr 01
#----------------------------------------------------------------------
#
cat <<EOD >comp1.mod
     1.000000      0.0          0.0          0.9      1.0      0.0   1
EOD
cat <<EOD >comp2.mod
     0.500000      2.0         37.0          2.0      0.5     38.0   1
EOD
cat comp1.mod comp2.mod >testg.mod
#----------------------------------------------------------------------
#
# Make a fake dataset that fits a model.
#
fake <<EOD >fakefake.lis
  OUTPUT        = testg.mrg
  MODEL         = testg.mod
  RA            = 18:03:39.177
  DEC           = 28:27:54.21
  YEAR          = 1982
  DAY           = 95
  START         = 06:00:00
  STOP          = 18:00:00
  INTEG         = 120
  FREQ          = 4989
  SOURCE        = TESTG
  NUP           = 9
  STATIONS      =  HN,   NL,   FD,   PT,   MK,  SC,   BR,   OV,   KP,   LA
    EFFICIENCY  = 0.5,  0.5,  0.5,  0.5,  0.5, 0.5,  0.5,  0.5,  0.5,  0.5
    DIAMETER    =  25,   25,   25,   25,   25,  25,   25,   25,   25,   25
    POINTING    =   1,    1,    1,    1,    1,   1,    1,    1,    1,    1  
    TSYS        =  60,   60,   60,   60,   60,  60,   60,   60,   60,   60
  BANDWIDTH     = 32
  ERRMULT       = 0.01
  NOCLOSE
  /
EOD
#----------------------------------------------------------------------
# We can't do a coherent model subtraction until the phases have
# been corrected for antenna-based errors.
amphi <<EOD
  INPUT         = testg.mrg
  OUTPUT        = testg.adj
  MODFILE       = testg.mod
EOD
#----------------------------------------------------------------------
# Subtract one of the two model components.
mrgsub <<EOD
  INPUT         = testg.adj
  OUTPUT        = test2.mrg
  MODFILE       = comp1.mod
  OPCODE        = VECTOR
  HISTORY       = "Subtract core component"
EOD
#----------------------------------------------------------------------
# Recompute the closure phases (QFIT wants them).
addclo <<EOD
  INPUT         = test2.mrg
  OUTPUT        = test2.cmrg
EOD
#----------------------------------------------------------------------
# The new dataset should fit the other component.
qfit <<EOD
test2.cmrg
comp2.mod
qfit.lis
NO
EOD
#----------------------------------------------------------------------
exit
