$!----------------------------------------------------------------------
$! This procedure tests the sequence: FAKE, LIST, MERGEFITS, FITSLIST, 
$! FITSMERGE. This produces a Merge file, converts it to FITS format,
$! and converts it back. The final file should contain identical
$! data to the starting file if all is well.
$!
$! Created 1990 Feb 8 - (TJP).
$!----------------------------------------------------------------------
$ create TEST1.MOD
! Daisy model with Gaussian components (TJP, 15-Nov-82)
!
     1.000000      0.0          0.0          0.9      1.0      0.0   1
     0.050000      1.99991     90.00219      1.0      1.0      0.0   1
     0.050000      3.99995     90.00040      1.0      1.0      0.0   1
     0.050000      5.99995     90.00027      1.0      1.0      0.0   1
     0.050000      8.0         90.00055      1.0      1.0      0.0   1
     0.050000      9.99990     90.0          1.0      1.0      0.0   1
     0.050000      2.00015     59.99922      1.0      1.0      0.0   1
     0.050000      4.00019     59.99779      1.0      1.0      0.0   1
     0.050000      5.99975     60.00362      1.0      1.0      0.0   1
     0.050000      7.99989     59.99959      1.0      1.0      0.0   1
     0.050000      9.99971     59.99938      1.0      1.0      0.0   1
     0.050000      2.00015     30.00078      1.0      1.0      0.0   1
     0.050000      4.00019     30.00222      1.0      1.0      0.0   1
     0.050000      5.99975     29.99638      1.0      1.0      0.0   1
     0.050000      7.99989     30.00041      1.0      1.0      0.0   1
     0.050000      9.99971     30.00063      1.0      1.0      0.0   1
     0.050000      1.99991     -0.00219      1.0      1.0      0.0   1
     0.050000      3.99995     -0.00040      1.0      1.0      0.0   1
     0.050000      5.99995     -0.00026      1.0      1.0      0.0   1
     0.050000      8.0         -0.00055      1.0      1.0      0.0   1
     0.050000      9.99990      0.0          1.0      1.0      0.0   1
$ define/user SYS$OUTPUT FAKEFAKE.LIS
$ fake 
  OUTPUT        = TEST1.MRG
  MODEL         = TEST1.MOD
  RA            = 18:03:39.177
  DEC           = 78:27:54.21
  YEAR          = 1982
  DAY           = 95
  START         = 06:00:00
  STOP          = 18:00:00
  INTEG         = 600
  FREQ          = 4989
  SOURCE        = DAISY_G
  NUP           = 3
  STATIONS      = BONN, HSTK, NRAO, FDVS, OVRO
    EFFICIENCY  = 0.5,  0.5,  0.5,  0.5,  0.5
    DIAMETER    = 100,  34,   43,   25,   40
    POINTING    =   1,   1,    1,    1,    1
    TSYS        =  75,  120,  40,   120,  70
  BANDWIDTH     = 1.8
  ERRMULT       = 0.01
  /
$ list 
  INPUT = TEST1.MRG
  LISTFILE = TEST1.LIST
  /
$ mergefits 
  INPUT = TEST1.MRG
  OUTPUT = TEST1.FITS
  /
$ fitslist 
  INPUT   = TEST1.FITS
  LIST    = TEST1.FITSLIST
  /
$ fitsmerge 
  INPUT = TEST1.FITS
  OUTPUT = TEST2.MRG
  /
$ list 
  INPUT = TEST2.MRG
  LISTFILE = TEST2.LIST
  /
$!----------------------------------------------------------------------
$ exit
