$!----------------------------------------------------------------------
$! This procedure tests the sequence: FAKE, AMPHI, INVERT, CLEAN, with
$! two input files in INVERT.
$! The model used in AMPHI is the starting model (i.e. cheating).
$!----------------------------------------------------------------------
$!
$ PROC = F$ENVIRONMENT("PROCEDURE")
$ PROC := 'PROC'
$ NAME = F$PARSE(PROC,,,"NAME","SYNTAX_ONLY")
$!
$ SET DEFAULT SYS$SCRATCH
$ ON WARNING THEN GOTO EXIT
$!
$! Change the following definitions to match your printer:
$!
$ PLOTTER = "PRINTRONIX"
$ LW = 1    ! line-width for plotting
$
$!----------------------------------------------------------------------
$ CREATE DAISYG.MOD
! Daisy model with Gaussian components (TJP, 15-Nov-82)
!
     1.000000      0.0          0.0          0.9      1.0      0.0   1
     0.050000      1.99991     90.00219      1.0      1.0      0.0   1
     0.050000      3.99995     90.00040      1.0      1.0      0.0   1
     0.050000      5.99995     90.00027      1.0      1.0      0.0   1
     0.050000      8.0         90.00055      1.0      1.0      0.0   1
     0.050000      9.99990     90.0          1.0      1.0      0.0   1
     0.050000      2.00015     59.99922      1.0      1.0      0.0   1
     0.050000      4.00019     59.99779      1.0      1.0      0.0   1
     0.050000      5.99975     60.00362      1.0      1.0      0.0   1
     0.050000      7.99989     59.99959      1.0      1.0      0.0   1
     0.050000      9.99971     59.99938      1.0      1.0      0.0   1
     0.050000      2.00015     30.00078      1.0      1.0      0.0   1
     0.050000      4.00019     30.00222      1.0      1.0      0.0   1
     0.050000      5.99975     29.99638      1.0      1.0      0.0   1
     0.050000      7.99989     30.00041      1.0      1.0      0.0   1
     0.050000      9.99971     30.00063      1.0      1.0      0.0   1
     0.050000      1.99991     -0.00219      1.0      1.0      0.0   1
     0.050000      3.99995     -0.00040      1.0      1.0      0.0   1
     0.050000      5.99995     -0.00026      1.0      1.0      0.0   1
     0.050000      8.0         -0.00055      1.0      1.0      0.0   1
     0.050000      9.99990      0.0          1.0      1.0      0.0   1
$!----------------------------------------------------------------------
$ ASSIGN/USER FAKEFAKE1.LIS FOR006
$ FAKE
  OUTPUT        = DAISYG1.MRG
  MODEL         = DAISYG.MOD
  RA            = 18:03:39.177
  DEC           = 78:27:54.21
  YEAR          = 1982
  DAY           = 95
  START         = 06:00:00
  STOP          = 18:00:00
  INTEG         = 600
  FREQ          = 4989
  SOURCE        = DAISY_G
  NUP           = 3
  STATIONS      = BONN, HSTK, NRAO, FDVS, OVRO
    EFFICIENCY  = 0.5,  0.5,  0.5,  0.5,  0.5
    DIAMETER    = 100,  34,   43,   25,   40
    POINTING    =   1,   1,    1,    1,    1
    TSYS        =  75,  120,  40,   120,  70
  BANDWIDTH     = 1.8
  ERRMULT       = 0.01
  /
$!----------------------------------------------------------------------
$ ASSIGN/USER FAKEFAKE2.LIS FOR006
$ FAKE
  OUTPUT        = DAISYG2.MRG
  MODEL         = DAISYG.MOD
  RA            = 18:03:39.177
  DEC           = 78:27:54.21
  YEAR          = 1987
  DAY           = 195
  START         = 06:00:00
  STOP          = 18:00:00
  INTEG         = 600
  FREQ          = 4989
  SOURCE        = DAISY_G
  NUP           = 3
  STATIONS      = BONN, BOLOGNA, WSRT, JODRELL, ONSALA
    EFFICIENCY  = 0.5,  0.5,  0.5,  0.5,  0.5
    DIAMETER    = 100,  34,   43,   25,   40
    POINTING    =   1,   1,    1,    1,    1
    TSYS        =  75,  120,  40,   120,  70
  BANDWIDTH     = 1.8
  ERRMULT       = 0.01
  /
$!----------------------------------------------------------------------
$ AMPHI
  INPUT   = DAISYG1.MRG
  OUTPUT  = DAISYG1.ADJ
  MODFILE = DAISYG.MOD
  LISTFILE= FAKEAMP1.LIS
  /
$!----------------------------------------------------------------------
$ AMPHI
  INPUT   = DAISYG2.MRG
  OUTPUT  = DAISYG2.ADJ
  MODFILE = DAISYG.MOD
  LISTFILE= FAKEAMP2.LIS
  /
$!----------------------------------------------------------------------
$ INVERT
  INPUT   = DAISYG1.ADJ, DAISYG2.ADJ
  MAPFILE = DAISYG.MAP
  BEAMFILE= DAISYG.BMM
  PLOTFILE= FAKEINV.PLT/{PLOTTER}
  LISTFILE= FAKEINV.LIS
  XYINT   = 0.25  MILLIARCSEC
  FLUX    = 2.0
  PRINTUV
  PLOTMAP
  PLOTBEAM = 5
  /
$!----------------------------------------------------------------------
$ CLEAN
  MAPFILE  = DAISYG.MAP
  BEAMFILE = DAISYG.BMM
  PLOTFILE = FAKECLN.PLT/{PLOTTER}
  LISTFILE = FAKECLN.LIS
  BEAM     = 1.0	! 10% smaller than dirty beam
  PRINTRESIDUALS
  NITER    = 400
  LRTB     = -12,2,6,-2,  -6,2,12,-2
  MODEL    = DAISYG.MDL
  CLEANMAP = DAISYG.CLM
  PLOTWINDOW
  PLOTMAP
  TITLE    = "{name}"
  CONTOURS = -5,-4,-3,-2,-1,1,2,3,4,5,10,20,30,40,50
  /
$!----------------------------------------------------------------------
$ FITSLIST
  INPUT   = DAISYG.CLM
  LIST    = FAKEFITS.LIS
  /
$!----------------------------------------------------------------------
$ EXIT: EXIT
