#----------------------------------------------------------------------
# This procedure tests the sequence: MODMAP MAPPLOT
#----------------------------------------------------------------------
# Time each program:
#
set time
#
# Change the following definitions to match your printer:
#
set PLOTTER = VPS
set LW = 1    # line-width for plotting
set NAME = "TestSource"
#----------------------------------------------------------------------
rm -f $NAME.MOD $NAME.MAP $NAME.PLT $NAME.FITSLIST
cat >$NAME.MOD <<EOD
! Daisy model with Gaussian components (TJP, 15-Nov-82)
!
     1.000000      0.0          0.0          0.9      1.0      0.0   1
     0.050000      1.99991     90.00219      1.0      1.0      0.0   1
     0.050000      3.99995     90.00040      1.0      1.0      0.0   1
     0.050000      5.99995     90.00027      1.0      1.0      0.0   1
     0.050000      8.0         90.00055      1.0      1.0      0.0   1
     0.050000      9.99990     90.0          1.0      1.0      0.0   1
     0.050000      2.00015     59.99922      1.0      1.0      0.0   1
     0.050000      4.00019     59.99779      1.0      1.0      0.0   1
     0.050000      5.99975     60.00362      1.0      1.0      0.0   1
     0.050000      7.99989     59.99959      1.0      1.0      0.0   1
     0.050000      9.99971     59.99938      1.0      1.0      0.0   1
     0.050000      2.00015     30.00078      1.0      1.0      0.0   1
     0.050000      4.00019     30.00222      1.0      1.0      0.0   1
     0.050000      5.99975     29.99638      1.0      1.0      0.0   1
     0.050000      7.99989     30.00041      1.0      1.0      0.0   1
     0.050000      9.99971     30.00063      1.0      1.0      0.0   1
     0.050000      1.99991     -0.00219      1.0      1.0      0.0   1
     0.050000      3.99995     -0.00040      1.0      1.0      0.0   1
     0.050000      5.99995     -0.00026      1.0      1.0      0.0   1
     0.050000      8.0         -0.00055      1.0      1.0      0.0   1
     0.050000      9.99990      0.0          1.0      1.0      0.0   1
EOD
#----------------------------------------------------------------------
modmap <<EOD
  MODFILE       = $NAME.MOD
  MAPFILE       = $NAME.MAP
  SOURCE        = $NAME
  BEAM          = 1.0
  XYINT         = 0.25 ! MILLIARCSEC
  LRTB          = -20,20,20,-20
  FREQ          = 5000
  /
EOD
#----------------------------------------------------------------------
fitslist <<EOD
  INPUT   = $NAME.MAP
  LIST    = $NAME.FITSLIST
  /
EOD
#----------------------------------------------------------------------
mapplot <<EOD
  MAPFILE = $NAME.MAP
  PLOTFILE= $NAME.PLT/$PLOTTER
  PLEV    = 1
  LEVS    = -5,-4,-3,-2,-1,-0.5,-0.25,0.25,0.5,1,2,3,4,5,10,20,30,40,50
  BEAM
  LINEWIDT= $LW
  /
EOD
#----------------------------------------------------------------------
exit
