$!----------------------------------------------------------------------
$! This procedure tests the sequence: FAKE, AMPHI, INVERT, CLEAN.
$! The model used in AMPHI is the starting model (i.e. cheating).
$! Programs LIST, UVPLOT, VISPLOT, FITSLIST and MAPPLOT are also tested.
$!
$! Revised 1986 Nov 17 - new syntax for LIST, VISPLOT, UVPLOT (TJP).
$! Revised 1988 Jun 23 - new syntax for AMPHI, INVERT, CLEAN (TJP).
$! Adapted 1988 Jul 20 - Unix csh (TJP).
$! Revised 1989 Aug 17 - change YRANGE in MAPPLOT for new CLEAN (TJP).
$! Revised 1992 Jun 15 - 10 antennas
$!----------------------------------------------------------------------
$! Time each program:
$!
$!set time
$!
$!----------------------------------------------------------------------
$ create DAISYG.MOD
! Daisy model with Gaussian components
!
     1.000000      0.0          0.0          0.1      1.0      0.0   1
     0.050000      1.99991     90.00219      1.0      1.0      0.0   1
     0.050000      3.99995     90.00040      1.0      1.0      0.0   1
     0.050000      5.99995     90.00027      1.0      1.0      0.0   1
     0.050000      8.0         90.00055      1.0      1.0      0.0   1
     0.050000      9.99990     90.0          1.0      1.0      0.0   1
     0.500000      2.00015     59.99922      0.2      1.0      0.0   1
     0.250000      4.00019     59.99779      0.3      1.0      0.0   1
     0.130000      5.99975     60.00362      0.4      1.0      0.0   1
     0.130000      7.99989     59.99959      0.5      1.0      0.0   1
     0.500000      9.99971     59.99938      0.6      1.0      0.0   1
     0.050000      2.00015     30.00078      0.7      1.0      0.0   1
     0.050000      4.00019     30.00222      1.0      1.0      0.0   1
     0.050000      5.99975     29.99638      1.0      1.0      0.0   1
     0.050000      7.99989     30.00041      1.0      1.0      0.0   1
     0.050000      9.99971     30.00063      1.0      1.0      0.0   1
     0.050000      1.99991     -0.00219      1.0      1.0      0.0   1
     0.050000      3.99995     -0.00040      1.0      1.0      0.0   1
     0.050000      5.99995     -0.00026      1.0      1.0      0.0   1
     0.050000      8.0         -0.00055      1.0      1.0      0.0   1
     0.050000      9.99990      0.0          1.0      1.0      0.0   1
$!----------------------------------------------------------------------
$ define/user sys$output FAKEFAKE.LIS
$ fake 
  OUTPUT        = DAISYG.MRG
  MODEL         = DAISYG.MOD
  RA            = 16:41:17.608
  DEC           = 39:54:10.82
  YEAR          = 1992
  DAY           = 95
  START         = 06:00:00
  STOP          = 18:00:00
  INTEG         = 600
  FREQ          = 4989
  SOURCE        = 3C345*
  NUP           = 3
  STATIONS      = VLBA_BR, VLBA_FD, VLBA_HN, VLBA_KP, VLBA_LA, VLBA_MK,
                  VLBA_NL, VLBA_OV, VLBA_PT, VLBA_SC
    EFFICIENCY  = .6, .6, .6, .6, .6, .6, .6, .6, .6, .6
    DIAMETER    = 25, 25, 25, 25, 25, 25, 25, 25, 25, 25
    POINTING    =  1,  1,  1,  1,  1,  1,  1,  1,  1,  1
    TSYS        = 35, 35, 35, 35, 35, 35, 35, 35, 35, 35
  BANDWIDTH     = 1.8 ! Mark-2
  ERRMULT       = 0.01
  /
$!----------------------------------------------------------------------
$ list 
  INPUT = DAISYG.MRG
  LISTFILE = FAKELIST.LIS
  HEADER 
  /
$!----------------------------------------------------------------------
$ visplot
  INPUT = DAISYG.MRG
  PLOTFILE = /xwin
  MODFILE = DAISYG.MOD
  NP=10 LINEWIDTH=1 HTLET=0.06 IHA MODEL=200 
  AMP PHASE
  /
$!----------------------------------------------------------------------
$ uvplot
  INPUT = DAISYG.MRG
  PLOTFILE = /xwin
  LINEWIDTH=1 
  /
$!----------------------------------------------------------------------
$ amphi
  INPUT   = DAISYG.MRG
  OUTPUT  = DAISYG.ADJ
  MODFILE = DAISYG.MOD
  LISTFILE= FAKEAMP.LIS
  /
$!----------------------------------------------------------------------
$ invert
  INPUT   = DAISYG.ADJ
  MAPFILE = DAISYG.MAP
  BEAMFILE= DAISYG.BMM
  PLOTFILE= /xwin
  LISTFILE= FAKEINV.LIS
  XYINT   = 0.25  MILLIARCSEC
  FLUX    = 2.0
  PRINTUV
  PLOTMAP
  PLOTBEAM = 5
  /
$!----------------------------------------------------------------------
$ clean
  MAPFILE  = DAISYG.MAP
  BEAMFILE = DAISYG.BMM
  PLOTFILE = /xwin
  LISTFILE = FAKECLN.LIS
  PRINTRESIDUALS
  NITER    = 500
  LRTB     = -12,2,6,-2,  -6,2,12,-2
  MODEL    = DAISYG.MDL
  CLEANMAP = DAISYG.CLM
  PLOTWINDOW
  PLOTMAP
  CONTOURS = -2,-1,-0.5,0.5,1,2,4,8,16,32,64
  /
$!----------------------------------------------------------------------
$ visplot
  INPUT    = DAISYG.ADJ
  PLOTFILE = /xwin
  MODFILE  = DAISYG.MDL
  NP       = 10
  LINEWIDTH= 1
  HTLET    = 0.06
  IHA
  MODEL    = 200
  AMP
  PHASE
  /
$!----------------------------------------------------------------------
$ fitslist 
  INPUT   = DAISYG.CLM
  LIST    = FAKEFITS.LIS
  /
$!----------------------------------------------------------------------
$ mapplot
  MAPFILE = DAISYG.CLM
  PLOTFILE= /xwin
  PLEV    = 1
  LEVS    = -2,-1,-0.5,-0.25,0.25,0.5,1,2,4,8,16,32,64
  BEAM
  XRANGE  = 10,85
  YRANGE  = 43,118
  LINEWIDT= 1
  /
$!----------------------------------------------------------------------
$ exit
