C*BESJ1 -- Bessel function J1
C+
      REAL FUNCTION BESJ1(X)
      REAL X
C
C Returns the Bessel function J1(x) for any real x.
C Reference: Numerical Recipes, Section 6.4.
C-----------------------------------------------------------------------
      REAL AX, Z, XX
      DOUBLE PRECISION Y, P1,P2,P3,P4,P5, Q1,Q2,Q3,Q4,Q5
      DOUBLE PRECISION R1,R2,R3,R4,R5,R6, S1,S2,S3,S4,S5,S6
      DATA R1,R2,R3,R4,R5,R6/
     *    72362614232.D0,-7895059235.D0,242396853.1D0,
     *    -2972611.439D0,15704.48260D0,-30.16036606D0/
      DATA S1,S2,S3,S4,S5,S6/
     *    144725228442.D0,2300535178.D0,
     *    18583304.74D0,99447.43394D0,376.9991397D0,1.D0/
      DATA P1,P2,P3,P4,P5/
     *    1.D0,.183105D-2,-.3516396496D-4,.2457520174D-5,
     *    -.240337019D-6/
      DATA Q1,Q2,Q3,Q4,Q5/.04687499995D0,-.2002690873D-3,
     *    .8449199096D-5,-.88228987D-6,.105787412D-6/
      IF(ABS(X).LT.8.)THEN
        Y=X**2
        BESJ1=X*(R1+Y*(R2+Y*(R3+Y*(R4+Y*(R5+Y*R6)))))
     *      /(S1+Y*(S2+Y*(S3+Y*(S4+Y*(S5+Y*S6)))))
      ELSE
        AX=ABS(X)
        Z=8./AX
        Y=Z**2
        XX=AX-2.356194491
        BESJ1=SQRT(.636619772/AX)*(COS(XX)*(P1+Y*(P2+Y*(P3+Y*(P4+Y
     *      *P5))))-Z*SIN(XX)*(Q1+Y*(Q2+Y*(Q3+Y*(Q4+Y*Q5)))))
     *      *SIGN(1.,X)
      ENDIF
      RETURN
      END
