C*CHSORT -- indexed sort of character array into ascending order
C+
      SUBROUTINE CHSORT (A,N,IND)
      INTEGER N
      CHARACTER*(*) A(N)
      INTEGER IND(N)
C
C CHSORT: indexed sort of a character array into increasing ASCII order.
C Algorithm used is Shell Sort.
C
C Arguments:
C  A      (input)  : the array to be sorted; this is not modified by
C                    the subroutine.
C  N      (input)  : number of elements in A.
C  IND    (in/out) : the elements of this array are permuted by
C                    CHSORT; normally on input IND should contain 
C                    1,2,3,...,N; on output, it will be ordered
C                    so that A(IND(M)) is the M'th element of A in
C                    ASCII order.
C
C Subroutines required:
C  None.
C
C Fortran 77 extensions:
C  None.
C
C History:
C  1984 Jan 16 - T.J. Pearson.
C-----------------------------------------------------------------------
      INTEGER I, J, IEX, IGAP, IMAX, JPLUSG
C
      IGAP = N
   10 IF (IGAP.LE.1) RETURN
      IGAP = IGAP/2
      IMAX = N-IGAP
   20 IEX = 0
      DO 30 I=1,IMAX
          J = IND(I)
          JPLUSG = IND(I+IGAP)
          IF (A(J).GT.A(JPLUSG)) THEN
              IND(I) = JPLUSG
              IND(I+IGAP) = J
              IEX = IEX+1
          END IF
   30 CONTINUE
      IF (IEX.GT.0) GOTO 20
      GOTO 10
      END
