      SUBROUTINE FITKEY (CARD,KEYW,TYPE,RVAL,CVAL)
C-----------------------------------------------------------------------
C FITKEY decodes a FITS header record card image, returning the keyword
C and the value.
C 
C Author:               T.J. Pearson (TJP)
C Language:             VAX-11 Fortran
C 
C Modifications:
C   Version 1.0:  1984 Jan 23 - (TJP).
C   Version 1.1:  1989 Aug  2 - revised for Convex compatibility (TJP).
C 
C Arguments:
C   CARD (input, character*80): the FITS header record
C   KEYW (output, character*8): the keyword
C   TYPE (output, integer): value type --
C               -1 : not a valid FITS header record
C                0 : END record
C                1 : logical
C                2 : (not used)
C                3 : integer or floating point
C                4 : character
C                5 : COMMENT (or blank keyword)
C                6 : HISTORY
C   RVAL (output, real*8): arithmetic value (0 if value is character)
C   CVAL (output, character): character value
C-----------------------------------------------------------------------
C     IMPLICIT NONE
      CHARACTER*(*) CARD, KEYW, CVAL
      INTEGER TYPE, I, J, IER
      DOUBLE PRECISION RVAL
C 
      RVAL = 0D0
      CVAL = ' '
      IF (LEN(CARD).LT.80) GOTO 110
      KEYW = CARD(1:8)
      IF (KEYW.EQ.'END') THEN
          TYPE = 0
          GOTO 100
      ELSE IF (KEYW.EQ.' ' .OR. KEYW.EQ.'COMMENT') THEN
          TYPE = 5
          CVAL = CARD(9:80)
          GOTO 100
      ELSE IF (KEYW.EQ.'HISTORY') THEN
          TYPE = 6
          CVAL = CARD(9:90)
          GOTO 100
      ELSE IF (CARD(9:10).NE.'= ') THEN
          GOTO 110
      END IF
      I = 11
   10 IF (I.GT.80) GOTO 110
      IF (CARD(I:I).EQ.' ') THEN
          I = I+1
          GOTO 10
      END IF
      IF (CARD(I:I).EQ.'/') GOTO 110
      IF (CARD(I:I).EQ.'''') THEN
          J = I+1
   20     IF (J.GT.80) GOTO 110
          IF (CARD(J:J).NE.'''') THEN
              J = J+1
              GOTO 20
          END IF
          CVAL = CARD(I+1:J-1)
          TYPE = 4
      ELSE IF (CARD(I:I).EQ.'T') THEN
          CVAL = 'T'
          RVAL = 1D0
          TYPE = 1
      ELSE IF (CARD(I:I).EQ.'F') THEN
          CVAL = 'F'
          RVAL = 0D0
          TYPE = 1
      ELSE
          J = I+1
   30     IF (J.GT.80) GOTO 110
          IF (CARD(J:J).NE.' ') THEN
              J = J+1
              GOTO 30
          END IF
          CVAL = CARD(I:J-1)
          READ (CARD(I:J-1), *, IOSTAT=IER) RVAL
          IF (IER.NE.0) GOTO 110
          TYPE = 3
      END IF
C 
C Normal return.
C 
  100 RETURN
C 
C Error return.
C 
  110 TYPE = -1
      GOTO 100
      END
