      SUBROUTINE KEPLER (AA,AFLAG,E,BB,BFLAG)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
C
C     SOFTWARE ORIGINALLY WRITTEN BY PHILLIP H. ROBERTS
C     SOFTWARE MAINTAINED BY R. STEPHEN SCHLAIFER
C     ********************WARNING**********************
C     DO NOT TRANSFER THIS SOFTWARE TO ANY INDIVIDUAL
C     OR INSTITUTION WITHOUT WRITTEN PERMISSION FROM
C
C             MISSION ANALYSIS SECTION (312)
C               JET PROPULSION LABORATORY
C          CALIFORNIA INSTITUTE OF TECHNOLOGY
C                 4800 OAK GROVE DRIVE
C             PASADENA, CALIFORNIA  91103
C                    (213) 354-4321
C
C                      2 MAY 1980
C
C          AA                          ! OUTPUT ANOMALY
C          E                           ! INPUT ECCENTRICITY
C          BB                          ! INPUT ANOMALY
C
C     ! FLAG FOR INPUT ANOMALY
      CHARACTER*(*) BFLAG
C     ! FLAG FOR OUTPUT ANOMALY
      CHARACTER*(*) AFLAG
      CHARACTER*4 FLAG(3)
      DATA FLAG/'MEAN','ECC','TRUE'/
      DATA PI /3.14159265358979324D0/ TPI /6.28318530717958648D0/

      ELLTE(AN,E)=2*ATAN2(SQRT((1-E)/(1+E))*SIN(AN/2),COS(AN/2))
      HYPTE(AN,E)=2*ATANH(SQRT((E-1)/(E+1))*TAN(AN/2))
      ELLET(AN,E)=2*ATAN2(SQRT((1+E)/(1-E))*SIN(AN/2),COS(AN/2))
      HYPET(AN,E)=2*ATAN(SQRT((E+1)/(E-1))*TANH(AN/2))
C
      IF (ICFIND(IA,AFLAG,FLAG,3).EQ.0) 
     1    CALL ERROR ('KEPLER: BAD OUTPUT FLAG')
C
      IF (ICFIND(IB,BFLAG,FLAG,3).EQ.0)
     1    CALL ERROR ('KEPLER: BAD INPUT FLAG')
C
      IA=IA+3*(IB-1)
      D=ABS(1-E)
      IF (E.LT.0) THEN
          CALL ERROR ('KEPLER: ECCENTRICITY<0')
      ELSEIF (E.EQ.1) THEN
          CALL ERROR ('KEPLER ERROR: PARABOLIC')
      ELSEIF (E.EQ.0) THEN
C             ! CIRCULAR CASES
          AA=BB
      ELSEIF (E.LE.1) THEN
          AA=MOD(BB,TPI)
C             ! AN BETWEEN +- 2*PI
          IF (ABS(AA).GT.PI) AA=AA-SIGN(TPI,AA)
          REVS=BB-AA
          GOTO (170,110,120,130,170,140,150,160,170), IA
110       AA=ELLME(AA,E)
          GOTO 170
120       AA=ELLET(ELLME(AA,E),E)
          GOTO 170
130       AA=ELLEM(AA,E)
          GOTO 170
140       AA=ELLET(AA,E)
          GOTO 170
150       AA=ELLEM(ELLTE(AA,E),E)
          GOTO 170
160       AA=ELLTE(AA,E)
170       AA=AA+REVS
      ELSE
C                             ! E>1
          GOTO (250,190,200,210,250,220,230,240,250), IA
190       AA=HYPME(BB,E)
          GOTO 260
200       AA=HYPET(HYPME(BB,E),E)
          GOTO 260
210       AA=HYPEM(BB,E)
          GOTO 260
220       AA=HYPET(BB,E)
          GOTO 260
230       AA=HYPEM(HYPTE(BB,E),E)
          GOTO 260
240       AA=HYPTE(BB,E)
          GOTO 260
250       AA=BB
260       CONTINUE
      ENDIF
      RETURN
      END
