C     RDCAT.INC   Include file for reading catalogs.
C
C     For source catalog.
C     SRCNAM  C8  -  Source name
C     SRCRA   R8  -  Right Ascension (rad)
C     SRCDEC  R8  -  Declination (rad)
C     SRCEPO  C5  -  Coordinate epoch: B1950, J2000, or DATE
C     SRCCAL  C1  -  Cal code - eg for VLA, perhaps VLBA later.
C     SRCVEL  R4*8  -  LSR Velocities of spectral line channels.
C                   -    If velocity not given, SRCVEL = CONT where
C                   -      DATA  CONT / 'CONT' /
C     SRCDRA  R4  -  Planetary motion dRA/dt in sec of time/day
C     SRCDDEC R4  -  Planetary motion dDEC/dt in sec of arc/day
C     SRCPMY  I4  -  Planetary motion reference epoch year
C     SRCPMM  I4  -                                   month
C     SRCPMD  I4  -                                   day
C     SRCPMT  R8  -                                   time - radians.
C                
C     For station catalog.
C     STANAM  C8  -  Station name
C     STACOD  C3  -  Station code (NUG code)
C     STACTL  C4  -  Control file format 
C                    Options:   (SNAP, NRAO, VLBA, NONE, HCRK, GB)
C     STAEL   R8  -  Elevation
C     STALAT  R8  -  Latitude (rad)
C     STALON  R8  -  Longitude (rad)
C     STAHAL  R4  -  Hour angle limit (hr)
C     STAZAL  R4  -  Zenith angle limit (deg)
C     STAX    R8  -  Station coordinate X (m)
C     STAY    R8  -     "        "      Y (m)
C     STAZ    R8  -     "        "      Z (m)
C     STANDR  I4  -  Number of broad band recorders at site.
C     
C  ----------------------------------------------------------------------
C
      CHARACTER*8       SRCNAM
      INTEGER           SRCPMY, SRCPMM, SRCPMD
      REAL              SRCVEL(8), SRCDRA, SRCDDEC
      DOUBLE PRECISION  SRCRA, SRCDEC, SRCPMT
      CHARACTER*1       SRCCAL
      CHARACTER*5       SRCEPO
C
C     For station catalog.
C
      INTEGER           STANDR
      CHARACTER*8       STANAM
      CHARACTER*3       STACOD
      CHARACTER*4       STACTL
      REAL              STAHAL, STAZAL
      DOUBLE PRECISION  STALON, STALAT, STAEL, STAX, STAY, STAZ
C
C     The COMMONS
C
      COMMON/RDCATC/  SRCNAM, SRCCAL, SRCEPO, STANAM, STACOD, STACTL
C 
      COMMON/RDCATN/  SRCRA, SRCDEC, SRCPMT, STALON, STALAT, STAEL, 
     1       STAX, STAY, STAZ, STAHAL, STAZAL, STANDR, SRCVEL,
     2       SRCDRA, SRCDDEC, SRCPMY, SRCPMM, SRCPMD
C
C               End of RDCAT.INC
