C*PARSEB -- parse a string into blank-delimited words.
C+
      SUBROUTINE PARSEB (STRING, PARSED, NWORDS)
      CHARACTER*(*) STRING
      CHARACTER*(*) PARSED(*)
      INTEGER NWORDS
C
C Parse an input string into "words" delimited by a variable number
C of blanks.  The words (with no blanks) are returned in PARSED,
C with NWORDS set to the total number of words recognized. The maximum
C length of the input string is 120 characters; the maximum length of
C each output word is set by the caller. If the input string is blank,
C NWORDS = 0.
C
C Arguments:
C  STRING (input)  : input character string.
C  PARSED (output) : array of strings to receive parsed words.
C  NWORDS (output) : the number of words found.
C
C History:
C  1987 Nov 12 - TJP.
C-----------------------------------------------------------------------
      CHARACTER*120 INPUT
      INTEGER L, EOW
C
      INPUT = STRING
      NWORDS = 0
      IF (INPUT .EQ. ' ') RETURN
      L = LEN(INPUT)
C
C Discard initial blanks, if any.
C
  100 IF (INPUT(1:1) .EQ. ' ') THEN
          INPUT = INPUT(2:)
          L = L - 1
          IF (L .LE. 0) RETURN
          GOTO 100
      END IF
      EOW = INDEX(INPUT,' ') - 1
      IF (EOW .LE. 0) EOW = LEN(INPUT)
      NWORDS = NWORDS + 1
      PARSED(NWORDS) = INPUT(1:EOW)
      INPUT = INPUT(MIN(LEN(INPUT),EOW+1):)
      L = L - EOW
      GOTO 100
C
      END
