C*REPORT -- report username, node name, operating system, etc.
C+
      SUBROUTINE REPORT (UNIT)
C
C REPORT generates a report of username, node name, operating system
C etc. on a specified Fortran unit.
C
C Author: T.J. Pearson (TJP)
C Language: Fortran-77
C
C Modifications:
C   Version 1.0:  1983 Dec 28 - [TJP].
C   Version 2.0:  1985 Jan  6 - rewritten for VMS version 4.0; the
C                               old version still works, but V4.0
C                               provides a cleaner interface [TJP].
C   Version 2.1:  1986 Dec 22 - check whether carriagecontrol characters
C                               are needed [TJP].
C
C Arguments:
C   UNIT (input, integer): the Fortran unit to which output is to be
C      written (formatted).
C-----------------------------------------------------------------------
C     IMPLICIT NONE
      INTEGER UNIT, L, LEN1, L1, L2
      CHARACTER*112 STRING
      CHARACTER*8   NODE
      CHARACTER*12  FMT, USER
C-----------------------------------------------------------------------
      FMT = '(A,T20,A)'
C
C User name.
C
      CALL USERNM(USER)
      L = LEN1(USER)
C
C Node name.
C
      CALL NODENM(NODE)
      L1 = LEN1(NODE)
C
C Operating system version.
C
      CALL SYSVER(STRING)
      L2 = LEN1(STRING)
C
      WRITE (UNIT,FMT) 'Run by:', USER(1:L)//' on '//NODE(1:L1)//
     1       ' ('//STRING(1:L2)//')'
C
C Date/time.
C
      L = 20
      CALL DATTIM(STRING(:L))
      WRITE (UNIT,FMT) 'Date:', STRING(:L)
C-----------------------------------------------------------------------
      END
