C*RNGAUS -- random number from Gaussian (normal) distribution
C+
      REAL FUNCTION RNGAUS (ISEED)
      INTEGER ISEED
C
C Returns a normally distributed deviate with zero mean and unit 
C variance. The routine uses the Box-Muller transformation of uniform
C deviates. Reference: Press et al., Numerical Recipes, Sec. 7.2.
C
C Arguments:
C  ISEED  (in/out) : seed used for RAN random-number generator.
C
C Subroutines required:
C  RAN -- return a uniform random deviate between 0 and 1.
C
C History:
C  1987 Nov 13 - TJP.
C-----------------------------------------------------------------------
      INTEGER ISET
      DATA ISET/0/
      REAL R, V1, V2, FAC, GSET
      REAL RAN
      SAVE ISET, GSET
C
      IF (ISET.EQ.0) THEN
   10     V1 = 2.*RAN(ISEED)-1.
          V2 = 2.*RAN(ISEED)-1.
          R = V1**2+V2**2
          IF (R.GE.1.) GOTO 10
          FAC = SQRT(-2.*LOG(R)/R)
          GSET = V1*FAC
          RNGAUS = V2*FAC
          ISET = 1
      ELSE
          RNGAUS = GSET
          ISET = 0
      END IF
C
      END
