      SUBROUTINE SRCPAN(ITIME,AS,DS,RA,DC)
      REAL*8 DS,AS,DC,RA,VECA(3),VECB(3)
      REAL*8 NORM,DELNG,CDEC,DJ,DELOBL,MOBL
      DIMENSION ITIME(6)
      REAL*8 NUTD(4)
      JY = ITIME(1)
      JMTH = ITIME(2)
      JD = ITIME(3)
      JH = ITIME(4)
      JM = ITIME(5)
      SEC = ITIME(6)
      CALL JULDAT(JY,JMTH,JD,JH,JM,SEC,DJ,IDOYC)
      VECA(1)=DCOS(AS)*DCOS(DS)
      VECA(2)=DSIN(AS)*DCOS(DS)
      VECA(3)=DSIN(DS)
      CALL PRECES(DJ,VECA,VECB)
      CALL ERTVEL(DJ,VX,VY)
      DELOBL=0.D0
      CALL MECMEQ(DJ,VECB,VECA,+1,DELOBL,MOBL)
      VECA(1)=VECA(1)+VX
      VECA(2)=VECA(2)+VY
      NORM=0.D0
      DO 356 I=1,3
      NORM=NORM+VECA(I)*VECA(I)
356   CONTINUE
      NORM=DSQRT(NORM)
      DO 357 I=1,3
      VECA(I)=VECA(I)/NORM
357   CONTINUE
      CALL NUTATE(DJ,NUTD)
      DELNG=NUTD(1)
      DELOBL=NUTD(2)
      VECB(1)=DCOS(DELNG)*VECA(1)-DSIN(DELNG)*VECA(2)
      VECB(2)=DSIN(DELNG)*VECA(1)+DCOS(DELNG)*VECA(2)
      VECB(3)=VECA(3)
      CALL MECMEQ(DJ,VECB,VECA,-1,DELOBL,MOBL)
      DO 1001 I=1,3
      VECB(I)=VECA(I)
1001   CONTINUE
      RA=DATAN2(VECB(2),VECB(1))
      IF (RA.LT.0.0D0)  RA = RA + 6.283185307179586D0
      CDEC=DSQRT(VECB(1)*VECB(1)+VECB(2)*VECB(2))
      DC=DATAN2(VECB(3),CDEC)
      RETURN
      END
C=======================================================================
      SUBROUTINE PRECES(DJ,VECIN,VECOUT)
C PRECESS FROM MEAN EQ. COORD. OF 1950.0 TO MEAN EQ. OF DATE
C  T=TROPICAL CENTURIES SINCE 1950.0
      DOUBLE PRECISION DJ50PT,DJ,DPERY
      DOUBLE PRECISION P(3,3),VECIN(3),VECOUT(3)
      DOUBLE PRECISION E,Z,TH,T
      DOUBLE PRECISION T2,T3,DEGRAD
      DOUBLE PRECISION CE,SE,CTH,STH,CZ,SZ
      DOUBLE PRECISION ASECRD,PI
      PI=3.14159265358979D0
      DEGRAD=180.D0/PI
      ASECRD=3600.D0*DEGRAD
      DJ50PT=2433282.423D0
      DPERY=365.24219879D0
      T=(DJ-DJ50PT)/(DPERY*100.D0)
      T2=T*T
      T3=T*T*T
      E=2304.952D0*T+0.3022D0*T2+0.018D0*T3
      E=E/ASECRD
      Z=2304.952D0*T+1.0951D0*T2+0.0183D0*T3
      Z=Z/ASECRD
      TH=2004.257D0*T-0.4268D0*T2-0.0418D0*T3
      TH=TH/ASECRD
      CE=DCOS(E)
      SE=DSIN(E)
      CTH=DCOS(TH)
      STH=DSIN(TH)
      CZ=DCOS(Z)
      SZ=DSIN(Z)
      P(1,1)=CE*CTH*CZ-SE*SZ
      P(1,2)=-SE*CTH*CZ-CE*SZ
      P(1,3)=-STH*CZ
      P(2,1)=CE*CTH*SZ+SE*CZ
      P(2,2)=-SE*CTH*SZ+CE*CZ
      P(2,3)=-STH*SZ
      P(3,1)=CE*STH
      P(3,2)=-SE*STH
      P(3,3)=CTH
      DO 10 I=1,3
      VECOUT(I)=0.D0
      DO 11 J=1,3
      VECOUT(I)=VECOUT(I)+P(I,J)*VECIN(J)
11    CONTINUE
10    CONTINUE
      RETURN
      END
C=======================================================================
      SUBROUTINE ERTVEL(DJ,VX,VY)
C   EARTH VELOCITY INMEAN ECLIPTIC COORD. OF DATE
C   DJ JULIAN DAYS E.T.     VX,VY IN UNITS OF C
C  NEGLECTS 'ELLIPTIC ABBERATION' COMPONENT OF VELOCITY
C  SUNLNG=MEAN LONG OF SUN IN MEAN ECLIPTIC COORD OF DATE
C    DELLNG=CORRECTION TO LONGITUDE FOR ELLIPTICITY TO FIRST ORDER IN
C ECCENTRICITY;ACCURACY APPROX. .05 DEG.
C APPROX. .02 ASEC ABBER. CORRECTION ERROR
C ERTLNG=EARTH LONG MEAN ECLIPTIC COORD OF DATE
C PERLNG=MEAN LONG OF PERIGEE IN MEAN ECLIPTIC COORD OF DATE
      DOUBLE PRECISION DJ,SUNLNG,PI,ERTLNG
      DOUBLE PRECISION DJ1900,DT,D
      DOUBLE PRECISION PERLNG
      PI=3.14159265358979D0
      DJ1900=2415020.D0
      D=DJ-DJ1900
      DT=D/10000.D0
      ERTSPD=29.78
      C=299792.5
      SUNLNG=279.696678D0+0.9856473354D0*D+0.00002267D0*DT*DT
      SUNLNG=DMOD(SUNLNG,360.D0)
      SUNLNG=SUNLNG*PI/180.D0
      ERTLNG=SUNLNG+PI
      ECC=.01672
      PERLNG=281.220833D0+0.0000470684D0*D+0.0000339D0*DT*DT+
     + 0.00000007D0*DT*DT*DT
      PERLNG=PERLNG*PI/180.D0+PI
      DELLNG=ECC*DSIN(ERTLNG-PERLNG)*2
      ERTLNG=ERTLNG+DELLNG
      VX=-ERTSPD*DSIN(ERTLNG)/C
      VY=ERTSPD*DCOS(ERTLNG)/C
      RETURN
      END
C=======================================================================
      SUBROUTINE MECMEQ(DJ,VECIN,VECOUT,ISGN,DELOBL,MOBL)
C  TRANSFORMS BETWEEN MEAN EQ. &MEAN ECLIPTIC OF DATE (DELOBL=0.0)
C   ISGN=+1 IF MEQ TO MECL; ISGN=-1 IF MECL TO MEQ
C TO TRANSFORM FROM MEAN ECLIP. TO TRUE  EQ. OF DATE SET DELOBL=NUTATION
C  IN OBLIQ. & ISGN=-1
C   T=TROPICAL YRS SINCE 1950.0
      DOUBLE PRECISION DJ50PT,DJ,DPERY
      DOUBLE  PRECISION DELOBL,OBL
      DOUBLE PRECISION VECIN(3),VECOUT(3),R(3,3)
      REAL*8 MOBL,DMOBL,T
      DOUBLE PRECISION T2,T3,DEGRAD
      DOUBLE PRECISION ASECRD,PI
      DPERY=365.24219879D0
      DJ50PT=2433282.423D0
      T=(DJ-DJ50PT)/(DPERY*100.D0)
      T2=T*T
      T3=T*T*T
      PI=3.14159265358979D0
      DEGRAD=180.D0/PI
      ASECRD=3600.D0*DEGRAD
      DMOBL=-46.850D0*T-0.0034D0*T2+0.0018D0*T3
      DMOBL=DMOBL/ASECRD
      MOBL=(23.D0+26.D0/60.D0+44.84D0/3600.D0)/DEGRAD+DMOBL
      VECOUT(1)=VECIN(1)
      OBL=MOBL+DELOBL
      R(2,2)=DCOS(OBL)
      R(3,3)=R(2,2)
      R(2,3)=ISGN*DSIN(OBL)
      R(3,2)=-R(2,3)
      DO 10 I=2,3
      VECOUT(I)=0.D0
      DO 11 J=2,3
      VECOUT(I)=VECOUT(I)+R(I,J)*VECIN(J)
11    CONTINUE
10    CONTINUE
      RETURN
      END
C=======================================================================
      SUBROUTINE JULDAT( YR, MO, DAY, HR, MIN, SEC, DJ, YRDY)
C     PROGRAM TO CHANGE YEAR/ MONTH/ DAY INTO JULIAN DATE
C     DJ1950 IS THE JULIAN DATE OF JAN 0 , 1950.
      INTEGER YR, MO,      DAY , HR, MIN , YRDY
      DOUBLE PRECISION DJ,       DJAN0, DJ1950, DFRAC
      INTEGER MON(12)
      DATA MON/0,31,59,90,120,151,181,212,243,273,304,334/
      DJ1950 = 2433281.5D0
      YRDY = MON(MO) + DAY
      IF ((MOD(YR,4) .EQ. 0) .AND. (MO .GT. 2))  YRDY = YRDY+1
      IYRPQ = (YR- 50)*365 + (YR - 49)/4
      DJAN0 = DJ1950 + IYRPQ
      DFRAC=HR/24.D0+MIN/1440.D0+SEC/86400.D0
      DJ = DJAN0 + YRDY + DFRAC
      RETURN
      END
C=======================================================================
      SUBROUTINE NUTATE(TJD,NUT)
C     THIS IS SUBROUTINE OF JAY LIESKE, MODIFIED TO GIVE ONLY NUT(1), AN
C     NUT(2).  TIME RATE OF CHANGE TERMS NOT GIVEN.                     
C     ALSO MODIFIED TO REMEMBER LAST TIME AT WHICH NUTATION OBTAINED    
C     AND TO UTILIZE THIS IF POSSIBLE RATHER THAN RECALCULATE.          
      DOUBLE PRECISION TJDSAV,NUT1SV,NUT2SV                             
      DOUBLE PRECISION TJD                                              
C--SUBROUTINE TO COMPUTE NUTATION ANGLES AND RATES FROM EXPRESSIONS     
C--    GIVEN BY WOOLARD TABLE 26 OF APAE VOL. 15 PART 1 (1953)          
C--    WHICH IS EQUIVALENT TO EXPLANATORY SUPPLEMENT PAGES 44-45.       
C--  NOTE   RATES FOR TIME-VARIATION OF COEFFICIENTS WERE ORIGINALLY    
C--    GIVEN BY WOOLARD  AS RATES PER TROPICAL CENTURY.   HERE ALL RATES
C--    ARE EVALUATED IN TERMS OF JULIAN CENTURIES.  DIFFERENCE IS ZILCH.
C--    CODED BY JAY LIESKE 11/69                                        
C--NUT(1) CONTAINS NUTATION IN LONGITUDE (RADIANS)                      
C--NUT(2) CONTAINS NUTATION IN OBLIQUITY(RADIANS)                       
C--NUT(3) CONTAINS NUTATION RATE IN LONGITUDE (RADIANS PER DAY)         
C--NUT(4) CONTAINS NUTATION RATE IN OBLIQUITY (RADIANS PER DAY)         
      DOUBLE PRECISION ANGL(5),NUT(4)                         
C     DOUBLE PRECISION ANGRAT(5)
      DOUBLE PRECISION TWOPI,TB,T,THETA,SINT,COST
C     DOUBLE PRECISION THDOT
      DOUBLE PRECISION ARG(4,5)                                         
C--ARGUMENT L  = L0 + L@T + L@@T**2 + L@@@T**3                          
      DATA ARG              /0.822512800925925923D0,                    
     A1325.55235863425925D0, 2.55324074074074074D-5,                    
     B3.99691358024691357D-8                                            
C--ARGUMENT L-PRIME                                                     
     +                    ,  0.995766203703703701D0,                    
     C99.9973604166666660D0,-4.16666666666666667D-7,                    
     D-9.25925925925925926D-9                                           
C--ARGUMENT FOR F                                                       
     +                    ,  3.12524691358024691D-2,                    
     E1342.22784763888888D0, -8.91975308641975310D-6,                   
     F-9.25925925925925926D-10                                          
C--ARGUMENT FOR D                                                       
     +                    ,  0.974270794753086417D0,                    
     G1236.85309504629629D0, -3.98919753086419752D-6,                   
     H5.24691358024691355D-9                                            
C--ARGUMENT FOR NODE                                                    
     +                    ,  0.719953541666666667D0,                    
     I-5.37261668981481480D0, 5.77160493827160492D-6,                   
     J6.17283950617283948D-9  /                                         
      DIMENSION IJKLM(5,69)                                             
      DATA IJKLM/                                                       
     A4*0,1,  2*0,2,-2,2,  4*0,2,  2*0,2,0,2,  0,1,3*0,                 
     B1,4*0,  0,1,2,-2,2,  2*0,2,0,1,  1,0,2,0,2,  0,-1,2,-2,2,         
     C2*0,2,-2,1,  0,2,3*0,  0,2*2,-2,2  ,                              
     D -1,0,2,0,2,  1,3*0,1,  -1,3*0,1,  -1,0,3*2,  -2,0,2,0,1,         
     E 1,0,2,0,1,  2*0,3*2,  1,0,2,-2,2,  2,0,2,0,2,  -1,0,2,0,1,       
     F 0,1,2*0,1,  -1,2*0,2,1,  1,2*0,-2,1,  0,-1,2*0,1,  -1,0,2*2,1,   
     G 0,1,2,0,2,  0,-1,2,0,2,  1,0,3*2,  2,0,2,-2,2,  3*0,2,1,         
     H -2,2*0,2,1,  0,-1,2,-2,1,  1,0,2,-2,1,  3*0,-2,1,  2*0,2*2,1,    
     I 0,-2,2,-2,1,  2,2*0,-2,1,  2,0,2,0,1,  0,1,2,-2,1,  -2,0,2,0,2 , 
     J 1,2*0,-2,0,  3*0,2,0,  2,2*0,-2,0,  2,4*0, 2*0,2,2*0,            
     K 2*0,2,-2,0,  2,0,-2,2*0,  2*1,0,-2,0,  1,2*0,2,0,  1,-1,3*0,     
     L 0,1,0,-2,0,  3*0,1,0,  1,0,-2,2*0,  1,0,2,2*0,  2*1,3*0,         
     M 1,2*0,-1,0,  1,-1,2,0,2,  1,-1,0,-1,0,  -2,3*0,1,  -1,0,2,-2,1,  
     N 2,3*0,1,  2*-1,3*2,  0,-1,3*2,  1,3*0,2,  2*1,2,0,2,             
     O 3,0,2,0,2  /                                                     
      DOUBLE PRECISION CT(2,13),ST(2,13),C(30),S(30),SL(26)             
C--OBLIQUITY.  COSINE TERMS                                             
      DATA CT                      /9.21D0,91.D-5,.5522D0,-29.D-5,      
     A-904.D-4,4.D-5, 884.D-4,-5.D-5, 4*0.D0, 216.D-4,-6.D-5, 183.D-4,  
     B0.D0,113.D-4,-1.D-5, -93.D-4,3.D-5, -66.D-4,3*0.D0, 7.D-4,0.D0/   
      DATA C/ -50.D-4,-31.D-4,30.D-4,22.D-4,-24.D-4,23.D-4,14.D-4,      
     C-11.D-4,11.D-4,-10.D-4,8.D-4,-7.D-4,7.D-4,2*5.D-4,-3.D-4,2*3.D-4, 
     D-2.D-4,3*3.D-4,-3.D-4,2*3.D-4,2.D-4,-2.D-4,2.D-4,-2.D-4,2.D-4/    
C--LONGITUDE.  SINE TERMS                                               
      DATA ST                      / -17.2327D0,-1737.D-5,-1.2729D0,    
     E-13.D-5,2088.D-4,2.D-5, -2037.D-4,-2.D-5, 1261.D-4,-31.D-5,       
     F675.D-4,1.D-5, -497.D-4,12.D-5, -342.D-4,-4.D-5, -261.D-4,0.D0,   
     G214.D-4,-5.D-5, 124.D-4,1.D-5, 16.D-4,-1.D-5, -15.D-4,1.D-5/      
      DATA S/ 114.D-4,58.D-4,-57.D-4,-52.D-4,45.D-4,-44.D-4,-32.D-4,    
     H26.D-4,-26.D-4,19.D-4,-15.D-4,14.D-4,-13.D-4,-10.D-4,-9.D-4,7.D-4,
     I 2*-6.D-4,6.D-4,-6.D-4,2*-5.D-4,5.D-4,2*-5.D-4,-4.D-4,4.D-4,      
     J-4.D-4,3.D-4,-3.D-4/                                              
      DATA SL/ -149.D-4,60.D-4,45.D-4,28.D-4,25.D-4,-21.D-4,10.D-4,     
     K-7.D-4,6.D-4,4.D-4,2*-4.D-4,4.D-4,3.D-4,3*-3.D-4,3*-2.D-4,2.D-4,  
     L3*-2.D-4,2.D-4,-2.D-4  /                                          
      DATA TWOPI/6.28318530717958648D0/                                 
      DATA TB/2415020.0D0/                                              
      DATA TJDSAV/-1.D37/                                               
      IF (TJD.EQ.TJDSAV) GO TO 201                                      
      T=(TJD-TB)/36525.D0                                               
C     DO 1 J=1,4                                                        
C   1 NUT(J)=0.D0                                                       
      NUT(1)=0.D0                                                       
      NUT(2)=0.D0                                                       
      DO 2 I=1,5                                                        
      ANGL(I)=DMOD(ARG(1,I)+T*(ARG(2,I)+T*(ARG(3,I)+T*ARG(4,I))),1.D0)  
     1*TWOPI                                                            
C   2 ANGRAT(I)=(ARG(2,I)+T*(2.D0*ARG(3,I)+3.D0*T*ARG(4,I)))*TWOPI/     
C    236525.D0                                                          
    2 CONTINUE                                                          
      DO 6 J=1,69                                                       
      THETA=0.D0                                                        
C     THDOT=0.D0                                                        
      DO 3 K=1,5                                                        
      IF(IJKLM(K,J).EQ.0) GO TO 3                                       
      THETA=THETA+DBLE(FLOAT(IJKLM(K,J)))*ANGL(K)                       
C     THDOT=THDOT+DBLE(FLOAT(IJKLM(K,J)))*ANGRAT(K)                     
    3 CONTINUE                                                          
      SINT=DSIN(THETA)                                                  
      COST=DCOS(THETA)                                                  
      IF(J.GT.13) GO TO 4                                               
C--  J.LE.13                                                            
      NUT(1)=NUT(1)+(ST(1,J)+T*ST(2,J))*SINT                            
      NUT(2)=NUT(2)+(CT(1,J)+T*CT(2,J))*COST                            
C     NUT(3)=NUT(3)+(ST(1,J)+T*ST(2,J))*COST*THDOT+ST(2,J)*SINT/36525.D0
C     NUT(4)=NUT(4)-(CT(1,J)+T*CT(2,J))*SINT*THDOT+CT(2,J)*COST/36525.D0
      GO TO 6                                                           
    4 CONTINUE                                                          
      IF(J.GT.43) GO TO 5                                               
C--  14 .GE. J . LE. 43                                                 
      NUT(1)=NUT(1)+S(J-13)*SINT                                        
C     NUT(3)=NUT(3)+S(J-13)*COST*THDOT                                  
      NUT(2)=NUT(2)+C(J-13)*COST                                        
C     NUT(4)=NUT(4)-C(J-13)*SINT*THDOT                                  
      GO TO 6                                                           
    5 CONTINUE                                                          
C--  44 .GE. J .LE. 69                                                  
      NUT(1)=NUT(1)+SL(J-43)*SINT                                       
C     NUT(3)=NUT(3)+SL(J-43)*COST*THDOT                                 
    6 CONTINUE                                                          
C     DO 7 I=1,4                                                        
C   7 NUT(I)=NUT(I)/206264.8062470964D0                                 
C*******************         CONVERT FROM ARC SECONDS TO RADIANS.       
      NUT(1)=NUT(1)/206264.8062470964D0                                 
      NUT(2)=NUT(2)/206264.8062470964D0                                 
      TJDSAV=TJD                                                        
      NUT1SV=NUT(1)                                                     
      NUT2SV=NUT(2)                                                     
      RETURN                                                            
  201 NUT(1)=NUT1SV                                                     
      NUT(2)=NUT2SV                                                     
      RETURN                                                            
      END                                                               
