C*CTRLCEN -- prepare to trap interrupt signal [Alliant-UNIX]
C+
      SUBROUTINE CTRLCEN
C
C CTRLCEN and CTRLCAST are Fortran routines that let you set up a
C Control-C handling facility.
C
C Call CTRLCEN to enable the next control-C typed on the keyboard
C to activate the CTRLCAST AST handler.  CTRLCAST sets the common
C flag CCFLAG in common /CONTROLC/, which may be tested by your
C program.
C
C You must call CTRLCEN each time you want to allow a control-C input.
C
C These programs do not affect the handling of control-Y.
C
C 25-Jul-1988 - test version for Convex [TJP].
C 02-Oct-1989 - replace SIGNAL function with Alliant SIGVEC [ALF].
C 07-Nov-1989 - add arguments N and NCODE to CTRLCAST subroutine
C               definition. This is correct for call to SIGVEC.
C               Also commented out WRITE statement. The Alliant trys
C               to execute two WRITE statements concurrently which
C               results in an I/O error [ALF].
C-----------------------------------------------------------------------
      INCLUDE '/usr/include/fortran/signal.h'
      EXTERNAL CTRLCAST
      INTEGER SIGVEC
      LOGICAL CCFLAG
      COMMON /CONTROLC/ CCFLAG
C
      CCFLAG = .FALSE.
      IER = SIGVEC(SIGINT, SIG_CALL, CTRLCAST, ISIG, ISUB)
      IF (IER.NE.0) CALL EXIT()
      END

      SUBROUTINE CTRLCAST(N,NCODE)
      INCLUDE '/usr/include/fortran/signal.h'
      LOGICAL CCFLAG
      COMMON /CONTROLC/ CCFLAG
C
      IF (.NOT.CCFLAG) THEN
          CCFLAG = .TRUE.
C         WRITE (0, '(/A/)') ' *INTERRUPT*'
      END IF
      END
