/* CPUTIME [Unix]
 *
 * Fortran-callable cpu clock
 *
 * Called as:
 *	elapsed = cputime(start)
 * where 'elapsed' is total cputime - 'start';
 * all arguments are REAL*4
 *
 * TJP: 12-Nov-1993
 */

#include <time.h>

#ifndef CLOCKS_PER_SEC
#define CLOCKS_PER_SEC 1000000
#endif

float cputime_(start)
float *start;
{
    return ( (float) clock() / (float)(CLOCKS_PER_SEC)) - *start;
}
