C*GETCOM -- get one line from user's terminal, with prompt [Convex-UNIX]
C+
      INTEGER FUNCTION GETCOM(TEXT,PROMPT,LENG)
      CHARACTER*(*) TEXT
      CHARACTER*(*) PROMPT
      INTEGER LENG
C
C Read a character string from the user's terminal with optional prompt.
C
C Arguments:
C  TEXT   (output) : text read from standard input.
C  PROMPT (input)  : prompt string; if this is blank, or if the
C                    standard input is not a terminal, no prompt is
C                    issued.
C  LENG   (output) : number of characters readand returned; GETCOM
C                    reads a complete line, but only returns as many
C                    characters as will fit in TEXT.
C
C Returns:
C  GETCOM          : 1 if successful;
C                    0 if end-of-file or an error occurs.
C
C Non-standard extensions to Fortran-77:
C  Uses Q and $ format descriptors.
C
C Subroutines required:
C  Fortran I/O.
C
C History:
C  1988 Jul 19 - TJP.
C  1989 Aug 23 - DLM. Remove Q descriptor for Sun-3/Sun-4 operation.
C-----------------------------------------------------------------------
      INTEGER IER
C
      IF (PROMPT.NE.' ') WRITE (6, '(A,$)') PROMPT
      READ (5, '(A)', IOSTAT=IER) TEXT
      LENG = LEN1(TEXT)
      IF (IER.EQ.0) THEN
          GETCOM = 1
          IF (LENG.GT.LEN(TEXT)) LENG = LEN(TEXT)
      ELSE
          GETCOM = 0
          LENG = 0
      END IF
      END
