/*
C*VALLOC -- allocate memory [Unix]
C+
      INTEGER FUNCTION VALLOC(NWORDS, BASE)
      INTEGER NWORDS, BASE(*)
C
C Allocate NWORDS words of dynamic memory. One word is the amount of
C memory required to store one INTEGER, REAL, or LOGICAL variable
C (4 bytes or 32 bits on most machines). The address of the allocated
C memory, I = VALLOC(), is returned as an index in the supplied array
C BASE. The calling program may then use the allocated memory by
C referencing elements BASE(I) through BASE(I+NWORDS-1). This technique
C is fairly portable but may cause problems on machines that do run-time
C array bounds checking. If the requested memory is not available, the
C program exits with error status.
C
C Arguments:
C  NWORDS (input)  : the number of words to allocate.
C  BASE (input)    : an array that will be "extended" by the allocation.
C
C Returns:
C  VALLOC          : the index in BASE of the first word allocated.
C
C History:
C  1990 Nov 17 - TJP
C-----------------------------------------------------------------------
*/

long valloc_(nwords, base)
long *nwords;
char *base;
{
    char *addr;

    addr = (char *) malloc(4*(*nwords));
    if (addr == (char *)0) 
	{
	printf("Insufficient memory available");
	exit(0);
	}
    return 1 + (addr - base)/4;
}
