C*FRDT   -- revision date of file [VAX/VMS]
C+
      SUBROUTINE FRDT (FNAM, RDATE)
      CHARACTER*(*) FNAM, RDATE
C
C Determine the "last modified" (revision) date of a named file.
C (Specific to VAX/VMS).
C
C Arguments:
C   FNAM (input, character): file name.
C   RDATE (output, character): ASCII string representing the date/time
C         (up to 23 characters). Result is string 'Undefined' if date
C         cannot be determined (e.g., file does not exist).
C
C Author:
C   Peter C. Parnicky
C
C Modifications:
C   1986 Feb 12 - new subroutine.
C-----------------------------------------------------------------------
      INCLUDE '($FABDEF)'
      INCLUDE '($XABDEF)'
      INCLUDE '($XABDATDEF)'

!  Structures.

!  RDT field is defined in /XABDEF/ since it is common to more than one
!  type of XAB. The other three date fields (BDT, CDT, EDT) are defined
!  in /XABDATDEF/.

      STRUCTURE /XABDAT/
        UNION
        MAP
          RECORD /XABDEF/ COM
        END MAP
        MAP
          RECORD /XABDATDEF/ DAT
        END MAP
        END UNION
      END STRUCTURE

!  Local data

      RECORD /FABDEF/ FAB
      RECORD /XABDAT/ XABDAT
      INTEGER*4  STATUS
      INTEGER*2  WLEN
      INTEGER*4  RDT(2)

!  Externals

      INTEGER*4  SYS$OPEN, SYS$CLOSE, SYS$ASCTIM

!  Allow writes to unsigned fields.

      CALL LIB$INT_OVER (0)

! Initialize RMS blocks.

      CALL LIB$MOVC5 (0,,0, FAB$C_BLN, FAB)
      FAB.FAB$B_BID = FAB$C_BID
      FAB.FAB$B_BLN = FAB$C_BLN
      CALL LIB$MOVC5 (0,,0, XAB$C_DATLEN, XABDAT)
      XABDAT.COM.XAB$B_COD = XAB$C_DAT
      XABDAT.COM.XAB$B_BLN = XAB$C_DATLEN

!  Set FAB name pointers and file attributes.

      CALL STR$ANALYZE_SDESC (FNAM, WLEN, FAB.FAB$L_FNA)
      FAB.FAB$B_FNS = WLEN

      FAB.FAB$L_XAB = %LOC (XABDAT)

!  Open the file to get info and then close it.

      RDATE = 'Undefined'
      STATUS = SYS$OPEN (FAB)
      IF (STATUS) THEN
         STATUS = SYS$CLOSE (FAB)
         RDT(1) = XABDAT.COM.XAB$Q_RDT(1)
         RDT(2) = XABDAT.COM.XAB$Q_RDT(2)
         IF (STATUS) THEN
           STATUS = SYS$ASCTIM (, RDATE, RDT,)
         END IF
      END IF

      END
