C*GETCOM -- get one line from user's terminal, with prompt [VAX/VMS]
C+
      INTEGER FUNCTION GETCOM(TEXT,PROMPT,LENG)
      CHARACTER*(*) TEXT
      CHARACTER*(*) PROMPT
      INTEGER LENG
C
C Read a character string from standard input with optional prompt.
C
C Arguments:
C  TEXT   (output) : text read from standard input.
C  PROMPT (input)  : prompt string; if this is blank, or if the
C                    standard input is not a terminal, no prompt is
C                    issued.
C  LENG   (output) : number of characters read and returned; GETCOM
C                    reads a complete line, but only returns as many
C                    characters as will fit in TEXT.
C
C Returns:
C  GETCOM           : 1 if successful;
C                    0 if end-of-file or an error occurs.
C
C Subroutines required:
C  LIB$GET_COMMAND (VMS) - get string from SYS$COMMAND with prompt
C
C History:
C  1988 Jul 19 - TJP.
C-----------------------------------------------------------------------
      INTEGER  LIB$GET_COMMAND
      GETCOM = LIB$GET_COMMAND(TEXT,PROMPT,LENG)
      END
