C*GETIN -- get one line from standard input, with prompt [VAX/VMS]
C+
      INTEGER FUNCTION GETIN(TEXT,PROMPT,LENG)
      CHARACTER*(*) TEXT
      CHARACTER*(*) PROMPT
      INTEGER LENG
C
C Read a character string from standard input with optional prompt.
C
C Arguments:
C  TEXT   (output) : text read from standard input.
C  PROMPT (input)  : prompt string; if this is blank, or if the
C                    standard input is not a terminal, no prompt is
C                    issued.
C  LENG   (output) : number of characters read and returned; GETIN
C                    reads a complete line, but only returns as many
C                    characters as will fit in TEXT.
C
C Returns:
C  GETIN           : 1 if successful;
C                    0 if end-of-file or an error occurs.
C
C Subroutines required:
C  LIB$GET_INPUT (VMS) - get string from standard input with prompt
C
C History:
C  1987 Nov 11 - TJP.
C-----------------------------------------------------------------------
      INTEGER  LIB$GET_INPUT
      GETIN = LIB$GET_INPUT(TEXT,PROMPT,LENG)
      END
