	program GRLOGPLOT                              

C	On DEIMOS: Link GRLOGPLOT,VALLOC,UTL/LIB
C	On IKAROS: fc -c -O2 grlogplot.f
C		   fc -o grlogplot grlogplot.o utl.o valloc.o -lpgplot

	character*80
     *		infile			! Filespec for input file
	integer
     *		inlun,			! LUN for input file
     *		nax1,nax2,		! Image dimensions
     *	   	irimgloc		! Pointer in rimg
	real
     *		rimg(1),		! Real image array
     *		wkar(6),		! Work array
     *		whitelev,blacklev	! White and black display levels

C Get the input file name

	call GETCH('Enter the input file: ',infile,jdef,istr)

C Read the image
                                              
	inlun = 10
	call READFILE(infile,rimg,irimgloc,nax1,nax2,inlun)

C Get the initial guesses for black and white levels

	call VMMA(rimg(irimgloc),nax1*nax2,blacklev,whitelev,avg)

C Allow user to change these levels

	call GETR4('Enter the black level: ',blacklev,'G10.2',blacklev,
     *			jdef)
	call GETR4('Enter the white level: ',whitelev,'G10.2',whitelev,
     *			jdef)

C Initialize PGPLOT

	call PGBEGIN(0,'?',1,1)
*	call PGENV(-(nax1/2+1)+0.5,float(nax1/2-1)+0.5,
*     *		   -(nax2/2+1)+0.5,float(nax2/2-1)+0.5,1,0)
        call PGENV(0.0, real(nax1+1), real(nax2+1), 0.0, 1, 0)
	call PGLABEL('X','Y','Greyscale Image')

C Display the image

	wkar(1) = 0.0
	wkar(2) = 1.0
	wkar(3) = 0.0
	wkar(4) = 0.0
	wkar(5) = 0.0
	wkar(6) = 1.0

	call PGGRAY(rimg(irimgloc),nax1,nax2,1,nax1,1,nax2,whitelev,
     *			blacklev,wkar)

	end

**************************************************************************

	subroutine READFILE(infile,rimg,irimgloc,nax1,nax2,inlun)

	integer	inlun,nax1,nax2,irimgloc,VALLOC
	character*80 infile
	real rimg(*)            

	open (unit=inlun,file=infile,form='UNFORMATTED',status='OLD')
	read (inlun) nax1,nax2
        irimgloc = VALLOC(nax1*nax2,rimg)
	call READFILE1(rimg(irimgloc),nax1,nax2,inlun)
	call MAKLOG(rimg(irimgloc),nax1*nax2)
	return
	end

**************************************************************************

	subroutine MAKLOG(rimg,numi)

	real rimg(*)
	integer numi

	do i = 1, numi
	    rimg(i) = log10(rimg(i))
	enddo

	return
	end


**************************************************************************

	subroutine READFILE1(rimg,nax1,nax2,inlun)

	integer inlun,nax1,nax2
	real rimg(nax1,nax2)

	read (inlun) rimg
                       
	return
	end

**************************************************************************

	subroutine VMMA(rimg,nax,rmin,rmax,avg)

	real rimg(*),rmin,rmax,avg
	integer nax

	rmin = rimg(1)
	rmax = rimg(1)
	avg = 0.
	do i = 1,nax
	    rmin = MIN(rmin,rimg(i))
	    rmax = MAX(rmax,rimg(i))
	    avg = avg + rimg(i)/nax
	enddo
	
	return
	end
