*
*         "TOY"  DEMONSTRATION PROGRAM FOR  MEMSYS 3
*
*       Maximum Entropy Data Consultants Ltd, June 1989

      PROGRAM TOY
      IMPLICIT REAL (A-H,O-Z)
* Declare all common blocks for tidyness
      INCLUDE 'MECOMS.INC'
      INCLUDE 'MECOMP.INC'
      INCLUDE 'MECOMC.INC'
      INCLUDE 'MECOML.INC'
* User input
    1 CALL UINPUT(METHOD,AIM,LEVEL)
* Assign memory
    2 CALL MEMORY
* Check OPUS / TROPUS consistency (optional)
    3 CALL MEMTRQ(4321,ERR)
      WRITE(IOUT,40) ERR
      CALL MEMTRQ(1234,ERR)
      WRITE(IOUT,40) ERR
* Simulation: data = <21>, accuracies = ACC or <22>
    4 CALL SIMUL(METHOD,DEF,ACC)
* Model = DEF or <20>
      CALL UMODEL(KB(20),DEF)
* Remaining MemSys3 input parameters
      RATE=1.5
      TOL=.1
      ITER=0
* Maximum Entropy Loop ............
      MEMRUN=0
    5 CONTINUE
        WRITE(IOUT,41) ITER
        CALL MEM3(METHOD,LEVEL,MEMRUN,1,5, AIM,RATE,DEF,ACC,TOL,
     *     ALPHA,BETA, S,TEST,CHISQ,SIGMA,PROB,GOOD,OMEGA,ISTAT)
        MEMRUN=1
        WRITE(IOUT,42) NTRANS,ST(33)
        ITER=ITER+1
      IF(ISTAT.NE.0) GOTO 5
* ......... repeat until converged 
    6 WRITE(IOUT,44) (ST(I),I=1,64)
      IF(IOUT.NE.0) CLOSE(IOUT)
      CALL UDIAG(' Run complete')
* Fluxes with error bars ..............
    7 CONTINUE
        WRITE(*,*) ' '
        WRITE(*,*) ' Left  cell ?  (0 exits)'
        READ(*,*) J
          IF(J.LE.0) STOP
        WRITE(*,*) ' Right cell ?'
        READ(*,*) K
*   Set mask 
        CALL UMASK(KB(2),J,K)
*   Estimate of masked image with error bar
        CALL MEMASK(DEF,ACC,TOL,ALPHA,SIGMA, RHO,DRHO,KSTAT)
        WRITE(*,45) RHO,DRHO
        IF(KSTAT.GE.2) WRITE(*,46)
      GOTO 7
* ................... repeat until exit
   40 FORMAT(' Fractional OPUS/TROPUS inconsistency  =',1PE12.4/)
   41 FORMAT(' Iteration',I5)
   42 FORMAT('    Trans  =',I5,33X,' Peak =',F9.4/)
   44 FORMAT(8F10.4)
   45 FORMAT(' Mask  =',F8.2,'  +or-',F7.2)
   46 FORMAT('  (Error estimate unreliable - rounding errors ?)')
      END

      SUBROUTINE UINPUT(METHOD,AIM,LEVEL)
* User input.
* Set MaxEnt parameters METHOD, AIM, LEVEL and define 
* destination (Fortran stream IOUT in /MECOMP/) for diagnostics.
      IMPLICIT REAL (A-H,O-Z)
      CHARACTER*72 FNAME
      INCLUDE 'MECOMP.INC'
      WRITE(*,*) '  Please input METHOD = 1000*M3 + 100*M2 + 10*M1 + M0'
      WRITE(*,*) ' '
      WRITE(*,*) '    M3 = 0 is "Linear data"'
      WRITE(*,*) '    M3 = 1 is "Nonlinear data"'
      WRITE(*,*) ' '
      WRITE(*,*) '    M2 = 0 is "Variable acc in <22>"'
      WRITE(*,*) '    M2 = 1 is "Constant acc=1/sigma"'
      WRITE(*,*) '    M2 = 2 is "Poisson statistics"'
      WRITE(*,*) ' '
      WRITE(*,*) '    M1 = 0 is "Constant default"'
      WRITE(*,*) '    M1 = 1 is "Variable def in <20>"'
      WRITE(*,*) '    M1 = 2 is "Constant default with pos/neg"'
      WRITE(*,*) '    M1 = 3 is "Variable def in <20> with pos/neg"'
      WRITE(*,*) ' '
      WRITE(*,*) '    M0 = 0 is "Historic Chisquared=Ndata"'
      WRITE(*,*) '    M0 = 1 is "Classic with known noise"'
      WRITE(*,*) '    M0 = 2 is "Classic with unknown noise"'
      WRITE(*,*) '    M0 = 3 is "Alpha given"'
      READ(*,*) METHOD
      M0=METHOD-(METHOD/10)*10
      IF(M0.EQ.0)
     * WRITE(*,*) '  Please input   AIM = Chisquared / Ndata  [1.]'
      IF(M0.EQ.1.OR.M0.EQ.2)
     * WRITE(*,*) '  Please input   AIM = Structure per good d.f. [1.]'
      IF(M0.EQ.3)
     * WRITE(*,*) '  Please input   AIM = value of alpha'
      WRITE(*,*)  '                 [smaller values fit data better]'
      READ(*,*) AIM
      WRITE(*,*) ' '
      WRITE(*,*) '  Please input  LEVEL = 10*L1 + L0'
      WRITE(*,*) ' '
      WRITE(*,*) '    L1 = 0 gives no numerical diagnostics'
      WRITE(*,*) '    L1 = 1 gives major numerical diagnostics'
      WRITE(*,*) '    L1 = 2 gives additional technical diagnostics'
      WRITE(*,*) ' '
      WRITE(*,*) '    L0 = 0 gives no progress diagnostics'
      WRITE(*,*) '    L0 = 1 gives names of main routines'
      WRITE(*,*) '    L0 = 2 gives additionally read/write flowchart'
      WRITE(*,*) '    L0 = 3 additionally calls udiag',
     *                     ' after each main routine'
      READ(*,*) LEVEL
      WRITE(*,*) ' '
      WRITE(*,*) '  Please input file name for diagnostics [cr]'
      READ(*,40) FNAME
* (Default stream to terminal is 0 here)
      IF(FNAME.EQ.' ') THEN
        IOUT=6
      ELSE
        IOUT=1
        OPEN(1,FILE=FNAME,STATUS='NEW')
      ENDIF
   40 FORMAT(A)
      END

      SUBROUTINE MEMORY
* Assign MaxEnt memory pointers.
      INCLUDE 'MECOMP.INC'
      INCLUDE 'MECOMS.INC'
* Image area is 64 reals, 
* defined as 2 buffers of 32 to check that buffering works.
      NJ=2
      MJ=32
* Data  area is 64 reals,
* defined as 4 buffers of 16 to check that buffering works.
      NK=4
      MK=16
* Set all areas in "core" (with impossible default addresses)
      DO 1 I=1,40
        KA(I)=0
        KB(I)=-99999999
    1 CONTINUE
* Define with length 64 all the areas <1>,<2>,<20> and 
* <21>,<22>,<23>,<24>,<25>,<26>,<27>,<28>,<29> which might be needed.
* Note that the transform is in place, so <25> can overlay <2>.
      LENGTH=64
      KB(1)=1
      KB(2)=KB(1)+LENGTH
      KB(20)=KB(2)+LENGTH
      KB(21)=KB(20)+LENGTH
      KB(22)=KB(21)+LENGTH
      KB(23)=KB(22)+LENGTH
      KB(24)=KB(23)+LENGTH
      KB(25)=KB(2)
      KB(26)=KB(24)+LENGTH
      KB(27)=KB(26)+LENGTH
      KB(28)=KB(27)+LENGTH
      KB(29)=KB(28)+LENGTH
* Check for violation of length of ST (parameter NSTORE in MECOMS.INC)
      KTOP=KB(29)+LENGTH-1
      IF(KTOP.GT.NSTORE) THEN
        WRITE(*,*)
     *     ' Need',I9,' reals in ST: edit MECOMS.INC and recompile'
        STOP
      ENDIF
* Initialise internal pointers to enable use of MEMSYS routines
      CALL MEINIT
      END

      SUBROUTINE SIMUL(METHOD,DEF,ACC)
*
* Set DEF = expected average image value,
*     <21> = data,
*     ACC = <22> = accuracies,
* for linear or nonlinear simulation according to METHOD.
*
*  This subroutine uses MEMSYS3 vector library calls
      IMPLICIT REAL (A-H,O-Z)
      INCLUDE 'MECOMP.INC'
*  Simulated image in <2> and its mean value
      CALL UMAP(KB(2),DEF)
*  Transform of image in <25>
      CALL OPUS(2,25)
*  (Nonlinear: MEMX(arbitrary) modifies <25> by calling MEMEX)
      IF(METHOD.GE.1000)  CALL MEMX(0.)
      IF((METHOD/100)-(METHOD/1000)*10.NE.2) THEN
* If not Poisson ...
*    Unit random noise in <23> (4321 is arbitrary seed)
        CALL VRAND(4321,0)
        CALL VRAND(KB(23),64)
*    Data  <21> = <25> + standarddeviation * <23>
        STDDEV=10.
        CALL VSMULA(KB(23),STDDEV,KB(25),KB(21),64)
*    Accuracies ACC = <22> = 1/standarddeviation 
        ACC=1./STDDEV
        CALL VFILL(KB(22),ACC,64)
      ELSE
* If Poisson ...
*    Data  <21> = <25> + Poissonnoise(<25>)
        CALL VPOISS(KB(25),KB(21),1234)
*    Accuracy not actually needed
        ACC=1.
      ENDIF
      END

      SUBROUTINE UMAP(F,DEF)
*  Set   <f> =  Two spikes + plateau    ,    DEF = Mean( <f> )
      IMPLICIT REAL (A-H,O-Z)
      INTEGER F
      INCLUDE 'MECOMS.INC'
      DO 1 I=0,63
        ST(F+I)=0.
    1 CONTINUE
      DO 2 I=33,47
        ST(F+I)=20.
    2 CONTINUE
      ST(F+32)=900.
      ST(F+48)=200.
      DEF=0.
      DO 3 I=0,63
        DEF=DEF+ST(F+I)
    3 CONTINUE
      DEF=DEF/64.
      END

      SUBROUTINE UMODEL(M,DEF)
*  Set   <m> = DEF = constant
      IMPLICIT REAL (A-H,O-Z)
      INCLUDE 'MECOMS.INC'
      DO 1 I=0,63
        ST(M+I)=DEF
    1 CONTINUE
      END

      SUBROUTINE UMASK(MASK,J,K)
* Set MASK = square wave from cell j to k (counting from 1 to 64)
      INCLUDE 'MECOMS.INC'
      DO 1 I=0,63
        ST(MASK+I)=0.
    1 CONTINUE
      DO 2 I=J-1,K-1
        ST(MASK+I)=1.
    2 CONTINUE
      END

      SUBROUTINE OPUS(K,L)
*   Convolution
      INCLUDE 'MECOMP.INC'
      CALL BLUR(KB(K),KB(L))
      END

      SUBROUTINE TROPUS(K,L)
*   Correlation (actually same as convolution)
      INCLUDE 'MECOMP.INC'
      CALL BLUR(KB(K),KB(L))
      END

      SUBROUTINE BLUR(A,B)
*   5-cell symmetric blur, can be in-place
      IMPLICIT REAL (A-H,O-Z)
      INTEGER A,B
      INCLUDE 'MECOMS.INC'
      Q=ST(A+60)+ST(A+61)+ST(A+62)+ST(A+63)+ST(A)
      R=Q-ST(A+60)+ST(A+1)
      S=R-ST(A+61)+ST(A+2)
      T=S-ST(A+62)+ST(A+3)
      U=T-ST(A+63)+ST(A+4)
      ST(B)=U-ST(A)+ST(A+5)
      DO 1 I=1,58
        ST(B+I)=ST(B+I-1)-ST(A+I)+ST(A+I+5)
    1 CONTINUE
      DO 2 I=58,0,-1
        ST(B+I+3)=ST(B+I)/5.
    2 CONTINUE
      ST(B+62)=Q/5.
      ST(B+63)=R/5.
      ST(B)=S/5.
      ST(B+1)=T/5.
      ST(B+2)=U/5.
      END

      SUBROUTINE MEMEX(X,PHI,DPHI)
* Set   PHI  = response of nonlinear experiment as function of x
* Set   DPHI = differential responsivity
*
* This example has scaled and squared response on a background
* 
      IMPLICIT REAL (A-H,O-Z)
      PHI=100.+X*X/10.
      DPHI=2.*X/10.
      END
 
      SUBROUTINE UGET(D,X,M)
*   Get a buffer of M reals from external address D to ST address X
*  ( Not called in standard "core" simulation )
      IMPLICIT REAL (A-H,O-Z)
      INTEGER D,X
      INCLUDE 'MECOMP.INC'
      INCLUDE 'MECOMS.INC'
      COMMON /DISC/ DISC(2560)
      DO 1 I=0,M-1
        ST(X+I)=DISC(D+I)
    1 CONTINUE
      END
 
      SUBROUTINE UPUT(D,X,M)
*   Put a buffer of M reals to external address D from ST address X
*  ( Not called in standard "core" simulation )
      IMPLICIT REAL (A-H,O-Z)
      INTEGER D,X
      INCLUDE 'MECOMP.INC'
      INCLUDE 'MECOMS.INC'
      COMMON /DISC/ DISC(2560)
      DO 1 I=0,M-1
        DISC(D+I)=ST(X+I)
    1 CONTINUE
      END

      SUBROUTINE VPOISS(K,D,IDUM)
*  Set  <D> = <K> + Poisson noise     (roughly  K +or- sqrt(K) )
*  Poisson noise generator from "Numerical Recipes"
      IMPLICIT REAL(A-H,O-Z)
      INTEGER K,D
      INCLUDE 'MECOMS.INC'
      GAMLOG(xxx)=(xxx+.5)*LOG(xxx+5.5)-(xxx+5.5)+
     * LOG(2.50662827465*(1.+76.18009173/(xxx+1.)-86.50532033/(xxx+2.)
     *                    +24.01409822/(xxx+3.)-1.231739516/(xxx+4.)
     *                    +.120858003E-2/(xxx+5.)-.536382E-5/(xxx+6.)))
      DO 5 I=0,63
        X=ST(K+I)
        IF(X.LT.12.) THEN
          G=EXP(-X)
          E=-1.
          T=1.
    2     E=E+1.
          T=T*RAN1(IDUM)
          IF(T.GT.G) GOTO 2
        ELSE
          S=SQRT(2.*X)
          A=ALOG(X)
          G=X*A-GAMLOG(X)
    1     Y=TAN(3.14159265*RAN1(IDUM))
          E=S*Y+X
          IF(E.LT.0.) GOTO 1
          E=INT(E)
          T=0.9*(1.+Y**2)*EXP(E*A-GAMLOG(E)-G)
          IF(RAN1(IDUM).GT.T) GOTO 1
        ENDIF
        ST(D+I)=E
    5 CONTINUE
      END

      FUNCTION RAN1(IDUM)
*  Uniform random noise generator from "Numerical Recipes"
      IMPLICIT REAL(A-H,O-Z)
      DIMENSION R(97)
      PARAMETER (M1=259200,IA1=7141,IC1=54773,RM1=3.8580247E-6)
      PARAMETER (M2=134456,IA2=8121,IC2=28411,RM2=7.4373773E-6)
      PARAMETER (M3=243000,IA3=4561,IC3=51349)
      DATA IFF /0/
      IF(IDUM.LT.0.OR.IFF.EQ.0) THEN
        IFF=1
        IX1=MOD(IC1-IDUM,M1)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX2=MOD(IX1,M2)
        IX1=MOD(IA1*IX1+IC1,M1)
        IX3=MOD(IX1,M3)
        DO 11 J=1,97
          IX1=MOD(IA1*IX1+IC1,M1)
          IX2=MOD(IA2*IX2+IC2,M2)
          R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
   11   CONTINUE
        IDUM=1
      ENDIF
      IX1=MOD(IA1*IX1+IC1,M1)
      IX2=MOD(IA2*IX2+IC2,M2)
      IX3=MOD(IA3*IX3+IC3,M3)
      J=1+(97*IX3)/M3
      RAN1=R(J)
      R(J)=(FLOAT(IX1)+FLOAT(IX2)*RM2)*RM1
      END
