* Last modified: 5-Dec-1990 [TJP]

*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
* VLBI Package using MemSys 3                                                *
*  Written by S.F. Gull, December 1989 CIT                                   *
*  This code is bequeathed to T.J. Pearson for extensive modification        *
*  and/or incorporation into the VLBI package                                *
*  It is the least tested part of the whole thing - the input format and     *
*  storage format on disk are arbitrary and quirky, so please feel free to   *
*  change it!                                                                *
*  Unlike the rest of this code, if you have trouble there is positively NO  *
*  guarantee from  Maximum Entropy Data Consultants Ltd.                     *
*----------------------------------------------------------------------------*

*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
* VLBMEM Status at 13 Dec 1989                                               *
*                                                                            *
* Usage:
*           R VLBMEM
*  Options are to start again or to restart from a VLBMEM.WRK file
*  that has been created by the program in the current directory
*
*  Initial data given:
*
*   Merge file name
*
*  Map size (nx,ny) which is the size of the MEM output map.
*  The Dirty maps, beams, residual are DOUBLE this size in each dimension.
*
*   Milli arcsec per pixel. If 0. it will choose something that I don't
*   necessarily recommend. Oversamplings in excess of 3 are essential.
*
*  Restarting:
*
*  There will be a brief pause, and you should be set to go from 1 
*  iteration before you left off.
*
*  Commands:
*
*     HELP
*     QUIT
*     EXIT
*     SAVE	: Refresh VLBMEM.DAT the MaxEnt iterate
*     DMAP    : Make a dirty map in DMAP.DAT
*     DBEAM   : Beam
*     DRESID  : Dirty residuals
*     TRQ     : Test consistency of transform code (it passes)
*     PAUSE   : Come back to command level after PAUSE iterations
*     ITER    : Perform MaxEnt
*     METHOD  : Change MEM3 METHOD (see manual)
*     AIM     : Change AIM
*     LEVEL   : Change MEM3 LEVEL (see manual)
*     FLUX    : Find quantified fluxes in a square window (can't be done
*             : for some METHODs or immediately after a restart.
*    Files:
*          VLBMEM.WRK	: Work file for restarting /quantifying
*           This file contains critical information about the last run.
*           It can be diconcertingly small - the MAP is NOT included!
*           DBEAM.DAT	: Dirty map (double size)
*           DBEAM.DAT  	: Dirty beam (double size)
*           DRESID.DAT	: Dirty residuals (double size)
*         These files are for information only - they are not actually used
*         inside the package. They are created ONLY when a DMAP, DBEAM or 
*         DRESID command is issued.
*         NB these are OVERWRITTEN every time a new DBEAM, DMAP or DRESID
*         command is issued - saving the contents is YOUR responsibility!
*-----------------------------------------------------------------------------*

      PROGRAM VLBMEM
* Declare all common blocks for tidyness
* MEM storage
      INCLUDE 'MECOMS.INC'
* MEM pointers
      INCLUDE 'MECOMP.INC'
* MEM characters
      INCLUDE 'MECOMC.INC'
* MEM alpha control
      INCLUDE 'MECOML.INC'
* VLBOPUS dimensions
      INCLUDE 'OPCOMP.INC'
* FITS header information
      INCLUDE 'MEFITS.INC'
* Running parameters for restart
      INCLUDE 'MEPARM.INC'
      DATA LUNIT1,LUNIT2,LUNIT3/17,2,3/
      CHARACTER*128 VLBFIL, FILENM
      CHARACTER*64 COMMAN
      INTEGER GETIN

* defaults
      ITER=0
      ITER0=1
      LEVEL=10
      RATE=1.0
      ILOG=7
      IOUT=6
      DEF=1.
      AIM=1.

* Log file
      OPEN(ILOG,FILE='VLBMEM.LOG',STATUS='UNKNOWN',ACCESS='APPEND')

      CALL PUTOUT('VLBMEM 5-Dec-1990')
      CALL PUTOUT(' ')
   10 CONTINUE
      CALL PUTOUT('Initial options: 0 == New dataset, '//
     1 '1 == Continue old MaxEnt run')
      IER = GETIN(COMMAN,'Option: ',LCOM)
      IF (IER.NE.1) GOTO 10
      READ  (COMMAN, *, ERR=10) MEMRUN
      IF (MEMRUN.EQ.0) THEN
        WRITE(ILOG,*) 'VlbMem> Initial options: 0 == New dataset '
        CALL START(VLBFIL)
      ELSEIF(MEMRUN.EQ.1) THEN
        WRITE(ILOG,*) 
     *    'VlbMem> Initial options: 1 == Continue old MaxEnt run'
* MaxEnt work file for restarting
        OPEN(LUNIT3,FILE='VLBMEM.WRK',STATUS='OLD',
     *       FORM='UNFORMATTED', IOSTAT=IER)
        IF (IER.NE.0) THEN
            CALL PUTOUT('Cannot open work file VLBMEM.WRK')
            GOTO 10
        END IF
        WRITE(ILOG,*) 
     *    'VlbMem> Initial options: 1 == Continue old MaxEnt run'
        CALL RESTRT(LUNIT3,VLBFIL)
* The alpha control has been disturbed
        MEMRUN=2
      ELSE
        GOTO 10
      ENDIF

* Set up gridder/degridder
      CALL OPSET
      CALL PUTOUT('VlbMem> Ready to go')

* Proto-Command interpreter
    1 CONTINUE
        IER = GETIN(COMMAN,'VlbMem> ',LCOM)
        IF (IER.NE.1) GOTO 99
        CALL UPCASE(COMMAN)
        IF (COMMAN.EQ.' ') THEN
          GOTO 1
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
* EXIT, QUIT and HELP and obvious stuff                                     *
*---------------------------------------------------------------------------*
        ELSEIF(COMMAN(1:2).EQ.'EX') THEN
          STOP
        ELSEIF(COMMAN(1:1).EQ.'Q') THEN
          STOP
        ELSEIF(COMMAN(1:1).EQ.'H') THEN
          CALL HELP
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*  METHOD changer                                                           *
*---------------------------------------------------------------------------*
        ELSEIF(COMMAN(1:3).EQ.'MET') THEN
          IF (MEMRUN.EQ.0) THEN
              CALL PUTOUT('You cannot change METHOD now')
          ELSE
              CALL METHIN(METHOD)
              WRITE(ILOG,*)'Vlbmem> METHOD = ',METHOD
*  A "facility" - MEMRUN should be set to 2 if METHOD is changed
*  it is possible that METHOD has not been changed - but then
*  why did you call METHIN? Possibly you wanted to reset MEMRUN
* Think about it. (advanced users of MEMSYS only!)
              MEMRUN=2
          ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*  LEVEL changer                                                            *
*---------------------------------------------------------------------------*
        ELSEIF(COMMAN(1:3).EQ.'LEV') THEN
          CALL LEVIN(LEVEL)
            WRITE(ILOG,*)'Vlbmem> LEVEL = ',LEVEL
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*  RATE changer                                                             *
*---------------------------------------------------------------------------*
        ELSEIF(COMMAN(1:3).EQ.'RAT') THEN
          CALL RATIN(RATE)
            WRITE(ILOG,*)'Vlbmem> RATE = ',RATE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*  PAUSE switch                                                             *
*---------------------------------------------------------------------------*
        ELSEIF(COMMAN(1:3).EQ.'PAU') THEN
          CALL PAUSIN(ITER0)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*  OPUS/TROPUS checker. Leave this in!                                      *
*---------------------------------------------------------------------------*
        ELSEIF(COMMAN(1:3).EQ.'TRQ') THEN
          CALL MEMTRQ(1234,ERR)
          WRITE(ILOG,*)'Vlbmem> TRQ'
          WRITE(ILOG,*)'Fractional OPUS/TROPUS inconsistency',ERR
          WRITE(IOUT,*)'Fractional OPUS/TROPUS inconsistency',ERR
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*  Dirty beam maker                                                         *
*  The Dirty beam is twice the size of the output MEM map                   *
*---------------------------------------------------------------------------*
        ELSEIF(COMMAN(1:2).EQ.'DB') THEN
          WRITE(ILOG,*)'Vlbmem> DBEAM'
          CALL DBEAM
          CALL VSMUL(KB(28),VARSUM,KB(28),NK*MK)
          CALL TROPUS(28,2)
          CALL DMAPWR(LUNIT2,2)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*  Dirty map maker                                                          *
*  The Dirty map is twice the size of the output MEM map                    *
*---------------------------------------------------------------------------*
        ELSEIF(COMMAN(1:2).EQ.'DM') THEN
          WRITE(ILOG,*)'Vlbmem> DMAP'
          CALL VMUL(KB(22),KB(22),KB(28),NK*MK)
          CALL VMUL(KB(28),KB(21),KB(27),NK*MK)
          CALL VSMUL(KB(27),VARSUM,KB(28),NK*MK)
          CALL TROPUS(28,2)
          CALL DMAPWR(LUNIT2,1)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*  Dirty residual maker                                                     *
*  The dirty maps are twice the size of the output MEM map                  *
*---------------------------------------------------------------------------*
        ELSEIF(COMMAN(1:2).EQ.'DR') THEN
          WRITE(ILOG,*)'Vlbmem> DRESID'
          CALL VMUL(KB(22),KB(24),KB(28),NK*MK)
          CALL VSMUL(KB(28),VARSUM,KB(28),NK*MK)
          CALL TROPUS(28,2)
          CALL DMAPWR(LUNIT2,3)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*  Write out Mockdata                                                       *
*---------------------------------------------------------------------------*
        ELSEIF(COMMAN(1:2).EQ.'MK') THEN
          WRITE(ILOG,*)'Vlbmem> MKDATA'
          CALL OPUS(1,28)
          OPEN(LUNIT2,FILE='MKDATA.DAT',STATUS='UNKNOWN',
     *         FORM='UNFORMATTED')
          WRITE(LUNIT2) VLBFIL
          WRITE(LUNIT2) NP
          CALL WRTOUT(LUNIT2,ST(KB(28)),NK*MK)
          INQUIRE (UNIT=LUNIT2, NAME=FILENM)
          CALL PUTOUT('Writing file '//FILENM(1:LEN1(FILENM)))
          CLOSE (UNIT=LUNIT2)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
* Write output MEM map                                                      *
*---------------------------------------------------------------------------*
        ELSEIF(COMMAN(1:3).EQ.'SAV') THEN
          WRITE(ILOG,*)'Vlbmem> SAVE'
          CALL DMAPWR(LUNIT2,0)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
* MaxEnt loop                                                               *
*---------------------------------------------------------------------------*
        ELSEIF(COMMAN(1:4).EQ.'ITER') THEN
          IF(MEMRUN.EQ.0) THEN
            CALL METHIN(METHOD)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
* Please change this!!                                                      *
*---------------------------------------------------------------------------*
            DEF=DEF*4./REAL(NX*NY)
            CALL VFILL(KB(20),DEF,NJ*MJ)
          ENDIF
          DUMMY=1.
          IT=0
          SIGMA=1.
   20     CONTINUE
          WRITE(ILOG,41) ITER
          WRITE(IOUT,41) ITER
          CALL MEM3(METHOD,LEVEL,MEMRUN,1,5,AIM,RATE,DEF,DUMMY,0.1,
     *       ALPHA,BETA, S,TEST,CHISQ,SIGMA,PROB,GOOD,OMEGA,ISTAT)
          MEMRUN=1
          WRITE(ILOG,52) S,TEST,CHISQ
          WRITE(ILOG,55) OMEGA,ALPHA
          IF(M0.EQ.1.OR.M0.EQ.2) WRITE(ILOG,53) PROB,GOOD,SIGMA
   52 FORMAT('  Entropy === ',1PE12.4,
     *       '    Test ===',0PF7.4,'         Chisq ===',1PE12.4)
   53 FORMAT('  LogProb ===',1PE13.4,'   Good  ===',1PE12.4,
     *       '    Sigma ===',1PE12.4)
   55 FORMAT('  Omega   === ',0PF10.6,'     Alpha ===',1PE12.4)
          WRITE(ILOG,42) NTRANS
          WRITE(IOUT,42) NTRANS
   41 FORMAT(' Iteration',I5)
   42 FORMAT('    Trans  =',I5/)
            IT=IT+1
            ITER=ITER+1
          IF(IT.LT.ITER0) GOTO 20
* MaxEnt work file for restarting
          OPEN(LUNIT3,FILE='VLBMEM.WRK',STATUS='UNKNOWN',
     *         FORM='UNFORMATTED')
          WRITE(LUNIT3) VLBFIL
* Write out relevant COMMON blocks - horrid FORTRAN code
* /MECOMP/
          CALL WRTOUT(LUNIT3,MECPHK,MECPSZ)
* /MEPARM/
          CALL WRTOUT(LUNIT3,MEPMHK,MEPMSZ)
* The data, errors, multipliers and u-v points
          CALL DISKOU(LUNIT3,20)
          CALL DISKOU(LUNIT3,21)
          CALL DISKOU(LUNIT3,22)
          CALL DISKOU(LUNIT3,23)
          CALL DISKOU(LUNIT3,40)
* Additional FITS header info
          WRITE (LUNIT3) HOBSER, HTELES, HSNAME, HDATOB
          WRITE (LUNIT3) HRA0, HDEC0, HXINT, HYINT, HEPOCH, HFREQ
          CLOSE(UNIT=LUNIT3)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*  FLUX command generates a mask in file 2  and calls MEMASK                *
*---------------------------------------------------------------------------*
        ELSEIF(COMMAN(1:4).EQ.'FLUX') THEN
          CALL PUTOUT(' ')
          WRITE(*,*)
     *     ' LowX,  LowY  cell counting  up  from  1,1  ? '
          READ(*,*) JX,JY
          WRITE(*,*)
     *    ' HighX, HighY cell counting down from NX,NY ?'
          READ(*,*) KX,KY
*   Set mask 
          CALL UMASK(NX/2,NY/2,JX,KX,JY,KY)
*   Estimate of masked image with error bar
          CALL MEMASK(0.0,0.0,0.1,ALPHA,SIGMA, RHO,DRHO,KSTAT)
          WRITE(*,45) RHO,DRHO
          IF(KSTAT.GE.2) WRITE(*,46)
   45 FORMAT(' Mask  =',F8.4,'  +or-',F7.4)
   46 FORMAT('  (Error estimate unreliable - rounding errors ?)')
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
* Primitive error traps                                                      *
*----------------------------------------------------------------------------*
        ELSE
          CALL PUTOUT('Unknown command : '//COMMAN(1:LCOM))
        ENDIF
        GOTO 1
   99 CONTINUE
      CALL PUTOUT('Error reading command')
      GOTO 1
      END

      SUBROUTINE START(VLBFIL)
      CHARACTER*(*) VLBFIL
* Read in merge file
      INCLUDE 'MEPARM.INC'
      INCLUDE 'MECOMP.INC'
      INCLUDE 'OPCOMP.INC'
      CALL DATFIL(LUNIT1,NP,VLBFIL)
      NDATA=NP*2
      WRITE(*,*) 'Size of map, NX, NY? : '
      READ(*,*) NXMAP,NYMAP
      NX=NXMAP*2
      NY=NYMAP*2
      ND(1)=NX
      ND(2)=NY
      NPIXEL=NXMAP*NYMAP
      CALL MEMORY(NPIXEL,NDATA)
      CALL MEMMIN(LUNIT1,NP)
      WRITE (*,*) 'Number of u-v points =', NP
* u-v checker
      WRITE(*,*) 'Grid size in milli-arcsec? : '
      READ(*,*) XYINT
      CALL UVCHK(NX,NY,XYINT,VARSUM)
      VARSUM=1./VARSUM
      END

      SUBROUTINE RESTRT(LUNIT,VLBFIL)
* Restart from VLBMEM.WRK
      INCLUDE 'MEPARM.INC'
      INCLUDE 'MECOMP.INC'
      INCLUDE 'OPCOMP.INC'
      INCLUDE 'MEFITS.INC'
      CHARACTER*(*) VLBFIL
* The VLB filename
      READ(LUNIT) VLBFIL
* Read relevant COMMON blocks - horrid FORTRAN code
* /MECOMP/ for blocking information
      CALL READIN(LUNIT,MECPHK,MECPSZ)
* /MEPARM/ for local parameters and running information
      CALL READIN(LUNIT,MEPMHK,MEPMSZ)
      ND(1)=NX
      ND(2)=NY
      NXMAP=NX/2
      NYMAP=NY/2
      NPIXEL=NXMAP*NYMAP
      CALL MEMORY(NPIXEL,MK*NK)
* The data, errors, multipliers and u-v points
      CALL DISKIN(LUNIT,20)
      CALL DISKIN(LUNIT,21)
      CALL DISKIN(LUNIT,22)
      CALL DISKIN(LUNIT,23)
      CALL DISKIN(LUNIT,40)
* Additional FITS header info
      READ (LUNIT) HOBSER, HTELES, HSNAME, HDATOB
      READ (LUNIT) HRA0, HDEC0, HXINT, HYINT, HEPOCH, HFREQ
      CLOSE(UNIT=LUNIT)
      END

      SUBROUTINE DBEAM
* Set up data for dirty deam
      INCLUDE 'MECOMS.INC'
      INCLUDE 'MECOMP.INC'
* This operation is not in [.MEM3]VLIB
      DO 1 I=1,NK
        CALL UREAD(22)
        DO 2 J=0,MK-1,2
          ST(KC(28)+J)=ST(KC(22)+J)**2
          ST(KC(28)+J+1)=0.
    2   CONTINUE
        CALL UWRITE(28)
    1 CONTINUE
      CALL UINIT
      END

      SUBROUTINE DMAPWR(LUNIT,IFILE)
* Write out maps; revised for FITS format TJP 1990 Jan 4.
      INCLUDE 'MEPARM.INC'
      INCLUDE 'MECOMS.INC'
      INCLUDE 'OPCOMP.INC'
      INCLUDE 'MECOMP.INC'
C
      IF (IFILE.EQ.0) THEN
        CALL MAP(ST(KB(1)),NX/2,NY/2,XMAX,1)
        CALL WRFITS(IFILE, ND(1)/2, ND(2)/2, ST(KB(1)), 'VLBMEM.DAT')
      ELSE IF (IFILE.EQ.1) THEN
        CALL WRFITS(IFILE, ND(1), ND(2), ST(KB(16)), 'DMAP.DAT')
      ELSE IF (IFILE.EQ.2) THEN
        CALL WRFITS(IFILE, ND(1), ND(2), ST(KB(16)), 'DBEAM.DAT')
      ELSE IF (IFILE.EQ.3) THEN
        CALL WRFITS(IFILE, ND(1), ND(2), ST(KB(16)), 'DRESID.DAT')
      END IF
      END

      SUBROUTINE METHIN(METHOD)
* Input METHOD
    1 CONTINUE
      WRITE(*,*) ' '
      WRITE(*,*) '  Please input METHOD'
      WRITE(*,*) '    METHOD = 0 is "Historic Chisquared=Ndata"'
      WRITE(*,*) '    METHOD = 1 is "Classic with known noise"'
      WRITE(*,*) '    METHOD = 2 is "Classic with unknown noise"'
      READ(*,*) METHOD
      IF(METHOD.LT.0.OR.METHOD.GT.2) GOTO 1
      METHOD=10+METHOD
      WRITE(*,*) ' '
      END     

      SUBROUTINE LEVIN(LEVEL)
* Input LEVEL
      WRITE(*,*) ' '
      WRITE(*,*) '  Please input  LEVEL = 10*L1 + L0'
      WRITE(*,*) ' '
      WRITE(*,*) '    L1 = 0 gives no numerical diagnostics'
      WRITE(*,*) '    L1 = 1 gives major numerical diagnostics'
      WRITE(*,*) '    L1 = 2 gives additional technical diagnostics'
      WRITE(*,*) ' '
      WRITE(*,*) '    L0 = 0 gives no progress diagnostics'
      WRITE(*,*) '    L0 = 1 gives names of main routines'
      WRITE(*,*) '    L0 = 2 gives additionally read/write flowchart'
      WRITE(*,*) '    L0 = 3 additionally calls udiag',
     *                      ' after each main routine'
      READ(*,*) LEVEL
      WRITE(*,*) ' '
      END     

      SUBROUTINE RATIN(RATE)
* Input RATE
      WRITE(*,*) ' '
      WRITE(*,*) '  Please input  RATE'
      READ(*,*) RATE
      WRITE(*,*) ' '
      END     

      SUBROUTINE PAUSIN(ITER0)
* Input PAUSE
      WRITE(*,100) ITER0
      WRITE(*,101) 
      READ(*,*) ITER0
      WRITE(*,102) ITER0
  100 FORMAT(' VlbMem> Iteration pause = ',I5,' New number? ')
  101 FORMAT(' VlbMem> ',$)
  102 FORMAT(' VlbMem> Iteration pause = ',I5)
      END     

      SUBROUTINE HELP
      WRITE(*,*) 'VlbMem> Commands available :'
      WRITE(*,*) 'VlbMem>'
      WRITE(*,*) 'VlbMem>        EXit:   STOP'
      WRITE(*,*) 'VlbMem>        Quit:   STOP'
      WRITE(*,*) 'VlbMem>        Help:   Print this message'
      WRITE(*,*) 'VlbMem>      METhod:   Change MEM3 METHOD'
      WRITE(*,*) 'VlbMem>       LEVel:   Change MEM3 LEVEL'
      WRITE(*,*) 'VlbMem>       PAUse:   Change iteration pause'
      WRITE(*,*) 'VlbMem>         TRQ:   Opus/Tropus consistency test'
      WRITE(*,*) 'VlbMem>        DMem:   Write out the Dirty map'
      WRITE(*,*) 'VlbMem>       DBeam:   Write out the Dirty beam'
      WRITE(*,*) 'VlbMem>      DResid:   Write out the Dirty residuals'
      WRITE(*,*) 'VlbMem>      MKdata:   Write out the mock data'
      WRITE(*,*) 'VlbMem>        SAVe:   Write out the MEM3 iterate'
      WRITE(*,*) 'VlbMem>        ITER:   Perform MEM3 iterates'
      WRITE(*,*) 'VlbMem>        FLUX:   Quantify a MEM3 map'
      WRITE(*,*) 'VlbMem>'
      WRITE(*,*) 'VlbMem> Commands may be entered in upper or',
     *           ' lower case, but not a mixture'
      WRITE(*,*) 'VlbMem> Capitals above indicate significant letters'
      WRITE(*,*) 'VlbMem> '
      END

      SUBROUTINE UVCHK(NX,NY,XYINT,VARSUM)
      INCLUDE 'MECOMP.INC'
      INCLUDE 'MECOMS.INC'
* Data files can be blocked
      VARSUM=0.
      DO 1 I=1,NK
        CALL UPDATE(40)
        CALL UREAD(22)
        CALL UVCHK1(ST(KC(40)),ST(KC(22)),MK/2,NX,NY,XYINT,VARSUM)
        CALL UWRITE(40)
    1 CONTINUE
      CALL UINIT
      END

      SUBROUTINE UVCHK1(UV,WEIGHT,NP,NX,NY,XYINT,VARSUM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
* u-v checker, snatched unchanged from the old VLBMEM                         *
* It throws out baselines that are too long for the gridding array            *
* or provides an estimate of a suitable XYINT if XYINT is .LE. 0. on input    *
* I have completely forgotten how this works!                                  *
* INPUT:     UV          Array of u-v points                                  *
*            WEIGHT      Accuracy  (1./sigma)                                 *
*            NP          Number of points to check                            *
*            NX,NY       Array size for gridder                               *
*            XYINT       milli arcsec per pixel                               *
* OUTPUT:    XYINT       milli arcsec per pixel                               *
*            VARSUM      Sum of accuracies for scaling beam                   *
*-----------------------------------------------------------------------------*
      INCLUDE 'MEFITS.INC'
      REAL UV(2,NP),WEIGHT(2,NP)
      SUM=0.
      XKMAX=0.
      DO 1 K=1,NP
        IF(WEIGHT(1,K).NE.0.) THEN
          XK=UV(1,K)**2+UV(2,K)**2
          XKMAX=MAX(XKMAX,XK)
        ENDIF
    1 CONTINUE
      XK=SQRT(XKMAX)
*     Default over-sampling is about 3
      XBS=NX*0.175
      XKSCL=XBS/XK

      AAAA=XKSCL*3.2228  *1.E6*64./NX
      IF(XYINT.GT.0.) XBS=NX*0.175*XYINT/AAAA
      IF(XBS.LT.2.) CALL ERROR('Oversampling too great')
      XKSCL=XBS/XK
      XKY=-1.0*XKSCL*REAL(NY)/REAL(NX)
      IF(XYINT.EQ.0.) XYINT=AAAA
  101 FORMAT(' Map scale', F10.2,' Milli arc sec / Grid point')
      WRITE(*,101) XYINT
*     Convert to degrees
      HXINT = XYINT/3600 000.0
      HYINT = HXINT
      ICHUCK=0
      XBC=NX/2.6
      XBD=NY/2.6
      SUM=0.
      DO 2 K=1,NP
        IF(WEIGHT(1,K).NE.0.) THEN
          UV(1,K)=XKSCL*UV(1,K)
          UV(2,K)=XKY*UV(2,K)
          IF(ABS(UV(1,K)).GT.XBC.OR.ABS(UV(2,K)).GT.XBD) THEN
            WEIGHT(1,K)=0.
            WEIGHT(2,K)=0.
            ICHUCK=ICHUCK+1
          ENDIF
          SUM=SUM+WEIGHT(1,K)**2
        ENDIF
    2 CONTINUE
      WRITE(*,102) SUM
      VARSUM=VARSUM+SUM
  102 FORMAT(' Sum of variances is ' ,1PE12.5)
      IF(ICHUCK.NE.0.) THEN
        WRITE(*,103) ICHUCK
      ENDIF
  103 FORMAT(' Number of baselines thrown out =',I6)
      END

      SUBROUTINE DATFIL(LUNIT,NP,RESULT)
      INTEGER LUNIT,NP
      CHARACTER*128 FILE, RESULT
      INTEGER IER,  L, NS, NB, NT, NREC
      INTEGER GETIN, VLBOPE
   10 IER = GETIN(FILE, 'Merge file name: ',L)
      IF (IER.NE.1) STOP
      IER = VLBOPE(LUNIT, FILE, 'MERGE', 'OLD', RESULT)
      IF (IER.NE.1) GOTO 10
      CALL MRGSIZ(LUNIT, NS, NB, NT, NREC, NP)
C     WRITE (*,*) 'File size =', NS, NB, NT, NREC, NP
      REWIND(UNIT=LUNIT)
      END

************************ Input/Output Routines *************************

      SUBROUTINE READIN(LUNIT,X,N)
* Read array from user's data file
      REAL X(N)
      READ(LUNIT) X
      END

      SUBROUTINE WRTOUT(LUNIT,X,N)
* Write array to user's data file
      REAL X(N)
      WRITE(LUNIT) X
      END

      SUBROUTINE DISKIN(LUNIT,L)
* Get area <L> from user
      INCLUDE 'MECOMS.INC'
      INCLUDE 'MECOMP.INC'
      IF(L.LE.20) THEN
        N=NJ
        M=MJ
      ELSE
        N=NK
        M=MK
      ENDIF
      DO 1 I=1,N
        CALL READIN(LUNIT,ST(KC(L)),M)
        CALL UWRITE(L)
    1 CONTINUE
      CALL UINIT
      END

      SUBROUTINE DISKOU(LUNIT,L)
* Write image-area <L> to user
      INCLUDE 'MECOMS.INC'
      INCLUDE 'MECOMP.INC'
      IF(L.LE.20) THEN
        N=NJ
        M=MJ
      ELSE
        N=NK
        M=MK
      ENDIF
      DO 1 I=1,N
        CALL UREAD(L)
        CALL WRTOUT(LUNIT,ST(KC(L)),M)
    1 CONTINUE
      CALL UINIT
      END

       SUBROUTINE MEMORY(NPIXEL,NDATA)
* Assign MemSys memory pointers.
      INCLUDE 'MECOMP.INC'
      INCLUDE 'MECOMS.INC'
      INTEGER VALLOC
      EXTERNAL VALLOC
* Image area is NPIXEL reals
      NJ=1
      MJ=NPIXEL/NJ
* Data  area is NDATA reals
      NK=1
      MK=NDATA/NK
* Set all areas in "core" (with impossible default addresses)
      DO 1 I=1,40
        KA(I)=0
        KB(I)=-99999999
    1 CONTINUE
* Define with length NPIXEL all the areas <1>,<2>, <20> and 
* <21>,<22>,<23>,<24>,<25>,<26>,<27>,<28>,<38>,<39>,<40>,
* Areas <15> and <16> are special Fourier/gridding areas of
* double size in each dimension.
* Area <40> is reserved for the u-v points and <38> and <39>
* contain tabling information for the gridder/degridder
*
* Modified to use dynamic storage for ST - SFG 2 Dec 1989
      KB(1)=VALLOC(NPIXEL*11+NDATA*11,ST)
      KB(2)=KB(1)+NPIXEL
      KB(15)=KB(2)+NPIXEL
      KB(16)=KB(15)+4*NPIXEL
      KB(20)=KB(16)+4*NPIXEL
      KB(21)=KB(20)+NPIXEL
      KB(22)=KB(21)+NDATA
      KB(23)=KB(22)+NDATA
      KB(24)=KB(23)+NDATA
      KB(25)=KB(24)+NDATA
      KB(26)=KB(25)+NDATA
      KB(27)=KB(26)+NDATA
      KB(28)=KB(27)+NDATA
      KB(38)=KB(28)+NDATA
      KB(39)=KB(38)+NDATA
      KB(40)=KB(39)+NDATA
* Initialise internal pointers to enable use of MEMSYS routines
      CALL MEINIT
      END

      SUBROUTINE UMASK(NX,NY,JX,KX,JY,KY)
* Set <2> = square wave from cell j to k (with blocking allowed)
      INCLUDE 'MECOMS.INC'
      INCLUDE 'MECOMP.INC'
      NROW=NY/NJ
      IF(MJ.NE.NROW*NX)
     *   STOP ' Blocksize must be a multiple of NX for UMASK'
      NY1=1
      NY2=NROW
      DO 1 I=1,NJ
        CALL UMASK1(ST(KC(2)),JX,KX,JY,KY, NX,NY1,NY2)
        CALL UWRITE(2)
        NY1=NY1+NROW
        NY2=NY2+NROW
    1 CONTINUE
      CALL UINIT
      END

      SUBROUTINE UMASK1(F,JX,KX,JY,KY,NX,NY1,NY2)
      REAL F(NX,*)
      NROW=NY2-NY1+1
      JMIN=MAX(JY-NY1+1,1)
      JMAX=MIN(KY-NY1+1,NROW)
      DO 2 J=1,NROW
        DO 1 I=1,NX
          F(I,J)=0.
    1   CONTINUE
    2 CONTINUE
      DO 4 J=JMIN,JMAX
        DO 3 I=JX,KX
          F(I,J)=1.
    3   CONTINUE
    4 CONTINUE
      END

* Dummy routines not needed for core implementation
      SUBROUTINE UPUT
      STOP 'UPUT'
      END

      SUBROUTINE UGET
      STOP 'UGET'
      END

